c        EXPSTACK.FOR
c           interactive autoscaler for stacked profile plots
c
c  mike webring, usgs, 9/86

	parameter        maxlin=250 
	common /catlog/  nline, id(maxlin), ndata(maxlin),
	1                isrec(maxlin),   ierec(maxlin),
	1                xstat(4,maxlin), ystat(4,maxlin)
	character*4      id

	common /devic/  idev, jdev, kdev
	common /files/  ifile, ofile, cfile
	character*80    ifile, ofile, cfile
	common /struc/  nw, ndmax, nt,   nw2, ndmax2, nt2
	common /pltpar/ dxp(2), dyp(2), xp(4), yp(4),
	1               xscale, yscale, zscale
	common /param/  iplotr, izchan, indepz, zscalset, ampfac,
	1               nwinnw, xrange(2), yrange(2), noneg,
	1               isctype, power, logopt, sigbas, startlog
	character                       logopt*4

	parameter       maxbuf=1024
	dimension       buffer(maxbuf)
	character       suffix*6, prog*8
1	format( a )

	prog = 'autoscal'
	call user( prog )
	call initc

10	type *, ' enter express filename '
	accept 1, ifile
	open ( idev, file=ifile, status='old', form='unformatted',
	1  access='direct', iostat=ios, readonly )
	if ( ios .ne. 0 ) go to 10

c  file structure

	read( idev, rec=1 ) nw, nd, nt
	if ( nt .gt. maxbuf ) then
	  type *, nt, ' words in array > ', maxbuf
	  stop
	endif
	ndmax = nt / nw
	nchan = nw - 2
	type *, ' number of channels =', nchan
c  output parameters for optional scaled profiles
	nw2    = 2 + 2 + 2
	nt2    = 509
	ndmax2 = nt2 / nw2

c  get profile catalog

	call getfn( ifile, 'xycat', cfile )
	call catdvr( idev, kdev, cfile, buffer )

c  derive line spacing
	call lineaz
	call linesp( spacing, buffer )

c  plot stacked profiles

100	call getpar

	maxb = maxbuf
	call varsca( buffer, maxb, spacing, zmin, zmax, zmean, zsigma,
	1            zhoriz )
	call endpt( 0 )

	type *, 'z normalize'
	type *, '  zmin    zmax     zmean     zsigma'
	type *, zmin, zmax, zmean, zsigma
	if ( indepz .eq. 1 ) zscalset = 1.5 * zmin
	if ( indepz .eq. 0 ) then
	  type *, ' zhoriz = ', zhoriz
	  type *, ' where zhoriz * z + ( x or y kilometers ) = map position'
	endif

	type *, ' another ?'
	if ( noyes( ) .eq. 0 ) stop
	go to 100 
	end
c*******************************************************************************
	subroutine initc

	parameter        maxlin=250 
	common /catlog/  nline, id(maxlin), ndata(maxlin),
	1                isrec(maxlin),   ierec(maxlin),
	1                xstat(4,maxlin), ystat(4,maxlin)
	character*4      id

	common /devic/  idev, jdev, kdev
	common /files/  ifile, ofile, cfile
	character*80    ifile, ofile, cfile
	common /struc/  nw, ndmax, nt,   nw2, ndmax2, nt2

	common /pltpar/ dxp(2), dyp(2), xp(4), yp(4),
	1               xscale, yscale, zscale
	common /param/  iplotr, izchan, indepz, zscalset, ampfac,
	1               nwinnw, xrange(2), yrange(2), noneg,
	1               isctype, power, logopt, sigbas, startlog
	character                       logopt*4

	idev = 10
	jdev = 11
	kdev = 12

	do i = 1, maxlin
	  id(i)    = ' '
	  ndata(i) = 0
	enddo

	iplotr   = 1
	izchan   = 3
	indepz   = 1
	zscalset = 0
	ampfac   = 1
	nwinnw   = 1
	noneg    = 0 
	isctype  = 1
	power    = 1
	logopt   = 'auto'
	sigbas   = 1
	startlog = 0

	xscale = 0.0
	yscale = 0.0
	zscale = 0.0

	return
	end
c*******************************************************************************
	subroutine catdvr( idev, kdev, cfile, buffer )
c  either read express catalog or create it.
	character cfile*(*)

	parameter       maxlin=250
	common /catlog/ nline, id(maxlin), ndata(maxlin),
	1               isrec(maxlin),   ierec(maxlin), 
	1               xstat(4,maxlin), ystat(4,maxlin)
	character*4     id

	dimension       buffer(1)

	nch    = leftj( cfile )
	ierror = 1
	open( kdev, file=cfile, status='old', form='formatted',
	1     readonly, iostat=ios )

	if ( ios .eq. 0 ) then
	  type *, ' reading catalog file :', cfile(1:nch)
	  call getcat( kdev, ierror )
	  if ( ierror .eq. 0 ) then
	    call chkcat( idev, ierror )
	    if ( ierror .eq. 0 ) type *, ' successful read'
	    else
	    type *, ' read error'
	  endif
	  close( kdev )
	endif

	if ( ierror .ne. 0 ) then
c  catalog either contained an error or it doesn't exist.

	  open( kdev, file=cfile, status='new', form='formatted',
	1       carriagecontrol='list' )

	  type *, ' creating catalog file :', cfile(1:nch)
	  mxln = maxlin
	  call gencat( idev, mxln, nline, id, ndata, isrec, ierec )
	  type *, 'found', nline, '  lines'

	  read( idev, rec=1 ) nw, nd, nt
	  ndmax = nt / nw
	  call xystat( idev, buffer, nw, ndmax )
	  call putcat( kdev )
	endif

	return
	end
c*******************************************************************************
	subroutine getcat( kdev, ierror )

c  read catalog file

	parameter        maxlin=250
	common /catlog/  nline, id(maxlin), ndata(maxlin),
	1                isrec(maxlin),   ierec(maxlin), 
	1                xstat(4,maxlin), ystat(4,maxlin)
	character*4      id

	ierror = 0

	i = 0
	do while (.true.)
	  i = i + 1
	  read( kdev, 1, err=20, end=10 ) id(i), ndata(i), 
	1                                 isrec(i), ierec(i) 
1	  format( 2x, a4, 4x, 3i8 )
	  if ( id(i) .eq. 'end%' ) go to 10
	  read( kdev, *, err=20, end=10 ) (xstat(j,i), j=1,4)
	  read( kdev, *, err=20, end=10 ) (ystat(j,i), j=1,4)
	enddo

10	nline = i - 1
	type *, 'nline=',nline, '  last line id=', id(nline)
	if ( isrec(1) .ne. 1 ) then
	  type *, '%%getcat: error, isrec(1)=', isrec(1)
	  ierror = 1
	endif

c  ending record( line n ) + 1 = starting record( line n+1 )
	do i = 1, nline - 1
	  if ( ierec(i) + 1 .ne. isrec(i+1) ) then
	    type *, ' catalog error'
	    type *, '#, id, is, ie', i, id(i), isrec(i), ierec(i+1)
	  endif
	enddo

	return
20	ierror = 1
99	return
	end
c*******************************************************************************
	subroutine putcat( kdev )

	parameter        maxlin=250
	common /catlog/  nline, id(maxlin), ndata(maxlin),
	1                isrec(maxlin),   ierec(maxlin), 
	1                xstat(4,maxlin), ystat(4,maxlin)
	character*4      id


	do i = 1, nline
	  write( kdev, 5 ) id(i) , ndata(i), isrec(i), ierec(i) 
5	  format( '%%', a4, 4x, 3i8 )
	  write( kdev, * ) (xstat(j,i), j=1,4)
	  write( kdev, * ) (ystat(j,i), j=1,4)
	enddo

	write( kdev, 10 )
10	format( '%%end%' )

	return
	end
c*******************************************************************************
	subroutine chkcat( idev, iprt, ierror )

c  check catalog against input file.
c  iprt = 1 print #1 error message, =2 print 1&2 error message.
c  ierror = 1  id doesn't match given start/stop records.
c  ierror = 2  xy stats missing.

	parameter        maxlin=250
	common /catlog/  nline, id(maxlin), ndata(maxlin),
	1                isrec(maxlin),   ierec(maxlin), 
	1                xstat(4,maxlin), ystat(4,maxlin)
	character*4      id

	character    charid*4
	equivalence  (intid,charid)

	ierror = 1
	if ( nline .le. 0 ) return

	ifail = 0
c  check first profile start and stop records
	do irec = isrec(1), ierec(1)
	  read( idev, rec=irec, err=999 ) nw, nd, nt, intid
	  nch = leftj( charid )
	  if ( charid .ne. id(1) ) then
	    ifail = 1
	    type *, charid, '<>', id(1)
	    go to 20
	  endif
	enddo

c  check for id switch at profile 2.
20	if ( nline .gt. 1 ) then
	  irec = isrec(2)
	  read( idev, rec=irec, err=999 ) nw, nd, nt, intid
	  nch = leftj( charid )
	  if ( charid .ne. id(2) ) then
	    ifail = 1
	    type *, charid, '<>', id(2)
	  endif
	endif

	if ( ifail .gt. 0 .and. iprt .ge. 1 ) then
	  type *, '%%chkcat: current catalog does not match input file'
	  type *, ' id(1)=', id(1), ' s/s rec=', isrec(1), ierec(1)
	  if ( nline .gt. 1 )
	1    type *, ' id(2)=', id(2), ' s/s rec=', isrec(2), ierec(2)
	  return
	endif

c  check xy stats
	norang = 0
	do n = 1, nline
	  xrange = xstat(2,n) - xstat(1,n)
	  yrange = ystat(2,n) - ystat(1,n)
	  if ( xrange .lt. 0.0 ) ifail = n
	  if ( yrange .lt. 0.0 ) ifail = n
	  if ( xrange .eq. 0.0   .and.   yrange .eq. 0.0 )
	1           norang = norang + 1
	enddo

	if ( norang .gt. nline / 5 )  ifail = 1 

	if ( ifail .gt. 0 .and. iprt .eq. 2 ) then
	  type *, '%%chkcat: current catalog contains errors in xy stats'
	  type *, ' line ', id(ifail)
	  return
	endif

c  are there enough records to cover the catalog ?
	irec = ierec(nline)
	read( idev, rec=irec, err=100, iostat=ios ) nw, nd, nt, intid
100	if ( ios .ne. 0 ) then
	  ierror = 1
	  if ( iprt .ge. 1 ) type *,
	1                    'input file shorter than current catalog'
	endif

c  is the catalog complete ?
	ierror = 0
	irec   = ierec(nline) + 1
	read( idev, rec=irec, err=999 ) nw, nd, nt, intid
	ierror = 1
	if ( iprt .ge. 1 ) type *,
	1                  ' input file longer than current catalog'

999	return
	end
c*******************************************************************************
	subroutine gencat( idev, maxlin, n, id, ndata, isrec, ierec )

c  extract line ids and number of points, and startstop records for
c  each profile.  Text records, nlog < 0, are recognized.

	dimension    ndata(maxlin), isrec(maxlin), ierec(maxlin)
	character*4  id(maxlin)

	integer      intid
	character    charid*4, currnt*4
	equivalence  ( intid, charid )
	
	irec = 1
	n    = 0
10	read( idev, rec=irec ) nword, nd, ntotal, intid
	if ( nd .le. 0 ) then
	  irec = irec + 1
	  go to 10
	endif

	if ( nword * nd .gt. ntotal  .or.  ntotal .lt. 50   .or.
	1    nword * nd .lt. 0      ) then
	  type *, '%%gencat: record ', irec, ' structure error'
	  type *, ' nword, nd, ntotal =', nword, nd, ntotal
	  stop
	endif

	ndmax  = ntotal / nword
	nch    = leftj( charid )
	currnt = charid

c  cycle entire file
	do 500 icnt = 1, 999999
	if ( n .eq. maxlin ) then
	  type *, ' catalog of ', maxlin, ' lines is full'
	  return
	endif
	n         = n + 1
	id(n)     = currnt
	isrec(n)  = irec	
	ierec(n)  = irec
	ndata(n)  = nd

c  line loop
	do 200 while ( charid .eq. currnt ) 

	  irec = irec + 1
	  read( idev, rec=irec, err=100, iostat=ios ) nw, nd, nt, intid

	  if ( nd .lt. 0 ) then
c  cycle past text records.
50	    irec = irec + 1
	    read( idev, rec=irec, err=100, iostat=ios ) nw, nd, nt, intid
	    if ( nd .lt. 0 ) go to 50
	    nch    = leftj( charid )
	    currnt = charid
	    go to 500
	  endif

c  ios .ne. 0  probably means EOF.
100	  if (ios .ne. 0 ) go to 999

c  check for fatal parameter errors.
	  if ( nw .ne. nword   .or.   nt .ne. ntotal  .or.
	1      nd .gt. ndmax   .or.   nd .lt. 0      ) then
	    type *, ' %%gencat: error in express parameters'
	    type *, ' line, irec, nw, nd, nt =', id(n), ',', 
	1             irec, nw, nd, nt
	    stop
	  endif

	  nch  = leftj( charid )
	  if ( charid .eq. currnt ) then
	    ierec(n) = irec
	    ndata(n) = ndata(n) + nd
	  endif

200	continue

	currnt = charid	
500	continue

999	return
	end
c*******************************************************************************
	subroutine xystat( idev, buff, nword, ndmax )

c       assemble statistics for x & y.
c  xy stat: 1=minimum, 2=maximum, 3=mean, 4=standard deviation.

	parameter        maxlin=250
	common /catlog/  nline, id(maxlin), ndata(maxlin),
	1                isrec(maxlin),   ierec(maxlin), 
	1                xstat(4,maxlin), ystat(4,maxlin)
	character*4      id

	dimension        buff(nword,ndmax)
	double precision xd, yd, xs, ys, xsq, ysq

	do iline = 1, nline

	xs   = 0
	ys   = 0
	xsq  = 0
	ysq  = 0
	nsum = 0
	xstat(1,iline) =  1.e30
	xstat(2,iline) = -1.e30
	xstat(3,iline) =  1.e30
	xstat(4,iline) =  0
	ystat(1,iline) =  1.e30
	ystat(2,iline) = -1.e30
	ystat(3,iline) =  1.e30
	ystat(4,iline) =  0

	do irec = isrec(iline), ierec(iline)
	  read( idev, rec=irec, err=10, iostat=ios ) nw, nd, nt, buff
10	  if ( ios .ne. 0 ) then
	    type *, 'xystat: attempt to read nonexistant record #', irec
	    type *, ' line, startrec, endrec =', 
	1             id(iline), isrec(iline), ierec(iline)
	    stop
	  endif	    

	  do idata = 1, nd
	    x   = buff(3,idata)
	    y   = buff(4,idata)
	    if ( x .lt. xstat(1,iline) ) xstat(1,iline) = x
	    if ( x .gt. xstat(2,iline) ) xstat(2,iline) = x
	    if ( y .lt. ystat(1,iline) ) ystat(1,iline) = y
	    if ( y .gt. ystat(2,iline) ) ystat(2,iline) = y
	    xd  = x
	    yd  = y  
	    xs  = xs  + xd
	    ys  = ys  + yd
	    xsq = xsq + xd * xd
	    ysq = ysq + yd * yd
	  enddo

	  nsum = nsum + nd
	enddo

	if ( ndata(iline) .ne. nsum ) then
	  type *, 'xystat: profile entry #', iline
	  type *, 'predicted ndata = ', ndata(iline), ',  found=', nsum
	  stop
	  else
	  if ( nsum .ge. 2 ) then
	    as   = nsum
	    xstat(3,iline) = xs / as
	    ystat(3,iline) = ys / as
	    tmpx = ( as * xsq - xs * xs ) / ( as * ( as - 1 ) )
	    tmpy = ( as * ysq - ys * ys ) / ( as * ( as - 1 ) )
	    if ( tmpx .gt. 0 ) xstat(4,iline) = sqrt( tmpx )
	    if ( tmpy .gt. 0 ) ystat(4,iline) = sqrt( tmpy )
	  endif
	endif

	enddo
	return
	end
c*******************************************************************************
	subroutine pltsca( iplt, izchan )

c  interactive plot setup

	common /files/  ifile
	character       ifile*80
	common /pltpar/ dxp(2), dyp(2), xp(4), yp(4),
	1               xscale, yscale, zscale

	character       title*80, title2*80
	data            gkm2in/ 39370.08 /

	if ( iplt .eq. 1 ) then
	  type *, 'do you want equal scaling in x and y ? [ y ] '
	  iscal = noyes()
	  if ( iscal .eq. -1 ) iscal = 1
	  call setgrf( iscal, dxp, dyp, xp, yp, 0 )
	  call neatl
	  xscale = abs( dxp(2) - dxp(1) ) / xp(1)
	  yscale = abs( dyp(2) - dyp(1) ) / yp(1)
	  return
	endif

10	type *, ' enter map scale ( eg 250000 ) '
	accept *, mscale
	type *, ' map scale = 1:', mscale
	type *, ' is this ok ? [ y ]'
	if ( noyes() .eq. 0 ) go to 10

	xkm   = abs( dxp(2) - dxp(1) )
	ykm   = abs( dyp(2) - dyp(1) )
	xp(1) = ( xkm * gkm2in ) / float( mscale )
	yp(1) = ( ykm * gkm2in ) / float( mscale )
	call xyequal( dxp, dyp, xp(1), yp(1) )

	type *, ' enter lower left xy margin'
	accept *, xp(3), yp(3)
	xsize = xp(1) + xp(3)
	ysize = yp(1) + yp(3)
	type *, ' xsize, ysize = ', xsize, ysize
	type *, ' is this ok ? [ y ]'
	if ( noyes() .eq. 0 ) go to 10

	call llcom( iplt, dxp, dyp )

	nch   = leftj( ifile )
	title = ' '
	write( title, 20 ) ifile(1:nch), izchan
20	format( ' file=',a<nch>, '  z channel=', i3 )
	nch = leftj( title )	
	type *, ' enter title [ ', title(1:nch), ' ]'
	accept 30, title2
30	format( a )
	nch = leftj( title2 )
	if ( nch .gt. 0 ) title = title2

	call pltset( iplt, xp(4), yp(4), 1 )
	if ( iplt .eq. 6 ) then
	  xp(4) = 72.
	  yp(4) = 72.
	endif
	if ( xp(4) .lt. xsize ) type *, ' x plotter size =', xp(4)
	if ( yp(4) .lt. ysize ) type *, ' y plotter size =', yp(4)

	ierr = 0
	call scale( dxp, dyp, xp, yp, 4, ierr )
	if ( ierr .ne. 0 ) then
	  type *, ' plotter type =', iplt
	  type *, ' dxp =', dxp
	  type *, ' dyp =', dyp
	  type *, '  xp =', xp
	  type *, '  yp =', yp
	  type *, ' x-y scaling error'
	  type *, ' xsize ysize =', xp(1) + xp(3),  yp(1) + yp(3)
	  type *, ' do you want another scale or margin ? [ y ]'
	  if ( noyes() .ne. 0 ) go to 10
	  iplt = 0 
	  return
	endif

100	call neatl
	xscale = abs( dxp(2) - dxp(1) ) / xp(1)
	yscale = abs( dyp(2) - dyp(1) ) / yp(1)
	call llpost
	yh = yp(3) / 2
	call text( xp(3), yh, title, .15, 0. )	

	return
	end
c*******************************************************************************
	subroutine llcom( iplt, dxp, dyp )
	common /llp/  ydm(3), ydx(3), xdm(3), xdx(3), cm(3), bl(3),
	1              iprj, xkm(2), ykm(2), sizep, unit, iplotr, 
	1              neat, tint, itpost, ibound
	dimension dxp(2), dyp(2)

	do i = 1, 2
	  xkm(i) = dxp(i)
	  ykm(i) = dyp(i)
	enddo
	sizep  = .08
	unit   = 2
	iplotr = iplt

	type *, ' lat-lon ticks'
	type *, ' enter tick interval, ( 0=no ticks, -1=default )'
	accept *, tint
	if ( tint .eq. 0 ) return

	type *, ' enter iproj, cm, baslat'
	accept *, iprj, cm(1), bl(1)

	return
	end
c*******************************************************************************
	subroutine opensca

	common /devic/ idev,  jdev,  kdev
	common /files/ ifile, ofile, cfile
	character*80   ifile, ofile, cfile
	common /struc/ nw, ndmax, nt,   nw2, ndmax2, nt2

	common /param/  iplotr, izchan, indepz, zscalset, ampfac,
	1               nwinnw, xrange(2), yrange(2), noneg,
	1               isctype, power, logopt, sigbas, startlog
	character                       logopt*4

	character prefx*80, pfile*80, suffx*6

	ofile = ' '
	pfile = ' '
	type *, ' enter output prefix'
	accept 1, prefx
1	format( a )

	write( suffx, 100 ) izchan
100	format( 'chan', i2 )
	if ( suffx(5:5) .eq. ' ' ) suffx(5:5) = '0'
	call suffix( prefx, suffx, ofile )
	ncho = leftj( ofile )
	type *, ' express output file : ', ofile(1:ncho)

	length = 3 + nt2
	open( jdev, file=ofile, status='new', form='unformatted',
	1     recl=length, recordtype='fixed', access='sequential' )

	write( suffx, 200 ) izchan
200	format( 'parm', i2 )
	if ( suffx(5:5) .eq. ' ' ) suffx(5:5) = '0'
	call suffix( prefx, suffx, pfile )
	nchp = leftj( pfile )
	type *, ' parameter listing file : ', pfile(1:nchp)

	open( kdev, file=pfile, status='new', form='formatted',
	1     carriagecontrol='list' )

	nchi = leftj( ifile )
	write( kdev, * ) '  input file=', ifile(1:nchi)
	write( kdev, * ) ' output file=', ofile(1:ncho)
	write( kdev, * ) ' channel    =', izchan

	if ( isctype .eq. 1 ) write( kdev, * ) ' linear scaling'

	if ( isctype .eq. 2 ) then
	  write( kdev, * ) ' exponential scaling'
	  write( kdev, * ) ' power      =' ,power
	endif

	if ( isctype .eq. 3 ) write( kdev, * ) ' logarithmic scaling'

	return
	end
c*******************************************************************************
	subroutine varsca( buff, maxb, spacing, zmin, zmax, zmean, zsigma,
	1                  zhoriz )

	parameter        maxlin=250
	common /catlog/  nline, id(maxlin), ndata(maxlin),
	1                isrec(maxlin),   ierec(maxlin), 
	1                xstat(4,maxlin), ystat(4,maxlin)
	character*4      id
	common /linpar/  azm(maxlin)

	common /devic/  idev, jdev, kdev
	common /struc/  nw, ndmax, nt,   nw2, ndmax2, nt2
	common /files/  ifile, ofile, cfile
	character*80    ifile, ofile, cfile

	common /pltpar/ dxp(2), dyp(2), xp(4), yp(4), 
	1               xscale, yscale, zscale, zdc
	common /param/  iplotr, izchan, indepz, zscalset, ampfac,
	1               nwinnw, xrange(2), yrange(2), noneg,
	1               isctype, power, logopt, sigbas, startlog
	character                       logopt*4

	parameter       maxxyz=5000
	common /array/  x(maxxyz), y(maxxyz), z(maxxyz), z2(maxxyz)

	dimension       buff(maxb)
	dimension       r(maxlin), s(maxlin)
	character       title*80
	logical         outside

	ldev    = 20
	sumnorm = 0.
	sumsq   = 0.
	norm    = 0

	call  xylmt( idev, dxp, dyp )

	if (iplotr .gt. 0 ) then
	  call pltsca( iplotr, izchan )
	  else
	  call opensca
	  if ( startlog .gt. 0.0 ) write( ldev, * ) ' rollover=', startlog
	  nwinnw = 1
	endif

c  note that indepz = 1, and zscale > 0 are inconsistent...
c  zhoriz units  are   horizontal_data_units / z_data_units

c  for fixed scaling ( indepz = 0 )
	zhoriz  = spacing * ampfac * zscalset
	if ( zscale .gt. 0   .and.   indepz .eq. 0 ) then
	  xscale  = ( dxp(2) - dxp(1) ) / xp(1)
	  zhoriz  = xscale / zscale
	endif


c  cycle through data file


	nlplt = 0
	do 50 iline = 1, nline

	jline = iline
	if ( outside( jline, dxp, dyp ) ) go to 50
	nlplt = nlplt + 1

c  get profile
	nxyz   = 1 + ( ndata(iline) - 1 ) / nwinnw
	if ( nxyz .gt. maxxyz ) nxyz = maxxyz
	call getxyz( idev, isrec(iline), ierec(iline), izchan, 
	1            x, y, z, nxyz, nwinnw,
	1            buff, nw, ndmax )

c  z working array
	do i = 1, nxyz
	  z2(i) = z(i) - zdc
	enddo
c  apply either power or log transform to z.
	call zlog( nxyz, z2, roll )
	r(nlplt) = roll

c  write rescaled output
	if ( iplotr .le. 0 ) then
	  if ( startlog .eq. 0 ) 
	1      write( ldev, * ) ' line :', id(iline), '  rollover=', roll
	  call putxyz( jdev, id(iline), x, y, z, z2, nxyz,
	1              buff, nw2, ndmax2, nt2 )
	  go to 50
	endif

c  find factor to normalize z range to -1, 1.
	call ammi( nxyz, z2, zmin, zmax, mn, mx, 1 )
	znorm    = amax1( abs(zmin), abs(zmax) )
	rnorm    = 1.0
	if ( znorm .gt. 1.e-30 )  then
	  rnorm    = 1.0 / znorm
	  norm     = norm + 1
	  s(norm)  = rnorm
	endif

c  for independent z scaling
	if ( indepz .eq. 1 ) zhoriz  = spacing * ampfac * rnorm

c  scale z
	do i = 1, nxyz
	  z2(i) = z2(i) * zhoriz
	enddo
	
c  transform and plot

	if ( azm(iline) .eq. 0.0 ) then
c  west east
	if ( noneg .eq. 0 ) then
	  do i = 1, nxyz
	    z2(i) = z2(i) + y(i)
	  enddo
	  else
	  do i = 1, nxyz
	    if ( z2(i) .gt. 0 ) then
	      z2(i) = z2(i) + y(i)
	      else
	      z2(i) = y(i)
	    endif
	  enddo
	endif

	call line( x, y,  nxyz, 0, 4 )
	call line( x, z2, nxyz, 0, 0 )	  

	else
c  south north
	if ( noneg .eq. 0 ) then
	  do i = 1, nxyz
	    z2(i) = z2(i) + x(i)
	  enddo
	  else
	  do i = 1, nxyz
	    if ( z2(i) .gt. 0 ) then
	      z2(i) = z2(i) + x(i)
	      else
	      z2(i) = x(i)
	    endif
	  enddo
	endif

	call line( x, y,  nxyz, 0, 4 )
	call line( z2, y, nxyz, 0, 0 )	  

	endif

	sz  = .08
	hsz = sz / 2.
	call linlab( nxyz, x, y, x1, y1, x2, y2 )
	if ( azm(iline) .eq. 0. ) then
	  call text( x1+sz,   y1-sz, id(iline), sz, 0.0 )
	  call text( x2-4*sz, y2-sz, id(iline), sz, 0.0 )
	  else
	  call text( x1+sz,   y1+sz, id(iline), sz, 0.0 )
	  call text( x2+sz,   y2-sz, id(iline), sz, 0.0 )
	endif

50	continue

	if ( iplotr .eq. 0 ) then
	  close( ldev )
	  return
	endif

c  plot title
	sizet = .08
	xt    = xp(3)
	yt    = yp(1) + yp(3) + sizet
	if ( isctype .eq. 1 ) then
	  write( title, 101 ) izchan
101	  format( 'variable scaling: channel=', i2, '  linear function' )
	endif
	if ( isctype .eq. 2 ) then
	  write( title, 102 ) izchan, power
102	  format( 'variable scaling: channel=', i2, '  power=', g11.2 )
	endif
	if ( isctype .eq. 3 ) then
	  rmean  = startlog
	  rsigma = 0.0
	  if ( startlog .eq. 0 ) 
	1      call stddevi( nlplt, r, rmin, rmax, rmean, rsigma )
	  write( title, 103 ) izchan, rmean, rsigma
103	  format( 'variable scaling: channel=', i2,
	1         '  rolloff mean&sigma=', 2g11.2 )
	endif

	call text( xt, yt, title, .08, 0.0 )

	call stddevi( norm, s, zmin, zmax, zmean, zsigma )

	if ( isctype .eq. 3   .and.   indepz .eq. 0 ) then
	  call logbar( zhoriz )
	endif

	return
	end
c*******************************************************************************
	subroutine linlab( n, x, y, x1pu, y1pu, x2pu, y2pu )

	common /pltpar/ dxp(2), dyp(2), xp(4), yp(4),
	1               xscale, yscale, zscale

	dimension x(n), y(n)
	logical   insidr

	do ient = 1, n
	  if ( insidr( x(ient), y(ient), dxp, dyp )  ) then
	    leav = ient
	    do j = ient + 1, n	    
	      if ( .not. insidr( x(j), y(j), dxp, dyp )  ) go to 10
	      leav = j
	    enddo
	    go to 10
	  endif
	enddo	    
	if ( ient .ge. n - 1 ) return

10	x1du = x(ient)
	y1du = y(ient)
	x2du = x(leav)
	y2du = y(leav)

c  symbols 3 & 4 are circle and x.
	call symbol( x1du, y1du, 1, 3, .08, 0.0 )
	call symbol( x2du, y2du, 1, 4, .08, 0.0 )

	call du2pu( x1du, y1du, x1pu, y1pu )
	call du2pu( x2du, y2du, x2pu, y2pu )

	return
	end
c******************************
	logical function insidr( x, y, xr, yr )
c  is x,y inside rectangle xr,yr ?

	dimension xr(2), yr(2)
	insidr = .false.

	if ( x .lt. xr(1) ) return
	if ( x .gt. xr(2) ) return
	if ( y .lt. yr(1) ) return
	if ( y .gt. yr(2) ) return
	insidr = .true.

	return
	end	   
c*******************************************************************************
	logical function outside( j, dxp, dyp )

	parameter        maxlin=250
	common /catlog/  nline, id(maxlin), ndata(maxlin),
	1                isrec(maxlin),   ierec(maxlin), 
	1                xstat(4,maxlin), ystat(4,maxlin)
	character*4      id

	dimension dxp(2), dyp(2)

	outside = .true.
	if ( xstat(1,j) .gt. dxp(2) ) return
	if ( xstat(2,j) .lt. dxp(1) ) return
	if ( ystat(1,j) .gt. dyp(2) ) return
	if ( ystat(2,j) .lt. dyp(1) ) return
	outside = .false.
	return
	end
c*******************************************************************************
	subroutine getxyz( idev, isrec, ierec, izchan, x, y, z,
	1                  nxyz, nwinnw, buff, nw, ndmax )

	dimension x(nxyz), y(nxyz), z(nxyz), buff(nw,ndmax)

	iword = izchan + 2
	ixyz  = 0
	js    = 1

	mxyz  = ndmax * ( ierec - isrec + 1 )
	mwin  = 1 + ( mxyz - 1 ) / nwinnw
	if ( nxyz .gt. mwin ) type *,
	1   ' getxyz: maximum vs reserved=', mwin, nxyz

	do irec = isrec, ierec
	  read( idev, rec=irec ) nw, nd, nt, buff
	  if ( js .lt. 1  .or.  js .gt. ndmax ) go to 100

	  do jdata = js, nd, nwinnw
	    ixyz    = ixyz + 1
	    x(ixyz) = buff( 3, jdata)
	    y(ixyz) = buff( 4, jdata)
	    z(ixyz) = buff( iword, jdata)
	    je      = jdata
	  enddo

	  js = ( je + nwinnw ) - nd	  
	enddo

	return
100	type *, 'getxyz: js, nd, ndmax=', js, nd, ndmax
	type *,'isrec,   ierec,    irec,    ixyz,    nwinnw'
	type *, isrec,   ierec,    irec,    ixyz,    nwinnw
	return
	end
c*******************************************************************************
	subroutine putxyz( jdev, lineid, x, y, z, z2, nxyz, 
	1                  buff, nword, ndmax, ntotal )
c  output id, x, y, z  in express format.

	dimension       bid(2), x(nxyz), y(nxyz), z(nxyz), z2(nxyz),
	1               buff(nword,ndmax)
	character       id*4, lineid*4
	equivalence     ( id, bid(1) )

	if ( nword .ne. 6 ) then
	  type *, '%%putxyz: nword .ne. 6 ', nword
	  stop
	endif
	if ( nword * ndmax .gt. ntotal ) then
	  type *, '%%putxyz nword * ndmax > ntotal', nword, ndmax, ntotal
	  stop
	endif

	ixyz   = 0
	id     = ' '
	bid(2) = bid(1)
	id     = lineid

	do j = 1, ndmax
	  buff(1,j) = bid(1)
	  buff(2,j) = bid(2)
	enddo

	do while ( .true. )
	  do nd = 1, ndmax
	    ixyz       = ixyz + 1
	    buff(3,nd) = x(ixyz)
	    buff(4,nd) = y(ixyz)
	    buff(5,nd) = z(ixyz)
	    buff(6,nd) = z2(ixyz)
	    if ( ixyz .eq. nxyz ) go to 100
	  enddo
	  write( jdev ) nword, ndmax, ntotal, buff
	  if ( ixyz .eq. nxyz ) go to 999
	enddo

100	id     = ' ' 
	bid(2) = bid(1)
	do j = nd + 1, ndmax
	  buff(1,j) = bid(1)
	  buff(2,j) = bid(2)
	  do i = 3, nword
	    buff(i,j) = 0.0
	  enddo
	enddo
	write( jdev ) nword, nd, ntotal, buff

999	return
	end
c*******************************************************************************
	subroutine getpar

	common /pltpar/ dxp(2), dyp(2), xp(4), yp(4),
	1               xscale, yscale, zscale, zdc
	common /param/  iplotr, izchan, indepz, zscalset, ampfac,
	1               nwinnw, xrange(2), yrange(2), noneg,
	1               isctype, power, logopt, sigbas, startlog
	character                       logopt*4

	character      answer*8, blank*8
	data           itty/ 5 /
	blank = ' ' 

1	format( a )
2	format( i8 )
3	format( f8.0 )
	type *
	type *, ' Current values displayed as...[nnn], enter <cr> to bypass.'
	type *, ' Enter control-z to end this prompting session.'
	type *

10	type 11, iplotr
11	format( ' enter plotter number ( zero for no plot): [', i2, ']' )
	read( itty, 1, err=10, end=999 ), answer
	call rightj( answer )
	if ( answer .ne. blank ) 
	1    read( answer, 2, err=10, end=999 ) iplotr
	if ( iplotr .le. 0 ) return
	if ( iplotr .gt. 6 ) go to 10

20	type 21, izchan
21	format( ' enter channel number [', i2, ']' )
	read( itty, 1, err=10, end=999 ), answer
	call rightj( answer )
	if ( answer .ne. blank ) 
	1    read( answer, 2, err=20, end=999 ) izchan
	if ( izchan .le. 0 ) go to 20

25	type 26, zdc
26	format( ' enter constant to be subtracted from z [', 
	1         g10.3, ']' )
	read( itty, 1, err=10, end=999 ), answer
	call rightj( answer )
	if ( answer .ne. blank ) 
	1    read( answer, 3, err=20, end=999 ) zdc

c  z scaling

30	if ( indepz .ne. 0   .and.   indepz .ne. 1  ) indepz = 1
	if ( indepz .eq. 1 ) then
	  type *, ' do you want each profile normalized independently ? [ y ] '
	  else
	  type *, ' do you want each profile normalized independently ? [ n ] '
	endif
	itmp = noyes()
	if ( itmp .eq. 0   .or.   itmp .eq. 1  ) indepz = itmp

	if ( indepz .eq. 0 ) then
	  write(6,*) ' you may either scale z relative to line spacing'
	  write(6,*) ' or absolutely by z_data_units per inch.'
	  write(6,*) ' enter rel, abs, or help  [ rel ]'
	  read( itty, 1, err=10, end=999 ), answer
	  call cvc( answer, 2 )
	  nch = leftj( answer )	  
	  if ( answer .eq. 'hel' ) then
	    write(6,*) ' Relative applies a normalizing factor to z'
	    write(6,*) ' to get the range close to -1 to 1  and then'
	    write(6,*) ' the function is adjusted to fit into the space'
	    write(6,*) ' between flightlines using an exaggeration'
	    write(6,*) ' factor, where 1 is equivalent to the line spacing.'
	    write(6,*) ' Relative z scaling therefore ignores map scale.'
	    write(6,*) ' Absolute scaling ( in z_data_units / inch )'
	    write(6,*) ' is useful once a plot is setup interactively but'
	    write(6,*) ' you want a user friendly scaling factor for'
	    write(6,*) ' for large format display.'
	    go to 30
	  endif

	  if ( answer(1:3) .eq. 'abs' ) then
	    write(6,331) zscale
331	    format( ' enter z scaling factor in data_units/inch [', 
	1         g10.3 ']')
	    read( itty, 1, err=10, end=999 ), answer
	    call rightj( answer )
	    if ( answer .ne. blank ) 
	1      read( answer, 3, err=32, end=999, iostat=ios ) zscale
	    go to 50
	  endif
	  
c  else relative
	  zscale = 0.0
	  write(6,31) zscalset
31	  format( ' enter z normalizing factor [', g10.3, ']' )
	  read( itty, 1, err=10, end=999 ), answer
	  call rightj( answer )
	  if ( answer .ne. blank ) 
	1      read( answer, 3, err=32, end=999, iostat=ios ) zscalset
32	  if ( zscalset .le. 0.0   .or.   ios .ne. 0 ) then
	    type *, ' input error'
	    type *, ' normalizing factor =', zscalset
	    type *, ' the function is multiplied by the normalizing'
	    type *, ' factor to get a residual somewhere near -1 to +1.'
	    go to 30
	  endif

c endif indepz = 0
	endif

c  nominal graph height
40	type 41, ampfac
41	format( ' enter vertical exaggeration [', g10.3, ']' )
	read( itty, 1, err=10, end=999 ), answer
	call rightj( answer )
	if ( answer .ne. blank ) 
	1    read( answer, 3, err=50, end=999 ) ampfac
	if ( ampfac .le. 0.0 ) ampfac = 1.0

c winnowing factor
50	type 51, nwinnw
51	format( ' enter winnowing factor [', i4, ']' )
	read( itty, 1, err=10, end=999 ), answer
	call rightj( answer )
	if ( answer .ne. blank ) 
	1    read( answer, 2, err=50, end=999 ) nwinnw
	if ( nwinnw .le. 0 ) nwinnw = 1

c  suppress negative sides.
	if ( noneg .ne. 0   .and.   noneg .ne. 1 )  noneg = 0
	if ( noneg .eq. 1 ) then
	  type *, ' suppress negative excursions of the curve ? [ y ]'
	  else
	  type *, ' suppress negative excursions of the curve ? [ n ]'
	endif
	itmp = noyes()
	if ( itmp .eq. 0   .or.   itmp .eq. 1 )  noneg = itmp

c  z scaling
60	type *, ' enter type of z scaling '
	type 61, isctype
61	format( ' 1=linear, 2=power, 3=combined linear&log, [', i2, ' ]' )
	read( itty, 1, err=10, end=999 ), answer
	call rightj( answer )
	if ( answer .ne. blank ) 
	1    read( answer, 2, err=60, end=70 ) isctype
	if ( isctype .lt. 1   .or.   isctype .gt. 3 ) go to 60
	  
70	if ( isctype .eq. 2 ) then
	  type 71, power
71	  format( ' enter power [', g10.3, ']' )
	  read( itty, 1, err=10, end=999 ), answer
	  call rightj( answer )
	  if ( answer .ne. blank ) 
	1      read( answer, 3, err=70, end=999 ) power
	  if ( power .lt. .1   .or.  power .gt. 10 ) then
	    type *, power, ' out of range .1 to 10. '
	    go to 70
	  endif
	endif

80	if ( isctype .eq. 3 ) then
	  type *, ' define option 3 rollover point'
	  type *, ' enter either: user, auto, or help: [', logopt, ']'
	  read( itty, 1, err=10, end=999 ), answer
	  call leftj(   answer )
	  call lowcase( answer )
	  if ( answer .ne. blank ) then
	    logopt = 'help'
	    if ( answer(1:1) .eq. 'u' ) logopt = 'user'
	    if ( answer(1:1) .eq. 'a' ) logopt = 'auto'
	  endif

	  if ( logopt .eq. 'user' ) then
90	    type 91, startlog
91	    format( ' enter rollover [', g10.3, ']' )
	    read( itty, 1, err=10, end=999 ), answer
	    call rightj( answer )
	    if ( answer .ne. blank ) 
	1        read( answer, 3, err=90, end=999 ) startlog

	    else if ( logopt .eq. 'auto' ) then
100	type *, ' enter sigma factor defining rollover point.'
	type *, ' range is .25 to 4, larger numbers suppress noise.'
	type 101, sigbas
101	format( ' current default [', g10.3, ']' )
	read( itty, 1, err=10, end=999 ), answer
	call rightj( answer )
	if ( answer .ne. blank ) 
	1    read( answer, 3, err=100, end=999 ) sigbas
	if ( sigbas .lt. .25   .or.   sigbas .gt. 4. ) then
	  type *, sigbas, ' out of range'
	  go to 100
	endif
	
	    else 
	      type *, ' This option is a function composed of a line'
	      type *, ' from zero to the rollover point'
	      type *, ' and then compressed using the log 10'
	      type *, ' ie.  y = log10( x - rollover + 1. ) + rollover'
	      type *, ' for  x >= rollover.  The function is symmetrical'
	      type *, ' about the x origin.'
	      type *, ' You may specify the rollover or the program will'
	      type *, ' derive one based on a standard deviation multiple'
	      type *, ' where sigma = 1 means about 60% of the data will'
	      type *, ' be linearly scaled, and 2 = 90%, 3 = 99%, 4=9999% '
	      go to 60
	  endif
	endif

999	return
	end
c*******************************************************************************
	subroutine linesp( spacing, y )

c  assuming most of the flight lines are adjacent to one another;
c  throw largest and smallest spacings and average remaining spacing.

	parameter        maxlin=250
	common /catlog/  nline, id(maxlin), ndata(maxlin),
	1                isrec(maxlin),   ierec(maxlin), 
	1                xstat(4,maxlin), ystat(4,maxlin)
	character*4      id
	common /linpar/  azm(maxlin)

	character   resp*24
	dimension   sp(maxlin)

1	format( a )

	spacing = 0.0
	if ( nline .lt. 3 ) go to 100

	iwe = 0
	isn = 0
	do j = 1, nline
	  if ( azm(j) .eq. 0.0 ) iwe = iwe + 1
	  if ( azm(j) .eq. 90. ) isn = ins + 1
	enddo
	write(6,*) ' number of west-east and south-north lines =', 
	1          iwe, isn

	nsp = 0
	do j = 1, nline - 1 
	  if ( azm(j) .eq. 0 ) then
	    if ( azm(j) .eq. azm(j+1) ) then
	      nsp     = nsp + 1
	      sp(nsp) = abs( ystat(3,j) - ystat(3,j+1) )
	    endif
	    else
	    if ( azm(j) .eq. azm(j+1) ) then
	      nsp     = nsp + 1
	      sp(nsp) = abs( xstat(3,j) - xstat(3,j+1) )
	    endif
	  endif
	enddo

	type *, ( sp(i), i=1, nsp )
	call stddevi( nsp, sp, spmn, spmx, spacing, sigma )

	n = 0
	s = 0	
	do j = 2, nsp
	  if ( sp(j) .gt.  .99 * ( spacing - sigma ) .and.
	1      sp(j) .lt. 1.01 * ( spacing + sigma )     ) then
	    s = s + sp(j)
	    n = n + 1
	  endif
	enddo

	if ( n .gt. 0 ) spacing = s / float( n )
100	type *, ' average line spacing', spacing

	type *, ' enter line spacing [', spacing, ']'
	resp = ' '
	accept 1, resp
	read( resp, *, end=50 ) s
	if ( s .gt. 0 ) spacing = s

50	type *, ' spacing=', spacing

	return
	end
c*******************************************************************************
	subroutine lineaz

	parameter        maxlin=250
	common /catlog/  nline, id(maxlin), ndata(maxlin),
	1                isrec(maxlin),   ierec(maxlin), 
	1                xstat(4,maxlin), ystat(4,maxlin)
	character*4      id

	common /linpar/  azm(maxlin)


	do 100 jline = 1, nline
	  azm(jline) = 0.0
	  rangex = xstat(2,jline) - xstat(1,jline)
	  rangey = ystat(2,jline) - ystat(1,jline)
	  if ( rangey .gt. 5.0 * rangex ) azm(jline) = 90.
100	continue

	return
	end
c*******************************************************************************
	subroutine xylmt( spacing, dxp, dyp )

	parameter        maxlin=250
	common /catlog/  nline, id(maxlin), ndata(maxlin),
	1                isrec(maxlin),   ierec(maxlin), 
	1                xstat(4,maxlin), ystat(4,maxlin)
	character*4      id

	common /param/  iplotr, izchan, indepz, zscalset, ampfac,
	1               nwinnw, xrange(2), yrange(2), noneg,
	1               isctype, power, logopt, sigbas, startlog
	character                       logopt*4

	dimension  dxp(2), dyp(2)
	character  answer*24, blank*24
	data       itty/ 5 /

1	format( a )
2	format( f8.0 )
	blank = ' ' 

	xmn =  1.e30
	xmx = -1.e30
	ymn =  1.e30
	ymx = -1.e30

	do j = 1, nline
	  if ( xstat(1,j) .lt. xmn ) xmn = xstat(1,j)
	  if ( xstat(2,j) .gt. xmx ) xmx = xstat(2,j)
	  if ( ystat(1,j) .lt. ymn ) ymn = ystat(1,j)
	  if ( ystat(2,j) .gt. ymx ) ymx = ystat(2,j)
	enddo

	xmx = xmx + spacing
	xmn = xmn - spacing
	ymx = ymx + spacing
	ymn = ymn - spacing

	if ( xrange(2) .le. xrange(1) ) then
	  xrange(1) = xmn
	  xrange(2) = xmx
	endif
	if ( yrange(2) .le. yrange(1) ) then
	  yrange(1) = ymn - spacing
	  yrange(2) = ymx + spacing
	endif

20	type *, ' data min/max x', xmn, xmx
	type 21, xrange
21	format(' current plot min/max x = [ ', 2g12.3, ' ]' )
	type *, ' enter plot area x min & max'
	read( itty, 1, err=20, end=100 ) answer
	if ( answer .ne. blank ) 
	1    read( answer, *, err=20, end=100 ) xrange

	type *
	type *, ' data min/max y', ymn, ymx
	type 31, yrange
31	format(' current plot min/max y = [ ', 2g12.3, ' ]' )
	type *, ' enter plot area y min & ymax '
	read( itty, 1, err=20, end=100 ) answer
	if ( answer .ne. blank ) 
	1    read( answer, *, err=20, end=100 ) yrange

100	if ( xrange(2) .le. xrange(1) ) then
	  xrange(1) = xmn
	  xrange(2) = xmx
	endif
	if ( yrange(2) .le. yrange(1) ) then
	  yrange(1) = ymn
	  yrange(2) = ymx
	endif
	dxp(1) = xrange(1)
	dxp(2) = xrange(2)
	dyp(1) = yrange(1)
	dyp(2) = yrange(2)
	return
	end
c*******************************************************************************
	subroutine zlog( nxyz, z, roll )

	common /param/  iplotr, izchan, indepz, zscalset, ampfac,
	1               nwinnw, xrange(2), yrange(2), noneg,
	1               isctype, power, logopt, sigbas, startlog
	character                       logopt*4

	dimension    z(nxyz)

	if ( isctype .eq. 1 ) return

c  nonlinear options
	if ( isctype .eq. 2 ) then
	  do i = 1, nxyz
	    tmp  = abs( z(i) )**power
	    z(i) = sign( tmp, z(i) )
	  enddo
	endif

	if ( isctype .eq. 3) then
	  if ( logopt .eq. 'auto'  .or.  startlog .le. 0.0 ) then
	    call spkamp( z, nxyz, sigbas, 5, roll, smean, ssig, smn, smx )
	    roll = roll + 1.e-20
	    else
	    roll = startlog
	  endif

	  zlimit = 4. * roll
	  do i = 1, nxyz
	    z(i) = sgnlog10( z(i), roll )
	    if ( abs( z(i) ) .gt. zlimit ) z(i) = sign( zlimit, z(i) )
	  enddo
	endif

	return
	end
c*******************************************************************************
	subroutine logbar( zhoriz )
c  log scaling bar

	parameter       nzmax=9

	common /pltpar/ dxp(2), dyp(2), xp(4), yp(4),
	1               xscale, yscale, zscale, zdc

	common /param/  iplotr, izchan, indepz, zscalset, ampfac,
	1               nwinnw, xrange(2), yrange(2), noneg,
	1               isctype, power, logopt, sigbas, startlog
	character                       logopt*4

	dimension    ilabel(3), x(nzmax), z(nzmax), z2(nzmax), z3(nzmax)
	character    label*12, fmt*12
	equivalence  ( label, ilabel )
	
	nz   = nzmax
	z(5) = 0.0
	z(6) = 1.    * startlog
	z(7) = 10.   * startlog
	z(8) = 100.  * startlog
	z(9) = 1000. * startlog
	i2   = nz
	do i = 1, nzmax / 2
	  z(i) = -z(i2)
	  i2   = i2 - 1
	enddo

	if ( noneg .eq. 1 ) then
	  nz   = 1 + nzmax / 2
	  z(1) = 0.0
	  z(2) = 1.    * startlog
	  z(3) = 10.   * startlog
	  z(4) = 100.  * startlog
	  z(5) = 1000. * startlog
	endif

	xkm = dxp(1) + 0.05 * ( dxp(2) - dxp(1) ) 
	ykm = dyp(1) + 0.05 * ( dyp(2) - dyp(1) ) 
	ykm = ykm + abs( zhoriz * sgnlog10( z(1), startlog )  )

	do i = 1, nz
	  z2(i) = sgnlog10( z(i), startlog )
	  z3(i) = zhoriz * z2(i) + ykm 
	  x(i)  = xkm
	enddo

	call line( x, z3, nz, 0, 0 )

	ticlen = .1
	xtic   = xkm + ticlen * xscale
	
	do i = 1, nz
	  call line(  xkm, z3(i), 1, 0, 0 )
	  call line( xtic, z3(i), 1, 1, 0 )

	  call getfmt( z3(i), fmt )
	  write( label, fmt ) z(i)
	  nch = leftj( label )
	  call vchar( xtic, z3(i), ilabel, nch, 2, 
	1             .08, 0.0, 0.08, 0.0 )
	enddo	 

	return
	end
c********************
	subroutine getfmt( z, fmt )
	character fmt*(*)

	fmt = '( f3.0 )'
	if ( z .eq. 0.0 ) return

	az    = abs( z ) + 1.e-30
	expon = alog10( az )

	fmt   = '( 1pe12.3 )'
	if ( expon .lt. -3.   .or.   expon .gt. 3.0 ) return

	if ( expon .ge. 0 ) fmt = '( f12.1 )'
	if ( expon .lt. 0 ) fmt = '( f12.2 )'
	if ( expon .lt. -1 ) fmt = '( f12.3 )'
	
	return
	end
c*******************************************************************************
	function sgnlog10( xinp, rollover )

c  A piecewise function that is linear in the range -roll to +roll
c  and logarithmic outside this range,  such that 
c  sgnlog10(     roll, roll ) = 1 * roll.
c  sgnlog10( 10 *roll, roll ) = 2 * roll.
c  sgnlog10( 100*roll, roll ) = 3 * roll   etc.

	sgnlog10 = xinp
	x        = abs( xinp )

	if ( x .gt. rollover ) then
	  y        = rollover * ( alog10( x / rollover ) + 1. )
	  sgnlog10 = sign( y, xinp )
	endif

	return
	end
c***************
	function asgnlog10( yinp, rollover )
	asgnlog10 = yinp
	y         = abs( yinp )

	if ( y .gt. rollover ) then
	  x         = rollover * 10.0**( y / rollover - 1.0 )	 
	  asgnlog10 = sign( x, yinp )
	endif

	return
	end
c*******************************************************************************
	subroutine spksca( x, y, n, tolbas, smean, ssig )
	dimension x(n), y(n)

c       linear scale x lower than tolbas and logarithmic scale x 
c       above tolbas with minimum distortion of the visual pattern
c       as the goal.

c  tolbas is amplitude for switching from linear to logarithmic scaling.
c  smean  is mean amplitude for spikes above tolbas.
c  ssig   is the standard deviation of the spikes above tolbas.

c  mike webring, usgs, 9/86

	if ( tolbas .eq. 0 ) then
	  do i = 1, n
	    y(i) = x(i)
	  enddo
	  return
	endif

	amp1 = .5
	amp2 = 1
	sca1 = amp1 / tolbas
	sca2 = 0

	spkmax = smean + ssig
	if ( spkmax .gt. tolbas ) then
	  baslog = alog10( tolbas )
	  sca2   = ( amp2 - amp1 ) / ( alog10( spkmax ) - baslog )
	endif

	do i = 1, n
	  ax = abs( x(i) )
	  if ( ax .le. tolbas ) then
	    y(i) = sca1 * ax
	    else
	    y(i) = amp1 + sca2 * ( alog10( ax ) - baslog )
	    if ( y(i) .gt. amp2 ) y(i) = amp2
	  endif
	  y(i) = sign( y(i), x(i) )
	enddo

	return
	end
c*******************************************************************************
	subroutine spkamp( x, n, sigbas, kwin, tolbas, 
	1                  smean, ssig, smn, smx )

c       derive statistics for spikes in a data string.

c  sigbas is the standard deviation multiple that defines the minimum
c         value for high amplitude spikes.
c  kwin   is width of spike test window 
c  smean  mean value of high amplitude spikes
c  ssig   standard deviation of hi amp spikes

c  mike webring, usgs, 9/86

	dimension x(n)
	double precision xd, sx, ss

	smean = 0
	ssig  = 0
	smn   = 1.e30
	smx   = 0
	if ( n .lt. 3 ) return

	sx  = 0
	ss  = 0
	do i = 1, n
	  xd = abs( x(i) ) 
	  sx = sx + xd
	  ss = ss + xd * xd
	enddo

	xn    = float( n )
	xmean = sx / xn
	sigsq = sngl( dble( xn ) * ss - sx * sx ) / 
	1               ( xn * ( xn - 1 ) )
	if ( sigsq .lt. 1.e-30 ) return
	xsig   = sqrt( sigsq )
	tolbas = sigbas * xsig

	ns = 0
	sx = 0
	ss = 0
	ih = kwin / 2
	ix = ih + 1

	do while ( ix .lt. n - ih )
	  ax = abs( x(ix) )
	  if ( ax .lt. tolbas ) go to 100
	  do i = 1, ih
	    i1 = ix - i
	    if ( abs( x(i1) ) .gt. ax ) go to 100
	    i2 = ix + i
	    if ( abs( x(i2) ) .gt. ax ) go to 100
	  enddo
	  if ( ax .gt. smx )  smx = ax
	  if ( ax .lt. smn )  smn = ax
	  xd = ax
	  sx = sx + xd
	  ss = ss + xd * xd
	  ns = ns + 1
	  ix = ix + 2 * ih

100	  ix = ix + 1
	enddo

	if ( ns .lt. 1 )          return
	xn    = float( ns )
	smean = sx / xn
	if ( ns .lt. 2 )          return
	sigsq = sngl( dble( xn ) * ss - sx * sx ) / 
	1             ( xn * ( xn - 1 ) )
	if ( sigsq .lt. 1.e-30 )  return
	ssig   = sqrt( sigsq ) 
	return
	end
c*******************************************************************************
	subroutine setgrf( iscaxy, dxp, dyp, xp, yp, ihalfy )

c  input min,max data area coordinates, performs graph scaling call,
c  labels axis, and returns board info for tektronix screens.
c  iscal  = 1 requires x,y scaling be the same
c  ihalfy = 0 use whole screen, ihalfy = -1,1 use lower or upper half

	dimension ifmt(5), jfmt(5), dxp(2), dyp(2), xp(4), yp(4) 
	character fmtx*20, fmty*20
	equivalence (fmtx,ifmt), (fmty,jfmt)

	iscal = 0
	if ( iscaxy .ne. 0 ) iscal = 1

c  pltset clears the screen, inits plotsys, and returns board size
	if( xp(4).eq.0 .or. yp(4).eq.0 )
	1            call pltset( 1, xp(4), yp(4) ,1 )

c  get axis interval, label format, and number of characters in label
	dx = 0.
	dy = 0.
	call setax( dxp, dx, 20, nx, fmtx )
	call setax( dyp, dy, 20, ny, fmty )

c  setup plot area
	nyax  =  ny
	rmarg = .15
	tmarg = .15
	xwid  = xp(4) - rmarg
	ywid  = yp(4) - tmarg
	halfy = ywid / 2
	if ( ihalfy .eq. 1 ) bmarg = halfy
	if ( ihalfy .ne. 0 ) nyax  = 13
	xp(3) = .08 * float( nyax + 2 ) 
	yp(3) = .08 * float( nx + 2 )   + bmarg
	if ( ihalfy .eq. -1 ) ywid = halfy
	xp(1) = xwid - xp(3) 
	yp(1) = ywid - yp(3) 

c  adjust x y scaling, if specified
	if ( iscal .eq. 1 ) then
	  xd  = abs( dxp(2) - dxp(1) )
	  yd  = abs( dyp(2) - dyp(1) )
	  xsc = xd / xp(1)
	  ysc = yd / yp(1)
	  sca = amax1( xsc, ysc )
	  if ( abs(sca) .lt. 1.e-20 ) sca = 1.e20
	  xp(1) = xd / sca
	  yp(1) = yd / sca
	endif
c
	call scale( dxp, dyp, xp, yp, 4, ier )
	if ( ier .ne. 0 ) stop
c
	if ( iscal .eq. 1 ) then
	if ( dy .lt. dx ) then
	 dx   = dy
	 fmtx = fmty
	 nx   = ny
	 else
	 dy   = dx
	 fmty = fmtx
	 ny   = nx
	endif
	endif
	call xaxis( dxp, dyp, xp, dx, 5, .08, ifmt, nx )
	call yaxis( dyp, dxp, yp, dy, 5, .08, jfmt, ny )
c
	return
	end
c*******************************************************************************
	subroutine du2pu( xdu, ydu, xpu, ypu )
	common /pltpar/  dxp(2), dyp(2), xp(4), yp(4),
	1                xscale, yscale, zscale

	if ( xscale .le. 0.0 ) xscale = abs( dxp(2) - dxp(1) ) / xp(1)
	if ( yscale .le. 0.0 ) yscale = abs( dyp(2) - dyp(1) ) / yp(1)

	xpu = ( xdu - dxp(1) ) / xscale  +  xp(3)
	ypu = ( ydu - dyp(1) ) / yscale  +  yp(3)

	return
	end
c*******************************************************************************
	subroutine xyequal( dxp, dyp, xpu, ypu )
c  input maximum plot widths
c  returns plot width with x and y scaled the same. 
	dimension dxp(2), dyp(2)
	xd  = abs( dxp(2) - dxp(1) )
	yd  = abs( dyp(2) - dyp(1) )
	xsc = xd / xpu
	ysc = yd / ypu
	sca = amax1( xsc, ysc )
	if ( abs(sca) .lt. 1.e-20 ) sca = 1.e20
	xpu = xd / sca
	ypu = yd / sca
	return
	end
c*******************************************************************************
	subroutine llpost
	common /llp/ latm(3),latx(3),longw(3),longe(3),cm(3),baslat(3),
	1     iproj,xxx(2),yyy(2),sizep,unit,iplotr,neat,tint,itpost,ib
	dimension scaf(3),range(2),xx(2),yy(2)
	real latm,latx,longw,longe
	character fmt*16
	logical nos,nom
	data d2r/1.7453292e-2/, conm/1.666667e-2/, cons/2.777778e-4/,
	1    scaf/39.370079,1.,.001/, west/-1.0/, icross/6/, nmax/8/
c
	dms2d(a,b,c) = a + sign(b,a) / 60. + sign(c,a) / 3600.
c
	if (iproj.lt.1 .or. iproj.gt.10) return
	sca = scaf(int(unit)+1)
	do i = 1, 2
	  xx(i) = xxx(i) / (1000.*sca)
	  yy(i) = yyy(i) / (1000.*sca)
	enddo
	hfx = 0.5*(xx(1)+xx(2))
	hfy = 0.5*(yy(1)+yy(2))
	if (iproj.gt.4) call setalb(iproj)
	bld = dms2d(baslat(1),baslat(2),baslat(3))
	cmd = dms2d(cm(1),cm(2),cm(3))
	if (abs(bld).gt.90. .or. abs(cmd).gt.360.) return
	call prjctl(bld,cmd,xb,yb,cmd,sca,iproj)
	ydm = dms2d(latm(1),latm(2),latm(3))
	ydx = dms2d(latx(1),latx(2),latx(3))
	xdm = dms2d(longw(1),longw(2),longw(3))
	xdx = dms2d(longe(1),longe(2),longe(3))
c  adjust cem for conic projection distance to equator
	cem = 4.0e7
	if(iproj.eq.4 .and. abs(bld).lt.15.) cem = 4.21e7
	if(iproj.gt.4 .and. abs(bld).lt.15.) cem = 3.84e7
	ce = cem*sca
	dt =  ( (yy(2)-yy(1))*360. ) / (ce*5.)
c  min-max latitude of area
	if (ydm.ge.ydx .or. ydm.eq.0.0 .or. ydx.eq.0.0) then
	  ydm = bld - dt + (yy(1)*360.) / ce
	  ydx = bld + dt + (yy(2)*360.) / ce
	  if (ydm.lt.-90.0) ydm = -90.0
	  if (ydx.gt.90.0)  ydx =  90.0
	  latx(1) = ydx
	  latm(1) = ydm
	endif
c  min-max longitude of area
	if (xdm.eq.0.0 .or. xdx.eq.0.0) then
	  cosp = cos(d2r * amax1( abs(ydx), abs(ydm) ))
	  if (cosp.lt.0.17364) cosp = .17364
	  xdm = cmd - dt + (xx(1)*360.) / (cosp*ce)
	  xdx = cmd + dt + (xx(2)*360.) / (cosp*ce)
	  longw(1) = xdm
	  longe(1) = xdx
	endif
c
c  default tick interval for less than nmax ticks per side
c  result is multiple of 1, 2 or 5 deg, min, or, sec
	if (tint.eq.0.0) return
	if (tint.lt.0.0) then
	range(1) = 0.0
	range(2) = amin1( (xdx-xdm), (ydx-ydm) )
	tint = 0.0
	dr = range(2)*60. / float(nmax)
	if(dr.ge.60.) then
	 call setax(range,tint,nmax,ndum,fmt)
	 tint = tint*60.
	else if(dr.ge.1. .and. dr.lt.60.) then
	 range(2) = range(2)*60.
	 call setax(range,tint,nmax,ndum,fmt)
	else
	 range(2) = range(2)*3600.
	 call setax(range,tint,nmax,ndum,fmt)
	 tint = tint / 60.
	endif
	endif
c  final initialization
	if (itpost.le.0) itpost = 2
	dt  = (aint(tint*60.+.0001)) / 3600.
	dt2 = dt*float(itpost)
	dt3 = dt2*60.0
	nos = .false.
	if (dt3-aint(dt3) .eq. 0.0) nos=.true.
	nom = .false.
	if (amod(dt3,60.0) .eq. 0.0) nom = .true.
	if (yy(2)-yy(1) .lt. 20.)  ydm = aint(60.*ydm)/60.
	if (yy(2)-yy(1) .ge. 20.)  ydm = aint(ydm+90.)-90.
	if (yy(2)-yy(1) .gt. 500.) ydm = 5.*aint((ydm+90.)/5.) - 90.
	if (xx(2)-xx(1) .lt. 20.)  xdm = aint(60.*xdm)/60.
	if (xx(2)-xx(1) .ge. 20.)  xdm = aint(xdm+360.)-360.
c     utm has a limit of 3 degrees
	if(xx(2)-xx(1).gt.500. .and. iproj.ne.2)
	1 xdm=5.*aint((xdm+360.)/5.) - 360.
c  plot longitude labels
	if(sizep.le.0.0) return
	xd=xdm
100	if(xd.gt.xdx) go to 190
	call dms(xd,id,im,is)
	id=west*id
	yd=ydm
105	call prjctl(yd,xd,x,y,cmd,sca,iproj)
	y=y-yb
	if(x.ge.xx(1).and.x.le.xx(2) .and.
	1 y.ge.yy(1).and.y.lt.hfy) go to 109
	yd=yd+dt
	if(yd-ydx) 105,105,110
109	call latlab(-1.,0,sizep,x,yy(1),id,im,is,nos,nom)
110	if(iplotr.eq.1 .or. iplotr.eq.4) go to 120
	yd=ydx
115	call prjctl(yd,xd,x,y,cmd,sca,iproj)
	y=y-yb
	if(x.ge.xx(1).and.x.le.xx(2) .and.
	1 y.gt.hfy.and.y.le.yy(2)) go to 119
	yd=yd-dt
	if(yd-ydm) 120,115,115
119	call latlab(1.,0,sizep,x,yy(2),id,im,is,nos,nom)
120	xd=xd+dt2
	go to 100
c  plot latitude labels
190	yd=ydm
200	if(yd.gt.ydx) go to 300
	call dms(yd,id,im,is)
	xd=xdm
205	call prjctl(yd,xd,x,y,cmd,sca,iproj)
	y=y-yb
	if(y.ge.yy(1).and.y.le.yy(2) .and.
	1 x.ge.xx(1).and.x.lt.hfx) go to 209
	xd=xd+dt
	if(xd-xdx) 205,205,210
209	call latlab(-1.,1,sizep,xx(1),y,id,im,is,nos,nom)
210	if(iplotr.eq.1 .or. iplotr.eq.4) go to 220
	xd=xdx
215	call prjctl(yd,xd,x,y,cmd,sca,iproj)
	y=y-yb
	if(y.ge.yy(1).and.y.le.yy(2) .and.
	1 x.gt.hfx.and.x.le.xx(2)) go to 219
	xd=xd-dt
	if(xd-xdm) 220,215,215
219	call latlab(1.,1,sizep,xx(2),y,id,im,is,nos,nom)
220	yd=yd+dt2
	go to 200
c  plot interior lat-lon ticks
300	yd=ydm
	do 360 j=1,int((ydx-yd)/dt)+1
	xd=xdm
	do 350 i=1,int((xdx-xd)/dt)+1
	call prjctl(yd,xd,x,y,cmd,sca,iproj)
	y=y-yb
	if(x.lt.xx(1) .or. x.gt.xx(2)) go to 350
	if(y.lt.yy(1) .or. y.gt.yy(2)) go to 350
	call vchar(x,y,icross,1,2,2.0*sizep,0.,0.,0.)
350	xd=xd+dt
360	yd=yd+dt
	return
	end
c*******************************************************************************
	subroutine dms(d,id,im,is)
	is = int( 3600.0*abs(d) + 0.5 )
	id = is / 3600
	im = (is - 3600*id) / 60
	is = is - (3600*id + 60*im)
	id = isign(id,int(d))
	return
	end
c*******************************************************************************
	subroutine latlab(side,lat,sz,x,y,jd,jm,js,nosec,nomin)
	dimension labint(3)
	character label*12,jd2*1,jm2*1,js2*1
	equivalence (labint,label)
	logical nosec,nomin
	jd2=char(24)
	jm2=char(39)
	js2=char(34)
	write(label,50) jd,jd2,jm,jm2,js,js2
50	format(i4,a1,2(i2,a1))
	if(jm.ne.0 .or. js.ne.0) nomin=.false.
	if(js.ne.0) nosec=.false.
	nch=11
	if(nosec) nch=8
	if(nomin) nch=5
	xl=nch*sz
	yof=0.
	if(lat.eq.1) then
	if(side.lt.0.) xof=-(2.*sz+xl)
	if(side.gt.0.) xof=2.*sz
	else
	xof=-xl/2.
	yof=2.*sz*side
	endif
	call vchar(x,y,labint,nch,2,sz,0.,xof,yof)
	return
	end
c******************************************************************************
	subroutine lowcase( a )
	character  a*(*)
	call cvc( a, 2 )
	return
	end
c*****************
	subroutine upcase( a )
	character  a*(*)
	call cvc( a, 1 )
	return
	end
c*****************
	subroutine cvc( a, i2 )
c  i2=1 for lower case to upper
	dimension  ilb(2), iub(2), icv(2)
	character  a*(*)
	data       ilb/97,65/, iub/122,90/, icv/-32,+32/

	n = len( a )

	do 10 i = 1, n
	  j      = ichar( a(i:i) )
	  if ( j .lt. ilb(i2)   .or.   j .gt. iub(i2) ) go to 10
	  j      = j + icv(i2)
	  a(i:i) = char(j)
10	continue

	return
	end
c*******************************************************************************
	subroutine stddevi( n, y, ymin, ymax, ymean, sigma )
c  One pass standard deviation, mean, and min/max.
c  Iterative improvement throws out elements beyond 4 sigma in an
c  attempt to correct for extreme elements.

	dimension         amean(5), asigma(5), mused(5), y(n)
	double precision  dbly, sy, sysq, dmean, foursig

	ymin    = 1.e30
	ymax    = -ymin
	ymean   = 0
	sigma   = 0
	if ( n .le. 0 ) return

	dmean   = 0.0d0
	foursig = 1.0d30
	iter    = 0

c  begin standard deviation calculation
1	mu      = 0
	sy      = 0.0d0
	sysq    = 0.0d0
	ymin    = 1.e35
	ymax    = -ymin

	do i = 1, n
	  if ( y(i) .lt. ymin ) ymin = y(i)
	  if ( y(i) .gt. ymax ) ymax = y(i)
	  dbly = dble( y(i) )
	  if ( dabs( dbly - dmean ) .lt. foursig ) then
	    mu   = mu   + 1
	    sy   = sy   + dbly
	    sysq = sysq + dbly * dbly
	  endif
	enddo

	ymean = 0
	sigma = 0	

	if ( mu .lt. 1 )          go to 999
	ym    = float( mu )
	ymean = sngl( sy ) / ym

	if ( mu .lt. 2 )          go to 999
	a     = sngl( dble( ym ) * sysq - sy*sy ) /
	1          ( ym * ( ym - 1.0 ) )  

	if ( a .lt. 1.e-30 )     go to 999
	sigma = sqrt( a )

c  store results
100	iter         = iter + 1
	mused(iter)  = mu
	amean(iter)  = ymean
	asigma(iter) = sigma

	if ( iter .lt. 5 ) then
	  dmean   = dble( ymean )
	  foursig = dble( 4. * sigma )
	  if ( iter .eq. 1 ) go to 1
	  if ( mused(iter-1) .ne. mused(iter) ) go to 1
	endif

	if ( iter .gt. 3 ) then
	  type *, ' stddevi: iterative summary,  n input elements = ', n 
	  type *, '      n       mean       sigma'
	  do i = 1, iter
	    type *, mused(i), amean(i), asigma(i)
	  enddo
	endif

999	return
	end
c*******************************************************************************
	function rightj( a )
	character a*(*)
	na     = len( a )
	rightj = 0.0

	do ie = na, 1, -1
	  if ( a(ie:ie) .ne. ' ' ) then
	    if ( ie .eq. na ) return

	    j = na
	    do i = ie, 1, -1 
	      a(j:j) = a(i:i)
	      j = j - 1
	    enddo

	    do k = j, 1, -1
	      a(k:k) = ' '
	    enddo
	    return

	  endif
	enddo

	return
	end
c******************************************************************************
	subroutine ammi( n, a, amn, amx, mn, mx, isave )
	dimension a(n)
	if ( isave .gt. 1 ) go to 1
	mn  = 1
	mx  = 1 
	amn = a(1)
	amx = a(1)
1	do 3 i = 1, n
	  if ( a(i) .ge. amn ) go to 2
	  amn = a(i)
	  mn  = i
2	  if ( a(i) .le. amx ) go to 3
	  amx = a(i)
	  mx  = i
3	continue
	return
	end
c******************************************************************************
	subroutine text( x, y, string, size, angle )
c  text driver where x,y are in plot units.
	dimension   is(25)
	character   s*100
	character   string*(*)
	equivalence (is,s)
	data        icode/3/, xoff,yoff/0.0,0.0/

	sizet  = size
	lenstr = len(string)
	do nch = lenstr, 1, -1
	  ich = ichar( string(nch:nch) )
	  if ( ich .gt. 32  .and.  ich .lt. 127 ) go to 10
	enddo
	return
10	s(1:nch) = string(1:nch)
	radian   = 1.7453292e-2 * angle
	call vchar( x, y, is, nch, icode, sizet, radian, xoff, yoff )
	return
	end
c******************************************************************************
	subroutine symbol( x, y, nxy, ich, size, angle )
c  symbol driver where x,y are in data units (clipping occurs outside
c  the data window).
c  'ich' is an integer akin to fortran 77 coding ich=038=ichar('&').
c  'vchar'  uses 1-13, 24-31 for symbols such as diamonds and squares, 
c  and 32-126 as the normal ascii character sequence when icode=1.
	dimension x(nxy), y(nxy)
	data      icode/1/, xoff,yoff/ 0.0, 0.0 /
	radian = 1.7453292e-2 * angle
	call vchar( x, y, ich, nxy, icode, size, radian, xoff, yoff )
	return
	end
c******************************************************************************
	subroutine setax( x, dx, maxint, nch, fmt )
c  adjust interval and labeling format
c  input x-min max range, optional dx-spacing and maxint-intervals
c  returns dx, nch-number of significant figures, fmt-labeling format
	dimension    x(2)
	character    fmt*(*)
	ixpon(r) =   int( alog10( abs( r ) ) + 100. ) - 100

	fmt  = '(1pe13.6)'
	nch  = 13
	maxi = maxint
	if ( maxi .le. 0 )  maxi = 20
	dt   = abs( x(2) - x(1) ) / float( maxi )
	if ( dt .lt. 1.e-20 ) then
	  dx = 1.0e20
	  return
	endif
	if ( dx .eq. 0.0 ) then
	  p10 = 10. ** ixpon( dt )
	  t1  = dt / p10
	  if ( t1 .le. 1.0 ) dx =       p10
	  if ( t1 .gt. 1.0 ) dx =  2. * p10
	  if ( t1 .gt. 2.0 ) dx =  5. * p10
	  if ( t1 .gt. 5.0 ) dx = 10. * p10
	endif
	m10 = ixpon( dx )
	m20 = ixpon( amax1( abs( x(1) ), abs( x(2) ) ) )
	if ( x(1) .gt. x(2) ) dx = -abs( dx )

	idecm = 0
	if ( m10 .lt. 0 ) idecm = iabs( m10 )
	iw    = 4 + idecm
	if ( m20 .ge. 1 ) iw = iw + m20
	if (  iw .gt. 9   .or.   idecm .gt. 9 ) go to 99

	write( fmt, 10 ) iw, idecm
10	format(  '(f', i1, '.', i1, ')'   )
	nch = iw
	if ( idecm .eq. 0 ) nch = nch - 1
99	return
	end
c******************************************************************************
	subroutine getfn(ifile,suffix,ofile)
c  strip off old extension and specified device/directory and add new suffix.
c  VAX filename conventions:    device:[directory]filename.extension
c  directory is level(n).level(n+1).level(n+2)...
	character ifile*(*),suffix*(*),ofile*(*)

	lenin = len(ifile)
	lenou = len(ofile)
	ofile = ' '
c  strip off device/directory and default to the working directory
	m = index(ifile,']') + 1
	n = lenin - m + 1
	ofile(1:n) = ifile(m:lenin)

c  find nonblank length
10	lennb=0
	do i = n, 1, -1
	  if(ofile(i:i).ne.' ' .and. lennb.eq.0) lennb=i
	enddo
	if(lennb.eq.0) then
	  type *,' getfn: cannot parse filename, enter new prefix'
	  type *,'        to go with the suffix ',suffix
	  read(5,*,err=10) ofile
	  go to 10
	endif

c  terminate prefix with period.
	n = index(ofile,'.')
	if (n .eq. 0) then
	  n = lennb + 1
	  ofile(n:n)='.'
	endif	

	m = n + 1
	lens = len(suffix)
	n = n + lens
	ofile(m:n) = suffix(1:lens)

	do i = n+1, lenou
	  ofile(i:i) = ' '
	enddo
	return
	end
c*******************************************************************************
	subroutine suffix( file, ext, file2 )
c  change file extension.
c  find last period and append 'ext'.
	character*(*) file, ext, file2

	nc1   = len( file )
	ns    = len( ext )
	lastc = 0

	do i = nc1, 1, -1
	if ( lastc .eq. 0  .and.  file(i:i) .ne. ' ' ) lastc = i
	if ( file(i:i) .eq. '.' ) then
	  ie = i + ns
	  file2(1:ie) = file(1:i) // ext 
	  go to 99
	endif
	enddo

c  if no periods
	if ( lastc .gt. 0 ) then
	  file2 = file(1:lastc) // '.' // ext
	  else
	  file2 = ext
	endif

99	return
	end	  
c******************************************************************************
	function leftj(a)
c  left justifies a string and returns the position
c  of the last nonblank character
	character a*(*)
	n = len(a)
	ich = ichar(a(1:1))
	if (ich.ne.0 .and. ich.ne.32) go to 15
	do 1 m = 2, n
	ich = ichar(a(m:m))
1	if (ich.ne.0 .and. ich.ne.32) go to 5
	leftj = 0
	return
c
5	i2 = 0
	do 10 i = m, n
	i2 = i2 + 1
	a(i2:i2) = a(i:i)
10	continue
	do 11 i3 = i2+1, n
11	a(i3:i3) = ' '
	n = n-m+1
c
15	do 20 leftj = n, 1, -1
	ich = ichar(a(leftj:leftj))
20	if (ich.ne.0 .and. ich.ne.32) go to 25
25	return
	end
c******************************************************************************
	function noyes()
c  returns -1 for indeterminate, 0 for no, 1 for yes
	character  inp*4, blank*4
	data       blank/ '    ' /

	icnt  = 0
	noyes = -1

1	inp   = ' '
	read ( 5, 2, end=5, err=5 ) inp
2	format( a )
	if ( inp .eq. blank ) return

	do 3 n = 1, 4
	  if ( inp(n:n) .ne. ' ' ) then
	    if ( inp(n:n).eq.'y' .or. inp(n:n).eq.'Y' ) noyes = 1
	    if ( inp(n:n).eq.'n' .or. inp(n:n).eq.'N' ) noyes = 0
	    if ( noyes .gt. -1 ) return
	    go to 5
	  endif
3	continue

5	if ( icnt .lt. 3 ) then
	  icnt = icnt + 1
	  write( 6, * ) ' <cr>, no, or yes :'
	  go to 1
	endif

	write( 6, * ) ' count exceeded, returning indeterminate state '
9	return
	end
c******************************************************************************
	subroutine user( prog )
	integer       total(20), testi(40)
	character*8   prog, test(20)
	equivalence   (test,testi)

	open( unit=8, file='user$disk:[mwebring.work]usage.dat;1',
	1 access='direct', status='old', form='unformatted', recl=60,
	1 iostat=ios )
	if ( ios .ne. 0 ) return

	read( 8, rec=1, err=99 ) testi, total
	do 10 i=1, 20
	if ( prog .eq. test(i) ) go to 20
10	continue
	go to 99

20	total(i) = total(i) + 1
	write( 8, rec=1, err=99 ) testi, total
99	close(8)
	return
	end
	subroutine prjctl(ylat,xlon,x,y,cm,sfac,iprojt)
c  call projection routines
	double precision yl,xl,x1,y1,degr
	data degr/.0174532925199433d0/
	yl=dble(ylat)*degr
	xl=dble(xlon-cm)*degr
	go to (1,2,3,4,5,5,5,8,9),iprojt
1	call poly(yl,xl,x1,y1)
	go to 20
2	call utmfwd(yl,xl,x1,y1,ier)
	go to 20
3	call merctr(yl,xl,x1,y1)
	go to 20
4	call lambert(yl,xl,x1,y1)
	go to 20
5	call albers(yl,xl,x1,y1)
	go to 20
8	call polars(yl,xl,x1,y1)
	go to 20
9	call transm(yl,xl,x1,y1)
20	x=sngl(x1)*sfac
	y=sngl(y1)*sfac
	return
	end
      subroutine poly(phi,dlamb,x,y)
      double precision phi,dlamb,xc,x,y,a,b,t,q,phi2,c1,c2
      a(xc)=
     1   6.378206402718907d 06 +xc*(
     1  -3.167517353503576d 06 +xc*(
     1   2.478805037574243d 05 +xc*(
     1  -3.530710396439220d 03 +xc*(
     1  -6.565371848240127d 02 +xc*(
     1   6.822539551727124d 01 +xc*(
     1  -2.888860980506611d 00 ))))))
      b(xc)=
     1   3.189103200618349d 06 +xc*(
     1  -2.115275857345996d 06 +xc*(
     1   4.144758431728325d 05 +xc*(
     1  -3.625295427368928d 04 +xc*(
     1   1.322429746943889d 03 +xc*(
     1   4.427183005616853d 01 +xc*(
     1  -8.630738701658902d 00 +xc*(
     1   4.279183401413811d-01 )))))))
      q(xc)=
     1   6.335034386662446d 06 +xc*(
     1   2.144094496614083d 04 +xc*(
     1  -4.182226973512467d 03 +xc*(
     1   3.609995316780635d 02 +xc*(
     1  -1.346978283534684d 01 ))))
      t(xc)=
     1   9.999999957157490d-01+xc*(
     1  -1.666665796975878d-01+xc*(
     1   8.333050613721043d-03+xc*(
     1  -1.980904608528695d-04+xc*
     1   2.605165638554101d-06 )))
      phi2=phi**2
      c1=dlamb*phi
      c2=(c1*t(phi2))**2
      x=dlamb*a(phi2)*t(c2)
      y=dlamb*c1   *b(phi2)*t(.25d0*c2)**2 + phi*q(phi2)
      return
      end
	subroutine utmfwd(phi,dlam,x,y)
c  developed by g.i. evenden, usgs
	double precision phi,dlam,x,y,dl2,p
	p=phi*phi
	dl2=dlam*dlam
	if (p .le.1.94965360d0.and.dl2.le.3.7319881d-3)
	1    go to 10
	x=1.d30
	y=1.d30
	return
10	y=phi*(
	1     6332500.47d0+p*(21431.67d0+p*(-4179.269d0+p*(
	1     359.981d0-p*13.267d0)))
	1 -dl2*(-3187827d0+p*(2114440d0+p*(-414363.5d0+p*(
	1     36344.6d0-p*1420.3d0)))
	1  -dl2*(1334935d0+p*(-2356027d0+p*(1371758d0-p*
	1     267852d0)))))
	x=dlam*(6375655.2d0+p*(-3166253.6d0+p*(247800.26d0+p*(
	1     -3569.65d0+p*(-617.35d0+p*50.89d0))))
	1  -dl2*(-1069479d0+p*(2661562d0+p*(-1785956d0+p*(
	1    485045d0-p*52022d0)))))
	return
	end
	subroutine merctr(lat,long,x,y)
	double precision lat,long,x,y,a,halfpi,b2da2,z,phi
	data a/6378206.d0/,halfpi/1.57079632679489d0/,
	1 b2da2/9.932315290818186d-1/
	x=a*long
c	compute z/2
	z=0.5d0*(halfpi-datan(b2da2*dsin(lat)/dcos(lat)))
	y=a*dlog(dcos(z)/dsin(z))
	return
	end
      subroutine lambert(ylat,xlon,x,y)
      implicit double precision(a-h,o-z)
      save fn,fk
c
c   Lambert Conformal Conic forward projection program using
c    Clark 1866 ellipsoidal earth.  (See Map Projections Used by
c    the U. S. Geological Survey, GS Bulletin 1532, pp. 107-108.)
c
c      Input:  ylat - Latitude in radians.
c              xlon - Longitude in radians, east of central meridian.
c      Output: x    - Distance in meters east of central meridan.
c              y    - Distance in meters (negative) south of 90 degrees lat.
c
c    Note that if setlam entry is not called prior to calling
c     subroutine lambert, the constants fn & fk are set to calculate
c     x & y for standard parallels of 33. & 45. degrees.
c
      data a/6378206.4d0/,e2/.006768657997291099d0/
      data pi4/.785398163397448310d0/,e/.82271854223003258d-1/
      data b2da2/.993231342002708901d0/
      data fn/.63049989185603457d0/,fk/.124526547337527528d8/
      z=pi4-.5d0*datan(b2da2*(dtan(ylat)))
      r=fk*dtan(z)**fn
      theta=fn*xlon
      x=r*dsin(theta)
      y=-r*dcos(theta)
      return
c
      entry setlam(ylat1,ylat2)
c
c   This entry sets up the Lambert Conformal Conic constants for
c     standard parallels ylat1 & ylat2, entered in radians, using the
c     Clark 1866 ellipsoidal earth parameters of a = 6378206.4 meters
c     & b = 6356583.8 meters.  Note that e**2 = (a*a - b*b) / (a*a).
c
	if(ylat1.ne.ylat2 .and. ylat1*ylat2.gt.0.d0) go to 2
	type  1,ylat1,ylat2
1	format(2f10.3,' incorrect standard parallels, 33 & 45 will be used')
	ylat1=.575958656d0
	ylat2=.785398167d0
2     cos1=dcos(ylat1)
      cos2=dcos(ylat2)
      sin1=dsin(ylat1)
      sin2=dsin(ylat2)
      esin1=e*sin1
      esin2=e*sin2
      fm1=cos1/dsqrt(1.d0-e2*sin1*sin1)
      fm2=cos2/dsqrt(1.d0-e2*sin2*sin2)
      t1=dtan(pi4-.5d0*datan(b2da2*(sin1/cos1)))
      t2=dtan(pi4-.5d0*datan(b2da2*(sin2/cos2)))
      fn=(dlog(fm1)-dlog(fm2))/(dlog(t1)-dlog(t2))
      fk=a*fm1/(fn*t1**fn)
      return
      end
	subroutine albers(ylat,xlon,x,y)
	double precision ylat,xlon,x,y,n,rho1sq,sinbt1,twoc2n,
	1 nus,nals,nhaw,rho295,rho55,rho8,tcnus,tcnals,tcnhaw,
	1 a1,b,c1,d,e1,f1,g,h,theta,rho,sinbet,sinphi,s2
	data a1/9.954804334645587d-1/,b/4.492024607745888d-3/,
	1 c1/2.736435989866449d-5/,d/1.763992166249299d-7/,
	1 e1/1.160814577272288d-9/,f1/7.714265487727804d-12/,
	1 g/5.154557173568170d-14/,h/3.455700205911349d-16/,
	1 nus/6.02903493787094d-1/,nals/8.627447947235633d-1/,
	1 nhaw/2.241096394314637d-1/,rho295/8.49196923967458d13/,
	1 rho55/1.806308673895081d13/,rho8/7.943986660586285d14/,
	1 tcnus/1.346470921892769d14/,tcnals/9.409410848453636d13/,
	1 tcnhaw/3.622298555079059d14/,sbt295/4.907351753179611d-1/,
	1 sbt55/8.1792905450587868d-1/,sbt8/1.385562096187223d-1/
	sinphi=dsin(ylat)
	s2=sinphi*sinphi
	sinbet=sinphi*(a1+s2*(b+s2*(c1+s2*(d+s2*
	1 (e1+s2*(f1+s2*(g+s2*h)))))))
	rho=dsqrt(rho1sq+twoc2n*(sinbt1-sinbet))
	theta=n*xlon
	x=rho*dsin(theta)
	y=-rho*dcos(theta)
	return
c
c set up constants
	entry setalb(iproj)
	if(iproj-6)500,510,520
500	n=nus
	rho1sq=rho295
	sinbt1=sbt295
	twoc2n=tcnus
	return
510	n=nals
	rho1sq=rho55
	sinbt1=sbt55
	twoc2n=tcnals
	return
520	n=nhaw
	rho1sq=rho8
	sinbt1=sbt8
	twoc2n=tcnhaw
	return
	end
	subroutine polars(ylat,xlon,x,y)
c   polar stereographic projection
c  partially checked by mike webring
c  there is about 1% error with polarr calculated this way,
c  but the form should be (1+e)/(1-e) (?) which makes bigger errors.
c  basic routine is due to kay edwards, flagstaff
	implicit double precision (a-h,o-z)
	data e/8.1820567882165d-2/,r/6378160d0/,rad45/.785398163397448d0/,
	1 ee/4.09102839410826d-2/,polarr/12713644.51d0/
	dlat=dabs(ylat)
c	polarr=(2.d0*r/dsqrt(1.d0-e*e)) * ((1.d0-e)/(1.d0+e))**ee
	sinc=e*dsin(dlat)
	sine=(1.d0+sinc)/(1.d0-sinc)
	dlat2=dlat*.5d0
	tane2=rad45+dlat2
	tane1=dcos(tane2)/dsin(tane2)
	tanz=tane1*(sine**ee)
	p=tanz*polarr
	y=-(p*dcos(xlon))
	x=p*dsin(xlon)
	if(ylat.lt.0.d0) y=-y
c	scale=p*dsqrt(1.d0-e*e*dsin(dlat)**2)/dcos(dlat)/r
	return
	end
      subroutine transm(ylat,xlon,x,y)
c
c   Transverse Mercator forward projection program using spherical
c     earth of radius 6371204. meters.  This is the radius of a
c     spherical earth of equivalent surface area to the Clark 1866
c     ellipsoid.  Note that the constant rsf is the product of this
c     radius and a scale factor of 0.926.  The scale factor is present
c     to balance the scale errors over North America.
c
c     input:  ylat - Latitude in radians.
c             xlon - Longitude in radians, east of central meridian.
c     output: x    - Distance in meters east of central meridian.
c             y    - Distance in meters north of equator.
c
      double precision ylat,xlon,x,y,rsf,b
      data rsf/5899734.904d0/
      b=dcos(ylat)*dsin(xlon)
      x=0.5d0*rsf*dlog((1.d0+b)/(1.d0-b))
      y=rsf*datan(dtan(ylat)/dcos(xlon))
      return
      end
