c
c             program gmerge
c  Merge two grids without interpolation, no restriction on placement.
c  Intersection is handled in two modes: (1) primary has priority and
c  secondary only overwrites dvals and (2) secondary has priority.
c
	common /gmerge/ r(2000), r2(2000), r3(2000)
	character*56    f1, f2
	data isw,jsw,ksw/13,14,15/, dval/'ffff7fff'x/
	type *, ' first input grid :'
	accept 1, f1
1	format(a)
	open (unit=isw, file=f1, status='old', form='unformatted',
	1     readonly)
	type *, ' second input grid :'
	accept 1, f2
	open (unit=jsw, file=f2, status='old', form='unformatted',
	1     readonly)
c
	call gmrg( dval, isw, jsw, ksw, r, r2, r3 )
c
	close(isw)
	close(jsw)
	close(ksw)
	stop
	end
c******************************************************************************
	subroutine gmrg( dval, isw, jsw, ksw, r, r2, r3 )
	dimension r(1),r2(1),r3(1)
	character id*56, p*8, f3*56
	logical   dump1, dump2, primry, ovrwrt
	fltbig = 1.e29
	primry = .true.
	ovrwrt = .true.
c
	type *, ' merged output grid :'
	accept 1, f3
1	format(a)
c
	type  10
10	format(' does the first grid have priority ? '$)
	if ( noyes(ldum) .eq. 1 ) ovrwrt = .false.
c
	read (isw) id,p, nc, nr, nz, xo, dx, yo, dy
	read (jsw) id,p, nc2,nr2,nz, xo2,dx2,yo2,dy2
	if ( dx .eq. 0.0 ) stop ' dx = 0'
	if ( dy .eq. 0.0 ) stop ' dy = 0'
	testdx = abs( ( dx - dx2 ) / dx )
	testdy = abs( ( dy - dy2 ) / dy )
	if ( testdx .gt. 0.001 ) stop ' dx.ne.dx2'
	if ( testdy .gt. 0.001 ) stop ' dy.ne.dy2'
	flipx = 1.0
	flipy = 1.0
	if ( dx .lt. 0.0 ) then
	  xo  = -xo
	  xo2 = -xo2
	  dx  = -dx
	  flipx = -1.0
	endif
	if ( dy .lt. 0.0 ) then
	  yo  = -xo
	  yo2 = -yo2
	  dy  = -dy
	  flipy = -1.0
	endif
c
	istop = 0
	gu    = abs ( ( xo2 - xo ) / dx )
	xt    = gu - aint( gu )
	if ( xt .le. 0.9  .and.  xt .ge. 0.1 ) then
	  type *, ' xo, xo2, grid unit offset', xo, xo2, xt
	  type *, ' x misregistered more than .1 unit'
	  istop = 1
	endif
c
	gu = abs ( ( yo2 - yo ) / dy )
	yt = gu - aint( gu )
	if ( yt .le. 0.9  .and.  yt .ge. 0.1 ) then
	  type *, ' yo, yo2, grid unit offset', yo, yo2, yt
	  type *, ' y misregistered more than .1 unit'
	  istop = 1
	endif
	if ( istop .eq. 1 ) stop
c
	xm1  = xo  +  dx*float(nc-1)
	xm2  = xo2 + dx2*float(nc2-1)
	xmin = xo
	if ( xo2 .lt. xo ) xmin = xo2
	xmax = xm1
	if ( xm2 .gt. xm1 ) xmax = xm2
c
	ym1  = yo  +  dy*float(nr-1)
	ym2  = yo2 + dy2*float(nr2-1)
	ymin = yo
	if ( yo2 .lt. yo ) ymin = yo2
	ymax = ym1
	if ( ym2 .gt. ym1 ) ymax = ym2
c
	nc3 = 1 + int(((xmax-xmin)/dx) + 0.1)
	nr3 = 1 + int(((ymax-ymin)/dy) + 0.1)
	type  50, nc3, nr3
50	format(' output cols, rows = ',2i5)
	if ( nc3 .gt. 2000 ) stop ' output columns > 2000'
	xo3 = flipx*xmin
	yo3 = flipy*ymin
	dx3 = flipx*dx
	dy3 = flipy*dy
c
	length = nc3 + 1
	if ( length .lt. 26 ) length = 26
	open ( unit=ksw, file=f3, status='new', form='unformatted',
	1      recl=length, recordtype='fixed', access='sequential' )
	write (ksw) id,p, nc3,nr3,nz, xo3,dx3,yo3,dy3, 
	1           iproj, cm, baslat
c
	ir1 = 1 + int( ((xo-xmin)/dx) + 0.1)
	ir2 = 1 + int( ((xo2-xmin)/dx)+ 0.1)
	dump1 = .true.
	dump2 = .true.
	dyerr = 0.1*dy
	yu = ymin + dyerr
	yl = ymin - dyerr
	iout  = 0
	irow1 = 0
	irow2 = 0
c
c  initialize output row
100	do i = 1, nc3
	  r3(i) = dval
	enddo
c
c  input row 1
	if (dump1) then
	  call rowio (nc,r,-1,isw,isw,ie1)
	  do i = 1, nc
	    if ( r(i) .gt. fltbig ) r(i) = dval
	  enddo
	  dump1 = .false.
	  y1    = yo + dy*float(irow1)
	  irow1 = irow1 + 1
	endif
c
c  input row 2
	if (dump2) then
	  call rowio( nc2, r2, -1, jsw, jsw, ie2 )
	  do i = 1, nc2
	   if ( r2(i) .gt. fltbig ) r2(i) = dval
	  enddo
	  dump2 = .false.
	  y2    = yo2 + dy*float(irow2)
	  irow2 = irow2 + 1
	endif
c
c  insert row 1
	if( ie1.eq.0 .and. y1.gt.yl .and. y1.lt.yu ) then
	  call xfer( dval, nc, r, ir1, nc3, r3, primry )
	  dump1 = .true.
	endif
c
c  insert row 2
	if ( ie2.eq.0 .and. y2.gt.yl .and. y2.lt.yu ) then
	  call xfer( dval, nc2, r2, ir2, nc3, r3, ovrwrt )
	  dump2 = .true.
	endif
c
c  output row
	call rowio(nc3, r3, 0, ksw, ksw, ie )
	yout = ymin + dy*float(iout)
	yu   = yout + dyerr
	yl   = yout - dyerr
	iout = iout + 1
	if ( iout .eq. nr3 ) go to 999
	if ( irow1 .lt. nr .or. irow2 .lt. nr2 ) go to 100
c
	type 210,iout,nr3
210	format( ' output',i4,' needed',i4)
999	return
	end
c******************************************************************************
	subroutine xfer(dval, nc, r, istart, nc3, r3, ovrwrt )
	dimension r(nc), r3(nc3)
	logical ovrwrt
	iend = istart - 1 + nc
	if (istart.le.0 .or. iend.gt.nc3) stop ' xfer: index error'
	j = istart
	do i = 1, nc
	if (r(i).lt.dval) then
	  if (ovrwrt) then
	    r3(j)=r(i)
	    else if (r3(j).eq.dval) then
	    r3(j)=r(i)
	  endif
	endif
	j = j + 1
	enddo
	return
	end
c******************************************************************************
	function noyes(idum)
	character inp*8
	icnt = 0
	noyes = -1
1	inp = ' '
	read (5,2,end=5,err=5) inp
2	format(a8)
	do n = 1,8
	  if (inp(n:n).ne.' ') then
	    if (inp(n:n).eq.'y' .or. inp(n:n).eq.'Y') noyes = 1
	    if (inp(n:n).eq.'n' .or. inp(n:n).eq.'N') noyes = 0
	    if (noyes.gt.-1) return
	    go to 5
	  endif
	enddo
5	if (icnt.lt.3) then
	  icnt = icnt + 1
	  type  6
6	  format(' y or n:'$)
	  go to 1
	endif
	type *,' count exceeded, answering no'
	noyes = 0
	return
	end
c******************************************************************************
	subroutine rowio(n,z,iop,idev,jdev,iend)
c  read iop<0, write iop=0, r&w iop=1
	dimension z(n)
	iend=0
	if(iop)1,2,1
1	read(idev,end=10) y,z
	if(iop)9,9,2
2	write(jdev) y,z
9	return
10	iend=1
	return
	end
