c        program gradient
c
c  2-d derivative operations
c  incomplete grids have blank areas flagged by > 1.e29.
c  coded by mike webring usgs
c
	common /illum/  azmuth,sunele,sx,sy,sz,const
	common /header/ id,p
	dimension z(10000)
	character id*56,id2*56,p*8,muse*8
	character*8 p2(7)
	data nwrk/10000/,dval/'ffff7fff'x/,isw,jsw,ksw,lsw/10,11,12,13/
	data const/128./,muse/'gradient'/,p2/'gradient','illumin ',
	1 'xpartial','ypartial','dircos x','dircos y','dircos z'/
c  dval (default grid value) is the maximum VAX floating point number
c  fltbig is a dval testing value
	fltbig=1.0e30
	type 10
10	format(' input grid :'$)
	read(5,37) id
37	format(a56)
	open(isw,file=id,status='old',form='unformatted')
	read(isw) id,p,nc,nr,nz,xo,dx,yo,dy
	type 60,id,p,nc,nr,xo,yo,dx,dy
60	format(/,' title:',a56,'pgm:',a8,/,' nc x nr ',2i5,/,' xo, yo=',
	1 1p2g13.5,'  dx, dy=',1p2g11.3)
	type 40
40	format(/,' output grid :'$)
	read(5,37) id
	open(jsw,file=id,status='new',form='unformatted')
	type 50
50	format(' output title :'$)
	read(5,37) id2
	type 20
20	format(' 1 = gradient magnitude',/,
	1 ' 2 = surface illumination',/,
	1 ' 3,4 = x,y partial derivative',/,
	1 ' 5,6,7 = x,y,z direction cosine',/,
	1 ' enter function # : '$)
	read(5,*) isurf
	if(isurf.eq.2) then
	type 70
70	format(' (east is zero and positive azimuth is counter-clockwise',/,
	1 ' elevation=0 is horizontal, =90 is ''noon'')',/,
	1 ' enter illumination azimuth and elevation : '$)
	read(5,*) azmuth,sunele
	if(sunele.gt.180. .or. sunele.lt.0.)
	1 stop ' back illumination'
	endif
	type 30
30	format(' enter operator length (3,5,7) :'$)
	read(5,*) iw
	if(iw.eq.3 .or. iw.eq.5 .or. iw.eq.7) then
	  nc2=nc+iw-1
	  nbuf=iw*nc2
	  if(3*nc2+nbuf.gt.nwrk) stop ' ran out of space'
	else
	  stop ' incorrect operator length'
	endif
c
	do 100 j=1,nr
	call rowio(nc,z,-1,isw,isw,iend)
	do 100 i=1,nc
	if(z(i).gt.fltbig) go to 110
100	continue
	call deriv2(isurf,iw,nc,nr,z,z(nbuf+1),isw,jsw,id2,p2(isurf))
	go to 999
c
110	continue
	open(ksw,file='grad1.tmp',status='new',form='unformatted')
	call fill2(z,nwrk,fltbig,isw,ksw)
	open(lsw,file='grad2.tmp',status='new',form='unformatted')
	n2=nc*iw+1
	n3=n2+nc
	n4=n3+nc
	call ave2d(3,fltbig,nc,5,z,z(n2),z(n3),z(n4),ksw,lsw,isw)
	call deriv2(isurf,iw,nc,nr,z,z(nbuf+1),lsw,ksw,id2,p2(isurf))
	rewind isw
	rewind ksw
	read(isw)
	read(ksw)  id,p,nc,nr,nz,xo,dx,yo,dy
	write(jsw) id,p,nc,nr,nz,xo,dx,yo,dy
	do 150 j=1,nr
	call rowio(nc,z,-1,isw,isw,iend)
	call rowio(nc,z(nc+1),-1,ksw,ksw,iend)
	do 140 i=1,nc
	if(z(i).gt.fltbig) z(nc+i)=dval
140	continue
	call rowio(nc,z(nc+1),0,jsw,jsw,iend)
150	continue
	close(ksw)
	close(lsw)
999	close(isw)
	close(jsw)
	stop
	end
c***********************************************************************
	subroutine deriv2(ifunc,iw,nc,nr,z,r,isw,jsw,id2,p2)
c  1  gradient magnitude
c  2  surface illumination
c  3  x partial derivative
c  4  y partial derivative
c  5  x direction cosine
c  6  y direction cosine
c  7  z direction cosine	
	common /illum/ azmuth, sunele, sx, sy, sz, const
	dimension      dir(3000)
	dimension      na(3), opr(3), opr3(1), opr5(2), opr7(3), factm(7)
	dimension      z(nc+iw-1,iw), r(nc)

	character      id*56, id2*56, p*8, p2*8
	logical        xderiv, yderiv
	data           dval/ 'ffff7fff'x /
	data           ydum/0./, factm/0.,0.,2.,6.,24.,120.,720./
	data opr3/1./, opr5/ 16.,   -2./,
	1              opr7/540., -108., 12./

37	format( a )
	r2d = 180. / 3.1415927
	if (ifunc.lt.1 .or. ifunc.gt.7) stop ' deriv2: invalid function'
	if (iw.lt.3 .or. iw.gt.7) stop ' deriv2: 3 <= opr length <= 7'

	ihw  = ( iw - 1 ) / 2
	ihw1 = ihw + 1
	if ( ihw + ihw1 .ne. iw ) stop ' deriv2: iw must be odd'

	if ( ifunc .eq. 2 ) then
	  t  =     cos( sunele / r2d )
	  sx = t * cos( azmuth / r2d )
	  sy = t * sin( azmuth / r2d )
	  sz =     sin( sunele / r2d )
	endif
	ihr    = iw - ihw1
	nc2    = nc + ihw + ihr
	xderiv = .true.
	yderiv = .true.
	if ( ifunc .eq. 3 ) yderiv = .false.
	if ( ifunc .eq. 4 ) xderiv = .false.

	rewind isw
	rewind jsw
	read( isw ) id, p, na, xo, dx, yo, dy
	if (dx.eq.0. .or. dy.eq.0. .or. dx.ne.dy )
	1   stop ' grid must be equally spaced in x&y'
	write( jsw ) id2, p2, na, xo, dx, yo, dy

	if ( ifunc .eq. 1 ) then
	  type *, ' Enter minimum gradient magnitude '
	  type *, ' defining valid strike direction. '
	  accept *, tol
	  type *, ' enter title for gradient strike grid'
	  accept 37, id2
	  length = na(1) + 1
	  if ( length .lt. 30 ) length = 30
	  open( 20, file='strike.grd', status='new', form='unformatted' )
	  write(20) id2, p2, na, xo, dx, yo, dy
	endif

c  select operator
	labl = (iw-1)/2
	do 30 i = 1, ihw
	go to (23,25,27) labl
23	opr(i) = opr3(i)
	go to 30
25	opr(i) = opr5(i)
	go to 30
27	opr(i) = opr7(i)
30	continue
	rwt = 1.0 / ( dx * factm(iw) )

c  initialize buffer
	irow = 0
	do 50 j = ihw1, iw
	call rowio( nc, z(ihw1,j), -1, isw, jsw, iend )
	irow = irow + 1
	i2   = iw
	do i = 1, ihw
	  z(i,j) = 2.0 * z(ihw1,j) - z(i2,j)
	  i2     = i2 - 1
	enddo
	ie = ihw + nc
	i2 = ie  - 1
	do i = ie + 1, nc2
	  z(i,j) = 2.0 * z(ie,j) - z(i2,j)
	  i2     = i2 - 1
	enddo
50	continue

	j2 = iw
	do j = 1, ihw
	  do i = 1, nc
	    z(i,j) = 2.0 * z(i,ihw1) - z(i,j2)
	  enddo
	  j2 = j2 - 1
	enddo

c  cycle thru mesh
	jend = iw
	do 300 jp = 1, nr
	do 200 ip = 1, nc

	if ( xderiv ) then
	  tx = 0.0
	  i2 = ip + ihw1
	  i3 = ip + ihw - 1
	  do k = 1, ihw
	    tx = (tx + opr(k) * z(i2,ihw1) ) - opr(k) * z(i3,ihw1)
	    i3 = i3 - 1
	    i2 = i2 + 1
	  enddo
	endif

	if ( yderiv ) then
	  ty = 0.0
	  j2 = ihw1 + 1
	  j3 = ihw
	  do k = 1, ihw
	    ty = (ty + opr(k) * z(ip,j2)) - opr(k) * z(ip,j3)
	    i3 = i3 - 1
	    j2 = j2 + 1
	  enddo
	endif

	xdr = tx * rwt
	ydr = ty * rwt

	go to (151,152,153,154,155,156,157) ifunc

c  gradient magnitude and strike angle from North
151	r(ip)   = sqrt( xdr * xdr + ydr * ydr )
	dir(ip) = dval
	if ( r(ip) .gt. tol ) then
	  if ( xdr .gt. 0.0 ) then
	    alf = r2d * atan2( ydr, xdr )
	    dir(ip) = -alf
	   else
	    alf = r2d * atan2( ydr, xdr )
	    if ( ydr .gt. 0 ) then
	      dir(ip) = 180. - alf
	      else
	      dir(ip) = -( 180. + alf )
	    endif
	  endif
	endif
	go to 200

152	fz = 1.0 / sqrt(1.0 + xdr*xdr + ydr*ydr)
	fx = -xdr*fz
	fy = -ydr*fz
	r(ip) = const*(fx*sx + fy*sy + fz*sz)
	if (r(ip).lt.0.0) r(ip)=0.0
	go to 200
153	r(ip) = xdr
	go to 200
154	r(ip) = ydr
	go to 200
155	r(ip) = -xdr / sqrt(1.0 + xdr*xdr + ydr*ydr)
	go to 200
156	r(ip) = -ydr / sqrt(1.0 + xdr*xdr + ydr*ydr)
	go to 200
157	r(ip) = 1.0  / sqrt(1.0 + xdr*xdr + ydr*ydr)
200	continue

	write( jsw ) ydum, r
	if ( ifunc .eq. 1  ) call rowio(nc, dir, 0, 20, 20 ,iend )
	if ( jp    .eq. nr ) return

c  down shift buffer
	do j = 1, iw-1
	  j1 = j+1
	  do i = 1, nc2
	    z(i,j) = z(i,j1)
	  enddo
	enddo

c  either get new row
	if (irow.lt.nr) then
	call rowio(nc,z(ihw1,iw),-1,isw,jsw,iend)
	irow = irow+1
	i2 = iw
	do i = 1, ihw
	  z(i,iw) = 2.0*z(ihw1,iw) - z(i2,iw)
	  i2=i2-1
	enddo
	ie = ihw+nc
	i2 = ie-1
	do i = ie+1, nc2
	  z(i,iw) = 2.0*z(ie,iw) - z(i2,iw)
	  i2 = i2-1
	enddo
	else
c  or reflect at upper boundary
	jend=jend-1
	j2=jend-(iw-jend)
	do i = 1, nc2
	  z(i,iw) = 2.0*z(i,jend) - z(i,j2)
	enddo
	endif
300	continue
	return
	end
c***********************************************************************
	subroutine fill2(z,nwrk,dval,isw,jsw)
	character id*56,p*8
	dimension xx(4),z(nwrk)
	rewind isw
	rewind jsw
	read(isw) id,p,nc,nr,nz,xx
	itest=nwrk-max((nc+nc/10),(nr+nr/10))
	do 10 jump=1,min(nc,nr)
	mc=(nc+jump)/jump+1
	mr=(nr+jump)/jump+1
	mg=mc*mr
	if(mg.lt.itest) go to 20
10	continue
	stop ' fill2: work area too small'
20	i2=1
	do 25 j=1,mr
	do 25 i=1,mc
	z(i2)=dval
25	i2=i2+1
c
	jrow=1
	do 50 j=1,nr,jump
	call rowio(nc,z(mg+1),-1,isw,jsw,ie)
	if(ie.ne.0) go to 100
	i2=(jrow-1)*mc+1
	do 30 i=mg+1,mg+nc,jump
	z(i2)=z(i)
30	i2=i2+1
	if(jump.gt.1) then
	do 40 k=1,jump-1
40	read(isw,end=100)
	endif
50	jrow=jrow+1
c
100	call gridr(mc,mr,z,z(mg+1),dval,ier)
	if(ier.ne.0) stop ' fill2: error in subroutine gridr'
c
	rjump=1.0/float(jump)
	rewind isw
	read(isw)
	write(jsw) id,p,nc,nr,nz,xx
	do 150 j=1,nr
	call rowio(nc,z(mg+1),-1,isw,jsw,ie)
	if(ie.ne.0) go to 200
	iy=(j-1)/jump+1
	idy=mod(j-1,jump)
	if(iy+1.gt.mr) stop ' fill2: y ran off control grid'
	istart=(iy-1)*mc
	i2=mg+1
	do 130 i=1,nc
	if(z(i2).lt.dval) go to 130
	ix=(i-1)/jump+1
	idx=mod(i-1,jump)
	if(ix+1.gt.mc) stop ' fill2: x ran off control grid'
	ig=istart+ix
	if(idx-idy.gt.0) then
	ig1=ig+1
	dzx=z(ig1)-z(ig)
	dzy=z(ig1+mc)-z(ig1)
	else
	ig2=ig+mc
	dzx=z(ig2+1)-z(ig2)
	dzy=z(ig2)-z(ig)
	endif
	z(i2)=z(ig) + (dzx*float(idx) + dzy*float(idy)) * rjump
130	i2=i2+1
	call rowio(nc,z(mg+1),0,isw,jsw,ie)
150	continue
	return
200	type 210,j
210	format(' fill2: eof on input grid')
	return
	end
c***********************************************************************
	subroutine ave2d(iopr,dval,nc,iw,z,csum,arow,comp,
	1                isw,jsw,ksw)
c  in-place 2d averaging
c  when iopr < 0, trim grid one half window width.
c  iopr=1 smooth all, =2 smooth & mask, =3 smooth extrapolated
	common /header/ id2,p2
	dimension z(nc,iw),csum(nc),arow(nc),comp(nc)
	character id*56,id2*56,p*8,p2*8
	logical trim
c
	trim=.false.
	if(iopr.lt.0) trim=.true.
	ifunc=iabs(iopr)-1
	if(ifunc.lt.0 .or. ifunc.gt.2) stop ' ave2d: 1 > iopr > 3'
	ihw=(iw-1)/2
	ihw1=ihw+1
	if(ihw+ihw1.ne.iw) stop ' ave2d: iw must be odd'
c
	rewind isw
	rewind jsw
	rewind ksw
	read(isw) id,p,nc,nr,nz,xo,dx,yo,dy
	read(ksw)
	if(iw.gt.nc .or. iw.gt.nr)
	1            stop ' ave2d: window larger than grid dimension'
	if(trim) then
	  xo2=xo+ihw*dx
	  yo2=yo+ihw*dy
	  nc2=nc-2*ihw
	  nr2=nr-2*ihw
	  write(jsw) id2,p2,nc2,nr2,nz,xo2,dx,yo2,dy
	else
	  write(jsw) id2,p2,nc,nr,nz,xo,dx,yo,dy
	endif
c
c  initialize column sums
	do 5 i=1,nc
5	csum(i)=0.
	do 20 j=1,ihw
	call rowio(nc,z(1,j),-1,isw,jsw,iend)
	do 10 i=1,nc
10	csum(i)=csum(i)+z(i,j)
20	continue
c
c  lower half window
	irow=0
	do 50 j=1,ihw1
	jrow=j+ihw
	call rowio(nc,z(1,jrow),-1,isw,jsw,iend)
	do 30 i=1,nc
30	csum(i)=csum(i)+z(i,jrow)
	read(ksw) ydum,comp
	if(trim .and. j.eq.ihw1) then
	  call raopr(ifunc,dval,nc,jrow,iw,csum,arow,comp)
	  call rowio(nc2,arow(ihw1),0,jsw,jsw,ie)
	  irow=irow+1
	else
	  call raopr(ifunc,dval,nc,jrow,iw,csum,arow,comp)
	  write(jsw) ydum,arow
	  irow=irow+1
	endif
50	continue
	if(irow.ne.ihw1 .and. irow.ne.1) stop ' ave2d: error 1'
c
c  full window
c  iptr is the trailing row address
	iptr=1
	jrow=iw
	do 100 j=ihw1+1,nr-ihw
	do 60 i=1,nc
60	csum(i)=csum(i)-z(i,iptr)
	call rowio(nc,z(1,iptr),-1,isw,jsw,iend)
	do 70 i=1,nc
70	csum(i)=csum(i)+z(i,iptr)
	iptr=iptr+1
	if(iptr.gt.iw) iptr=1
	read(ksw) ydum,comp
	call raopr(ifunc,dval,nc,jrow,iw,csum,arow,comp)
	if(trim) then
	 call rowio(nc2,arow(ihw1),0,jsw,jsw,ie)
	else
	 write(jsw) ydum,arow
	endif
	irow=irow+1
100	continue
	if(trim) go to 300
c
c  upper half window
	do 200 j=nr-ihw+1,nr
	jrow=jrow-1
	do 110 i=1,nc
110	csum(i)=csum(i)-z(i,iptr)
	iptr=iptr+1
	if(iptr.gt.iw) iptr=1
	read(ksw) ydum,comp
	call raopr(ifunc,dval,nc,jrow,iw,csum,arow,comp)
	write(jsw) ydum,arow
	irow=irow+1
200	continue
	if(irow.ne.nr) type 310,irow,nr
	return
300	if(irow.ne.nr2) type 310,irow,nr2
310	format(' ave2d: rows output vs rows desired',2i5)
	return
	end
c***********************************************************************
	subroutine raopr(ifunc,dval,nc,jrow,iw,csum,arow,comp)
	dimension csum(nc),arow(nc),comp(nc)
	ihw=(iw-1)/2
	ihw1=ihw+1
	t=0.0
	do 10 i=1,ihw
10	t=t+csum(i)
	do 20 i=1,ihw1
	t=t+csum(ihw+i)
20	arow(i)=t/float((ihw+i)*jrow)
c
	rwt=1.0/float(iw*jrow)
	ldr=iw+1
	itrl=1
	do 50 i=ihw1+1,nc-ihw
	t=(t+csum(ldr))-csum(itrl)
	arow(i)=t*rwt
	ldr=ldr+1
50	itrl=itrl+1
c
	icol=iw-1
	do 100 i=nc-ihw+1,nc
	t=t-csum(itrl)
	arow(i)=t/float(icol*jrow)
	itrl=itrl+1
100	icol=icol-1
c
	if(ifunc.eq.0) return
	do 200 i=1,nc
	go to (110,120) ifunc
110	if(comp(i).ge.dval) arow(i)=dval
	go to 200
120	if(comp(i).lt.dval) arow(i)=comp(i)
200	continue
	return
	end
c***********************************************************************
	subroutine rowio(n,z,iop,idev,jdev,iend)
c  read iop<0, write iop=0, r&w iop=1
	dimension z(n)
	iend=0
	if(iop)1,2,1
1	read(idev,end=10) y,z
	if(iop)9,9,2
2	write(jdev) y,z
9	return
10	iend=1
	return
	end
c***********************************************************************
	subroutine gridr(nc,nr,zg,wz,dval,ier)
c  initialize grid with reasonable anomalies
c  dval is the flag value to be replaced
c  wz at least max(nc,nr)
	dimension iw1(3)
	dimension zg(1),wz(1)
	data iw1/3,7,9/
	ier=0
	nn=nc*nr
	nsep=(iw1(3)-1)/2
	ns1=nsep+1
	mxpass=max(nc,nr)/(2*nsep)
	i=1
201	if(i.gt.nn) return
	if(zg(i).ge.dval) go to 200
	i=i+1
	go to 201
c
c  insert control point net
c     distances for ring averages specified by iw1
200	if(nc.lt.nsep+ns1 .or. nr.lt.nsep+ns1) go to 140
	ipass=0
	iflag=1
130	iw=iw1(iflag)
	ihw=(iw-1)/2
	iset=ihw*nc+ihw
131	nass=0
	do 110 jj=ns1,nr-ihw,nsep
	ip=(jj-1)*nc+ns1
	do 100 ii=ns1,nc-ihw,nsep
	if(zg(ip).lt.dval) go to 100
	ips=ip-iset
	it=0
	t=0.0
	do 121 j=1,iw
	ip2=ips
	do 120 i=1,iw
	if(zg(ip2).ge.dval) go to 120
	t=zg(ip2)+t
	it=it+1
120	ip2=ip2+1
121	ips=ips+nc
	if(it-3.lt.0) go to 100
	zg(ip)=t/float(it)
	nass=nass+1
100	ip=ip+nsep
110	continue
	ipass=ipass+1
	if(nass.eq.0 .and. iflag.eq.3) go to 140
	if(ipass.gt.mxpass) go to 140
	if(iflag-2)133,132,131
133	iflag=2
	go to 130
132	iflag=3
	go to 130
140	continue
c
c  fill holes
	inc=nc*nsep
	j=inc+1
	if(nr.lt.ns1) go to 21
	do 20 irow=ns1,nr-nsep,nsep
	call plugm3(nc,zg(j),dval)
20	j=j+inc
21	do 28 icol=1,nc
	j=icol
	do 22 k=1,nr
	wz(k)=zg(j)
22	j=j+nc
	call plugm3(nr,wz,dval)
	j=icol
	do 24 k=1,nr
	zg(j)=wz(k)
24	j=j+nc
28	continue
c  final check
	do 40 i=1,nn
	if(zg(i).ge.dval) go to 41
40	continue
	return
41	t=0.0
	it=0
	do 42 i=1,nn
	if(zg(i).ge.dval) go to 42
	t=t+zg(i)
	it=it+1
42	continue
	if(it.eq.0) stop ' cannot init grid'
	t=t/float(it)
	type  43,t
43	format(' gridr init with',1pe15.5)
	do 44 i=1,nn
	if(zg(i).ge.dval) zg(i)=t
44	continue
	return
	end
c***********************************************************************
	subroutine plugm3(n,z,dval)
c  plug holes using linear interpolation
	dimension z(n)
	do 1 is=1,n
	if(z(is) .lt. dval) go to 2
1	continue
	return
2	ix=is
3	ix=ix-1
	if(ix.lt.1) go to 4
	z(ix)=z(is)
	go to 3
4	do 5 idv=is,n
	if(z(idv) .ge. dval) go to 6
5	continue
	return
6	is=idv-1
	do 7 ie=idv,n
	if(z(ie) .lt. dval) go to 10
7	continue
	ix=is
9	ix=ix+1
	if(ix.gt.n) return
	z(ix)=z(is)
	go to 9
10	dz=(z(ie)-z(is))/float(ie-is)
	do 11 i=is+1,ie-1
11	z(i)=z(i-1)+dz
	is=ie
	go to 4
	end
