c
c                  program grafedit
c
c  interactive graphic editting of xyz data sets using local
c              gridding and contouring.
c  
c  mike webring, u.s. geological survey, 2/84, 6/84, 1/85
c
	common /save/   icheck(50)
	common /exist/  idata,iexist
	common /dfile/  igrd,   iran,   iran2,  ingrd,  indat,
	1               irf(14),ibf(14),isf(14),igf(14),idf(14)
	common /data/   ibsiz,nsec,ntier,nran,maxrec,nval,nseq,lstout
	common /header/ dval,id(14),ipgm(2),nc,nr,nz,
	1               xo,dx,yo,dy,iflip,jflip
	common /wrkgrd/ iwrkg,icount,c1(2,10),c2(2,10),nskip(10),
	1               icol(10),irow(10),ncwrk(10),nrwrk(10)
	common /contou/ icoper,ncontd,nlevel,ncsam,nrsam,clevel(50),
	1               ltype(50),xydist(400)
	common /edit/   fract,lswt1,iold,zold,znew,itrack,dummy(7)
	common /stalab/ isymb,sizsta,sizlab,angle,labfmt(3)
	common /boxcrn/ p1(2),p2(2)
c
	common /plot/   dxp(2),dyp(2),xp(4),yp(4),dxpw(2),dypw(2),
	1               xpw(4),ypw(4),xpix,ypix,xscale,yscale
	common /plot2/  dypg(2),ypg(4),g2msca,g2myo
	common /tty1/   iterm,mode
	common /tty/    ipen,ich
	common /menu1/  nbox,menux,menudy
c
	common /datai/  xyz(1400)
	common /array/  wrk(40000)
c
	dimension za(20),iflag(20000)
	dimension plot1(26),scal(26),menus(3),menuq(3)
	character gfile*56,dfile*56,bline*79
	character*12 label(7)
	character prog*8
c
	equivalence (igf,gfile), (idf,dfile)
	equivalence (plot1,dxp(1)),(menus,nbox),
	1 (wrk(20001),iflag)
	data prog/'grafedit'/, nwrk/40000/, 
	1    nmenu/7/,label/'exit', 'contour', 'plt dat', 'expand',
	1    'contract', 'edit', 'setup'/
c  user is a site dependent usage tally routine
c	call user(prog)
c initialize common variables
	call initc
	ngmax = nwrk / 2
9	call tmode(1)
	call tclear(0)
	call tpromp(1,1,1,' ')
c
	type 20
20	format(' grid filename : '$)
	read(5,37) gfile
37	format(a56)
	call grd2da
	type 30
30	format(' data filename : '$)
	dfile=' '
	read(5,37) dfile
	if(dfile(1:5).ne.'     ') then
	  call opendf(nzrec,iz)
	  call makran(za,nzrec,iz)
	  idata=1
	  type *,' track sequential data points '
	  type *,' in the edit function ?'
	  if(noyes(ldum).eq.1) then
	    call makseq(ierrsq)
	    itrack=1
	  endif
	endif
	call inits
	call chkcom(ierr)
	if (ierr.ne.0) go to 999
c
c  draw from igrd
50	call tclear(0)
	call tmode(3)
	icoper=0
	icplot=0
	call cdvr(icplot,ncontd,ngmax,wrk,iflag)
	call boxall
	call whscal
	call menu(nmenu,label)
c
100	call chkcom(ierr)
	if (ierr.ne.0) then
	  call tpromp(1,1,1,' static variable error')
	  go to 999
	endif
	call fundvr(ifunc)
	go to (999,200,300,400,500,600,700)ifunc
c
c  contour data area
200	icplot=1
	call tmode(3)
	call cdvr(icplot,ncontd,ngmax,wrk,iflag)
	go to 100
c
c  plot data 
300	if(idata.eq.0) then
	  call tpromp(1,1,1,' no data to plot')
	  go to 100
	endif
	call tmode(3)
	call pltpt(0)
	go to 100
c
c  expand
400	call expand(ipen,iret)
	go to (50,100) iret
c
c  contract
500	call contrk(iret)
	go to (50,100) iret
c
c  edit function
600	if(idata.eq.0) then
	  call tpromp(1,1,1,' no data to edit')
	  go to 100
	endif
	call tmode(3)
	if (icoper.ne.2) 
	1  call cdvr(1,ncontd,ngmax,wrk,iflag)
	call tdraw(1)
	call menu(nmenu,label)
	call tdraw(0)
	call edtctl
	call menu(nmenu,label)
	go to 100
c
c  setup function
700	call geset
	go to 100
c
999	call tmode(1)
	if (idata.eq.1) then
	  call output(isave,za,nzrec,iz)
	  if(isave.eq.0) type *,' no output file has been created'
	endif
	type *,' do you want to exit the program ?'
	if(noyes(ldum).eq.0) then
	  call tmode(3)
	  go to 100
	endif
	close(igrd)
	if (idata.eq.1)  close (indat)
	if (idata.eq.1)  close (iran)
	if (itrack.eq.1) close (iran2)
	stop
	end
c******************************************************************************
	subroutine addpt
	common /dfile/  igrd,iran,iran2
	common /data/   ibsiz,nsec,ntier,nran,maxrec,nval,nseq,lstout
	common /edit/   dumm(5),itrack
	common /stalab/ isymb,sizsta,sizlab,angle,labfmt(3)
	common /tty/    idev,ich
	common /datai/  xyz(400)
	dimension dnew(3)
	data icross/0/, lab1/1/
c
	npmax=nran/nval
10	call tclear(1)
	call tpromp(1,1,1,'move cross-hair to new data location')
	call cursdu(icross,ich,dnew(1),dnew(2))
	call tmode(1)
	call tpromp(1,1,1,' ')
	type *,' enter z value : '
	read(5,*,end=10,err=10) dnew(3)
	type *,' new z =',dnew(3)
	type *,' is this ok ?'
	if(noyes(ldum).eq.0) go to 10
	call tmode(3)
	call lablpt(lab1,dnew)
c
c  add new point to outside area linked list
	nseq = nseq + 1
	irec = lstout
20	read(iran,rec=irec,err=999) next,ndp,xyz
	if (ndp.lt.npmax) then
c  add point to partially filled record
	  ix = ndp*nval + 1
	  xyz(ix)   = dnew(1)
	  xyz(ix+1) = dnew(2)
	  xyz(ix+2) = dnew(3)
	  xyz(ix+3) = float(nseq)
	  ndp = ndp + 1
	  call wrblk2(iran,irec,next,ndp,nran,xyz)
	else 
c  full record at end of list
c  change linking parameter of old maxrec
	  maxrec = maxrec + 1
	  next   = maxrec
	  call wrblk2(iran,irec,next,ndp,nran,xyz)
	  do i = 1,nran
	    xyz(i) = 0.0
	  enddo
	  xyz(1)=dnew(1)
	  xyz(2)=dnew(2)
	  xyz(3)=dnew(3)
	  xyz(4) = float(nseq)
c  add new maxrec
	  irec = maxrec
	  next = 0
	  ndp  = 1
	  call wrblk2(iran,irec,next,ndp,nran,xyz)
	  lstout = maxrec
	endif
c
c  update sequence file
	if (itrack.eq.1) then
	  write(iran2,rec=nseq,err=80) dnew,irec,ndp
	endif
	go to 90
80	type *,' error updaing sequence file'
c
90	call tmode(1)
	type *,'>> another ?'
	if(noyes(ldum).eq.1) go to 10
100	call tclear(1)
	call tmode(3)
	return
999	type *,' error reading linked list'
	type *,' irec, maxrec', irec,maxrec
	call waiter(5.0)
	go to 100
	end
c******************************************************************************
	subroutine ammi(n,a,amn,amx,mn,mx,isave)
	dimension a(n)
	if(isave.gt.1) go to 1
	mn=1
	mx=1
	amn=a(1)
	amx=a(1)
1	do 3 i=1,n
	if(a(i).ge.amn) go to 2
	amn=a(i)
	mn=i
2	if(a(i).le.amx) go to 3
	amx=a(i)
	mx=i
3	continue
	return
	end
c******************************************************************************
	subroutine assign(slope,xogu,yogu,nc,nr,b,np3,xyz)
c   associate np data values with grid locations of one block.
c   'slope' > 0 indicates that all data values within +-one half grid unit
c   will be combined by distance weighting.
c   'slope' = 0 indicates that the closest data value is the only one used.
	dimension xyz(np3),b(1)
	logical lslope
c
	if(np3.lt.3) return
	lslope=.false.
	if(slope.gt.0.0) lslope=.true.
c
	do 100 ixy=1,np3-2,3
	x=xyz(ixy)-xogu
	igx=int(x+.5)
	y=xyz(ixy+1)-yogu
	igy=int(y+.5)
c
	if(igx.gt.nc .or. igx.lt.1) go to 10
	if(igy.gt.nr .or. igy.lt.1) go to 20
	go to 30
10	type  11,igx
11	format(i5,'x'$)
	go to 100
20	type  21,igy
21	format(i5,'y'$)
	go to 100
c
30	z=xyz(ixy+2)
	ig=(igy-1)*nc+igx
	ib1=(ig-1)*6+1
	dx=x-float(igx)
	dy=y-float(igy)
	rsq=dx*dx+dy*dy
c
	if(lslope) go to 50
	if(rsq.ge.b(ib1)) go to 100
	b(ib1)=rsq
	b(ib1+1)=dx
	b(ib1+2)=dy
	b(ib1+5)=z
	go to 100
c
50	dwt=1.0/(rsq+slope)
	ib2=ib1+1
	ib3=ib1+2
	ib6=ib1+5
	b(ib1)=b(ib1)+dwt
	b(ib2)=b(ib2)+dx*dwt
	b(ib3)=b(ib3)+dy*dwt
	b(ib6)=b(ib6)+z*dwt
100	continue
	return
	end
c******************************************************************************
	subroutine bwts(izset,slope,binit,nc,nr,zg,iqd,b)
c   initialize iqd and zg arrays.
c   calculate weights for minimum curvature equations.
c   'b' is dimensioned (6,nc*nr)
c   b(1,ig) contains either r squared or 1./weight
	dimension itabl(4)
	dimension zg(1),iqd(1),b(1)
	logical notslp
	data itabl/3,4,2,1/
c
	notslp=.true.
	if(slope.gt.0.0) notslp=.false.
	ib1=1
	do 100 ig=1,nc*nr
	if(b(ib1).eq.binit) go to 100
	ib2=ib1+1
	ib3=ib1+2
	ib6=ib1+5
	if(notslp) go to 50
	rwt=1./(b(ib1))
	b(ib2)=b(ib2)*rwt
	b(ib3)=b(ib3)*rwt
	b(ib6)=b(ib6)*rwt
	b(ib1)=b(ib2)*b(ib2)+b(ib3)*b(ib3)
c
50	if(b(ib1).gt.0.0025) go to 80
	iqd(ig)=-1
	zg(ig)=b(ib6)
	go to 100
80	ix=1
	if(b(ib2).ge.0.0) ix=2
	iy=0
	if(b(ib3).ge.0.0) iy=2
	iqd(ig)=itabl(ix+iy)
	if(izset.ne.0) zg(ig)=b(ib6)
100	ib1=ib1+6
c
c  calculate weighting
200	is=2*nc+3
	ie=3*nc-2
	do 230 j=3,nr-2
	ib1=(is-1)*6+1
	do 220 i=is,ie
	if(iqd(i))220,220,210
210	ib2=ib1+1
	ib3=ib2+1
	ib4=ib3+1
	ib5=ib4+1
	ib6=ib5+1
	dx=abs(b(ib2))
	dy=abs(b(ib3))
	dy2=dy*dy
	f1=dx*(dx+dy+dy+1.)
	b5=4./(f1+dy2+dy)
	b4=(b5*f1*.5)-1.
	b5dx=b5*dx
	b4b4=b4+b4
	b3=b5dx*(dy+1.)-b4b4
	b(ib2)=2.+b5dx-(b5*dy2+b4b4+b3)
	b(ib1)=b3+b4-b5dx
	b(ib3)=b3
	b(ib4)=b4
	b(ib5)=b5*b(ib6)
	b(ib6)=1./(1.+b(ib1)+b(ib2)+b3+b4+b5)
220	ib1=ib1+6
	is=is+nc
230	ie=ie+nc
	return
	end
c******************************************************************************
	subroutine border(nc,nr,zg,iqd,row)
	common /dfile/  igrd
	common /header/ dval, id(14), ipgm(2), nc1
	common /wrkgrd/ iw,icount,c1(2,10),c2(2,10),nskip(10),
	1               icol(10),irow(10),ncw(10),nrw(10)
	dimension isie(4)
	dimension zg(nc,nr),iqd(nc,nr),row(1)
	data isie/1,2,0,0/
	if(nc.ne.ncw(iw)) type *,' border:',nc,'.ne.',ncw(iw)
	if(nr.ne.nrw(iw)) type *,' border:',nr,'.ne.',nrw(iw)
	isie(3) = nc-1
	isie(4) = nc
c  first 2 rows
	irec = irow(iw)
	do j = 1, 2
	  call rowda (nc1,row,-1,irec,igrd,ierr)
	  ic = icol(iw)
	  do i = 1, nc
	    zg(i,j) = row(ic)
	    if (zg(i,j).lt.dval) iqd(i,j) = -1
	    ic = ic+1
	  enddo
	irec = irec + 1
	enddo
c  2 columns up the sides
	do j = 3, nr-2
	  call rowda (nc1,row,-1,irec,igrd,ierr)
	  do k = 1, 4
	    i = isie(k)
	    ic = icol(iw) + isie(k) - 1
	    zg(i,j) = row(ic)
	    if (zg(i,j).lt.dval) iqd(i,j) = -1
	  enddo	
	  irec = irec+1
	enddo
c  and the last 2 rows
	do j = nr-1, nr
	  call rowda (nc1,row,-1,irec,igrd,ierr)
	  ic = icol(iw)
	  do i = 1, nc
	    zg(i,j) = row(ic)
	    if (zg(i,j).lt.dval) iqd(i,j) = -1
	    ic = ic+1
	  enddo
	irec = irec + 1
	enddo
	return
	end
c******************************************************************************
	subroutine box(p1,p2)
	dimension p1(2),p2(2)
	do i = 1,2
	if(p1(i).gt.p2(i)) then
	  tmp=p1(i)
	  p1(i)=p2(i)
	  p2(i)=tmp
	endif
	enddo
	call line(p1(1),p1(2),1,0,0)
	call line(p1(1),p2(2),1,1,0)
	call line(p2(1),p2(2),1,1,0)
	call line(p2(1),p1(2),1,1,0)
	call line(p1(1),p1(2),1,1,0)
	return
	end
c******************************************************************************
	subroutine boxall
	common /wrkgrd/ iwrkg,icount,c1(2,10),c2(2,10),if2(50)
	common /plot/   dxp(2),dyp(2),xp(4),yp(4)
	character label*2
	if(icount.le.1) return
	size=.1
	do ibox = 2,icount
	  call box(c1(1,ibox),c2(1,ibox))
	  call du2pu(c1(1,ibox),c1(2,ibox),xpu,ypu)
	  write(label,10) ibox
10	  format(i2)
	  call text(xpu+size,ypu+size,label,size,0.0)
	enddo
	return
	end
c******************************************************************************
	subroutine cdvr(icplot,leveld,ngmax,z,iflag)
c  contour driver input: 
c  icplot, 0=init only, 1=contour only, 2=init&cont,
c  leveld, number of levels default, same as 'ncontd'
c  2 'ngmax' working arrays.
	common /plot/   dxp(2),dyp(2),xp(4),yp(4),dxpw(2),dypw(2),
	1               xpw(4),ypw(4),xpix,ypix,xscale,yscale
	common /contou/ icoper,ncontd,nlevel,nc,nr, c(50),ltype(50),
	1               xy(400)
	common /stalab/   ifill2(4),labfmt(3)
	dimension zrange(2)
	dimension z(ngmax),iflag(ngmax)
	character id*56,p*8,fmtz*12,fmttit*72,title*72
	equivalence (labfmt,fmtz)
	data maxlev/50/, dval/1.0e30/
	idval=0
	if(icplot.eq.1) go to 200
	icoper=0
c
c  assign levels default
	if (leveld.le.0 .and. ncontd.le.0) ncontd=20
	if (leveld.gt.0 .and. ncontd.le.0) ncontd=leveld
	levels=leveld
	if (levels.le.0) levels=ncontd
c
	call getz(ngmax,nc,nr,xy,z)
	nn = nc*nr
	if (nn.le.0) then
	  call tpromp(1,1,1,' cdvr: getz returned nc*nr=0')
	  return
	endif
c
c  get grid range and replace dval's
	call dvmm(nc*nr,z,zrange(1),zrange(2),dval,idval)
c
c  initialize plot, scale and axis tic
	dxp(1) = xy(1)
	dxp(2) = xy(nc)
	dyp(1) = xy(nc+1)
	dyp(2) = xy(nc+nr)
	call setgrf(1,dxp,dyp,xp,yp,0)
	xscale = (dxp(2)-dxp(1)) / xp(1)
	yscale = (dyp(2)-dyp(1)) / yp(1)
	call neatl
c
c  contour interval
	zint = 0.0
	max  = levels
	if (max.gt.maxlev) max = maxlev
	call setax(zrange,zint,max,nz,fmtz)
	nlevel = 1
	if (zint.le.0.0) zint = 1.0
	nlevel = 1 + int( (zrange(2)-zrange(1)) / zint )
	if (nlevel.lt.1)      nlevel = 1
	if (nlevel.gt.maxlev) nlevel = maxlev
c
c  assign contour levels and dashing patterns
c  line 1 is solid, 2-7 are dashed.
	idash  = 2
	iprime = 0
	pint = 5.0*zint
	cs = zint*aint(zrange(1)/zint + 0.5)
	do i = 1, nlevel
	  c(i) = cs + float(i-1)*zint
	  t = abs( amod(c(i),pint) )
	  if (t.lt.1.0e-2*zint) then
	    if (iprime.eq.0) iprime = i
	    ltype(i) = idash
	    idash = idash + 1
	    if (idash.gt.7) idash = 2
	  else
	    ltype(i) = 1
	  endif
	enddo
c
c  plot title
	write(fmttit,100) fmtz,fmtz
100	format(' (''min prime contour ='',', a,
	1      ',''  interval ='',', a, ')')
	write (title,fmttit) c(iprime), zint
	call text(.5,0.08,title,.08,0.0)
	icoper=1
	if (icplot.eq.0) return
c
c  contour z array
200	iy = nc+1
	call contur(nc,nr, xy,xy(iy), z,iflag, nlevel,c,ltype)
	icoper=2
	return
	end
c******************************************************************************
	subroutine changz(ichang,xyzs)
	common /stalab/ isymb,sizsta,sizlab,angle,labfmt(3)
	common /edit/   ifill(2),iold,zold,znew,itrack
	dimension xyzs(4)
	character zchar*12
	icross=4
	call tdraw(0)
	call symbol(xyzs(1),xyzs(2),1,icross,2*sizsta,angle)
	call tmode(1)
	call tpromp(1,1,1,' ')
	type *,'> old z = ',xyzs(3)
5	type 10
10	format('> new z = ',$)
	zchar=' '
	znew=1.e-30
	read(5,20,end=5,err=5) zchar
20	format(a12)
	if(zchar.ne.'            ') read(zchar,30,end=40,err=5) znew
30	format(bn,f12.0)
40	call tmode(3)
	call tdraw(1)
	call symbol(xyzs(1),xyzs(2),1,icross,2*sizsta,angle)
	if(znew.ne.1.e-30 .and. znew.ne.xyzs(3)) then
	  ichang=1
	  call lablpt(1,xyzs)
	  zold   = xyzs(3)
	  xyzs(3) = znew
	endif
	call tdraw(0)
	call lablpt(1,xyzs)
	if (ichang.eq.1 .and. itrack.eq.1) then
	  iseq = int (xyzs(4) + 0.01)
	  if (iseq.le.0) return
	  call trackz(ichang,iseq)
	endif
	return
	end		  
c******************************************************************************
	subroutine chkcom(ierr)
	common /save/   is(50)
	common /dfile/  igrd,iran,iran2,ingrd,indat
	common /data/   ibsiz,nsec,ntier,nran,maxrec,nval,nseq
	common /header/ dval,id(14),ipgm(2),nc,nr,nz,
	1               x(4),iflip,jflip
	common /wrkgrd/ iwrkg,icount,c1(2,10),c2(2,10),nskip(10),
	1               icol(10),irow(10),ncwrk(10),nrwrk(10)
	equivalence (dval,idval), (x,ix)
	dimension ix(4)
c
	ierr=0
	if (is(1) .ne. igrd)  go to 999
	if (is(2) .ne. iran)  go to 999
	if (is(3) .ne. ibsiz) go to 999
	if (is(4) .ne. nsec)  go to 999
	if (is(5) .ne. ntier) go to 999
	if (is(6) .ne. nran)  go to 999
	if (is(7) .ne. nval)  go to 999
	if (is(8) .ne. idval) go to 999
	if (is(9) .ne. nc)    go to 999
	if (is(10) .ne. nr)   go to 999
	if (is(11) .ne. ix(1)) go to 999
	if (is(12) .ne. ix(2)) go to 999
	if (is(13) .ne. ix(3)) go to 999
	if (is(14) .ne. ix(4)) go to 999
	if (is(15) .ne. iflip) go to 999
	if (is(16) .ne. jflip) go to 999
	if (is(17) .ne. ingrd) go to 999
	if (is(18) .ne. indat)  go to 999
c	is(19) is initial maxrec
c
	if(maxrec.gt.is(19)+2) then
	  type *,'chkcom: maxrec, chkrec',maxrec,is(19)
	  ierr=1
	endif
	maxseq = maxrec*(nran/nval)
	if(nseq.lt.0 .or. nseq.gt.maxseq) then
	  call tmode(1)
	  call tpromp(1,1,1,' nseq,maxrec,nran,nval')
	  type *, 'chkcom:', nseq,maxrec,nran,nval
	  go to 999
	endif
	return
999	ierr=1
	return
	end
c******************************************************************************
	subroutine contrk(iret)
	common /wrkgrd/ iwrkg,icount
	character prompt*79
	call tmode(1)
	call tclear(1)
1	call tpromp(1,1,1,' ')
	type *,' number of active grids is', icount
	type *,' present grid number', iwrkg
	type *,' enter desired grid number (Gn)'
	type *,' Gn < 0, will reset active grids to abs(Gn)'
	read (5,*,end=99,err=99) iw2
	if(iabs(iw2).gt.10 .or. iw2.gt.icount) go to 1
	if(iw2.eq.0 .or. iw2.eq.iwrkg) go to 88
	if(iw2.lt.0) then
	  iw2 = iabs(iw2)
	  if(iw2.gt.icount) go to 1
	  icount=iw2
	  type *,' number of active grids is', icount
	endif
	iwrkg=iw2
	iret=1
	go to 99
c
88	type *,' no change'
	iret=2
	call waiter(1.0)
99	call tclear(1)
	call tmode(3)
	return
	end
c******************************************************************************
	subroutine contur(nx,ny, x,y, z,un, nc,cont,ltype)
c  specified dashing patterns for each contour require ltype(nc) storage
c  and ltype(1) > 0. 
	common /cfoll/  open,first,last,h,line
	dimension x(nx),y(ny),z(nx,ny),cont(nc),ltype(1)
	logical un(nx,ny)
	logical open,first,last
	jm=ny-1
	im=nx-1
	do 7 k=1,nc
	h=cont(k)
	if(ltype(1).le.0) then
	  line=1
	  else
	  line=ltype(k)
	endif
c  Evenden plotsys line range is 0:6
	line=line-1
	do 1 j=2,jm
	do 1 i=2,im
	un(i,j)=.false.
	if(z(i-1,j).lt.h .and. z(i,j).ge.h) un(i,j)=.true.
1	continue
	open=.true.
	do 2 i=2,nx
	if( z(i-1,1).lt.h .and. z(i,1).ge.h ) call follow(i,1,-1,0,
	1 x,y,z,nx,ny,un)
2	continue
	do 3 j=2,ny
	if( z(nx,j-1).lt.h .and. z(nx,j).ge.h ) call follow(nx,j,0,-1,
	1 x,y,z,nx,ny,un)
3	continue
	do 4 l=1,im
	i=nx-l
	if( z(i+1,ny).lt.h .and. z(i,ny).ge.h ) call follow(i,ny,1,0,
	1 x,y,z,nx,ny,un)
4	continue
	do 5 l=1,jm
	j=ny-l
	if( z(1,j+1).lt.h .and. z(1,j).ge.h ) call follow(1,j,0,1,
	1 x,y,z,nx,ny,un)
5	continue
	open=.false.
	do 6 l=2,jm
	j=ny-l+1
	do 6 m=2,im
	i=nx-m+1
	if( un(i,j) ) call follow(i,j,-1,0,x,y,z,nx,ny,un)
6	continue
7	continue
	return
	end
c*****************************************************************************
	subroutine cursdu(ipen,ich,xdu,ydu)
c  scales GIN location in data units
c  dxpw, dypw board area in data units; xpix, ypix data units/pixel
	common /plot/ dumm(12),dxpw(2),dypw(2),dumm2(8),xpix,ypix
	call tgin(ipen,ich,ix,iy)
	xdu=float(ix)*xpix+dxpw(1)
	ydu=float(iy)*ypix+dypw(1)
	return
	end
c******************************************************************************
	subroutine defbox(fract,p1,p2)
c  default box coordinates
	common /wrkgrd/ iwrkg,icount,c1(2,10),c2(2,10),if2(50)
	dimension p1(2),p2(2)
	xbox  = fract * (c2(1,iwrkg)-c1(1,iwrkg))
	ybox  = fract * (c2(2,iwrkg)-c1(2,iwrkg))
	p1(1) = 0.5 * (c2(1,iwrkg)+c1(1,iwrkg)) - 0.5*xbox
	p1(2) = 0.5 * (c2(2,iwrkg)+c1(2,iwrkg)) - 0.5*ybox
	p2(1) = xbox + p1(1)
	p2(2) = ybox + p1(2)
	return
	end
c******************************************************************************
	subroutine delpt(iswt,p1,p2,labswt)
c  delete points inside of box p1,p2 by negating the sequence number
c  iswt=-1 delete, iswt=0 change value, iswt=1 restore
	common /dfile/  igrd,iran,iran2
	common /data/   ibsiz,nsec,ntier,nran,maxrec,nval,nseq,lstout
	common /header/ dval,id(14),ipgm(2),nc,nr,nz,
	1               xo,dx,yo,dy
	common /actblk/ iblock,irec,next,np
	common /edit/   if2(2),ix,zold,znew
	common /datai/  xyz(400)
	dimension p1(2),p2(2),ibx(2),iby(2)
	character prompt*79
c
	swt=float(iswt)
	if(iswt.lt.0) call tdraw(1)
	if(iswt.gt.0) call tdraw(0)
	call getblk(p1,p2,ibx,iby,iout)
	last=0
c
	do 50 jblk = iby(1), iby(2)
	if (jblk.eq.iby(2)) last=1
	do 50 iblk = ibx(1), ibx(2)+last
	  iblock = iblk + nsec*(jblk-1)
	  if (iblk .eq. ibx(2)+1) iblock = nsec*ntier+1
	  irec = iblock
10	read(iran,rec=irec,err=777) next,np,xyz
	ichang=0
	do 20 i=4,nval*np,nval
	  ix=i-3
	  if(xyz(ix).lt.p1(1) .or. xyz(ix).gt.p2(1)) go to 20
	  iy=ix+1
	  if(xyz(iy).lt.p1(2) .or. xyz(iy).gt.p2(2)) go to 20
	  if(iswt.eq.0) then
	    if (xyz(i).lt.0.0) go to 20
	    call changz(ichang,xyz(ix))
	  else
	    call lablpt(labswt,xyz(ix))
	    xyz(i)=sign(xyz(i),swt)
	    ichang=1
	  endif
20	continue
	if(ichang.eq.1) write(iran,rec=irec) next,np,xyz
	if(next.eq.0) go to 50
	irec=next
	go to 10
50	continue
	go to 999
c
777	write(prompt,888) iblk,jblk,irec
888	format(' delpt: block=',2i4,' attempt to read record',i15)
	call tpromp(1,1,1,prompt)
999	call tdraw(0)
	return
	end
c******************************************************************************
	subroutine du2pu(xdu,ydu,xpu,ypu)
	common /plot/  dxp(2),dyp(2),xp(4),yp(4),dxpw(2),dypw(2),
	1              xpw(4),ypw(4),xpix,ypix,xscale,yscale
	xpu = (xdu-dxp(1))/xscale + xp(3)
	ypu = (ydu-dyp(1))/yscale + yp(3)
	return
	end
c******************************************************************************
	subroutine dvmm(n,a,amn,amx,dval,idval)
c  find min&max grid values and whether dval's are present
	dimension a(n)
	idval=0
	amn=1.0e30
	amx=-amn
	do i=1,n
	  if(a(i).ge.dval) then
	    idval=1
	  else
	    if(a(i).lt.amn) amn=a(i)
	    if(a(i).gt.amx) amx=a(i)
	  endif
	enddo
	if (idval.eq.1) then
	  aset = amn - (amx-amn)/20.
	  do i=1,n
	    if (a(i).ge.dval) a(i)=aset
	  enddo
	endif
	return
	end
c******************************************************************************
	subroutine edtctl
c  edit level controller
	common /dfile/  igrd,iran,iran2
	common /data/   ibsiz,nsec,ntier,nran,maxrec,nval,nseq,lstout
	common /wrkgrd/ iwrkg,icount,c1(2,10),c2(2,10),if2(50)
	common /edit/   fract,labswt,iold,zold,znew,itrack
	common /tty1/   iterm,imode
	common /tty/    ipen,ich 
	common /datai/  xyz(400)
	common /array/  wrk(40000)
	dimension p1(2),p2(2), iflag(20000)
	equivalence (wrk(20001),iflag)
	character*12 label(8)
	data  ngmax/20000/, icross/0/
	data nmenu/8/, label/'return', 'size box', 'move  box', 'restore',
	1  'delete pt', 'add data', 'change z', 'grid&cont'/
c
	call tmode(1)
	call tpromp(1,1,1,' ')
	type 1
1	format('> label existing points ? ',$) 
	lab1=noyes(ldum)
	call tclear(1)
	call tmode(3)
	call pltpt(lab1)
	p1(1)=0.0
	p2(1)=0.0
	call defbox(fract,p1,p2)
	call box(p1,p2)
	call menu(nmenu,label)
c
10	call chkcom(ierr)
	if (ierr.ne.0) return
	call fundvr(ifunc)
	go to (999,200,300,400,500,600,700,800) ifunc
c
c  adjust box size
200	call tdraw(1)
	call box(p1,p2)
	call tdraw(0)
	call getbox(p1,p2)
	go to 10
c
300	call movbox(icross,ich,p1,p2)
	go to 10
c
c  restore points within box
400	call delpt(1,p1,p2,labswt)
	go to 10
c
c  delete points within box
500	call delpt(-1,p1,p2,labswt)
	go to 10
c
c  add point at cross-hair
600	call addpt
	go to 10
c
c  change z value
700	call delpt(0,p1,p2,labswt)
	call tclear(1)
	go to 10
c
800	continue
	call regrd(ierr)
	if(ierr.ne.0) go to 10
	call tclear(0)
	call tmode(3)
	call cdvr(2,0,ngmax,wrk,iflag)
	call pltpt(lab1)
	call boxall
	call box(p1,p2)
	call whscal
	call menu(nmenu,label)
	go to 10
c
999	call tdraw(1)
	call box(p1,p2)
	call menu(nmenu,label)
	call tdraw(0)
	return
	end
c******************************************************************************
	subroutine expand(ipen,iret)
c  wrkgrd common: igrd-  active unit number
c                 iwrkg- active grid index (1-10)
c                 icount-number of grids active (default=1)
	common /header/ dval,id(14),ipgm(2),nc,nr,nz,
	1               xo,dx,yo,dy
	common /wrkgrd/ iwrkg,icount,c1(2,10),c2(2,10),nskip(10),
	1               icol(10),irow(10),ncw(10),nrw(10)
	common /boxcrn/ p1(2),p2(2)
c
	iret=1
c  get expand area
5	call tdraw(1)
	call box(p1,p2)
	call tdraw(0)
10	call tpromp(1,1,1,' lower-left corner (''exit'' to cancel)')
	call menudvr(ipen,ich,p1(1),p1(2),ifunc)
	if(ifunc.gt.0) then
	  call tpromp(1,1,1,' function canceled')
	  go to 999
	endif
15	call tpromp(1,1,1,' upper-right corner')
	call menudvr(ipen,ich,p2(1),p2(2),ifunc)
	if(ifunc.gt.0) go to 10
	call box(p1,p2)
	call tpromp(1,1,1,' ''exit'' if ok')
	call menudvr(ipen,ich,tx,ty,ifunc)
	if(ifunc.ne.1) go to 5
c
	if(icount.lt.1) icount=1
	icount=icount+1
	if(icount.gt.10) icount=10
	new = icount
c
	is = 1 + int((p1(1)-xo)/dx)
	js = 1 + int((p1(2)-yo)/dy)
	if (is.lt.1) is=1
	if (js.lt.1) js=1
c  extend across sampling interval 
	if (nskip(iwrkg).le.0) nskip(iwrkg)=1
	ie = nskip(iwrkg) + int((p2(1)-xo)/dx + 0.5)
	je = nskip(iwrkg) + int((p2(2)-yo)/dy + 0.5)
	if (ie.gt.nc) ie=nc
	if (je.gt.nr) je=nr
c  store new area
	c1(1,new) = xo + dx*float(is-1)
	c1(2,new) = yo + dy*float(js-1)
	c2(1,new) = xo + dx*float(ie-1)
	c2(2,new) = yo + dy*float(je-1)
	ncw(new)  = ie-is+1
	nrw(new)  = je-js+1
	icol(new) = is
	irow(new) = js
	iwrkg = new
	call tdraw(1)
	call box(p1,p2)
	call tdraw(0)
	return
c
c  undefined box
999	iret=2
	do i=1,2
	  p1(i)=0.0
	  p2(i)=0.0
	enddo
	return
	end
c******************************************************************************
	subroutine fit3c (dval,ihw,ip,jp,nc,nr,zg,iset)
c  Generate local 4 coefficient surface, width 2*ihw+1, and 
c  calculate value at zg(ip,jp).  Defined grid values must exist
c  in at least 2 diagonal quadrants.
	dimension a(9),b(3),c(3),iqt(4)
	dimension zg(nc,nr)
	tol=1.e-20
	iset=0
	idata=-1
	do i=1,9
	  a(i)=0.0
	  if (i.le.3) b(i)=0.0
	  if (i.le.4) iqt(i)=0
	enddo
	jqd = 0
	do j = -ihw, ihw
	  jg = jp + j
	  if (j.gt.0) jqd = 2
	  iqd = 1
	  do i = -ihw, ihw
	    if (i.gt.0) iqd = 2
	    ig = ip + i
	    if(zg(ig,jg).lt.dval) then
	      iqt(iqd+jqd) = 1
	      idata = idata + 1
	      if(idata.eq.0) then
	        zo = zg(ig,jg)
	        io = i
	        jo = j
	      else
	        z = zg(ig,jg) - zo
	        x = float(i-io)
	        y = float(j-jo)
	        x2 = x*x
	        y2 = y*y
	        a(1) = a(1) + x2
	        a(2) = a(2) + x*y
	        a(3) = a(3) + x2*y
	        a(5) = a(5) + y2
	        a(6) = a(6) + x*y2
	        a(9) = a(9) + x2*y2
	        b(1) = b(1) + x*z
	        b(2) = b(2) + y*z
	        b(3) = b(3) + x*y*z
	      endif
	    endif
	  enddo
	enddo
	if (idata.lt.3) return
	x = -float(io)
	y = -float(jo)
	i1 = iqt(1) + iqt(4)
	i2 = iqt(2) + iqt(3)
c
	if (i1.ne.2 .and. i2.ne.2) return
	a(4) = a(2)
	a(7) = a(3)
	a(8) = a(6)
	a(6) = a(1)*a(6) - a(3)*a(4)
	a(9) = a(1)*a(9) - a(3)*a(7)
	b(3) = a(1)*b(3) - a(3)*b(1)
	a(5) = a(1)*a(5) - a(2)*a(4)
	a(8) = a(1)*a(8) - a(2)*a(7)
	b(2) = a(1)*b(2) - a(2)*b(1)
	a(9) = a(5)*a(9) - a(6)*a(8)
	b(3) = a(5)*b(3) - a(6)*b(2)
	if (abs(a(9)*a(5)).lt.tol) return
	c(3) =  b(3) / a(9)
	c(2) = (b(2) - a(8)*c(3)) / a(5)
	c(1) = (b(1) - a(7)*c(3) - a(4)*c(2)) / a(1)
	zg(ip,jp) = zo + x*c(1)+ y*c(2) + x*y*c(3)
	iset = 1
	return
	end
c******************************************************************************
	subroutine follow(if,jf,iaf,jaf,x,y,z,nx,ny,un)
c  follow one contour to either closure or grid boundary
	dimension x1(20),y1(20)
	dimension x(nx),y(ny),z(nx,ny)
	common /cfoll/ open,first,last,h,ltyp
	logical un(nx,ny)
	logical open,last
	integer first,contin
c first=0 is true, =1 is false
	ixy=0
	first=0
	contin=0
	last=.false.
	i=if
	j=jf
	ia=iaf
	ja=jaf
	z1=z(i,j)
	za=z(i+ia,j+ja)
1	t=0.
	if(z1.ne.za) t=(z1-h)/(z1-za)
c
	ixy=ixy+1
	x1(ixy)=x(i)-t*(x(i)-x(i+ia))
	y1(ixy)=y(j)-t*(y(j)-y(j+ja))
	if(ixy.eq.20) then
	  call line(x1,y1,ixy,contin,ltyp)
	  contin=1
	  ixy=0
	endif
c
	if(open) go to 2
	if(ia.eq.-1 .and. .not.un(i,j)) last=.true.
	go to 3
2	if(first.eq.0) go to 4
	if(ja.eq.0 .and. (j.eq.1 .or. j.eq.ny)) last=.true.
	if(ja.ne.0 .and. (i.eq.1 .or. i.eq.nx)) last=.true.
3	if(last) go to 4
	if(ia.eq.-1) un(i,j)=.false.
c
4	if(last .and. ixy.gt.0) call line(x1,y1,ixy,contin,ltyp)
c
	if(last) return
	zb=z(i+ja,j-ia)
	if(zb.ge.h) go to 5
	za=zb
	temp=ia
	ia=ja
	ja=-temp
	go to 7
5	zc=z(i+ia+ja,j-ia+ja)
	if(zc.ge.h) go to 6
	z1=zb
	za=zc
	i=i+ja
	j=j-ia
	go to 7
6	z1=zc
	i=i+ia+ja
	j=j-ia+ja
	temp=ja
	ja=ia
	ia=-temp
7	first=1
	go to 1
	end
c******************************************************************************
	subroutine fundvr(ifunc)
	common /tty1/ iterm,mode
	common /tty/ ipen,ich
	if(iterm.ne.2) then
1	call tpromp(1,21,1,' enter menu function')
	call menudvr(ipen,ich,x,y,ifunc)
	call tpromp(1,20,1,' ')
	call tpromp(1,21,1,' ')
	  if(ifunc.eq.0) then
	    call tpromp(1,21,1,' renter function')
	    call waiter(1.0)
	    go to 1
	  endif
	endif
	if(iterm.eq.2) then
2	  call menudvr(ipen,ich,x,y,ifunc)
	  if(ifunc.eq.0) then
	    type *,' re-enter function'
	    call waiter(1.0)
	    go to 2
	  endif
	endif
	return
	end
c******************************************************************************
	subroutine geset
	common /exist/  idata,iexist
	common /contou/ icoper,ncontd
	common /edit/   fract,labswt,iold,zold,znew,itrack
	common /stalab/ isymb,sizsta,sizlab,angle,labfmt(3)
	common /tty1/   itty,mode
	modein=mode
	call tmode(1)
	call tclear(1)
	call tpromp(1,1,1,' ')
c
	if(idata.eq.1) then
	  type *,' enable tracking in edit function ?'
	  itrack = noyes(ldum)
	  if (iexist.eq.0) call makseq(ierr)
	endif
c
	type *,' label stations at edit level ?'
	labswt=noyes(ldum)
c
10	type *,' default box size (.01 to 1.0 of active grid) :'
	read(5,*,end=10,err=10) fract
	if(fract.le.0.01) go to 10
	if(fract.gt.1.0)  go to 10
c
20	type *,' number of contour intervals (1 to 50) :'
	read(5,*,end=20,err=20) ncontd
c
30	type *,' angle of data labels'
	read(5,*,end=30,err=30) angle
	call tclear(1)
	call tmode(modein)	
	return
	end
c******************************************************************************
	subroutine getblk(p1,p2,ibx,iby,iout)
c  get beginning and end block addresses
	common /data/   ibsiz,nsec,ntier,nran,maxrec,nval,nseq,lstout
	common /header/ dval,id(14),ipgm(2),nc,nr,nz,
	1               xo,dx,yo,dy
	dimension p1(2),p2(2),ibx(2),iby(2)
c
	do i=1,2
	  ibx(i)=0
	  iby(i)=0
	enddo
	if(ibsiz.le.0 .or. maxrec.le.0) then
	  type *,' getblk: error in data file addresses'
	  return
	endif
	rdb=1.0/(dx*float(ibsiz))
	x2 = 1.0 - rdb*xo
	y2 = 1.0 - rdb*yo
	ibx(1)=int(rdb*p1(1)+x2)
	ibx(2)=int(rdb*p2(1)+x2)
	iby(1)=int(rdb*p1(2)+y2)
	iby(2)=int(rdb*p2(2)+y2)
	iout=0
	if(ibx(1).lt.1 .or. ibx(2).gt.nsec)  iout=1
	if(iby(1).lt.1 .or. iby(2).gt.ntier) iout=1
	if(ibx(1).lt.1) ibx(1)=1
	if(ibx(2).gt.nsec)  ibx(2)=nsec
	if(iby(1).lt.1) iby(1)=1
	if(iby(2).gt.ntier) iby(2)=ntier
	return
	end
c******************************************************************************
	subroutine getbox(p1,p2)
	common /tty/    ipen,ich 
	dimension p1(2),p2(2)
	if(p1(1).eq.p2(1) .or. p1(2).eq.p2(2)) 
	1                             call defbox(0.10, p1,p2)
	call box(p1,p2)	
	call tpromp(1,1,1,'lower-left box corner is reference')
	call tpromp(1,2,1,'move crosshair to adjust size')
	ipen = 0
	call cursdu(ipen,ich,xdu,ydu)
	call tclear(1)
	call tdraw(1)
	call box(p1,p2)
	call tdraw(0)
	p2(1) = xdu
	p2(2) = ydu
	call box(p1,p2)
	ipen = 1
	return
	end
c******************************************************************************
	subroutine getesc(ipar,np,head,tail,escseq)
	dimension ipar(np)
	character*4 par(10)
	character head*(*),tail*(*),escseq*(*)
	lenh=len(head)
	lent=len(tail)
	lene=len(escseq)
	do 10 i=1,np
	 write(par(i),5) ipar(i)
5	 format(i4)
10	continue
	escseq(1:lenh)=head
	is=lenh+1
	ie=is+3
	escseq(is:ie)=par(1)
	is=ie+1
	do 20 i=2,np
	escseq(is:is)=';'
	is=is+1
	ie=is+3
	escseq(is:ie)=par(i)
20	is=ie+1	
	ie=is+lent-1
	escseq(is:ie)=tail
c
	do 30 i=ie,1,-1
	if(escseq(i:i).eq.' ') escseq(i:i)='0'
30	continue
	return
c
c	left=lene
c	i=1
c25	if(i.gt.left) return
c	if(escseq(i:i).eq.' ') then
c	i2=i+1
c	i3=left-1
c	escseq(i:i3)=escseq(i2:left)
c	escseq(left:left)=' '
c	left=i3
c	go to 25
c	endif
c	i=i+1
c	go to 25
	end
c******************************************************************************
	subroutine getz(ngmax,nc2,nr2,xy,z)
c  prepare contourable z array
	common /dfile/   igrd
	common /header/  dval,id(14),ipgm(2),nc,nr,nz,
	1                xo,dx,yo,dy
	common /wrkgrd/  iwrkg,icount, c1(2,10),c2(2,10),nskip(10),
	1                icol(10),irow(10),ncw(10),nrw(10)
	dimension xy(1),z(1)
c
	ngrd = ncw(iwrkg)*nrw(iwrkg)
	nskip(iwrkg) = 1 + int( sqrt( float(ngrd)/float(ngmax) ))
	nc2 = ncw(iwrkg)/nskip(iwrkg)
	nr2 = nrw(iwrkg)/nskip(iwrkg)
c
	ngrd = nc2*nr2
	do iz = ngrd+1, ngrd+nc2
	  z(iz) = dval	  
	enddo
	iz = 1
	ioff = ngrd+1
	do j=1,nr2
	  jrec = irow(iwrkg) + nskip(iwrkg)*(j-1)
	  call rowda (nc,z(ioff),-1,jrec,igrd,ierr)
	  if (ierr.ne.0) type *,' getz: ierr=', ierr
	  ix = icol(iwrkg)
	  do i=1,nc2
	    z(iz) = z(ngrd+ix)
	    ix = ix + nskip(iwrkg)
	    iz = iz+1
	  enddo		
	enddo
c
	dx2 = dx*float(nskip(iwrkg))
	dy2 = dy*float(nskip(iwrkg))
	xo2 = xo + dx*float(icol(iwrkg) - 1)
	yo2 = yo + dy*float(irow(iwrkg) - 1)
	do i=1,nc2
	  xy(i)= xo2 + float(i-1)*dx2
	enddo
	ixy = nc2+1
	do i=1,nr2
	  xy(ixy)= yo2 + float(i-1)*dy2
	  ixy = ixy+1
	enddo
	return
	end
c******************************************************************************
	subroutine grd2da
c  convert input grid to random access, initialize wrkgrd common
	common /dfile/  igrd,   iran,   iran2,  ingrd,  indat,
	1               irf(14),ibf(14),isf(14),igf(14),idf(14)
	common /header/ dval,id(14),ipgm(2),nc,nr,nz,
	1               xo,dx,yo,dy,iflip,jflip
	common /wrkgrd/ iwrkg,icount,c1(2,10),c2(2,10),nskip(10),
	1               icol(10),irow(10),ncw(10),nrw(10)
	common /array/  z(40000)
	character*56 gfile,rfile
	equivalence (igf,gfile), (irf,rfile)
c
	open (ingrd, file=gfile, status='old', form='unformatted',
	1     readonly)
	read(ingrd) id,ipgm,nc,nr,nz,xo,dx,yo,dy
	if (dx.eq.0.0 .or. dy.eq.0.0) stop ' input dx or dy = zero'
	open (igrd, file=rfile, form='unformatted', status='scratch',
	1    access='direct', recl=nc, maxrec=nr)
c
c  shift origin to lower-left to avoid truncation problems
	iflip=0
	jflip=0
	if(dx.lt.0.0) then
	  dx=-dx
	  xo=-xo
	  iflip=1
	  type *,' flipping x direction'
	endif
	if(dy.lt.0.0) then
	  dy=-dy
	  yo=-yo
	  jflip=1
	  type *,' flipping y direction'
	endif
c
	iwrkg=1
	icount=1
	c1(1,1) = xo
	c1(2,1) = yo
	c2(1,1) = xo + dx*float(nc-1)
	c2(2,1) = yo + dy*float(nr-1)
	icol(1)=1
	irow(1)=1
	ncw(1)=nc
	nrw(1)=nr
c
	do j=1,nr
	  call rowio(nc,z,-1,ingrd,ingrd,iend)
	  if(ierr.ne.0) type *,' grd2da: iend=',iend
	  jrec=j
	  call rowda(nc,z,0,jrec,igrd,ierr)
	  if(ierr.ne.0) type *,' grd2da: ierr=',ierr
	enddo
	close(ingrd)
	return
	end
c******************************************************************************
	subroutine grdctl(nc,nr,xo,yo,del,ierr)
c  minimum curvature gridding control for up to 5000 grid points.
	common /dfile/  igrd,iran,iran2
	common /data/   ibsiz,nsec,ntier,nran,maxrec,nval,nseq,lstout
	common /header/ dval
	common /datai/  xyz(400), extra(1000)
	common /array/  zg(5000),iqd(5000),b(30000)
	dimension c1(2),c2(2),ibx(2),iby(2)
	character line*79
	data binit/1.0/, slope/0.0/, bxo,byo/0.0,0.0/
	data izset/1/, nim/50/, epsm/0.0/
c
	call tpromp(1,1,1,' regridding...')
	ierr=0
	ndata=0
	nn=nc*nr
	if(nn.gt.5000 .or. nn.le.25) go to 91
	do i=1,nn
	  iqd(i)=0
	  zg(i)=dval
	enddo
	do i=1,nn*6
	  b(i)=binit
	enddo
c
	c1(1) = xo
	c1(2) = yo
	c2(1) = xo + del*float(nc-1)	
	c2(2) = yo + del*float(nr-1)
	call getblk(c1,c2,ibx,iby,iout)
	rdel = 1.0/del
	x2 = 1.0 - xo*rdel
	y2 = 1.0 - yo*rdel
c
c  read data blocks near the working grid
	last = 0
	do 50 jblk = iby(1), iby(2)
	  if (jblk.eq.iby(2)) last = 1
	  do 50 iblk = ibx(1), ibx(2)+last
	    irec = iblk + nsec*(jblk-1)
	    if(last.eq.1 .and. iblk.eq.ibx(2)+1) irec = nsec*ntier+1
c  
20	read (iran,rec=irec,err=99,iostat=ierr) next,np,xyz
	npout=0
c  eliminate data outside of working grid
	if (np.gt.0) call packxy(nval,np,c1,c2,xyz,npout)
	np3 = npout*3
	if (np3.ge.3) then
	  ndata = ndata + npout
c  convert to grid units
	  do ix = 1, np3-2, 3
	    xyz(ix) = xyz(ix)*rdel + x2
	    iy = ix+1
	    xyz(iy) = xyz(iy)*rdel + y2
	  enddo
	  call assign(slope,bxo,byo,nc,nr,b,np3,xyz)
	endif
	if(next.eq.0) go to 50
	irec=next
	go to 20
50	continue
c
	if(ndata.eq.0) go to 99
	call bwts(izset,slope,binit,nc,nr,zg,iqd,b)
	call border(nc,nr,zg,iqd,xyz)
	call grdsrf(nc,nr,zg,xyz,dval,ierr)
	if(ierr.ne.0) go to 94
	call curvmn(zg,iqd,b,nc,nr,epsm,nim,st,end,ni)
	write (line,60) ndata,st,end
60	format(' ndata,start,end err',i6,2g15.4)
	call tpromp(1,1,1,line)
	call waiter(2.0)
	return
91	ierr=1
	return
94	ierr=4
99	return
	end
c******************************************************************************
	subroutine grdsrf(nc,nr,zg,wz,dval,ier)
c  quickly replace dvals with reasonable values.
c  A control net spaced at 'nsep' is generated from local surfaces or
c  ring averages with radii 3, nsep; linear interpolation completes 
c  the process.  Array 'wz' is at least max(nc,nr).
	dimension iw1(3)
	dimension zg(1),wz(1)
	data iw1/3,7,9/
	ier=0
	nn=nc*nr
	nsep=(iw1(3)-1)/2
	ns1=nsep+1
	mxpass=max(nc,nr)/(2*nsep)
	i=1
201	if(i.gt.nn) return
	if(zg(i).ge.dval) go to 200
	i=i+1
	go to 201
c
c  insert control point net
c     distances for ring averages specified by iw1
200	if(nc.lt.nsep+ns1 .or. nr.lt.nsep+ns1) go to 140
	ipass=0
	iflag=2
130	iw=iw1(iflag)
	ihw=(iw-1)/2
	iset=ihw*nc+ihw
131	nass=0
	do 110 jj=ns1,nr-ihw,nsep
	ip=(jj-1)*nc+ns1
	do 100 ii=ns1,nc-ihw,nsep
	if(zg(ip).lt.dval) go to 100
	  call fit3c(dval,ihw,ii,jj,nc,nr,zg,ifit)
	  if(ifit.eq.1 .or. iflag.eq.2) go to 100
	ips=ip-iset
	it=0
	t=0.0
	do 121 j=1,iw
	ip2=ips
	do 120 i=1,iw
	if(zg(ip2).ge.dval) go to 120
	t=zg(ip2)+t
	it=it+1
120	ip2=ip2+1
121	ips=ips+nc
	if(it-3.lt.0) go to 100
	zg(ip)=t/float(it)
	nass=nass+1
100	ip=ip+nsep
110	continue
	ipass=ipass+1
	if(nass.eq.0 .and. iflag.eq.3) go to 140
	if(ipass.gt.mxpass) go to 140
	if(iflag-2)133,132,131
133	iflag=2
	go to 130
132	iflag=3
	go to 130
140	continue
c
c  fill holes
	inc=nc*nsep
	j=inc+1
	if(nr.lt.ns1) go to 21
	do 20 irow=ns1,nr-nsep,nsep
	call plugm(nc,zg(j),dval)
20	j=j+inc
21	do 28 icol=1,nc
	j=icol
	do 22 k=1,nr
	wz(k)=zg(j)
22	j=j+nc
	call plugm(nr,wz,dval)
	j=icol
	do 24 k=1,nr
	zg(j)=wz(k)
24	j=j+nc
28	continue
c  final check
	do 40 i=1,nn
	if(zg(i).ge.dval) go to 41
40	continue
	return
41	t=0.0
	it=0
	do 42 i=1,nn
	if(zg(i).ge.dval) go to 42
	t=t+zg(i)
	it=it+1
42	continue
	if(it.eq.0) stop ' cannot init grid'
	t=t/float(it)
	type  43,t
43	format(' gridr init with',1pe15.5)
	do 44 i=1,nn
	if(zg(i).ge.dval) zg(i)=t
44	continue
	return
	end
c******************************************************************************
	subroutine initc
	common /exist/  idata,iseqex
	common /dfile/  igrd,   iran,   iran2,  ingrd,  indat,
	1               irf(14),ibf(14),isf(14),igf(14),idf(14)
	common /wrkgrd/ iwrkg,icount,c1(2,10),c2(2,10),nskip(10),
	1               icol(10),irow(10),ncwrk(10),nrwrk(10)
	common /data/   ibsiz,nsec,ntier,nran,maxrec,nval,nseq
	common /header/ dval,id(14),ipgm(2),nc,nr,nz,
	1               xo,dx,yo,dy,iflip,jflip
	common /contou/ icoper,ncontd,nlevel,ncsam,nrsam,clevel(50),
	1               ltype(50),xydist(400)
	common /edit/   fract,lswt1,iold,zold,znew,itrack
	common /stalab/ isymb,sizsta,sizlab,angle,labfmt(3)
	common /tty/    ipen,ich
c
	character*56 rfile, bfile, sfile
	equivalence (irf,rfile), (ibf,bfile), (isf,sfile)
	data dv/'ffff7fff'x/
c exist common
	idata = 0
	iseqex = 0
c dfile common
	igrd  = 10
	iran  = 11
	iran2 = 12
	ingrd = 13
	indat = 14
	rfile = 'grafrow.tmp'
	bfile = 'grafblk.tmp'
	sfile = 'grafseq.tmp'
c data common
	nran=400
	nval=4
c header common
	dval=dv
c contou common
	ncontd=20
c edit common
	fract=0.05
	lswt1=1
	itrack=0
c stalab common
	isymb=6
	sizsta=0.03
	sizlab=0.08
	angle=0.0
	labfmt(1)=0
c tty common
	ipen=1
	return
	end
c******************************************************************************
	subroutine inits
	common /save/   is(50)
	common /dfile/  igrd,iran,iran2,ingrd,indat
	common /data/   ibsiz,nsec,ntier,nran,maxrec,nval,nseq
	common /header/ dval,id(14),ipgm(2),nc,nr,nz,
	1               x(4),iflip,jflip
	common /wrkgrd/ iwrkg,icount,c1(2,10),c2(2,10),nskip(10),
	1               icol(10),irow(10),ncwrk(10),nrwrk(10)
	equivalence (dval,idval), (x,ix)
	dimension ix(4)
c
	is(1) = igrd
	is(2) = iran
	is(3) = ibsiz
	is(4) = nsec
	is(5) = ntier
	is(6) = nran
	is(7) = nval
	is(8) = idval
	is(9) = nc
	is(10) = nr
	is(11) = ix(1)
	is(12) = ix(2)
	is(13) = ix(3)
	is(14) = ix(4)
	is(15) = iflip
	is(16) = jflip
	is(17) = ingrd
	is(18) = indat
	is(19) = maxrec
	is(20) = nseq
	return
	end
c******************************************************************************
	subroutine lablpt(labswt,xyz)
	common /stalab/ isymb,sizsta,sizlab,angle,labfmt(3)
	dimension xyz(3)
	character plab*16, fmtlab*12
	equivalence (labfmt,fmtlab)
c
	call symbol(xyz(1),xyz(2),1,isymb,sizsta,angle)
	if(labswt.eq.1) then
	  write(plab,fmtlab,err=99) xyz(3)
	  nch=leftj(plab)
	    do ich=nch,2,-1
	    if(plab(ich:ich).ne.'0') then
	      call du2pu(xyz(1),xyz(2),xin,yin)
	      xin=xin+sizlab
	      call text(xin,yin,plab(1:ich),sizlab,angle)
	      return
	    endif
	    enddo
	endif
99	return
	end	
c******************************************************************************
	function leftj(a)
c  left justifies a string and returns the position
c  of the last nonblank character
	character a*(*)
	n = len(a)
	ich = ichar(a(1:1))
	if (ich.ne.0 .and. ich.ne.32) go to 15
	do 1 m = 2, n
	ich = ichar(a(m:m))
1	if (ich.ne.0 .and. ich.ne.32) go to 5
	leftj = 0
	return
c
5	i2 = 0
	do 10 i = m, n
	i2 = i2 + 1
	a(i2:i2) = a(i:i)
10	continue
	do 11 i3 = i2+1, n
11	a(i3:i3) = ' '
	n = n-m+1
c
15	do 20 leftj = n, 1, -1
	ich = ichar(a(leftj:leftj))
20	if (ich.ne.0 .and. ich.ne.32) go to 25
25	return
	end
c******************************************************************************
	function lenrec(idev)
c  find the number of words in a data file record
	integer*4 iz(24)
	do 15 lenrec = 24,1,-1
	  read(idev,err=10) (iz(i),i=1,lenrec)
	  go to 20
10	  rewind idev
15	continue
20	rewind idev
	return
	end
c******************************************************************************
	subroutine makran(za,nzrec,iz)
c  data are stored in nsec*ntier+1 pidgeon holes.
c  the last hole receives the data that fall outside the grid.
	common /dfile/  igrd,   iran,   iran2,  ingrd,  indat,
	1               irf(14),ibf(14),isf(14),igf(14),idf(14)
	common /header/ dval,id(14),ipgm(2),nc,nr,nz,
	1               xo,dx,yo,dy,iflip,jflip
	common /data/   ibsiz,nsec,ntier,nran,maxrec,nval,nseq,lstout
	common /datai/  loca(200),ioff(200)
	common /array/  wrk(40000)
	dimension idsta(2),za(nzrec)
	character bfile*56
	logical xyzrec
	equivalence (ibf,bfile)
	data nwrk/40000/
c
	xyzrec = .true.
	if (nzrec.gt.1) xyzrec = .false.
	open (iran,  file=bfile, form='unformatted', status='scratch', 
	1     access='direct', recl=nran+2)
c
	del   = dx
	ibsiz = 10
10	nsec  = 1 + nc/ibsiz
	ntier = 1 + nr/ibsiz
	nblk  = nsec*ntier
	nblk1 = 1 + nblk
	if (nblk1.le.200) go to 20
	ibsiz = 1 + ibsiz
	go to 10
c
20	npb = int (float(nwrk)/float(nval*nblk1))
	if (npb.gt.nran/nval) npb = nran/nval
	nvb  = nval*npb
	nchk = nvb-nval
	rdb  = 1.0/(del*float(ibsiz))
	x2   = 1.0 - xo*rdb
	y2   = 1.0 - yo*rdb
c
c   'loca' contains the address where a block of data will be written.
c   a linked list is formed by 'next'.
	do i=1,nblk1
	  ioff(i)=1
	  loca(i)=i
	enddo
c   A data value resides in 4 contiguous words: x,y,z,and a sequence number
	do i=1,nvb*nblk1
	  wrk(i)=0.0
	enddo
c
c  read data, find pigeon hole
	next=nblk1+1
	ic=0
100	if (xyzrec) then
	  read(indat,end=200) xin,yin,z
	  else
	  read(indat,end=200) idsta,xin,yin,za
	  z = za(iz)
	endif
	if(iflip.ne.0) xin = -xin
	if(jflip.ne.0) yin = -yin
	ic = ic + 1
	if(mod(ic,1000).eq.0) type *,'count=',ic
	ibx  = int(rdb*xin+x2)
	iby  = int(rdb*yin+y2)
	mblk = (iby-1)*nsec+ibx
	if (ibx.lt.1 .or. ibx.gt.nsec)  mblk=nblk1
	if (iby.lt.1 .or. iby.gt.ntier) mblk=nblk1
c
c  put data in pigeon hole, output when full
	ixs=(mblk-1)*nvb
	ip=ixs+ioff(mblk)
	wrk(ip) = xin
	wrk(ip+1)=yin
	wrk(ip+2)=z
	wrk(ip+3)=float(ic)
	ioff(mblk)=ioff(mblk)+nval
	if(ioff(mblk).lt.nvb) go to 100
	ndp=(ioff(mblk)-1)/nval
	call wrblk2(iran,loca(mblk),next,ndp,nran,wrk(ixs+1))
	loca(mblk)=next
	next=next+1
	ioff(mblk)=1
	go to 100
c
c   output all pigeon holes
200	maxrec = next - 1
	ip=1
	next=0
	lstrec = 0
	do i=1,nblk1
	  ndp=(ioff(i)-1)/nval
	  call wrblk2(iran,loca(i),next,ndp,nran,wrk(ip))
	  ip=ip+nvb
	  if (loca(i).gt.lstrec) lstrec = loca(i)
	enddo
	if (maxrec.ne.lstrec) 
	1   type *,'makran: next-1.ne.last record',maxrec,lstrec
c
	type *,ic,' data points'
	nseq = ic
c  the last outside (nblk1) record collects added points
	lstout = loca(nblk1)
	return
	end
c******************************************************************************
	subroutine makseq(ierr)
	common /exist/  idata,iexist
	common /dfile/  igrd,   iran,   iran2,  ingrd,  indat,
	1               irf(14),ibf(14),isf(14),igf(14),idf(14)
	common /data/   ibsiz,nsec,ntier,nran,maxrec,nval,nseq,lstout
	common /datai/  xyz(400)
	dimension abc(3),i2(2)
	character sfile*56
	equivalence (isf,sfile)
	if (iexist.eq.1) go to 1
c  create sequence file
	iexist = 1
	open (iran2, file=sfile, status='scratch', recl=5,
	1     form='unformatted', access='direct')
	do i=1,3
	  abc(i)=0.0
	  if(i.ne.3) i2(i)=0
	enddo
	do jrec = nseq+1, nseq+100
	 write (iran2,rec=jrec) abc,i2
	enddo
c
c  update sequence file from blocked file
c  a deleted data point is flagged by a negative position pointer
1	iwrt = 0
	do 40 iblk = 1, nsec*ntier+1
	irec = iblk
10	read (iran,rec=irec,err=40) next,ndp,xyz
	ix = 1
	do 30 ipt = 1,ndp
	  ix3 = ix + 3
	  ipt2 = isign (ipt, int(xyz(ix3)) )
	  jrec = int (abs (xyz(ix3)) + .01)
	  write (iran2,rec=jrec,err=20) xyz(ix),xyz(ix+1),xyz(ix+2),
	1                               irec,ipt2
	  ix = ix + nval
	  go to 30
20	  iwrt = iwrt + 1
30	continue
	irec = next
	if (irec.gt.0 .and. irec.le.maxrec) go to 10
40	continue
c
	if(iwrt.ne.0) type *,' makseq:',iwrt,' write errors'
	return
	end
c******************************************************************************
	subroutine menu(nbox,label)
	common /plot/   dumm(12),dxpw(2),dypw(2),xpw(4),ypw(4),
	1               xpix,ypix
	common /menu1/  mbox,menux,menudy
	character*12 label(nbox)
	mbox = nbox
	xsca = (dxpw(2)-dxpw(1)) / xpw(1)
	ysca = (dypw(2)-dypw(1)) / ypw(1)
	xleft = dxpw(2) - 1.0*xsca
	call line(xleft,  dypw(2),1,0,0)
	call line(dxpw(2),dypw(2),1,1,0)
	call line(dxpw(2),dypw(1),1,1,0)
	call line(xleft,  dypw(1),1,1,0)
	call line(xleft,  dypw(2),1,1,0)
	dy   = (dypw(2)-dypw(1)) / float(nbox)
	ybox = dypw(1) + dy
	do i = 1, nbox-1
	  call line(xleft,  ybox,1,0,0)
	  call line(dxpw(2),ybox,1,1,0)
	  ybox = ybox + dy
	enddo
	x = xleft + .1*xsca
	y = dypw(1) + dy/2.
	do i = 1, nbox
	  call vchar(x,y,%ref(label(i)),12,2,.1,0.,0.,0.)
	  y = y + dy
	enddo
	menux  = (xleft-dxpw(1)) / xpix
	menudy = 780 / nbox
	return
	end
c******************************************************************************
	subroutine menudvr(ipen,ich,x,y,ifunc)
	common /plot/ dumm(12),dxpw(2),dypw(2),dumm2(8),xpix,ypix
	common /menu1/ nbox,menux,menudy
	ifunc=0
	x=0.
	y=0.
	call tgin(ipen,ich,ix,iy)
	if(ix.gt.menux) then
	  ifunc=1+iy/menudy
	  if(ifunc.gt.nbox) ifunc=nbox
	else
	  x=float(ix)*xpix+dxpw(1)
	  y=float(iy)*ypix+dypw(1)
	endif
	return
	end
c******************************************************************************
	subroutine movbox(idev,ich,p1,p2)
	dimension p1(2),p2(2)
c  get new center
	call tpromp(1,1,1,'new box center')
	call cursdu(idev,ich,xcen,ycen)
	call tpromp(1,1,1,' ')
c  undraw old box
	call tdraw(1)
	call box(p1,p2)
	call tdraw(0)
c  draw new box
	hx=0.5*(p2(1)-p1(1))
	hy=0.5*(p2(2)-p1(2))
	p1(1)=xcen-hx
	p2(1)=xcen+hx
	p1(2)=ycen-hy
	p2(2)=ycen+hy
	call box(p1,p2)
	return
	end
c******************************************************************************
	function noyes(idum)
	character inp*20
	ic=0
	noyes=-1
1	continue
	read(5,2,err=5) inp
2	format(a20)
	if(ic.ge.3) go to 9
4	if(inp(1:1).eq.'y' .or. inp(1:1).eq.'Y') noyes=1
	if(inp(1:1).eq.'n' .or. inp(1:1).eq.'N') noyes=0
	if(noyes.gt.-1) return
5	type  6
6	format(' y or n:'$)
	ic=ic+1
	go to 1
9	type *,' count exceeded, answering no'
	noyes=0
	return
	end
c******************************************************************************
	subroutine opendf (nz,iz)
c  open data file and find type
	common /dfile/  igrd,   iran,   iran2,  ingrd,  indat,
	1               irf(14),ibf(14),isf(14),igf(14),idf(14)
	character*56 dfile
	equivalence (idf,dfile)
	nz = 1
	iz = 1
	open (indat, file=dfile, form='unformatted', status='old',
	1     readonly)
	nword = lenrec(indat)
c  default record type  -- x,y,z --
	if (nword.gt.3) then
c  setup for record type -- id(2),x,y,z(nz) --
	  nz = nword - 4
	  if (nz.lt.1) stop ' 4 word data record not presently defined'
10	  type 11, nz
11	  format(' found ',i3,' data channels')
	  type *,' which do you want ?'
	  read(5,*,end=10,err=10) iz
	  if (iz.gt.nz .or. iz.lt.1) go to 10
	endif
	return
	end
c******************************************************************************
	subroutine output(isave,za,nzrec,iz)
	common /dfile/  igrd,iran,iran2,ingrd,indat
	common /data/   ibsiz,nsec,ntier,nran,maxrec,nval,nseq,lstout
	common /header/ ifill(23),dy,iflip,jflip
	common /datai/  xyz(400)
	dimension abc(3),za(nzrec)
	character*56 prefix,ofile,ofile2
	character  idsta*8,suff*4,suff2*4
	data iout,idel/15,16/, suff,suff2/'.edt', '.del'/
c
	prefix=' '
	ofile=' '
	ofile2=' '
	isave=0
	iwarn=0
	tol = 0.001*dy
	ic=0
	ic2=0
	type 1
1	format(' do you want to output data ? '$)
	if(noyes(ldum).eq.0) return
	type 5
5	format(' enter output filename prefix : '$)
	read(5,37) prefix
37	format(a56)
c
c  skip over directory section, check for file prefix, strip extensions
	npre = leftj(prefix)
	nbrac = 1 + index (prefix,']')
	ndot = index (prefix(nbrac:npre),'.')
	if(ndot.gt.0) then
	  do i = ndot, npre
	  prefix(i:i)=' '
	  enddo
	  npre = ndot-1
	endif
c
	ofile(1:npre+4) = prefix(1:npre)//suff
	open(iout,file=ofile,status='new',form='unformatted',err=88)
	ofile2=' '
	ofile2(1:npre+4) = prefix(1:npre)//suff2
	open(idel,file=ofile2,status='new',form='formatted',err=99)
c
c  update sequence file
	call makseq(ierr)
c
	if (nzrec.eq.1) then
c  output binary xyz file
	  do iseq = 1, nseq
	    read(iran2,rec=iseq) abc,irec,ipt
	    if (iflip.ne.0) abc(1) = -abc(1)
	    if (jflip.ne.0) abc(2) = -abc(2)
	    if(ipt.gt.0) then
	      write(iout) abc
	      ic = ic + 1
	    else
	      write(idel,20) iseq, abc
20	      format(' #',i6,1x,1p3g13.5)
	      ic2 = ic2 + 1
	    endif
	  enddo
	  else
c  output a posting type record
	  rewind (indat)
	  do iseq = 1, nseq
	    read(indat,end=50,iostat=istat) idsta,x,y,za
	    go to 51
50	    idsta=' '
	    do i=1,nzrec
	      za(i)=0.0
	    enddo
51	    read(iran2,rec=iseq) abc,irec,ipt
	    if (iflip.ne.0) abc(1) = -abc(1)
	    if (jflip.ne.0) abc(2) = -abc(2)
	    za(iz) = abc(3)
	    xt = abs(x-abc(1))
	    yt = abs(y-abc(2))
	    if (istat.eq.0 .and. (xt.gt.tol .or. yt.gt.tol) ) then
	      iwarn = iwarn + 1
	      if(iwarn.eq.1) then
	        type *,'external x,y',x,y
	        type *,'internal x,y',abc(1),abc(2)
	        type *,'lost registration of output file'
	        type *,'continuing output'
	      endif
	    endif
	    if(ipt.gt.0) then
	      write(iout) idsta,abc(1),abc(2),za
	      ic = ic + 1
	    else
	      write(idel,52) iseq, idsta, abc(1),abc(2),za
52	      format(' #',i6,1x,a8,1p2g13.5,<nzrec>g13.5)
	      ic2 = ic2 + 1
	    endif
	  enddo
	endif
c
100	close(iout)
	close(idel)
	type *,' number saved, deleted :',ic,ic2
	type *,' edit   file is "', ofile (1:npre+4),'"'
	type *,' delete file is "', ofile2(1:npre+4),'"'
	isave=1
	if (iwarn.gt.0) type *,iwarn,' possibly misregistered stations'
	return
c
c
88	type *,' open error on edit file:',ofile
	return
99	type *,' open error on delete file:',ofile2
	close(iout)
	return
	end
c******************************************************************************
	subroutine packxy(nval,n,c1,c2,xyz,n2)
c  nval - number of values associated with each data point
c  n,n2 - are the number of input and output data points
	dimension c1(2),c2(2),xyz(400)
	data jval/3/
	ival = nval
	nin  = n*ival
	jx   = 0
	do 10 iflag = ival, nin, ival
	if(xyz(iflag).gt.0.0) then
	  ix=iflag-3
	  if(xyz(ix).lt.c1(1) .or. xyz(ix).gt.c2(1)) go to 10
	  iy=ix+1
	  if(xyz(iy).lt.c1(2) .or. xyz(iy).gt.c2(2)) go to 10
	  do k = ix, ix+2
	    jx = jx+1
	    xyz(jx) = xyz(k)
	  enddo
	endif
10	continue
	n2 = jx/jval
	itest = jx - n2*jval
	if(itest.ne.0) type *,'packxy: index error jx,n2',jx,n2
	return
	end
c******************************************************************************
	subroutine pltpt(labswt)
	common /dfile/  igrd,iran,iran2
	common /data/   ibsiz,nsec,ntier,nran,maxrec,nval,nseq
	common /wrkgrd/ iwrkg,icount,c1(2,10),c2(2,10),if2(50) 
	common /datai/  xyz(400)
	dimension ibx(2),iby(2)
	character prompt*79
c
	lab1=labswt
	xmn=c1(1,iwrkg)
	xmx=c2(1,iwrkg)
	ymn=c1(2,iwrkg)
	ymx=c2(2,iwrkg)
	ic=0
	call getblk(c1(1,iwrkg),c2(1,iwrkg),ibx,iby,iout)
	last = 0
	do 50 jblk = iby(1), iby(2)
	  if (jblk.eq.iby(2)) last = 1
	  do 50 iblk = ibx(1), ibx(2)+last
	    irec = iblk + nsec*(jblk-1)
	    if(last.eq.1 .and. iblk.eq.ibx(2)+1) irec = nsec*ntier+1
c
10	read(iran,rec=irec,err=999) next,np,xyz
	do 20 i=4,nval*np,nval
	if(xyz(i).gt.0.0) then
	  ix=i-3
	  if(xyz(ix).lt.xmn .or. xyz(ix).gt.xmx) go to 20
	  iy=ix+1
	  if(xyz(iy).lt.ymn .or. xyz(iy).gt.ymx) go to 20
	  call lablpt(lab1,xyz(ix))
	  ic=ic+1
	  if(ic.ge.100) lab1=0
	endif
20	continue
	if(next.eq.0) go to 50
	irec=next
	go to 10
50	continue
c
200	write(prompt,210) ic
210	format(1x,i7,' data points')
	call tpromp(1,1,1,prompt)
	return
999	write(prompt,888) irec
888	format(' pltpt: attempt to read record',i15)
	call tpromp(1,1,1,prompt)
	return
	end
c******************************************************************************
	subroutine plugm(n,z,dv)
c  plug holes using linear interpolation
	dimension z(n)
	do 1 is=1,n
	if(z(is) .lt. dv) go to 2
1	continue
	return
2	ix=is
3	ix=ix-1
	if(ix.lt.1) go to 4
	z(ix)=z(is)
	go to 3
4	do 5 idv=is,n
	if(z(idv) .ge. dv) go to 6
5	continue
	return
6	is=idv-1
	do 7 ie=idv,n
	if(z(ie) .lt. dv) go to 10
7	continue
	ix=is
9	ix=ix+1
	if(ix.gt.n) return
	z(ix)=z(is)
	go to 9
10	dz=(z(ie)-z(is))/float(ie-is)
	do 11 i=is+1,ie-1
11	z(i)=z(i-1)+dz
	is=ie
	go to 4
	end
c******************************************************************************
	subroutine regrd(ierr)
	common /dfile/  igrd,iran,iran2
	common /data/   ibsiz,nsec,ntier,nran,maxrec,nval,nseq
	common /wrkgrd/ iw,icount,c1(2,10),c2(2,10),nskip(10),
	1               icol(10),irow(10),ncw(10),nrw(10)
	common /header/ dval,id(14),ipgm(2),nc,nr,nz,
	1               xo,dx,yo,dy
	common /array/  zg(5000),iqd(5000),b(30000)
	common /datai/  row(1400)
	dimension zr(2)
	character line*79
	data ngmax/5000/
c
	ierr = 0
	nc2 = ncw(iw)
	nr2 = nrw(iw)
	nn = nc2*nr2
	if(nn.gt.ngmax .or. nn.le.25) then
	  write (line,1) nc2,nr2,ngmax
1	  format(' cannot regrid ',i3,' *',i3,' > ',i5,' grid points')
	  call tpromp(1,1,1,line)
	  ierr=1
	  return
	endif
	if(dx.ne.dy) then
	  call tpromp(1,1,1,' cannot regrid unless dx=dy')
	  ierr=1
	  return
	endif
c
c  grid the working area
	xo2 = xo + dx*float(icol(iw)-1)
	yo2 = yo + dy*float(irow(iw)-1)
	call grdctl(nc2,nr2,xo2,yo2,dx,ierr)
	if(ierr.ne.0) then
	  type *,' regrd: grdctl error=',ierr
	  return
	endif
	call dvmm (nn,zg,zr(1),zr(2),1.e20,idval)
	if (idval.ne.0) ierr=1
	if (zr(1).lt.-1.e20) ierr=2
	if (ierr.ne.0) then
	  type *,' regrd: range or dval error'
	  return
	endif
c
c  update grid file
	ird = 0
	iwt = 0
	irec = irow(iw)
	do j = 1,nr2
	  do i = 1,nc
	    row(i)=dval
	  enddo
	  call rowda(nc,row,-1,irec,igrd,ierr)
	  if(ierr.ne.0) ird = ird + 1
	  ig = 1 + nc2*(j-1)
	  do i = icol(iw), icol(iw)+nc2-1
	    row(i) = zg(ig)
	    ig = ig+1
	  enddo
	  call rowda(nc,row,0,irec,igrd,ierr)
	  if(ierr.ne.0) iwt = iwt + 1
	  irec = irec+1
	enddo
c
	if (ird.ne.0) type *,' regrd:',ird,' read errors on grid file'
	if (iwt.ne.0) type *,' regrd:',iwt,' write errors on grid file'
	return
	end
c******************************************************************************
	subroutine rowda(n,z,iop,irec,idev,ierr)
	dimension z(n)
	ierr=0
	if (iop.eq.0) then
	  write (idev,rec=irec,iostat=ierr) z
	  else
	  read  (idev,rec=irec,iostat=ierr) z
	endif
	return
	end
c******************************************************************************
	subroutine rowio(n,z,iop,idev,jdev,iend)
c  read iop<0, write iop=0, r&w iop=1
	dimension z(n)
	iend=0
	if(iop)1,2,1
1	read(idev,end=10) y,z
	if(iop)9,9,2
2	write(jdev) y,z
9	return
10	iend=1
	return
	end
c******************************************************************************
	subroutine setgrf(iscal,dxp,dyp,xp,yp,ihalfy)
c  input min,max data area coordinates, performs graph scaling call,
c  labels axis, and returns board info for tektronix screens.
c  iscal = 1 requires x,y scaling be the same
c  ihalfy = 0 use whole screen, ihalfy = -1,1 use lower or upper half
	dimension ifmt(5),jfmt(5),dxp(2),dyp(2),xp(4),yp(4) 
	character fmtx*20,fmty*20
	equivalence (fmtx,ifmt),(fmty,jfmt)
	dx=0.
	dy=0.
	call pltset(1,xp(4),yp(4),1)
	call setax(dxp,dx,20,nx,fmtx)
	call setax(dyp,dy,20,ny,fmty)
	halfy = 0.5*yp(4) 
	ymarg = 0.0
	if (ihalfy.eq.1) ymarg = halfy
	xp(3) = .08*( float( max(nx,ny) ) + 1.0 )
	yp(3) = xp(3) + ymarg
	ywid  = yp(4)
	if (ihalfy.eq.-1) ywid = halfy
	xp(1) = xp(4) - xp(3) - 1.5
	yp(1) = ywid  - yp(3) - .05
	if (iscal.eq.1) then
	  xd = dxp(2) - dxp(1)
	  yd = dyp(2) - dyp(1)
	  xsc  = xd / xp(1)
	  ysc  = yd / yp(1)
	  scal = amax1(xsc,ysc)
	  if (abs(scal).lt.1.e-10) scal = 1.0e-10
	  xp(1) = xd / scal
	  yp(1) = yd / scal
	endif
	call scale(dxp,dyp,xp,yp,4,ier)
	if(iscal.eq.1) then
	  if(dy.lt.dx) then
	   dx   = dy
	   fmtx = fmty
	   nx   = ny
	   else
	   dy   = dx
	   fmty = fmtx
	   ny   = nx
	  endif
	endif
	call xaxis(dxp,dyp,xp,dx,5,.08,ifmt,nx)
	call yaxis(dyp,dxp,yp,dy,5,.08,jfmt,ny)
	return
	end
c******************************************************************************
	subroutine sendesc(tail)
	character head*2,tail*(*)
	equivalence (nullesc,head)
	data nullesc/'00001b00'x/
	n=len(tail)
	write(6,1) head,tail
1	format(a2,a<n>)
	return
	end
c******************************************************************************
	subroutine setax(x,dx,maxint,nch,fmt)
c  adjust interval and labeling format
c  input x-min max range, optional dx-spacing and maxint-intervals
c  returns dx, nch-number of significant figures, fmt-labeling format
	dimension x(2)
	character fmt*(*)
	ixpn(r) = int( alog10(abs(r)) + 100. ) - 100
	fmt = '(1pe13.6)'
	nch = 13
	if (maxint.le.0)  maxint = 20
	dt = abs( x(2) - x(1) ) / float(maxint)
	if(dx.eq.0.0) then
	  dx = 1.0
	  if (dt .lt. 1.0e-30) return
	  p10 = sign(1.0,dt) * 10.**ixpn(dt)
	  t1  = dt / p10
	  if (t1.le.1.0) dx = p10
	  if (t1.gt.1.0) dx = 2.*p10
	  if (t1.gt.2.0) dx = 5.*p10
	  if (t1.gt.5.0) dx = 10.*p10
	endif
	m10 = ixpn( dx )
	m20 = ixpn( amax1(abs(x(1)),abs(x(2))) )
	idecm = 0
	if (m10.lt.0) idecm = iabs(m10)
	iw = 4 + idecm
	if (m20.ge.1) iw = iw + m20
	if (iw.gt.9 .or. idecm.gt.9) go to 99
	write (fmt,10) iw,idecm
10	format('(f',i1,'.',i1,')' )
	nch = iw
	if (idecm.eq.0) nch = nch - 1
99	return
	end
c******************************************************************************
	subroutine solv3(a,b,c,ierr)
	dimension a(9),b(3),c(3)
	ierr=1
	tol=1.e-20
	if(abs(a(1)).lt.tol) return
	if(abs(a(4)).lt.tol) return
	if(abs(a(3)).gt.tol) then
	  piv = a(1)/a(3)
	  aa = piv*a(6) - a(4)
	  bb = piv*a(9) - a(7)
	  cc = piv*b(3) - b(1)
	else
	  aa = a(6)
	  bb = a(9)
	  cc = b(3)
	endif
	if(abs(a(2)).gt.tol) then
	  piv = a(1)/a(2)
	  dd = piv*a(5) - a(4)
	  ee = piv*a(8) - a(7)
	  ff = piv*b(2) - b(1)
	else
	  dd = a(5)
	  ee = a(8)
	  ff = b(2)
	endif
	if(abs(aa).gt.tol) then
	  piv = dd/aa
	  gg = piv*bb - ee
	  hh = piv*cc - ff
	else
	  gg = bb
	  hh = cc
	endif
	if (abs(gg).lt.tol .or. abs(dd).lt.tol) return
	c(3) = hh/gg
	c(2) = (ff - ee*c(3)) / dd
	c(1) = (b(1) - a(7)*c(3) - a(4)*c(2)) / a(1)
	ierr=0
	return
	end
c******************************************************************************
	subroutine text(x,y,string,size,angle)
c  text driver where x,y are in plot units.
	dimension is(25)
	character s*100
	character string*(*)
	equivalence (is,s)
	data icode/3/, xoff,yoff/0.0,0.0/
	lenstr=len(string)
	do nch=lenstr,1,-1
	  ich=ichar(string(nch:nch))
	  if(ich.gt.32 .and. ich.lt.127) go to 10
	enddo
	return
10	s(1:nch)=string(1:nch)
	radian=1.7453292e-2*angle
	call vchar(x,y,is,nch,icode,size,radian,xoff,yoff)
	return
	end
c******************************************************************************
	subroutine symbol(x,y,nxy,ich,size,angle)
c  symbol driver where x,y are in data units (clipping occurs outside
c  the data window).
c  'ich' is an integer akin to fortran 77 coding ich=038=ichar('&').
c  'vchar'  uses 1-13, 24-31 for symbols such as diamonds and squares, 
c  and 32-126 as the normal ascii character sequence when icode=1.
	dimension x(nxy),y(nxy)
	data icode/1/, xoff,yoff/0.0,0.0/
	radian=1.7453292e-2*angle
	call vchar(x,y,ich,nxy,icode,size,radian,xoff,yoff)
	return
	end
c******************************************************************************
	subroutine trackz(ichang,iseq)
c  Track sequential data points with zold and update to znew.
c  note xyz is different from the active block xyz and this routine updates
c  point iseq.  ipyram(1) is a pyramid pointing down, (2) points up.
	common /dfile/  igrd,iran,iran2
	common /data/   ibsiz,nsec,ntier,nran,maxrec,nval,nseq,lstout
	common /wrkgrd/ iwk,icount,c1(2,10),c2(2,10)
	common /edit/   fract,labswt,iold,zold,znew
	common /stalab/ isymb,sizsta,sizlab,angle,ifmt(3)
	common /actblk/ iblock,irecin
	common /array/  xyz(400)
	dimension nt(2), ipyram(2)
	dimension xt(20),yt(20),zt(20),irt(20),ipt(20)
	character line*79
	data maxtrk/11/, ipyram/12,11/
c
	size2  = sizlab
	xmin = c1(1,iwk)
	xmax = c2(1,iwk)
	ymin = c1(2,iwk)
	ymax = c2(2,iwk)
	if (iseq.le.0 .or. iseq.gt.nseq) return
	it=1
	read (iran2,rec=iseq,err=999) xt(1),yt(1),zt(1),irt(1),ipt(1)
	call symbol(xt(it),yt(it),1,ipyram(1),size2,angle)
c
c  track negative then positive direction
	do 100 idir = 1,2
	ione = -1
	maxt = 1 + maxtrk/2
	if (idir.eq.2) then
	  ione = 1
	  maxt = maxtrk
	endif
c  step through the sequential file
	jrec = iseq + ione
10	if (jrec.le.0 .or. jrec.gt.nseq) go to 100
	it = it + 1
	read (iran2,rec=jrec,err=50) 
	1     xt(it),yt(it),zt(it),irt(it),ipt(it)
	if (zt(it).eq.zold) then
	  if (xt(it).lt.xmin .or. xt(it).gt.xmax) go to 50
	  if (yt(it).lt.ymin .or. yt(it).gt.ymax) go to 50
	  call symbol(xt(it),yt(it),1,ipyram(idir),size2,angle)
 	  jrec = jrec + ione
	  if (it.lt.maxt) go to 10
	endif
	go to 100
50	it = it - 1
100	nt(idir) = it
	nt(2) = nt(2) - nt(1)
c
	call tmode(1)
	call tpromp(1,1,1,' ')
	type *,' tracking ',zold
	type *,' found',nt(1),' on the down side'
	type *,' and  ',nt(2),' on the up side'
110	type *,' enter number of points to change on the down side'
	read(5,*,err=110) nt1
	if (nt1.eq.0) nt1 = 1
	type *,' enter number of points to change on the up side'
	read(5,*,err=110) nt2
	call tclear(1)
	if (nt1.lt.0 .or. nt1.gt.nt(1)) nt1 = nt(1)
	if (nt2.lt.0 .or. nt2.gt.nt(2)) nt2 = nt(2)
	call tmode(3)
	if(nt1.lt.nt(1) .or. nt2.lt.nt(2)) then
	  call tdraw(1)
	  do i = nt(1), nt1+1, -1
	    call symbol(xt(i),yt(i),1,ipyram(1),size2,angle)
	  enddo	  
	  do i = nt(1)+nt(2), nt(1)+nt2+1, -1
	    call symbol(xt(i),yt(i),1,ipyram(2),size2,angle)
	  enddo	  
	  call tdraw(0)
	endif
c
c  update block and sequence files
c  "deleted" points are updated also
	ierrt = 0
	do idir = 1, 2
	is = 1
	ie = nt1
	if (idir.eq.2) then
	  is = nt(1)+1
	  ie = nt(1)+nt2
	endif
c
	do i = is, ie
	  read(iran,rec=irt(i),err=200,iostat=ierr) next,ndp,xyz
	  ix = 1 + nval*(ipt(i)-1)
	  if (xyz(ix).eq.xt(i)) then
	    call tdraw(1)
	    call lablpt(1,xyz(ix))
	    xyz(ix+2) = znew
	    call tdraw(0)
	    call lablpt(1,xyz(ix))
	    jrec = int (abs (xyz(ix+3)) + .01)
	    write (iran, rec=irt(i),err=200,iostat=ierr) next,ndp,xyz
	    if (i.eq.1) ichang=0
	    write (iran2,rec=jrec,  err=200,iostat=ierr) 
	1   xt(i),yt(i),znew,irt(i),ipt(i)
	  else
	    type *,' trackz: xyz address error'
	  endif
200	  if (ierr.ne.0) ierrt = ierrt + 1
	enddo
	enddo
c
	if (ierrt.ne.0) then
	  write(line,400) ierrt
400	  format(' trackz:',i5,' random access read/write errors')
	  call tpromp(1,1,1,line)
	endif
999	return
	end
c******************************************************************************
	subroutine tmode(mode1)
c
c  enter various terminal modes
c
c  iterm 1= DEC VT100 /w Digital Engineering Retrographics
c        2= Tektronix
c        3= Selanar HiRez 100
c        5= Northwest Digital Systems G-29
c
c  mode  1= internal character, 2= alpha, 3= vector, 
c        4= crosshair, 5= light pen, 6= internal graphics
c
c  where internal means characters sent to the terminal character generators.
c  alpha and vector are compatible with PLOT-10 software.
c
	common /tty1/ iterm,mode2
c
	mode = mode1
1	continue
	if(iterm.lt.1 .or. iterm.gt.5) then
	  type *,' please identify terminal'
	  type *,' 1=Dig. Eng., 2=Tektronics, 3=Selanar'
	  type *,' 4=Envision,  5=NDS G-29'
	  read(5,*,err=1) iterm
c  and always go to character mode
	  mode = 1
	  if (iterm.eq.5) call tinit
	  go to 1
	endif
c
c  VT100 /w Digital Engineering graphics vt640
	if(iterm.eq.1) then
	  if(mode.eq.1 .and. mode2.ne.1) call sendesc('"0g')
	  if(mode.eq.2) call sendesc(char(31))
	  if(mode.ge.3) call sendesc(char(29))
	  if(mode.eq.4) call sendesc('"4g')
c     flash 'light pen ready' on VT100 line 22
	  if(mode.ge.5) call sendesc('"3e')
	  if(mode.ge.5) call sendesc('"5g')
	endif
c
c  Tektronix 4010/14
	if(iterm.eq.2) then
	  if(mode.eq.1) call sendesc(char(31))
	  if(mode.eq.2) call sendesc(char(31))
	  if(mode.eq.3) call sendesc(char(29))
	  if(mode.eq.4) call sendesc(char(26))
	  if(mode.eq.5) call sendesc(char(26))
	endif
c
c  Selanar HiRez 100
	if(iterm.eq.3) then
	  if(mode.eq.1) call sendesc('2')
	  if(mode.gt.1 .and. mode2.eq.1) call sendesc('1')
	  if(mode.eq.2) then
	    call sendesc(char(29))
	    call sendesc(char(31))
	  endif
	  if(mode.ge.3) call sendesc(char(29))
	  if(mode.ge.4) call sendesc(char(26))
	endif
c
c  Envision
	if(iterm.eq.4) then
	  if(mode.eq.1) call sendesc(char(31))
	  if(mode.gt.1) call sendesc(char(29))
	  if(mode.eq.4) call sendesc(char(26))
	  if(mode.eq.5) continue
	  if(mode.eq.6) continue
	endif
c
c  Northwest Digital G-29
	if(iterm.eq.5) then
c	  if(mode.eq.1) call sendesc(char(2))
c  select plane 1 for writing characters 
	  if (mode.eq.1 .or. mode.eq.2) then
	    call sendesc(char(18))
	    type *,'1 o'
	    call sendesc(char(31))
	  endif	    
	  if (mode.ge.3) then
c  select graphics plane 2
	    call sendesc(char(18))
	    type *,'2 o'
	    call sendesc(char(29))
	  endif
	  if(mode.eq.4) call sendesc(char(26))
	  if(mode.eq.5) call sendesc(char(26))
	  if(mode.eq.6) call sendesc(char(18))
	endif
c
	mode2 = mode
	return
	end
c*******************************************************************************
	subroutine tinit
c  initialize NDS terminal to combined plane operation
	character dc2*1
c  combined planes
	call sendesc('[=6h')
c  graphics
	call sendesc(char(12))
c  enter NDS 'easy-entry' graphics
	dc2 = char(18)
	type *,dc2
c  set plane origin at 0,0 and display to OR'd planes.
	type *,'0 0 3 s'
c  return to Tek graf
	call sendesc(char(29))
	return
	end
c******************************************************************************
	subroutine twhat
	common /tty1/ iterm,mode
	character resp*20
	call sendesc(char(5))
	read(5,1) resp
1	format(a20)
	if(resp(1:5).eq.'de640') iterm=1
	if(resp(1:5).eq.'selan') iterm=3
	return
	end
c******************************************************************************
	subroutine tdraw(iop)
c  drawing mode:  iop= 0 pixel on, 1 off, 2 toggled
	common /tty1/ iterm,mode
	character*3 retro(3)
	character*8 selnar(3)
	character*1 nds(3)
	data retro/ '/0d', '/1d', '/2d' /, 
	1   selnar/ 'OW `` @@', 'OW b` @@', 'OW a` @@' /
	1   nds/    '2',   '0',   '1'/
c
	iop1 = iop+1
	if (iop1.lt.1 .or. iop1.gt.3) iop1=1
	call tmode(3)
	if (iterm.eq.1) call sendesc( retro(iop1) )
	if (iterm.eq.2) return
	if (iterm.eq.3) call sendesc( selnar(iop1) )
	if (iterm.eq.4) return
	if (iterm.eq.5) call sendesc( nds(iop1) )
	return
	end
c******************************************************************************
	subroutine tclear(iop1)
c  clear screen, return to entering mode
c  iop=0   clear all
c  iop=1   character plane
c  iop=2   graphics plane
	common /tty1/ iterm,mode
	modein = mode
	if ( iopt1.lt.0 .or. iop1.gt.2 ) return
	is = 1
	ie = 2
	if(iop1.gt.0) then
	  is   = iop1
	  ie   = iop1
	endif
c
	do iop = is,ie
c
	if (iterm.ne.2) then
	  if(iop.eq.1) then
	    call tmode(1)
	    if (iterm.ne.5) then
	      call sendesc('[2J')
	      call sendesc('[0;1f')
	      else
	      call sendesc(char(12))
	    endif
	  endif
	  if (iop.eq.2) then
	    call tmode(3)
	    call sendesc(char(12))
	  endif
	endif
c
c  Tektronix 4014
	if(iterm.eq.2) then
c    let the user clear the alpha plane
	  if (iop.eq.2) call sendesc(char(12))
	endif
c
	enddo
c
	call tmode (modein)
	return
	end
c******************************************************************************
	subroutine tgin(ipen,ich,ix,iy)
c  GIN controller 
c  input device type: ipen= 0 crosshair, 1 lightpen
	common /tty1/ iterm,mode
	character bell*1,ch*1,cxy*4
	dimension ixy(4)
	data itty/5/,maxx/1020/
	modein = mode
c
1	inpmod = 4 + ipen
	call tmode(3)
	call tmode(inpmod)
c
c  decode Plot-10 formatted coordinates
	read(itty,10,end=1,err=1) ch,cxy
10	format(a1,a4)
	ich = ichar(ch)
	do i = 1, 4
	  ixy(i) = ichar( cxy(i:i) ) - 32
	enddo
	ix = 32*ixy(1) + ixy(2)
	iy = 32*ixy(3) + ixy(4)
c
c  check for Retrographics light pen decode error
	if((ix.le.0 .and. iy.le.0) .and. iterm.eq.1) then
	  call tmode(inpmod)
c  trap terminal cycling in the case 'ch' is <cr>
	  read(itty,10,end=1,err=1) ch,cxy
	  read(itty,10,end=1,err=1) ch,cxy
	  go to 100
	endif
c
c  return terminal to entering mode and exit
	call tmode(modein)
	if (iterm.gt.1) return
c
c  trap wraparound bug in early Retrographics
	if((ix.lt.maxx .and. ipen.eq.1) .or. ipen.eq.0) return
c
c  type error message
100	call tmode(1)
	bell = char(7)
	type 150, bell
150	format(' conversion error, please reenter',a1)
	call waiter(2.0)
	call tclear(1)
	go to 1
	end
c******************************************************************************
	subroutine tpromp(iwrt,line,icol,prompt)
c  iwrite is the terminal plane to write into (ie. 1 or 2).
c  then reenters previous terminal mode
	common /tty1/ iterm,mode
	dimension iadr(2)
	character p79*79, setadr*16, cursor*2
	character prompt*(*)
	data itty/5/, cursor/'[H'/
	modein  = mode
	iwrite  = iwrt
	iadr(1) = line
	iadr(2) = icol

	if(iterm.eq.2 .or. iterm.eq.5 .or. iwrite.eq.2) then
c  writing plane is Tektronix
	  call tmode (2)
	  if (line.le.1 .and. icol.le.1) call tclear(1)
	else
c  writing plane is ANSI
	  call getesc(iadr,2,cursor(1:1),cursor(2:2),setadr)
	  call tmode(iwrite)
	  call sendesc(setadr)
	endif
c
	if (len(prompt).gt.1 .or. prompt(1:1).ne.' ') then
	  p79 = prompt
	  write(itty,10) p79
10	  format(1x,a79)
	endif
c
	call tmode(modein)
	return
	end
c******************************************************************************
	subroutine whscal
c  rescale entire board in coordinate system of dxp,dyp
c  xpix, ypix data units/Tektronix 4014 pixel
c  xscale, yscale are data units/inch
	common /plot/ dxp(2),dyp(2),xp(4),yp(4),dxpw(2),dypw(2),
	1             xpw(4),ypw(4),xpix,ypix,xscale,yscale
	dimension a(16)
	equivalence (a,dxpw(1))
	do 1 i=1,16
1	a(i)=0.
	xpw(1)=xp(4)
	ypw(1)=yp(4)
	xpw(4)=xp(4)
	ypw(4)=yp(4)
	xscale=(dxp(2)-dxp(1))/xp(1)
	yscale=(dyp(2)-dyp(1))/yp(1)
	xpix=xscale*xp(4)/1024.
	ypix=yscale*yp(4)/780.
	dxpw(1)=dxp(1)-xp(3)*xscale
	dypw(1)=dyp(1)-yp(3)*yscale
	dxpw(2)=xscale*xp(4)+dxpw(1)
	dypw(2)=yscale*yp(4)+dypw(1)
	call scale(dxpw,dypw,xpw,ypw,3,ier)
	if (ier.ne.0) type *,'whscal: scaling error'
	return
	end
c******************************************************************************
	subroutine wrblk2(iunit,iorec,next,ndp,nxyz,xyz)
	dimension xyz(nxyz)
	write(iunit,rec=iorec,err=99,iostat=ierr) next,ndp,xyz
	return
99	type *,' wrblk2: write error'
	type *,' record=', iorec, '  io status=', ierr
	return
	end
c******************************************************************************
	subroutine curvmn(zg,iqd,b,nc,nr,epsmx,nim,eps1,dn1,ni)
c   Applies minimum curvature equations to the first
c  nc*nr elements of array zg.
c   Array iqd contains nc*nr elements which indicate
c  for each mesh location the quadrant where a data
c  value is located. An iqd value of zero indicates
c  no data and -1 locks the present mesh value.
c   Array b should contain 6*nc*nr elements used for
c  weighting when iqd is 1 to 4, in the case where
c  iqd is only 0 or -1, b can be of length one.
c   The over-relaxation parameter w increases
c  as the system converges until 1.7 is reached.
c  Mike Webring, USGS Open-File report 81-1224.
	dimension zg(1),iqd(1),b(1)
	data nimn/5/,lmtc/1/
	if(nc.lt.5 .or. nr.lt.5) return
	ni=0
	dn=1.e20
	w=1.3
	eps=0.
	eps1=0.
	epsm=abs(epsmx)
111	continue
	if(ni.ge.nim) go to 72
	eps=0.
c first row
	if(iqd(1))2,1,1
1	zg(1)=(( (2.*(zg(2)+zg(nc+1))-zg(nc+nc+1)-zg(3))*.5 )-
	1 zg(1))*w+zg(1)
2	j1=nc+2
	j2=j1+nc
	if(iqd(2))4,3,3
3	zg(2)=(( (4.*(zg(3)+zg(j1))+2.*zg(1)-zg(4)-zg(j1-1)-
	1 zg(j1+1)-zg(j2))*.16666667 )-zg(2))*w+zg(2)
4	do 6 i=3,nc-2
	j1=i+nc
	j2=j1+nc
	if(iqd(i))6,5,5
5	zg(i)=(( (4.*(zg(i-1)+zg(j1)+zg(i+1))-zg(j1+1)-zg(j1-1)-
	1 zg(j2)-zg(i+2)-zg(i-2))*.14285714 )-zg(i))*w+zg(i)
6	continue
	if(iqd(nc-1))8,7,7
7	i=nc-1
	j1=i+nc
	zg(i)=(( (4.*(zg(i-1)+zg(j1))+2.*zg(i+1)-zg(i-2)-
	1 zg(j1+1)-zg(j1-1)-zg(j1+nc))*.16666667 )-zg(i))*w+zg(i)
8	if(iqd(nc))10,9,9
9	j1=nc+nc
	zg(nc)=(( (2.*(zg(j1)+zg(nc-1))-zg(nc-2)-zg(j1+nc))*.5 )-
	1 zg(nc))*w+zg(nc)
c second row
10	if(iqd(nc+1))12,11,11
11	i=nc+1
	j1=i+nc
	zg(i)=(( (4.*(zg(j1)+zg(i+1))+2.*zg(1)-zg(2)-
	1 zg(i+2)-zg(j1+1)-zg(j1+nc))*.16666667 )-zg(i))*w+zg(i)
12	if(iqd(nc+2))14,13,13
13	i=nc+2
	j1=i+nc
	jm=i-nc
	zg(i)=(( (8.*(zg(j1)+zg(i+1))+4.*(zg(jm)+zg(i-1))-
	1 2.*zg(j1+1)-zg(jm+1)-zg(j1-1)-zg(i+2)-zg(j1+nc))*
	1 5.5555556e-2 )-zg(i))*w+zg(i)
14	do 16 i=nc+3,nc+nc-2
	j1=i+nc
	jm=i-nc
	if(iqd(i))16,15,15
15	zg(i)=(( (8.*(zg(i-1)+zg(j1)+zg(i+1))+4.*(zg(jm))-
	1 2.*(zg(j1-1)+zg(j1+1))-zg(jm-1)-zg(jm+1)-
	1 zg(j1+nc)-zg(i+2)-zg(i-2))*5.263158e-2 )-zg(i))*w+zg(i)
16	continue
	i=nc+nc-1
	if(iqd(i))18,17,17
17	j1=i+nc
	jm=i-nc
	zg(i)=(( (8.*(zg(j1)+zg(i-1))+4.*(zg(jm)+zg(i+1))-2.*zg(j1-1)-
	1 zg(jm-1)-zg(j1+1)-zg(i-2)-zg(j1+nc))*5.5555556e-2 )-
	1 zg(i))*w+zg(i)
18	i=nc+nc
	if(iqd(i))20,19,19
19	j1=i+nc
	jm=i-nc
	zg(i)=(( (4.*(zg(j1)+zg(i-1))+2.*zg(jm)-zg(jm-1)-
	1 zg(i-2)-zg(j1-1)-zg(j1+nc))*.16666667 )-zg(i))*w+zg(i)
c rows 3 to nr-2
20	do 39 j=3,nr-2
	i=(j-1)*nc+1
	if(iqd(i))22,21,21
21	j1=i+nc
	jm=i-nc
	zg(i)=(( (4.*(zg(i+1)+zg(j1)+zg(jm))-zg(j1+nc)-zg(j1+1)-zg(i+2)-
	1 zg(jm+1)-zg(jm-nc))*.14285714 )-zg(i))*w+zg(i)
22	i=i+1
	if(iqd(i))24,23,23
23	j1=i+nc
	jm=i-nc
	zg(i)=(( (8.*(zg(j1)+zg(i+1)+zg(jm))+4.*zg(i-1)
	1 -2.*(zg(j1+1)+zg(jm+1))-zg(j1-1)-zg(j1+nc)-zg(i+2)-
	1 zg(jm-nc)-zg(jm-1))*5.2631578e-2 )-zg(i))*w+zg(i)
24	do 35 j2=3,nc-2
	i=i+1
	if(iqd(i))35,25,25
25	j1=i+nc
	jm=i-nc
	d=zg(i)
	if(iqd(i))26,26,27
26	d=(( (8.*(zg(i+1)+zg(i-1)+zg(jm)+zg(j1))-2.*(zg(j1+1)+zg(jm+1)+
	1 zg(jm-1)+zg(j1-1))-zg(j1+nc)-zg(jm-nc)-zg(i-2)-zg(i+2))*
	1 .05 )-d)*w+d
	go to 33
27	ndx=(i-1)*6+1
	b1=b(ndx)
	b2=b(ndx+1)
	b3=b(ndx+2)
	b4=b(ndx+3)
	b5=b(ndx+4)
	b6=b(ndx+5)
	go to (28,29,30,31)iqd(i)
28	bu=b1*zg(jm+1)+b2*zg(jm)+b3*zg(i-1)+b4*zg(j1-1)
	go to 32
29	bu=b1*zg(jm-1)+b2*zg(jm)+b3*zg(i+1)+b4*zg(j1+1)
	go to 32
30	bu=b1*zg(j1-1)+b2*zg(j1)+b3*zg(i+1)+b4*zg(jm+1)
	go to 32
31	bu=b1*zg(j1+1)+b2*zg(j1)+b3*zg(i-1)+b4*zg(jm-1)
32	t=.25*(zg(j1+nc)+zg(i-2)+zg(jm-nc)+zg(i+2))
	1 +.5*(zg(j1-1)+zg(jm-1)+zg(jm+1)+zg(j1+1))-
	1 (zg(j1)+zg(i-1)+zg(jm)+zg(i+1))
	d=(( (bu+b5-t)*b6 )-d)*w+d
33	epsln=d-zg(i)
	if(abs(epsln).lt.abs(eps)) go to 34
	eps=epsln
	ieps=i
34	zg(i)=d
35	continue
	i=i+1
	if(iqd(i))37,36,36
36	j1=i+nc
	jm=i-nc
	zg(i)=(( (8.*(zg(j1)+zg(i-1)+zg(jm))+4.*zg(i+1)-2.*(zg(j1-1)+
	1 zg(jm-1))-zg(jm+1)-zg(jm-nc)-zg(i-2)-
	1 zg(j1+nc)-zg(j1+1))*5.2631578e-2 )-zg(i))*w+zg(i)
37	i=i+1
	if(iqd(i))39,38,38
38	j1=i+nc
	jm=i-nc
	zg(i)=(( (4.*(zg(j1)+zg(i-1)+zg(jm))-zg(jm-nc)-zg(jm-1)-zg(i-2)-
	1 zg(j1-1)-zg(j1+nc))*.14285714 )-zg(i))*w+zg(i)
39	continue
c row nr-1
40	i=(nr-2)*nc+1
	if(iqd(i))42,41,41
41	j1=i+nc
	jm=i-nc
	zg(i)=(( (4.*(zg(jm)+zg(i+1))+2.*zg(j1)-zg(jm-nc)-zg(jm+1)-
	1 zg(i+2)-zg(j1+1))*.16666667 )-zg(i))*w+zg(i)
42	i=i+1
	if(iqd(i))44,43,43
43	j1=i+nc
	jm=i-nc
	zg(i)=(( (8.*(zg(i+1)+zg(jm))+4.*(zg(i-1)+zg(j1))-
	1 2.*zg(jm+1)-zg(jm-1)-zg(jm-nc)-zg(i+2)-
	1 zg(j1+1))*5.5555556e-2 )-zg(i))*w+zg(i)
44	do 46 j=3,nc-2
	i=i+1
	if(iqd(i))46,45,45
45	j1=i+nc
	jm=i-nc
	zg(i)=(( (8.*(zg(i-1)+zg(jm)+zg(i+1))+4.*zg(j1)-
	1 2.*(zg(jm-1)+zg(jm+1))-zg(j1-1)-zg(i-2)-
	1 zg(jm-nc)-zg(i+2)-zg(j1+1))*5.2631578e-2 )-zg(i))*w+zg(i)
46	continue
	i=(nr-1)*nc-1
	if(iqd(i))48,47,47
47	j1=i+nc
	jm=i-nc
	zg(i)=(( (8.*(zg(i-1)+zg(jm))+4.*(zg(j1)+zg(i+1))-2.*zg(jm-1)-
	1 zg(j1-1)-zg(i-2)-zg(jm-nc)-zg(jm+1))*5.5555556e-2 )-
	1 zg(i))*w+zg(i)
48	i=i+1
	if(iqd(i))50,49,49
49	j1=i+nc
	jm=i-nc
	zg(i)=(( (4.*(zg(i-1)+zg(jm))+2.*zg(j1)-zg(jm-nc)-zg(jm-1)-
	1 zg(i-2)-zg(j1-1))*.16666667 )-zg(i))*w+zg(i)
c last row
50	i=i+1
	if(iqd(i))52,51,51
51	jm=i-nc
	zg(i)=(( (2.*(zg(i+1)+zg(jm))-zg(i+2)-zg(jm-nc))*.5 )-
	1 zg(i))*w+zg(i)
52	i=i+1
	if(iqd(i))54,53,53
53	jm=i-nc
	zg(i)=(( (4.*(zg(i+1)+zg(jm))+2.*zg(i-1)-zg(i+2)-zg(jm+1)-
	1 zg(jm-nc)-zg(jm-1))*.16666667 )-zg(i))*w+zg(i)
54	do 56 j=3,nc-2
	i=i+1
	if(iqd(i))56,55,55
55	jm=i-nc
	zg(i)=(( (4.*(zg(i-1)+zg(i+1)+zg(jm))-zg(i-2)-zg(jm-1)-
	1 zg(jm-nc)-zg(jm+1)-zg(i+2))*.14285714 )-zg(i))*w+zg(i)
56	continue
	i=i+1
	if(iqd(i))58,57,57
57	jm=i-nc
	zg(i)=(( (4.*(zg(i-1)+zg(jm))+2.*zg(i+1)-zg(i-2)-
	1 zg(jm-1)-zg(jm-nc)-zg(jm+1))*.16666667 )-zg(i))*w+zg(i)
58	i=i+1
	if(iqd(i))60,59,59
59	jm=i-nc
	zg(i)=(( (2.*(zg(i-1)+zg(jm))-zg(i-2)-zg(jm-nc))*.5 )-
	1 zg(i))*w+zg(i)
60	if(ni)70,70,71
70	eps1=abs(eps/w)
71	ni=ni+1
	if(eps.eq.0) go to 72
	dn1=abs(eps/w)
	if(dn1.le.epsm .and. ni.ge.nimn) go to 72
	dlam=dn1/dn
	dn=dn1
	if(dlam.gt.1.) go to 74
	if(dlam.lt..8) go to 75
	if(w.ge.1.6) go to 75
	w=w+.1
	go to 75
74	if(iconv.eq.lmtc) go to 76
	iconv=iconv+1
	go to 75
76	w=w-.1*aint(dlam*10.-9.11)
	iconv=0
	if(w.lt.1.)w=1.
75	continue
	go to 111
72	return
	end
