      program GRAVDUP
C
      implicit real (a-h,o-z) 
      implicit integer (i-n)
C
      character*80 quest,ans,ftype*1,firstname
      logical*1 dupid,savedup,exclor,onlyread,readwrite
      integer root
C
      real tree(30000,28)
C
      parameter (iunit=11,junit=17,kunit=19,lunit=21,onlyread=.true.)
      parameter (readwrite=.false.)
      data quest /'Function'/ ifunc /2/ ftype/'S'/
      data rtmin /1.0/
C
      print *
      print *,'USGS Program GRAVDUP; Version 2.001; July, 1988.'
      print *,'Technical Contact:  Michael G. Medberry fts 776-1204'
      print *	
      print *,'GRAVDUP will sort and edit duplicate station records in'
      print *,'your gravity data in standard, post, or express format.'
      print *
      print *
      print *,'Functions:'
      print *
      print *,'        1) List duplicate stations to output file'
      print *,'           using a single input file.'
      print *,'        2) Edit duplicate stations from a single'
      print *,'           input file (with options).'
      print *,'        3) List duplicate stations occuring in two'
      print *,'           input files.'
      print *,'        4) Edit duplicate stations occuring in either of'
      print *,'           two input files (with options).'
      print *,'        5) Compare two files and save only unique '
      print *,'           stations from second file.'    
      print *
5     continue
      ival=iiquest(quest,ifunc,'(i1)',-1)
      if ((ifunc.lt.0).or.(ifunc.gt.5)) then
         print *,'Function value out of range.'
         goto 5
      end if
      print *
      quest='File types to be used: (P)ost, (E)xpress, (S)tandard'
      ftype='S'
      ival=iaquest(quest,ftype,'(a1)',-1)
      if (ftype.eq.'S') then
         print *,'Gravity file header lines are not transferred.'
         print *,'Please make sure your input files have three header'
         print *,'header lines.'
      end if
      print *
      quest='Do duplicate id fields indicate a duplicate record'
      ans = 'NO'
      ival=iaquest(quest,ans,'(a80)',-1)      
      if (ans(1:1).eq.'Y') then
         dupid = .true.
      else
         dupid = .false.
      end if
      if (ftype.eq.'S') then
         quest='Enter latitude radius tolerance in minutes'
         ival=irquest(quest,rtmin,'(f7.2)',1)
         quest='Enter longitude radius tolerance in minutes'
         rgmin=rtmin
 	 ival=irquest(quest,rgmin,'(f7.2)',-1)
         xtol=rgmin / 60.0
         ytol=rtmin / 60.0
      else
         print *
         print *,'In the next two questions if your x and channels'
         print *,'are in decimal degrees answer in decimal degrees,'
         print *,'if they are in kilometers answer in kilometers.  If'
         print *,'you don''t know, you should not run this program.'
         print *
         quest='Enter x tolerance in decimal units'
         ival=irquest(quest,xtol,'(f12.4)',0)
         quest='Enter y tolerance in decimal units'
         ytol=xtol
         ival=irquest(quest,ytol,'(f12.4)',-1)
      end if
      print *
      if (ifunc.eq.5) goto 5000
      if (ifunc.ge.3) then
         goto 3000
      end if
C
C	Single file function
C
1000  continue
         quest='Name of input file'
         ival=iaquest(quest,ans,'(a80)',0)
         call opnfil(ans,iunit,ftype,onlyread,ichan)
         if (ifunc.eq.2) goto 2000
            quest='Name of output duplicate file'
            ival=iaquest(quest,ans,'(a80)',0)
            call opnfil(ans,junit,ftype,readwrite,jchan)
            call grow(iunit,ichan,ftype,dupid,xtol,ytol,root,tree)
            call dupls(tree,junit,ichan,ftype)
         goto 9000
2000     continue
            quest='Name of output file'
            ival=iaquest(quest,ans,'(a80)',0)
            call opnfil(ans,junit,ftype,readwrite,jchan)
            quest='Do you wish to save duplicates in a separate file'
            ans='YES'
            ival=iaquest(quest,ans,'(a80)',-1)
            if (ans(1:1).eq.'Y') then
                savedup=.true.
                quest='Name of duplicate file'
                ival=iaquest(quest,ans,'(a80)',0)
                call opnfil(ans,kunit,ftype,readwrite,kchan)
            else
                savedup=.false.
            end if
            quest='Do you wish to keep one copy of a duplicate'//
     $            ' record in your output file'
            ans = 'YES'
            ival=iaquest(quest,ans,'(a80)',-1)              
            if (ans(1:1).eq.'Y') then
               exclor = .false.
            else
               exclor = .true.
            end if
            call grow(iunit,ichan,ftype,dupid,xtol,ytol,root,tree)
            call prune(tree,junit,ichan,ftype,exclor)
            if (savedup) then
      	       call dupls(tree,kunit,ichan,ftype)
               call clsfil(kunit,ftype)
            end if
            call clsfil(junit,ftype)
            close(iunit)
         goto 9000
3000  continue
         quest='Name of first input file'
         ival=iaquest(quest,ans,'(a80)',0)
         call opnfil(ans,iunit,ftype,onlyread,ichan)
         quest='Name of second input file'
         ival=iaquest(quest,ans,'(a80)',0)
         call opnfil(ans,junit,ftype,onlyread,jchan)
         if (ichan.ne.jchan) then
             print *,'Input files do not have identical number of'
             print *,'channels.'
             goto 9999
         end if
         if (ifunc.eq.4) goto 4000
         quest='Name of duplicate file'
         ival=iaquest(quest,ans,'(a80)',0)
         call opnfil(ans,kunit,ftype,readwrite,kchan)
         call grow(iunit,ichan,ftype,dupid,xtol,ytol,root,tree)
         call grow(junit,jchan,ftype,dupid,xtol,ytol,root,tree)
      	 call dupls(tree,kunit,ichan,ftype)
         call clsfil(kunit,ftype)
         close(iunit)
         close(junit)
      goto 9000
4000  continue
         quest='Name of output file'
         ival=iaquest(quest,ans,'(a80)',0)
         call opnfil(ans,kunit,ftype,readwrite,kchan)
         quest='Do you wish to save duplicates in a separate file'
         ans='YES'
         ival=iaquest(quest,ans,'(a80)',-1)
         if (ans(1:1).eq.'Y') then
            savedup=.true.
            quest='Name of duplicate file'
            ival=iaquest(quest,ans,'(a80)',0)
            call opnfil(ans,lunit,ftype,readwrite,lchan)
         else
            savedup=.false.
         end if
         quest='Do you wish to keep one copy of a duplicate'//
     $         ' record in your output file'
         ans = 'YES'
         ival=iaquest(quest,ans,'(a80)',-1)              
         if (ans(1:1).eq.'Y') then
            exclor = .false.
         else
            exclor = .true.
         end if
         call grow(iunit,ichan,ftype,dupid,xtol,ytol,root,tree)
         call grow(junit,jchan,ftype,dupid,xtol,ytol,root,tree)
         call prune(tree,kunit,ichan,ftype,exclor)
         if (savedup) then
      	    call dupls(tree,lunit,ichan,ftype)
            call clsfil(lunit,ftype)
         end if
         call clsfil(kunit,ftype)
         close(iunit)
         close(junit)
      goto 9000
5000  continue 
         quest = 'Name of first input file'
         ival = iaquest(quest,firstname,'(a80)',0)
         call opnfil(firstname,iunit,ftype,onlyread,ichan)
         quest = 'Name of second input file'
         ival = iaquest(quest,ans,'(a80)',0)
         call opnfil(ans,junit,ftype,onlyread,jchan)
         quest='Name of output file'
         ival = iaquest(quest,ans,'(a80)',0)
         call opnfil(ans,kunit,ftype,readwrite,kchan)
         
         call grow(iunit,ichan,ftype,dupid,xtol,ytol,root,tree)
         call grow(junit,jchan,ftype,dupid,xtol,ytol,root,tree)
         close(iunit)
         call opnfil(firstname,iunit,ftype,onlyread,ichan)
         call grow(iunit,ichan,ftype,dupid,xtol,ytol,root,tree)
         exclor = .true.
         call prune(tree,kunit,ichan,ftype,exclor)
         call clsfil(kunit,ftype)
         close(iunit)
         close(junit)
         
         
9000  continue            
      print *
      print *,'GRAVDUP operation complete.  Thanks.'
9999  continue
      print *        
      end
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C	
      subroutine opnfil(fname,iunit,ftype,onlyread,nchan)
      character*(*) fname
      character*1 ftype
      logical*1 onlyread

      if (ftype.eq.'S') then
         if (onlyread) then
            open(iunit,file=fname,status='old',carriagecontrol='list',
     &           readonly)
            do 5 i=1,3
               read(iunit,*)
5           continue
         else
            open(iunit,file=fname,status='new',carriagecontrol='list')
         end if
      else if (ftype.eq.'P') then
          if (onlyread) then
             open(iunit,file=fname,status='old',form='unformatted',
     &          readonly)
             nchan= lenz(iunit) - 2
          else
             open(iunit,file=fname,status='new',form='unformatted')
          end if
      else if (ftype.eq.'E') then
         print *,'Express file processing is not available in this '
         print *,'version.'
         stop
C         if (onlyread) then
C            call xopen(iunit,fname,'O','readonly',ierr)
C         else
C            call xopen(iunit,fname,'N',' ',ierr)
C         end if
C         if (ierr.ne.0) then
C           ilen=itlen(fname)
C           print *,'Fortran error ',ierr,' occured opening ',
C     &             fname(1:ilen)
C           stop
C         end if
C         nchan= ixlenz(iunit) 
      else
         print *,'Bad file type'
         stop
      end if
      return
      end
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
      subroutine clsfil(iunit,ftype)
      character*1 ftype
      if (ftype.eq.'E') then               
         call xiobuf('W',iunit,iend)
         close(iunit)
      else
         close(iunit)
      end if
      return
      end
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
      subroutine grow(iunit,nchan,ftype,dupid,xtol,ytol,root,tree)
C
      character*1 ftype,zline*80,id*8
      logical*1 dupid
      integer root
C
      real tree(30000,28),z(20)
C
C
10    continue
         call getrec(iunit,ftype,id,x,y,z,nchan,iend)
         if (iend.gt.0) then
            goto 1000
         else if (root.gt.30000) then
            print *
            print *,'You have exceeded the 30,000 record limit of'
            print *,'this program.  Please break up your files and'
            print *,'rerun this program or contact your programmer.'
            stop
         else if (root.eq.0) then
            root=root+1
            call loadrec(tree,root,id,x,y,z)
            goto 10
         else
            ipt = 1
         end if
20       continue
            ival=kompare(id,x,y,xtol,ytol,dupid,tree,ipt)
            if (ival.lt.0) then
               if (tree(ipt,1).gt.0.0) then
                  ipt=int(tree(ipt,1))
                  goto 20
               else
                  root = root + 1
                  call loadrec(tree,root,id,x,y,z)
                  tree(ipt,1)=float(root)
                  tree(root,3) = float(ipt)
               end if
            else if (ival.gt.0) then
               if (tree(ipt,2).gt.0.0) then
                  ipt=int(tree(ipt,2))
                  goto 20
               else
                  root=root+1
                  call loadrec(tree,root,id,x,y,z)
                  tree(ipt,2) = float(root)
                  tree(root,3) = float(ipt)
               end if
            else
30             continue
               if (tree(ipt,4).gt.0.0) then
                  ipt = int(tree(ipt,4))
                  goto 30
               else
                  root = root + 1
                  call loadrec(tree,root,id,x,y,z)
                  tree(ipt,4) = float(root)
                  tree(root,3) = float(ipt)
               end if
            end if               
         goto 10
1000  continue
      return
      end
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
      subroutine prune(tree,iunit,nchan,ftype,exclor)
      character*1 ftype
      logical*1 exclor,visit(30000)
      real tree(30000,28)
      integer root

      ipt = 1
10    continue
         if (visit(ipt).eq.2) then
            if (ipt.ne.1) then
               ipt = int(tree(ipt,3))
            else 
               goto 20
            end if
         else if (visit(ipt).eq.1) then
            if ((tree(ipt,4).eq.0.0).or.(.not.exclor)) then
               call writerec(tree,ipt,iunit,ftype,nchan)
            end if
            visit(ipt) = 2
            if (tree(ipt,2).gt.0.0) then
               ipt = int(tree(ipt,2))               
            else if (ipt.ne.1) then
               ipt = int(tree(ipt,3))
            end if
         else
            visit(ipt) = 1
            if (tree(ipt,1).gt.0.0) then
               ipt=int(tree(ipt,1))
            end if
         end if
      goto 10
20    continue
      return
      end
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
      subroutine dupls(tree,iunit,nchan,ftype)
      character*1 ftype
      logical*1 exclor,visit(30000)
      real tree(30000,28)
      integer root

      ipt = 1
C      print *,ftype
10    continue
         if (visit(ipt).eq.2) then
            if (ipt.ne.1) then
               ipt = int(tree(ipt,3))
            else 
               goto 20
            end if
         else if (visit(ipt).eq.1) then
            if (tree(ipt,4).gt.0.0) then
               call writerec(tree,ipt,iunit,ftype,nchan)
               jpt = int(tree(ipt,4))
15             continue
                  call writerec(tree,jpt,iunit,ftype,nchan)
                  if (tree(jpt,4).gt.0.0) then
                     jpt=int(tree(jpt,4))
                     goto 15
                  end if
            end if
            visit(ipt) = 2
            if (tree(ipt,2).gt.0.0) then
               ipt = int(tree(ipt,2))               
            else if (ipt.ne.1) then
               ipt = int(tree(ipt,3))
            end if
         else
            visit(ipt) = 1
            if (tree(ipt,1).gt.0.0) then
               ipt=int(tree(ipt,1))
            end if
         end if
      goto 10
20    continue
      return
      end
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C	
      subroutine loadrec(tree,ipt,id,x,y,z)
      character id*8,id2*8
      real z(20),zid(2),tree(30000,28)
      equivalence (zid(1),id2)
      id2 = id
      tree(ipt,5)=zid(1)
      tree(ipt,6)=zid(2)
      tree(ipt,7)=x
      tree(ipt,8)=y
      do 10 i=1,20
         tree(ipt,i+8) = z(i)
10    continue
      return
      end 
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
      integer function Kompare(id,x,y,xtol,ytol,dupid,tree,ipt)
      character id*8,id2*8
      real tree(30000,28),zid(2)
      logical*1 dupid
      equivalence(zid,id2)
 
      if (dupid) then
         zid(1)=tree(ipt,5)
         zid(2)=tree(ipt,6)
         if (id.eq.id2) then
            kompare=0
            goto 90
         end if
      end if
      xdiff = x-tree(ipt,7)
      ydiff = y-tree(ipt,8)
      if ((abs(xdiff).lt.xtol).and.(abs(ydiff).lt.ytol)) then
         kompare=0
      else if (ydiff.lt.0.0) then
         kompare=-1
      else if (ydiff.gt.0.0) then
         kompare=1
      else if (xdiff.lt.0.0) then
         kompare=-1
      else
         kompare=1
      end if  
90    continue
      return
      end
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
      subroutine getrec(iunit,ftype,id,x,y,z,nchan,iend)
      character id*8,zline*80,ftype*1
      real z(20),w(22),zow(20)
      equivalence (zow,zline)
      equivalence (w(3),zow(1))
      if (ftype.eq.'E') then         
         if (nchan.le.0) then
            nchan=8
         end if
         call xiopst('R',iunit,iend,id,w,nchan)
         x=w(1)
         y=w(2)
      else if (ftype.eq.'P') then
         read(iunit,end=90)id,x,y,(zow(i),i=1,nchan)
         iend=0
      else
         read(iunit,'(a)',end=90) zline
         read(zline,80)id,lat,ltmin,lon,llmin
         x=float(lon) + sign((float(llmin)/6000.0),float(lon))
         y=float(lat) + sign((float(ltmin)/6000.0),float(lat))
         iend=0
      end if
      do 70 i=1,20
         z(i) = zow(i)
70    continue
      goto 100
80    format(a8,13x,i3,3i4)
90    continue
      iend=1
100   continue
      return
      end
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
      subroutine writerec(tree,ipt,iunit,ftype,nchan)
      character*1 ftype,zline*80,id*8
      real z(20),w(22),tree(30000,28),zid(2)

      equivalence (z,zline)
      equivalence (z(1),w(3)),(zid(1),id)

      do 10 i=1,22
         w(i) = tree(ipt,i+6)
 10   continue
      zid(1)=tree(ipt,5)
      zid(2)=tree(ipt,6)
      
      if (ftype.eq.'E') then
         call xiopst('W',iunit,iend,id,w,(nchan+2))
         if (iend.ne.0) then
            print *,'Fortran error ',iend
            stop
         end if
      else if (ftype.eq.'P') then
         write(iunit)id,(w(i),i=1,(nchan+2))
      else
         write(iunit,'(a80)')zline
      end if
      return
      end
CS    USGS Function IAQUEST
C     Version: 1.0
C     Technical Contact: R. Saltus
C     Release: not released
C
C+
C     Function IAQUEST
C
C     Program purpose:
C         Asks a question requiring a character-string response.
C         Allows the use of a default answer and will optionally upshift the
C         response.
C
C     Instructions for use:
C         This subroutine should be called whenever a character-string response
C         is called for in a FORTRAN program.
C
      Integer Function iaquest(quest,aval,form,mode)
C-
C
C     Variables and parameters:
C     ireturn = IAQUEST (quest,aval,form,mode)
C
C      ireturn =  -1 if '//' was given as response (user wants out)
C                  0 if no response (user took default)
C                  1 if user responded (returns response in aval)
C
C        quest =  Character string containing question to be asked
C                 (with no ? at the end, it is added by function)
C
C         aval =  Character string to receive answer
C                 (used to pass default if one is available)
C
C         form =  Character string containing fortran format to be
C                 used to read the user response
C
C         mode =  Integer control parameter:
C
C              mode > 0, default allowed
C              mode = 0, no default allowed, upshift response
C              mode < 0, default allowed, upshift response
C
C         Calls ITLEN, UPSHIFT, GETANS
C^
C  *********************************************
      Character quest*(*),form*(*),aval*(*)
      Character*100 str,form2*10,ans*80,astr*30
      iaquest=0
      iqlen=itlen(quest)
      irlen=itlen(aval)
C
C     If response is to be upshifted, upshift default
C
      If (mode.LT.0)Call upshift(aval)
      If (irlen.EQ.0)irlen=1
C
C     Insert default answer into question
C
      If (mode.NE.0) Then
         str=quest(1:iqlen)//' ['//aval(1:irlen)//']?'
         islen=iqlen+irlen+4
      Else
         str=quest(1:iqlen)//'?'
         islen=iqlen+1
      End If
C
C     Construct fortran format for printing of question
C
      Write (form2,105)islen
  105 Format ('(x,a',i3,',$)')
C
C     Repeats to here if question is re-asked
C
   13 Continue
C
C     Call getans to obtain answer (allows multiple answers per line)
C
      Call getans(str,form2,ans)
C
C     If getans is not used, the following two statements ask question
C
C       Write (6,form2)str
C       Read (5,form)ans
C
C     Check answer
C
      ialen=31
      ialen=itlen(ans)
      If (ialen.NE.0) Then
C
C     got an answer
C
C     find first non-blank character
C
      do 5,ifirst=1,ialen
      if (ans(ifirst:ifirst).ne.' ') goto 6
   5  continue
   6  continue
      ans(1:ialen)=ans(ifirst:ialen)
         If (ans(ifirst:ialen).EQ.'//') Then
            iaquest=-1
         Else
            iaquest=1
C
C           Move answer into AVAL
C
            aval(1:len(aval))=ans(1:len(aval))
            If (mode.LE.0)Call upshift(aval)
         End If
      Else
C
C        Didn't get an answer, if no default ask question again
C
         If (mode.EQ.0)Go To 13
      End If
      Return
      End
CS    USGS Function IIQUEST
C     Version: 1.0
C     Technical Contact: Richard W. Saltus
C     Release: not released
C
C+
C     Function IIQUEST
C
C     Program purpose:
C         This function asks a question which requires an integer as response.
C         If a default is available, the user may take it by simply pressing
C         return. If a non-integer response is given, the question is re-asked.
C         Use of the special string "//" allows the user to signal the main
C         program (usually used to flag the end of a list or desire to exit
C         a program section).
C
C     Instructions for use:
C         This function should be used to ask all questions requiring integral
C         response.
C
      INTEGER FUNCTION IIQUEST(QUEST,IVAL,FORM,MODE)
C-
C
C     Variables and parameters:
C
C    IIQUEST - Asks a question with an integer answer
C
C     ireturn = IIQUEST (quest,ival,form,mode)
C
C      ireturn =  -1 if '//' was given as response (user wants out)
C                  0 if no response (user took default)
C                  1 if user responded (returns response in aval)
C
C        quest =  Character string containing question to be asked
C                 (with no ? at the end, it is added by function)
C
C         ival =  integer variable to receive answer
C                 (used to pass default if one is available)
C
C         form =  Character string containing fortran format to be
C                 used to format the default contained in ival
C
C         mode =  Integer control parameter:
C
C            mode = 0, required response (no default allowed)
C            mode <>0, default allowed
C
C         Calls: ITLEN, GETANS
C^
C  *********************************************
      Character quest*(*),form*(*),rstr2*30
      Character*100 str,form2*10,ans*30,astr*30
      iiquest=0
      iqlen=itlen(quest)
C
C     Format default for insertion into question
C
      Write (rstr2,form)ival
      irlen=ideblank(rstr2)
      If (mode.NE.0) Then
C
C        Construct question with default in brackets
C
         str=quest(1:iqlen)//' ['//rstr2(1:irlen)//']?'
         islen=iqlen+irlen+4
      Else
C
C        No default, add '?' to question
C
         str=quest(1:iqlen)//'?'
         islen=iqlen+1
      End If
C
C     Make fortran format for printing of question
C
      Write (form2,105)islen
  105 Format ('(x,a',i3,',$)')
C
C     Repeats to here if question is re-asked
C
   13 Continue
C
C     call getans to obtain answer
C
      Call getans(str,form2,ans)
C
C     If GETANS is not used, the following two statements will ask question
C
C      Write (6,form2)str
C      Read (5,110)ans
  110 Format (a30)
C
C     Check answer
C
      ialen=ideblank(ans)
      If (ialen.NE.0) Then
C
C        Got an answer
C
         If (ans.EQ.'//') Then
            iiquest=-1
         Else
C
C           Convert answer to an integer
C
            iiquest=1
            Read (ans(1:ialen),120,err=25)ival
  120       Format (i11)
         End If
      Else
C
C        Didn't get an answer, if no default ask question again
C
         If (mode.EQ.0)Go To 13
      End If
      Return
C
C     Couldn't decode, give error and ask question again
C
   25 Continue
      Write (6,130)
  130 Format (' Please answer again, I expect a number.')
      Go To 13
      End
CS    USGS Function IRQUEST
C     Version: 1.0
C     Technical Contact: Richard W. Saltus
C     Release: not released
C
C+
C     Function IRQUEST
C
C     Program purpose:
C         This function asks a question requiring a real number response.
C         It allows a default answer (if the user simply presses return).
C         The question is re-asked if a non-numeric answer is supplied.
C         The special character sequence "//" can be answered to indicate
C         a special condition.
C
C     Instructions for use:
C         This function should be called to ask all questions requiring decimal
C         numbers as answers.
C
      INTEGER FUNCTION IRQUEST(QUEST,RVAL,FORM,MODE)
C-
C
C     Variables and parameters:
C
C     ireturn = IRQUEST (quest,rval,form,mode)
C
C      ireturn =  -1 if '//' was given as response (user wants out)
C                  0 if no response (user took default)
C                  1 if user responded (returns response in aval)
C
C        quest =  Character string containing question to be asked
C                 (with no ? at the end, it is added by function)
C
C         rval =  Real variable to receive answer
C                 (used to pass default if one is available)
C
C         form =  Character string containing fortran format to be
C                 used to format the default contained in rval
C
C         mode =  Integer control parameter:
C
C            mode = 0, required response (no default allowed)
C            mode <>0, default allowed
C
C         Calls: ITLEN, GETANS
C^
C  *********************************************
      Character quest*(*),form*(*),rstr2*30
      Character*100 str,form2*10,ans*30,astr*30
      irquest=0
      iqlen=itlen(quest)
C
C     Format default for inclusion in question
C
      Write (rstr2,form)rval
      irlen=ideblank(rstr2)
      If (mode.NE.0) Then
C
C     If default allowed, insert it in question
C
         str=quest(1:iqlen)//' ['//rstr2(1:irlen)//']?'
         islen=iqlen+irlen+4
      Else
C
C        No default, just add '?' to question
C
         str=quest(1:iqlen)//'?'
         islen=iqlen+1
      End If
C
C     Construct format for printing the question
C
      Write (form2,105)islen
  105 Format ('(x,a',i3,',$)')
C
C     Repeats to here if question is re-asked
C
   13 Continue
C
C     call getans to obtain answer
C
      Call getans(str,form2,ans)
C
C      If getans is not used, the following statements will ask question
C
C      Write (6,form2)str
C      Read (5,110)ans
  110 Format (a30)
C
C     Check answer
C
      ialen=ideblank(ans)
      If (ialen.NE.0) Then
C
C        Got an answer
C
         If (ans.EQ.'//') Then
            irquest=-1
         Else
C
C           Convert answer to real number
C
            irquest=1
            Read (ans(1:ialen),120,err=25)rval
  120       Format (f20.0)
         End If
      Else
C
C        Didn't get an answer, if no default re-ask question
C
         If (mode.EQ.0)Go To 13
      End If
      Return
C
C     Couldn't convert the answer to a real number
C
   25 Continue
      Write (6,130)
  130 Format (' Please answer again, I''m expecting a number.')
      Go To 13
      End
CS    USGS Subroutine GETANS
C     Version: 1.0
C     Technical Contact: Richard W. Saltus
C     Release: not released
C
C+
C     Subroutine GETANS
C
C     Program purpose:
C         This subroutine is called by IAQUEST, IIQUEST, and IRQUEST to
C         ask questions and get responses. It allows for buffering of
C         input, answers to multiple questions on a single line, echoing
C         of program dialog, or input of answers from a file.
C
C     GETANS - Reads next answer from saved command line,
C              prompts for new command line if old command line empty.
C              Answers in the command line are delimited by semi-colons.
C
C       GETANS recognizes the following special commands:
C
C              @filename - takes subsequent input from the file 'filename'
C              >filename - records questions and responses to 'filename'
C              >*        - echos questions and answers at terminal
C              <         - stops recording
C              <*        - stops echoing
C              !stuff!   - skips stuff between exclamation points
C
C     Instructions for use:
C         Intended for use by the IxQUEST subroutines only.
C
       SUBROUTINE GETANS(QUEST,QFORM,ANS)
C-
C
C     Variables and parameters:
C
C
C     Call GETANS (quest, qform, ans)
C
C          quest = character variable, question to be asked
C
C          qform = character variable, fortran format for question
C
C          ans   = character variable to receive answer
C
C     Called by IIQUEST, IAQUEST, IRQUEST
C
C     Calls IGETTOK
C
C     Commons used : /GETCOM/ nextc, ifile, isfile, command
C
C^
C
      Character*(*) quest,qform,ans
      Common /getcom/nextc,ifile,isfile,command
      Character*(80) command,tok,form*40
      Logical asked,typed
C
C     initialize token
C
    1 Continue
      tok=' '
      lentok=0
      ic=len(command)
      it=len(tok)
      asked=.false.
      typed=.false.
C
C     If nothing in command line, ask question
C
    5 Continue
      If ((nextc.EQ.0).OR.(nextc.GT.ic)) Then
         If (ifile.EQ.0) Then
C
C        ask question at terminal
C
            asked=.true.
            typed=.true.
            Write (6,qform)quest
            Read (5,100)command
  100       Format (a80)
         Else
C
C        read command from file
C
            asked=.true.
         Read (ifile,100,End =99,err=99)command
      End If
      nextc=1
      End If
C
C     get a token from the command line
C
   10 Continue
      lenread=igettok(command(nextc:ic),tok(lentok+1:it),ierr,itype)
      nextc=lenread+nextc
      If (ierr.GE.0) Then
C
C     got a token
C
         If (tok(lentok+1:lentok+1).EQ.';') Then
C
C     got end of token
C
            If (nextc.GE.ic)nextc=0
         Else If (tok(lentok+1:lentok+1).EQ.'!') Then
C
C     skip over stuff between !'s in command line
C
            iskip=index(command(nextc:ic),'!')
            If (iskip.EQ.0) Then
C
C     skip rest of record
C
               nextc=0
               Go To 5
            Else
C
C     skip past next !
C
               nextc=nextc+iskip
               Go To 5
            End If
         Else
C
C     didn't get a ';' or a '!' - append new tok to old tok (reduce multiple
C                                 blanks to a single blank between tokens)
C
            newlen=itlen(tok(lentok+1:it))
            If (lenread.GT.newlen) Then
               newlen=newlen+1
               Do 20 icnt=newlen+lentok+1,lentok+1,-1
   20          tok(icnt+1:icnt+1)=tok(icnt:icnt)
               tok(lentok+1:lentok+1)=' '
            End If
            lentok=lentok+newlen
            If (ierr.EQ.0) Then
C
C     hit end of command line
C
               nextc=0
            End If
C
C     keep reading command line
C
            Goto 10
         End If
      Else
C
C      didn't get a token (hit end of line)
C
         nextc=0
         If ((lentok.EQ.0).AND.(.NOT.asked))Goto 5
      End If
C
C      ready to return answer
C
      ans=' '
      If (lentok.GT.0) Then
         If (tok(1:1).EQ.'@') Then
C
C     open file for command reading
C
            If (ifile.NE.0)Close (ifile)
            Open (69,file=tok(2:lentok),form='formatted',readonly,
     &      status='old',err=98)
            ifile=69
            nextc=0
            Go To 1
         Else If (tok(1:1).EQ.'>') Then
            If (tok(2:2).EQ.'*') Then
C
C     set echo flag for command echoing at terminal
C
               iecho=1
            Else
C
C     Open recording file
C
               If (isfile.NE.0)Close (isfile)
               Open (70,file=tok(2:lentok),form='formatted',status=
     &         'new',
     &         err=97)
               isfile=70
               Go To 1
            End If
         Else If (tok(1:1).EQ.'<') Then
            If (tok(2:2).EQ.'*') Then
C
C      turn off command echoing
C
               iecho=0
            Else
C
C      close recording file
C
               Close (isfile)
               isfile=0
               Go To 1
            End If
         Else
C
C     pass answer back and quit
C
            ans=tok(1:lentok)
         End If
      End If
      If (isfile.NE.0) Then
C
C     record question and answer in recording file
C
         If (lentok.LE.0)tok(1:1)=' '
         ir=max(1,lentok)
         iq=itlen(quest)
         Write (form,103)iq,ir
  103    Format ('(x,a1,a',i2,',a1,x,a',i2,')')
         Write (isfile,form)'!',quest(1:iq),'!',tok(1:ir)
      End If
      If ((iecho.NE.0).AND.(.NOT.typed)) Then
C
C     Echo question and answer at terminal
C
         If (lentok.LE.0)tok(1:1)=' '
         ir=max(1,lentok)
         iq=itlen(quest)
         Write (form,104)iq,ir
  104    Format ('(x,a',i2,',x,a',i2,')')
         Write (6,form)quest(1:iq),tok(1:ir)
      End If
      Return
C
C     error on recording file open
C
   97 Continue
      If (lentok.GE.2) Then
         Write (form,105)ir-1
  105    Format ('(x,a35,a',i2,')')
         Write (6,form)'Unable to open the recording file: ',tok(2:ir)
      Else
         Write (6,106)
  106    Format (x,'No name specified for recording file.')
      End If
      Go To 1
C
C     error on command file open
C
   98 Continue
      If (lentok.GE.2) Then
         Write (form,110)ir-1
         Write (6,form)'Unable to open the command file: ',
     &   tok(2:ir)
  110    Format ('(x,a33,a',i2,')')
      Else
         Write (6,111)
  111    Format (x,'No name specified for command file.')
      End If
      Go To 1
C
C     hit end of command file
C
   99 Continue
      Close (ifile)
      ifile=0
      Go To 5
      End
CS    USGS Function IGETTOK
C     Version: 1.0
C     Technical Contact: Richard W. Saltus
C     Release: not released
C
C+
C     Function IGETTOK
C
C     Program purpose:
C             - Selects next alpha-numeric token, special symbol,
C               or quoted string from BUF.
C               Puts token in TOK.  Returns ierr & itype to describe
C               token.
C
C     Instructions for use:
C           LEN = IGETTOK(BUF,TOK,IERR,ITYPE)
C
      INTEGER FUNCTION IGETTOK(BUF,TOK,IERR,ITYPE)
C-
C
C     Variables and parameters:
C
C                LEN = Length of BUF read.
C
C                BUF = Character string to search for token
C
C                TOK = Token found (Character string)
C
C               IERR = 1 , got a token
C                      0 , got a token, hit end of BUF
C                     -1 , didn't get a token, hit end of BUF
C
C               ITYPE = 1 , got an alpha-numeric token
C                       0 , got a quoted token
C                      -1 , got a single symbol
C
C         Called by: Style, IxQUEST subroutines, user program
C
C             Calls: ICTYPE
C
C      Commons used: none
C-
C  **********************************************************************
      Character*(*) buf,tok
      lbuf=len(buf)
      lmax=len(tok)
      ltok=0
C
      Do 10 i=1,lbuf
      If (ictype(buf(i:i)).LT.0) Then
C
C     got special symbol (non alpha-numeric)
C
         If (ltok.GT.0) Then
C
C       already have a token, this must end it
C
            igettok=i-1
            itype=1
            ierr=1
            Return
         Else
C
C       don't have a token yet
C
            If (buf(i:i).EQ.' ') Then
C
C         got a blank, skip it
C
               Continue
            Else If (buf(i:i).EQ.'''') Then
C
C         got a quote (begin quoted token)
C
               itemp=i
    5          Continue
               iend=index(buf(itemp+1:lbuf),'''')
               If (iend.EQ.0) Then
C
C           didn't find another quote
C
                  tok=buf(i:lbuf)
                  igettok=lbuf
                  itype=0
                  ierr=0
                  Return
               Else
C
C           did find another quote
C
                  nloc=itemp+iend+1
                  If (buf(nloc:nloc).EQ.'''') Then
C
C             paired quotes within quotes, keep looking for end
C
                     itemp=nloc
                     Go To 5
                  Else
C
C           found end of quoted token
C
                     tok=buf(i:itemp+iend)
                     igettok=itemp+iend
                     itype=0
                     If (i+iend.EQ.lbuf) Then
                        ierr=0
                     Else
                        ierr=1
                     End If
                  End If
                  Return
               End If
            Else
C
C       special symbol is token
C
               tok(1:1)=buf(i:i)
               itype=-1
               ierr=1
               igettok=i
               Return
            End If
         End If
      Else
C
C     got alpha-numeric
C
         ltok=ltok+1
         tok(ltok:ltok)=buf(i:i)
      End If
C
   10 Continue
C
C     reached end of buffer, all alpha-numerics
C
      itype=1
      igettok=lbuf
      If (ltok.EQ.0) Then
C
C       all blanks (no token)
C
         ierr=-1
      Else
C
C       got token
C
         ierr=0
      End If
      Return
      End
C+
C     ICTYPE - decides if a character is alphabetic, numeric, or other
C
C     ireturn = ICTYPE (C)
C
C            C = Single character (character*1)
C
C      ireturn =  1 , alpha (a-z,A-Z)
C              =  0 , digit (0-9)
C              = -1 , other
C
C      Called by: IGETTOK
C
C        Calls: none
C
C      Common: none
C-
C  *********************************************************************
      Integer Function ictype(c)
      Character*1 c,digits*10,abc*52
C
      digits='0123456789'
      abc='abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ'
C
      If (index(abc,c).GT.0) Then
         ictype=1
         Else If (index(digits,c).GT.0) Then
         ictype=0
         Else
         ictype=-1
         End If
      Return
      End
C+
C    IDEBLANK- removes all blanks and returns length
C
C    ireturn = IDEBLANK (string)
C
C       ireturn = length of the string without blanks
C        string = character string to be de-blanked
C
C-
C  *********************************************
      Integer Function ideblank(string)
      Character*256 string*(*),temp
      j=1
      temp=' '
      itemp=len(string)
      Do 10 i=1,itemp
      If (string(i:i).EQ.' ')Go To 10
      temp(j:j)=string(i:i)
      j=j+1
   10 Continue
      string=temp
      ideblank=j-1
      Return
      End
CS    USGS Function ITLEN
C     Version: 1.0
C     Technical Contact: Richard W. Saltus
C     Release: not released
C
C+
C     Function ITLEN
C
C     Program purpose:
C         This function returns the length of a character string without
C         trailing blanks.
C
C     Instructions for use:
C         Use this function to find out the position of the last non-blank
C         character in a string.
C
      INTEGER FUNCTION ITLEN(STRING)
C-
C
C     Variables and parameters:
C
C     ireturn = ITLEN (string)
C
C        ireturn = the length of the string without trailing blanks
C         string = string to have trailing blanks removed from
C
C^
C  *********************************************
      Character string*(*)
      i=len(string)
   10 Continue
      If (string(i:i).NE.' ')Go To 15
      i=i-1
      If (i.LE.0)Go To 15
      Go To 10
   15 Continue
      itlen=i
      Return
      End
C+
C     UPSHIFT - Converts lowercase to uppercase.
C               All non-lowercase characters unchanged.
C
C     CALL UPSHIFT(A)
C
C             A = A character string of any length
C
C-
      SUBROUTINE UPSHIFT(A)
      CHARACTER*(*) A,UP*(26),DOWN*(26)
      UP='ABCDEFGHIJKLMNOPQRSTUVWXYZ'
      DOWN='abcdefghijklmnopqrstuvwxyz'
      ILEN=LEN(A)
      DO 10 I=1,ILEN
        INUM=INDEX(DOWN,A(I:I))
        IF (INUM.NE.0) A(I:I)=UP(INUM:INUM)
  10      CONTINUE
      RETURN
      END
c*******************************************************************************
	subroutine xopen( iunit, filen, stat, mode, ierror )

c  open express unit, set internal arrays.
c  programmer note:  common ioexpc subject to developmental changes
c                    do not access from user programs.

	parameter       ( maxu=30, maxb=2048 )
	common /ioexpc/ nb, ibordr(maxu), iomode(maxu), irec(maxu), 
	1               nwrd(maxu), nlog(maxu), ntot(maxu), 
	1               ilog(maxu), ibpt(maxu), b(maxb)

	character       filen*(*), stat*(*), mode*(*)
	data            length/ 512 /
	ierror = 0

10	if ( stat(1:1) .eq. 'n'  .or.  stat(1:1) .eq. 'N' )    then
	  open( iunit, file=filen, status='new', form='unformatted',
	1       access='direct', recl=length )

	  call clrxa( iunit )
	  call setbp( iunit )
	  ntot(iunit) = length - 3

	  else

	  if ( mode(1:1) .eq. 'r' .or. mode(1:1) .eq. 'R' ) then
	  open( iunit, file=filen, status='old', form='unformatted',
	1       access='direct', iostat=ierror, readonly )
	  else
	  open( iunit, file=filen, status='old', form='unformatted',
	1       access='direct', iostat=ierror )
	  endif
	  if ( ierror .ne. 0 ) return

	  read( iunit, rec=1, err=50, iostat=ierror ) nw, nd, ntotal
50	  if ( ierror .ne. 0 ) then
	    write(6,*) ' error during read to get ntotal'
	    write(6,*) filen
	    stop
	  endif
	  if ( ntotal .le. 0   .or.   ntotal .gt. maxb ) then
	    write(6,*) ' file exists, but ntotal is out of range'
	    write(6,*) ' ntotal=', ntotal, ' valid range = 1 to ', maxb
	    stop
	  endif

	  call clrxa( iunit )
	  call setbp( iunit )
	  ntot(iunit)   = ntotal
	  iomode(iunit) = 0
	  if ( mode(1:1) .eq. 'r'   .or.   mode(1:1) .eq. 'R' ) 
	1                iomode(iunit) = 1

	endif
     
	return
	end
c************************
	subroutine clrxa( iu )
c  clear express parameter arrays.
c  captive subroutine called by ioexp.
	parameter       ( maxu=30, maxb=2048 )
	common /ioexpc/ nb, ibordr(maxu), iomode(maxu), irec(maxu), 
	1               nwrd(maxu), nlog(maxu), ntot(maxu), 
	1               ilog(maxu), ibpt(maxu), b(maxb)
	iomode(iu) = 0
	irec(iu) = 0
	nwrd(iu) = 0
	nlog(iu) = 0
	ntot(iu) = 0
	ilog(iu) = 0
	return
	end
c***********************
	subroutine setbp( iu )
c  set buffer pointers:  ibordr(1:nb)  the open units in the buffer.
c                        ibpt(1:maxu)  the start position for the unit.
c  captive routine called by ioexp.

	parameter       ( maxu=30, maxb=2048 )
	common /ioexpc/ nb, ibordr(maxu), iomode(maxu), irec(maxu), 
	1               nwrd(maxu), nlog(maxu), ntot(maxu), 
	1               ilog(maxu), ibpt(maxu), b(maxb)

	nb         = nb + 1
	ibordr(nb) = iu

	if ( nb .eq. 1 ) then
	  ibpt(iu) = 1
	  else	
	  lastu    = ibordr(nb-1)
	  ibpt(iu) = ibpt(lastu) + ntot(lastu)
	endif

	return
	end
c*******************************************************************************
	subroutine xclear
c  reset for all pointers.

	parameter       ( maxu=30, maxb=2048 )
	common /ioexpc/ nb, ibordr(maxu), iomode(maxu), irec(maxu), 
	1               nwrd(maxu), nlog(maxu), ntot(maxu), 
	1               ilog(maxu), ibpt(maxu), b(maxb)

	nb = 0
	do 10 i = 1, maxu
	  ibordr(i) = 0
	  iomode(i) = 0
	  irec(i)   = 0
	  nwrd(i)   = 0
	  nlog(i)   = 0
	  ntot(i)   = 0
	  ilog(i)   = 0
	  ibpt(i)   = 0
10	continue

	return
	end
c*******************************************************************************
	subroutine xiopst( oprin, iu, iend, id, z, nchan )

c  read or write post logical record using express file structure.
c  ilog and nlog are incremented before the r/w operation.
c  combine this subroutine with subroutines ioexp and xiobuf.

	parameter       ( maxu=30, maxb=2048 )
	common /ioexpc/ nb, ibordr(maxu), iomode(maxu), irec(maxu), 
	1               nwrd(maxu), nlog(maxu), ntot(maxu), 
	1               ilog(maxu), ibpt(maxu), b(maxb)

	dimension       bid(2), z(nchan)
	character       opr*1, id*8, chid*8, oprin*(*)
	equivalence     ( chid, bid )

	if ( ibpt(iu) .eq. 0 ) then
	  write(6,*) ' %%iopst: express w/r operation '
	  write(6,*) ' to unopened unit #', iu 
	  stop
	endif
	opr = oprin(1:1)

10	continue

c  read logical record

	if ( opr .eq. 'r'   .or. opr .eq. 'R' ) then
	  ilog(iu) = ilog(iu) + 1

	  if (  ilog(iu)  .gt.  nlog(iu)  ) then
	    call xiobuf( 'r', iu, iend )
	    if ( iend .ne. 0 ) return
	    go to 10
	  endif

	  ipst   = ibpt(iu)  +  nwrd(iu) * ( ilog(iu) - 1 )
	  bid(1) = b(ipst)
	  bid(2) = b(ipst+1)
	  id     = chid

	  ichan  = ipst + 2
	  do 20 i = 1, nchan
	    z(i)  = b(ichan)
	    ichan = ichan + 1
20	  continue
	  return
	endif

c  write logical record

	if ( opr .eq. 'w'   .or. opr .eq. 'W' ) then
	  if ( iomode(iu) .eq. 1 ) then
	    write(6,*) ' attempt to write to readonly unit #', iu
	    stop
	  endif

	  ilog(iu) = ilog(iu) + 1
	  if ( nwrd(iu) .le. 0 ) nwrd(iu) = nchan + 2
	  maxlog   = ntot(iu) / nwrd(iu)

	  if (  ilog(iu)  .gt.  maxlog  ) then
	    call xiobuf( 'w', iu, iend )
	    if ( iend .ne. 0 ) return
	    go to 10
	  endif

	  nlog(iu) = nlog(iu) + 1
	  ipst     = ibpt(iu)  +  nwrd(iu) * ( nlog(iu) - 1 )

	  chid      = id
	  b(ipst)   = bid(1)
	  b(ipst+1) = bid(2)

	  ichan  = ipst + 2
	  do 50 i = 1, nchan
	    b(ichan) = z(i)
	    ichan    = ichan + 1
50	  continue
	  return
	endif

	write(6,*) ' %%iopst: incorrect operator'
	return
	end
c*******************************************************************************
	subroutine xwpbuf( junit, lineid, ndata, z, maxdat, maxchn )

c  write buffer to express file in post records.  Order in the buffer
c  is by profile  ie.   buff( ndata, nchan ).

	parameter       ( maxu=30, maxb=2048 )
	common /ioexpc/ nb, ibordr(maxu), iomode(maxu), irec(maxu), 
	1               nwrd(maxu), nlog(maxu), ntot(maxu), 
	1               ilog(maxu), ibpt(maxu), b(maxb)

	dimension        fltid(2), z(maxdat,maxchn)
	character       lineid*4, id*8
	equivalence     ( fltid, id )

	nword   = maxchn + 2
	ntotal  = ntot(junit)
	maxlog  = ntotal / nword
	iaddr   = ibpt(junit)

	id      = ' '
	id(1:4) = lineid 
	jrec    = irec(junit)

	call wtp1( junit, jrec, fltid, ndata, z, maxdat, maxchn, 
	1          b(iaddr), nword, maxlog, ntotal )

	irec(junit) = jrec
	return
	end
c*****************
	subroutine wtp1( junit, jrec, fltid, ndata, z, maxdat, maxchn, 
	1                b, nword, maxlog, ntotal )

	dimension fltid(2), z(maxdat,maxchn), b(nword,maxlog)

	ncharw = 2
	do 10 j = 1, maxlog
	  b(1,j) = fltid(1)
	  b(2,j) = fltid(2)
10	continue

	nlog = 0
	do 30 idata = 1, ndata

	  nlog  = nlog + 1
	  iword = ncharw
	  do 20 j = 1, maxchn
	    iword         = iword + 1
	    b(iword,nlog) = z(idata,j)
20	  continue

	  if ( nlog .eq. maxlog ) then
	    call wtbuf( junit, jrec, nword, nlog, ntotal, b )
	    nlog = 0
	  endif
30	continue

	if ( nlog .gt. 0 ) then
	  call wtbuf( junit, jrec, nword, nlog, ntotal, b )
	endif

	return
	end
c*****************
	subroutine wtbuf( junit, jrec, nword, nlog, ntotal, b )
	dimension b(ntotal)
	do 10 i = nword * nlog + 1, ntotal
	  b(i) = 0.0
10	continue
	jrec = jrec + 1
	write( junit, rec=jrec ) nword, nlog, ntotal, b
	return
	end
c*******************************************************************************
	subroutine xsetr( iu, newrec )
c  user callable external record set for unit.

	parameter       ( maxu=30, maxb=2048 )
	common /ioexpc/ nb, ibordr(maxu), iomode(maxu), irec(maxu), 
	1               nwrd(maxu), nlog(maxu), ntot(maxu), 
	1               ilog(maxu), ibpt(maxu), b(maxb)

c  decrement by one because ioexpc increments before actual i/o.
	nrec = newrec - 1
	if ( nrec .le. 0 ) nrec = 0 
	irec(iu) = nrec

c  "rewind" pointers
	nwrd(iu) = 0
	nlog(iu) = 0
	ilog(iu) = 0

	return
	end
c*******************************************************************************
	subroutine xproft( iu, nrtst, iprof )

c  test nrtst records for constant id in each buffer.
c  nrtst <= zero tests entire file.

	parameter       ( maxu=30, maxb=2048 )
	common /ioexpc/ nb, ibordr(maxu), iomode(maxu), irec(maxu), 
	1               nwrd(maxu), nlog(maxu), ntot(maxu), 
	1               ilog(maxu), ibpt(maxu), b(maxb)

	character       id*4, id1*4, blank*4
	equivalence     ( bid, id )
	blank  = ' '
	idatr  = 0
	iblank = 0
	nrec   = nrtst
	if ( nrtst .le. 0 ) nrec = 9 999 999

	if ( ibpt(iu) .le. 0 ) then
	  write(6,*) iu, ' not active unit '
	  return
	endif

	do ir = 1, nrec
	  call xiobuf( 'r', iu, iend )
	  if ( iend .ne. 0 ) go to 100
	  nw = nwrd(iu)
	  nd = nlog(iu)

	  if ( nd .gt. 0 ) then
c  data record
	    idatr  = idatr + 1
	    kid    = ibpt(iu)
	    bid    = b(kid)
	    id1    = id
	    if ( id1 .eq. blank ) iblank = iblank + 1

c  check logical records
	    do idata = 2, nd
	      kid = kid + nw
	      bid = b(kid)	      	      
	      if ( id .ne. id1 ) then
	        write(6,*) ' xproft: p_rec, l_rec =', ir, idata
		write(6,*) ' id vs. first id =', id, '<<>>', id1, '<<'
	        write(6,*) ' different id in same record: not profile data'
	        go to 999
	      endif
	    enddo

	  endif
	enddo

100	if ( idatr .gt. 0 ) then
	  iprof = 1
	  write(6,*) ' checked ', idatr, ' records.'  
	  write(6,*) ' all are consistent with profile data format.'
	  if ( iblank .eq. idatr ) 
	1                    write(6,*) ' although all ids were blank.'
	  else
	  if ( iend .ne. 0 ) ir = ir - 1
	  write(6,*) ' checked', ir, ' records and did not find any data'
	endif


c    "rewind" iu before exit.
999	call xsetr( iu, 1 )

	return
	end
c*******************************************************************************
	subroutine xgetc( iu, kcom, ncom )
c  user callable - returns current common area info

	parameter       ( maxu=30, maxb=2048 )
	common /ioexpc/ nb, ibordr(maxu), iomode(maxu), irec(maxu), 
	1               nwrd(maxu), nlog(maxu), ntot(maxu), 
	1               ilog(maxu), ibpt(maxu), b(maxb)

	dimension    kcom(1)

	if ( ncom .le. 0 ) return

	do 5 i = 1, ncom
	  kcom(i) = -99
5	continue

	kcom(1) = nb

	if ( ncom .ge. 2 ) then
	  do 10 ju = 1, nb
	    if ( ibordr(ju) .eq. iu ) kcom(2) = ju
10	  continue
	endif

	if ( ncom .ge. 3 ) kcom(3) = iomode(iu)
	if ( ncom .ge. 4 ) kcom(4) = irec(iu)
	if ( ncom .ge. 5 ) kcom(5) = nwrd(iu)
	if ( ncom .ge. 6 ) kcom(6) = nlog(iu)
	if ( ncom .ge. 7 ) kcom(7) = ntot(iu)
	if ( ncom .ge. 8 ) kcom(8) = ilog(iu)
	if ( ncom .ge. 9 ) kcom(9) = ibpt(iu)

	return
	end
c*******************************************************************************
	subroutine xiobuf( oprin, iu, iend )

c  read and write express physical records.
c  irec is incremented before the operation.
c  combine this subroutine with subroutines from ioexp.
c  subroutines bufr and bufw are not to be called from user programs.

	parameter       ( maxu=30, maxb=2048 )
	common /ioexpc/ nb, ibordr(maxu), iomode(maxu), irec(maxu), 
	1               nwrd(maxu), nlog(maxu), ntot(maxu), 
	1               ilog(maxu), ibpt(maxu), b(maxb)

	character       opr*1, oprin*(*)

	if ( ibpt(iu) .eq. 0 ) then
	  write(6,*) ' %%iobuf: express w/r operation to '
	  write(6,*) ' unopened unit #', iu
	  stop
	endif

	opr = oprin(1:1)

	if ( opr .eq. 'r'   .or.   opr .eq. 'R' ) then
	  irec(iu) = irec(iu) + 1
	  call bufr( iu, iend, b(ibpt(iu)), ntot(iu) )
	  ilog(iu) = 0
	  return
	endif

	if ( opr .eq. 'w'  .or.  opr .eq. 'W' ) then
c  check for data or text
	  if ( nlog(iu) .eq. 0 ) return

	  irec(iu) = irec(iu) + 1
	  call bufw( iu, iend, b(ibpt(iu)), ntot(iu) )
	  nlog(iu) = 0
	  ilog(iu) = 0
	  return
	endif

	write(6,*) ' %%bufio: incorrect operator'
	return
	end
c**********************
	subroutine bufr( iu, iend, buffer, ntotal )
c  captive subroutine: call with iobuf only.

	parameter       ( maxu=30, maxb=2048 )
	common /ioexpc/ nb, ibordr(maxu), iomode(maxu), irec(maxu), 
	1               nwrd(maxu), nlog(maxu), ntot(maxu), 
	1               ilog(maxu), ibpt(maxu), b(maxb)

	dimension buffer(ntotal)

	iend     = 0
	read( iu, rec=irec(iu), err=9, iostat=ios ) 
	1                         nwrd(iu), nlog(iu), nt, buffer
	if ( nt .ne. ntot(iu) ) then
	  write(6,*) ' record # ', irec(iu), ' of unit #', iu
	  write(6,*) ' has ntotal different from the initial value'
	  write(6,*)  nt, '  vs  ', ntot(iu)
	  stop
	endif
	return

9	iend     = 1
	nlog(iu) = 0
	return
	end	
c**********************
	subroutine bufw( iu, iend, buffer, ntotal )
c  captive subroutine: call with iobuf only.

	parameter       ( maxu=30, maxb=2048 )
	common /ioexpc/ nb, ibordr(maxu), iomode(maxu), irec(maxu), 
	1               nwrd(maxu), nlog(maxu), ntot(maxu), 
	1               ilog(maxu), ibpt(maxu), b(maxb)

	dimension buffer(ntotal)

	iend     = 0
	write( iu, rec=irec(iu), err=9 ) 
	1                        nwrd(iu), nlog(iu), ntot(iu), buffer
	return

9	iend     = 1
	return
	end	
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
	integer function lenz(iswt)
c  find the number of channels in a post record
	dimension id(2),z(50)
	do 15 j = 50, 1, -1
          k = j
	  read(iswt,err=10,iostat=ierr) id,(z(i),i=1,j)
	  go to 20
10	  rewind iswt
15	continue
20	rewind iswt
        lenz = k
	return
	end
