c***************
c  GRAVPOLY.FOR
c program to input exact talwani polygonal prisms for 3d gravity-plouff
c modified by r.godson for denver multics 5/81
c
      character*4 unix,uniz
      character*8 name
      character*18 title
      character*40 idplot
      character*50 ifile,ifile2,cfile
      character*50 cafile,rfile,pfile
      character*80 ifmt
      common/st/cafile,rfile,pfile,ifile,ifile2,name,ifmt,idplot,
     1 unix,uniz
      common/gravinp/iplotr,ibody,lsqs,
     1 datum,xscale,dc,height,
     2 iobs,icalc,ires
      common /field/r(1000)
      common /fpts/ xf(1000),yf(1000),zf(1000)
      common /bodk/ mm,nlim,jbody,short,nend
      common /trans/ inpt,iout,jin,iprint
      dimension a(1000),b(1000),dstnc(900)
c dimension limits for 3 parameters.  corners, bodies, fieldpoints.
c one more than dimension of total number of fieldpoints
      data ncorn,nbod,npt/900,50,1001/
c
c     get input parameters
c
      call gravin(*220)
   10 write (iout,20) idplot
   20 format ('1 gravity effect of polygonal prisms',/,
     1 1x,                            ' for ',5x,a40)
      facx=0.0
      facz=0.0
      call unit(unix,uniz,facx,facz)
      if (facx .eq. 0.0) go to 200
      zfac=1.0/facz
      gfac=6.670*facx
   30 short=1.0e20
c
c     read body coordinates
c
      call bodg(facz,nbod,dstnc,ncorn,gfac)
c mm (common) is total number of layers
      if (mm .eq. 0) go to 200
c
c     read fieldpoint locations and maybe values
c
      call ptsm(nk,*220)
      if (nk .lt. 1) go to 200
c
c     check if printer plot of bodies & fieldpoints
c     desired if fieldpoints are in grid form
c
      title='body corners'
      if(ibody.ne.0.and.iplotr.eq.9.and.name.eq.'gridded')
     1 call cplot(dc,a,1,0,title,*365)
c
c     check if location plot of bodies & fieldpoints on
c     plotting device wanted
c
      if(ibody.ne.0.and.iplotr.ne.9) call grav3dplot(nk,*220)
c
c     check if plot of observed values desired
c
      title='observed values'
      if(iobs.ne.0.and.iplotr.eq.9.and.name.eq.'gridded')
     1 call cplot(dc,r,nk,1,title,*365)
      do 40 k=1,nk
   40 zf(k)=zf(k)*facz
   50 call gtalw(nk,mm,short,dstnc,a)
      if(datum .ne. 0.) write (iout,60) datum
   60 format (/,1x,f10.2,' mgal is added to gravity values')
      if (lsqs .eq. 0) go to 130
      do 70 k=1,nk
   70 r(k)=r(k)-datum
      if (lsqs .ne. 7) go to 90
      ier=0
      call glsqs(nk,a,ier,datum)
      if (ier .ne. 0) go to 200
   90 std=0.0
      avg=0.0
      do 100 k=1,nk
      errk=r(k)-a(k)
      b(k)=errk
      avg=avg+errk
  100 std=std+errk*errk
  110 if (nk  .lt. 2) go to 130
      std=sqrt(std/(nk -1))
      avg=avg/nk
      write (iout,120) std,avg
  120 format (///,5x,'standard deviation=',
     1 f8.2,' and average difference=',f8.2,' milligals')
  130 write (iout,140)
  140 format (/,15x,'x',9x,'y',9x,'z',9x,'g',4x,'residual')
      do 180 k=1,nk
      x=xf(k)
      y=yf(k)
      zfk=zf(k)*zfac
      grav=a(k)+datum
      a(k)=grav
      if (lsqs .eq. 0) go to 160
      write (iout,150) k,y,x,zfk,  grav,b(k)
  150 format (i6,3x,3f10.3,2f9.2)
      go to 180
  160 write (iout,170) k,y,x,zfk,  grav
  170 format (i6,3x,3f10.3,f9.2)
  180 continue
c
c     contour plots
c
  340 title='calculated values'
      if (icalc.ne.0.and.iplotr.eq.9.and.name.eq.'gridded')
     1 call cplot (dc,a,nk,1,title,*365)
      title='residual values'
      if (ires.ne.0.and.iplotr.eq.9.and.lsqs.ne.0.and.name.eq.'gridded')
     1 call cplot (dc,b,nk,1,title,*365)
      if(icalc.ne.0.and.iplotr.lt.9.and.name.eq.'gridded')
     1 call stdout(1,a)
      if(ires.ne.0.and.iplotr.lt.9.and.lsqs.ne.0.and.name.eq.'gridded')
     1 call stdout(2,b)
      go to 220
  365 write(iprint,375)
  375 format(' contour interval(dc) is 0.')
  200 write(iprint,210)
  210 format(' error - program abort')
  220 close(jin)
      close(iout)
      write(iprint,230) pfile
  230 format(/,' output is in file ',a50)
      stop
      end
c***************
      subroutine gravin(*)
c
c     namelist input parameter subroutine
c
c     r.godson - 3/81
c
      character*4 unix,uniz
      character*8 name
      character*40 idplot
      character*50 ifile,ifile2,cfile
      character*50 cafile,rfile,pfile
      character*80 ifmt
      common/st/cafile,rfile,pfile,ifile,ifile2,name,ifmt,idplot,
     1 unix,uniz
      common/gravinp/iplotr,ibody,lsqs,
     1 datum,xscale,dc,height,
     2 iobs,icalc,ires
      common/contg/nrow,ncol,dy,dx,xmin,ymin,xmax,ymax
      common /vec/cde,cie,sde,sie,ex,ey,ez,earth,cdci,sdci
      common /trans/ inpt,iout,jin,iprint
      common/widect/naxcol
      namelist/parms/iplotr,ibody,ifile,ifile2,lsqs,
     1 datum,xscale,dc,unix,uniz,name,height,
     2 ifmt,idplot,iobs,icalc,ires,naxcol
      inpt=5
      iout=8
      iprint=6
      jin=9
      iplotr=9
      naxcol=130
      ibody=0
      iobs=0
      icalc=0
      ires=0
      idplot=' '
      ifile=' '
      ifile2=' '
      lsqs=0
      datum=0.
      xscale=0.
      dc=0.
      unix='kilm'
      uniz='feet'
      name='gridded'
      height=0.
      write(iprint,10)
   10 format('$ enter command file name: ')
      read(inpt,20) cfile
   20 format(a)
      open(jin,file=cfile,status='old')
      read(jin,parms,end=30)
      if(lsqs.eq.0) ires=0
      if(ifile.eq.' ') go to 50
      if(iplotr.lt.0.or.iplotr.gt.9) iplotr=9
c
c     determine output file names
      call names(cfile,pfile,cafile,rfile)
c
      open(iout,file=pfile,status='new')
      return
   30 write(iprint,40)
   40 format(' end of file reading namelist command file')
      go to 70
   50 write(iprint,60)
   60 format(' no observed data file name specified')
   70 return 1
      end
c***************
      subroutine names(cfile,pfile,cafile,rfile)
      character*(*) cfile,pfile,cafile,rfile
      ic=index(cfile,'.')-1
      pfile=cfile(:ic)//'.prt'
      cafile=cfile(:ic)//'.cal'
      rfile=cfile(:ic)//'.res'
      return
      end
c***************
      subroutine bodg(facz,nbod,dstnc,ncorn,gfac)
c
c      reads body corner coordinates
c
c      r.godson - 4/81
c
      character*4 unix,uniz
      character*8 name
      character*40 idplot
      character*50 ifile,ifile2,cfile
      character*50 cafile,rfile,pfile
      character*80 ifmt
      dimension dstnc(1)
      common/mplot/ymin,xmin,ymax,xmax
      common/contg/nrow,ncol,dy,dx,yo,xo,xma,yma
      common/st/cafile,rfile,pfile,ifile,ifile2,name,ifmt,idplot,
     1 unix,uniz
      common/gravinp/iplotr,ibody,lsqs,
     1 datum,xscale,dc,height,
     2 iobs,icalc,ires
      common /bod/ rho(50),ifprnt(50),zee(50),zm(50)
c see ncorn dimension limit in main program
      common /side/xb(900),yb(900), ll(50)
      common /bodk/ mm,nlim,jbody,short,nend
      common /trans/ inpt,iout,jin,iprint
      nend=0
      mm=0
      xmin=1.0e38
      xmax=-1.0e38
      ymin=1.0e38
      ymax=-1.0e38
   10 read(jin,*,end=180)num,ifprnt(mm+1),dencon,top,bottom
      if(lsqs.eq.7) dencon=1.
      nst=nend+1
      nend=nend+num
      mm=mm+1
      if(mm.gt.nbod) go to 130
      if(nend.gt.ncorn) go to 70
      ll(mm)=num
      zee(mm)=top*facz
      zm(mm)=bottom*facz
      rho(mm)=dencon*gfac
      write(iout,30) mm,top,bottom,num,dencon
   30 format (' body',i3,' between depths',f11.3,' and',f11.3,
     1 ' and has',i4,' vertices. density = ',f8.3)
   40 if (top .gt. bottom) go to 90
   50 write (iprint,60) top,bottom
   60 format ('0top of body is below bottom',2f7.2)
      go to 170
   70 write(iprint,80) mm,nend,ncorn
   80 format (' body',i3,' includes sufficient corners,',i4,',to exceed'
     1 , ' limitation of',i5,' for all bodies.')
      go to 170
c coordinates of corners of body east,north (x,y) pairs.
c body has at least 3 corners
   90 read(jin,*,end=150) (yb(j),xb(j),j=nst,nend)
      write(iout,100) (yb(j),xb(j),j=nst,nend)
  100 format (5(5x,2f9.3))
      do 105 j=nst,nend
      if(xb(j).lt.xmin) xmin=xb(j)
      if(xb(j).gt.xmax) xmax=xb(j)
      if(yb(j).lt.ymin) ymin=yb(j)
      if(yb(j).gt.ymax) ymax=yb(j)
  105 continue
  110 np=nend+1
      xb(np)=xb(nst)
      yb(np)=yb(nst)
      do 120 j=nst,nend
      dist=(xb(j+1)-xb(j))**2+(yb(j+1)-yb(j))**2
      if (dist .eq. 0.0) go to 120
      dist=sqrt(dist)
      if (dist .lt. short) short=dist
  120 dstnc(j)=dist
      go to 10
  130 write (iprint,140) mm
  140 format (5x,'number of bodies=',i3,' exceeds limitation.')
      go to 170
  150 write(iprint,160) mm
  160 format(' end of file reading x,y pairs for body no. ',i3)
  170 mm=0
  180 return
      end
c***************
      subroutine unit(unix,uniz,facx,facz)
c conversion of horizontal (x) and vertical (z) distances-3d magnetics
      character*4 unix,uniz,feet,kilm,mile,kilf,metr,jblank,
     1 lunx,lunz
      common /trans/ inpt,iout,jin,iprint
      data kilm,  feet,  mile,  kilf,  metr,jblank
     1   /'kilm','feet','mile','kilf','metr','    '/
      write (iout,10) unix,uniz
   10 format (5x,'units of distance measurement are in ',a4,
     1 ' and heights are in ',a4)
   20 if (unix .eq. mile) facx=1.609347
      if (uniz .eq. mile) facz=1.609347
      if (unix .eq. feet) facx=3.048006e-4
      if (uniz .eq. feet) facz=3.048006e-4
      if (unix .eq. kilf) facx=3.048006e-1
      if (uniz .eq. kilf) facz=3.048006e-1
      if (unix .eq. kilm) facx=1.0
      if (uniz .eq. kilm) facz=1.0
      if (unix .eq. metr) facx=1.0e-3
      if (uniz .eq. metr) facz=1.0e-3
      if (facx .ne. 0.0) go to 40
      write(iprint,30)
   30 format(' unix specification is incorrect')
      return
   40 if (facz .ne. 0.0) go to 50
      facx=0.0
      return
c multiplying factor for heights to convert to distance units.
c negative sign to compensate for depths + downward later 'calc'.
   50 facz=-facz/facx
      return
      end
c***************
      subroutine gtalw(nk,mm,short,dstnc,a)
c exact solution for talwani 3d gravity in single precision (7 figures)
      common /side/xb(900),yb(900), ll(50)
      common /bod/ rho(50),ifprnt(50),zee(50),zm(50)
      common /fpts/ xp(1000),yp(1000),zp(1000)
      common /trans/ inpt,iout,jdisk,page
      dimension a(1),dstnc(1)
c 1/1000 length of shortest non-zero side
      test=short*1.0e-3
      do 240 k=1,nk
      x=xp(k)
      y=yp(k)
      z=zp(k)
      grav=0.0
      ne  =0
c loop of bodies
      do 230 m=1,mm
c number of vertices
      ns =ne  +1
      lk= ll(m)
      z1=zee(m)-z
      z2=zm (m)-z
      ne  =ns +lk-1
      gf=rho(m)
      jfprnt=ifprnt(m)
      g=0.0
c to give clockwise positive
      h1=abs(z1)
      h2=abs(z2)
      zz=z1+z2
      if (zz)10,230,20
c case where most of mass is above fieldpoint (minus g)
   10 gf=-gf
   20 if (h1 .lt. h2) go to 30
      t=h2
      h2=h1
      h1=t
   30 x1=xb(ns)-x
      y1=yb(ns)-y
c last point is repeat of first
      xf=x1
      yf=y1
      r1s=x1*x1+y1*y1
      r1sf=r1s
      hh1=h1*h1
      hh2=h2*h2
      dh=h2-h1
      r11= sqrt(r1s+hh1)
      r12= sqrt(r1s+hh2)
      r11f=r11
      r12f=r12
      ang=0.0
      t1=0.0
      t2=0.0
      w1=0.0
      w2=0.0
      w3=0.0
      n=ns
c loop of all sides
      do 210 l=1,lk
      nm=n
      if (l .ne. lk) go to 40
      x2=xf
      y2=yf
      r2s=r1sf
      r21=r11f
      r22=r12f
      go to 50
   40 n=n+1
      x2=xb(n)-x
      y2=yb(n)-y
      r2s=x2*x2+y2*y2
      r22= sqrt(r2s+hh2)
      r21= sqrt(r2s+hh1)
   50 ds=dstnc(nm)
      if (test .gt. ds) go to 190
c     same sign as definition used for magnetics. opposite last gravity
      p=(x1*y2-x2*y1)/ds
      dx=x2-x1
      dy=y2-y1
c test if perpendicular distance to line segment is less than 1/1000
c of shortest segment length
      ap=abs(p)
      if (ap .lt. test) go to 190
      d1= (x1*dx+y1*dy)/ds
      d2= (x2*dx+y2*dy)/ds
      dd1= abs(d1)
      dd2= abs(d2)
      if (dd1 .lt.  test) d1=0.0
      if (dd2 .lt.  test) d2=0.0
      fnum=ap*ds
      den=x1*x2+y1*y2
      if (den) 60,100,110
   60 gl=3.141593
      if (p .gt. 0.0) go to 80
      gl=-gl
   70 den=-den
   80 call tandet(fnum/den,w3,ang)
   90 ang=ang+gl
      go to 120
  100 gl=1.570796
      if (p .lt. 0.0) gl=-1.570796
      go to 90
  110 gl=0.0
      if (p .gt. 0.0) go to 80
      go to 70
  120 if (d1 .eq. 0.0) go to 130
      call tandet(-d1*h1/(p*r11),w1,t1)
      call tandet( d1*h2/(p*r12),w2,t2)
  130 if (d2 .eq. 0.0) go to 140
      call tandet( d2*h1/(p*r21),w1,t1)
      call tandet(-d2*h2/(p*r22),w2,t2)
  140 ph=p*p+hh1
      rz1=r11+d1
      if (d1 .ge. 0.0) go to 160
      if (d2 .gt. 0.0) go to 150
      gl=(r21-d2)/(r11-d1)
      go to 180
  150 dtest=ph/(d1*d1)
      if (dtest .lt. 0.01) rz1=dd1*0.5*dtest*(1.0-0.25*dtest)
  160 rz2=r21+d2
      if (d2 .ge. 0.0) go to 170
      dtest=ph/(d2*d2)
      if (dtest .lt. 0.01) rz2=dd2*0.5*dtest*(1.0-0.25*dtest)
  170 gl=rz1/rz2
  180 gl=p*alog(gl*(r22+d2)/(r12+d1))
      g=g-gl
  190 if (jfprnt .lt. 0) write (iout,200) l,p,d1,d2,ang,gl,w1,w2
  200 format (i4,7e16.8)
      x1=x2
      y1=y2
      r1s=r2s
      r12=r22
      r11=r21
  210 continue
      t1=t1+ atan(w1)
      t2=t2+ atan(w2)
      ang=  ang+atan(w3)
      g=gf*(ang*dh+g+h1*t1+h2*t2)
      if (jfprnt .ne. 0) write (iout,220) k,g,ang ,t1,t2
  220 format (i4,f8.2,' mgal',15x,3f9.3)
  230 grav=grav+g
  240 a(k)=grav
      return
      end
c***************
      subroutine tandet(f,zze,sume)
c program for arctangent addition. negative f for subtraction.
      q1=zze+f
      q2=1.0d0-zze*f
      if (q2 .ne. 0.0  ) go to 40
      if (q1) 10,20,20
   10 sume=sume-1.570796
      go to 30
   20 sume=sume+1.570796
   30 zze=0.0
      return
   40 zze=q1/q2
      if (q2 .gt. 0.0  ) return
      if (q1) 50,60,70
   50 sume=sume-3.141593
   60 return
   70 sume=sume+3.141593
      return
      end
c***************
      subroutine glsqs(kk,a,ier,datum)
c least-squares calculation of density regression
      real*8 fn,sx,sy,sxx,sxy,syy
      integer nm(4)/'n','x','s','y'/
      common /field/r(1000)
      common /trans/ inpt,iout,jdisk,page
      dimension a(1)
      l=1
      if (kk .lt. 3) go to 40
      fn=kk
      sx =0.0d0
      sy =0.0d0
      syy=0.0d0
      sxy=0.0d0
      sxx=0.0d0
      do 10 k=1,kk
      rk=r(k)
      ak=a(k)
      sx =sx +ak
      sy =sy +rk
      syy=syy+rk*rk
      sxy=sxy+ak*rk
   10 sxx=sxx+ak*ak
      xx=sxx-sx*sx/fn
      l=2
      if (xx .le. 0.0) go to 40
      xy=sxy-sx*sy/fn
      yy=syy-sy*sy/fn
      tm=xy/xx
      tb=(sy-tm*sx)/fn
      l=4
      if (yy .le. 0.0) go to 40
      coer=xy/sqrt(xx*yy)
      stdm=yy*(1.0-coer*coer)/(xx*(kk-2))
      l=3
      if (stdm .lt. 0.0) go to 40
      stdm=sqrt(stdm)
      tb=tb+datum
      write (iout,20) tm,stdm,coer,tb
   20 format (//,' least-squares density is',f7.3,' (std',f6.3,') with',
     1 ' correlation coefficient=',           f6.2,3x,'datum=',f7.2,
     2 ' mgal.')
      do 30 k=1,kk
   30 a(k)=tm*a(k)
      return
   40 ier=1
      write (iout,50) nm(l)
   50 format ('0stop. density can be calculated. cutoff ',a1)
      return
      end
c***************
      subroutine cplot(pc,a,nt,jk,title,*)
c jk must be zero for first call of cplot. later calls use revised xb/yb
c             ci---the initial contour value (calculated)
c          pc,dc---the increment in the contour values (read in)
c        a(y,x)---the input array containing the data to be contoured.
c index for equivalent 1d array is n*(x-1)+y
c              m---the  final  value of x-index in a-array
c              n---the  final  value of y-index in a-array
c             limits of plot are a(yi,xi) to a(n,m)
c nx is number of intervals in x-direction (right) less than 41.
c ny is number of intervals in y-direction (down)  less than 41.
      character*18 title
      integer pnt(131),sym(35),c,iy(41),jx(41)
      common /side/xb(900),yb(900), ll(50)
      common/fpts/xf(1000),yf(1000),zf(1000)
      common /contg/ m,n, dx,dy,  xmn,ymn,xmx,ymx
      common /trans/ inpt,iout,jin,iprint
      common /widect/ naxcol
      common /bodk/ mm,nlim,jbody,short,nend
      dimension a(1),xa(900),ya(900),lll(50)
      data sym/'1','2','3','4','5','6','7','8','9','a','b','c','d','e',
     1'f','g','h','i','j','k','l','m','n','o','p','q','r','s','t',
     2'u','v','w','x','y','z'/,ihor/'-'/,ivert/'|'/,         jplus/'+'/
c needs carriage with 132 columns available or change maxcol
      data maxcol,iblank,jex/131,' ','*'/
      if(pc.eq.0.) return 1
      dc=pc
      if (m .lt. 2) go to 650
      if (m .gt. 41) go to 650
      if (n .lt. 2) go to 650
      if (n .gt. 41) go to 650
      maxcol=naxcol+1
      if (naxcol .eq. 0 .or. naxcol .gt. 130) maxcol=131
      nx=m-1
      ny=n-1
      if(jk.eq.0) go to 60
      write (iout,10) title,n,m,nt,ymn,ymx,xmn,xmx,dc
   10 format (///,' expect plot of 'a18,' of',i3,' by',i3,
     1 '(',i3,') arra',
     2 'y. x=',f8.1,' to',f8.1,' y=',f8.1,' to',f8.1,' contoured at',
     3 f7.1,' milligals',//)
      fmin= 1.0e20
      fmax=-1.0e20
      do 20 i=1,nt
      aij=a(i)
      if (aij .gt. fmax) fmax=aij
      if (aij .lt. fmin) fmin=aij
   20 continue
   30 fc=fmin/dc
      ic=fc
      if(amod(fc,1.).ne.0.) ic=ic+1
      if (ic .lt. 0) ic=ic-1
      jc=fmax/dc
      if (jc .lt. 0) jc=jc-1
      ncont=jc-ic+1
      if (ncont .lt. 36) go to 50
      write  (iout,40) dc
   40 format (5x,'requested contour interval of',f9.4, ' is doubled',
     1 ' because more than 35 contours are produced.')
      dc=2.0*dc
      go to 30
   50 cd=1.0/dc
      ci=dc*ic
c     cf=dc*jc
   60 width=maxcol-1
      ux=nx/width
c number of columns in one grid interval
      fjinc=1.0/ux
      fjincp=0.5+fjinc
      colefm=1.0-fjinc
c maintains true proportions with x expanded to 130 columns
      uy=  dx*ux/(  dy*0.6)
      if (uy .lt. 1.0) go to 80
      uy=1.0/uy
      write  (iout,70) uy
   70 format(5x,'y-distances are exaggerated by',f9.4,' for contouring')
      uy=1.0
c number of columns per unit distance
   80 dlx=fjinc/dx
      fiinc=1.0/uy
      dly=fiinc/dy
      row=1.0
      do  90 k=1,ny
      row=row+fiinc
   90 iy(k)=row+0.5
      lastrw=iy(ny)
      col=1.0
      do  100 k=1,m
      jx(k)=col+0.5
  100 col=col+fjinc
      if (jk .ne. 0) go to 300
c
c     plot body(s) corners
c
      write (iout,110) title,ymn,ymx,xmn,xmx
  110 format (///,' expect plot of 'a18,
     1 'x=',f8.1,' to',f8.1,' y=',f8.1,' to',f8.1,//)
      do 120 i=1,nend
      xa(i)=xb(i)
      ya(i)=yb(i)
  120 continue
      do 130 i=1,mm
      lll(i)=ll(i)
  130 continue
      nb=nend
      jr=1
      do 280 jrow=1,lastrw
      do 140 l=1,maxcol
      pnt(l)=iblank
  140 continue
      ie=0
      do 180 i=1,mm
      is=ie+1
      ie=ie+lll(i)
      if(lll(i).eq.0) go to 180
  150 ky=1.5001+dly*(ya(is)-ymn)
      if(ky.ne.jrow) go to 170
      kx=1.5001+dlx*(xa(is)-xmn)
      if(kx.lt.1.or.kx.gt.maxcol) go to 170
      pnt(kx)=sym(i)
      nb=nb-1
      do 160 k=is,nb
      kk=k+1
      xa(k)=xa(kk)
      ya(k)=ya(kk)
  160 continue
      is=is-1
      ie=ie-1
      lll(i)=lll(i)-1
  170 is=is+1
      if(is.le.ie) go to 150
  180 continue
      itest=0
      if (jrow .eq. lastrw) go to 220
      if (jrow .eq.      1) go to 220
      if (jrow .eq. iy(jr)) go to 210
      if (pnt(maxcol) .eq. iblank) pnt(maxcol)=ivert
      if (pnt(     1) .eq. iblank) pnt(     1)=ivert
  190 write  (iout,200) (pnt(k),k=1,maxcol)
  200 format ( 1x,131a1)
      go to 280
  210 itest=1
      jr=1+jr
  220 do 230 k=1,m
      kx=jx(k)
      if (pnt(kx) .eq. iblank) pnt(kx)=jplus
  230 continue
      if (itest .eq. 1) go to 190
      do 240 k=1,maxcol
      if (pnt(     k) .eq. iblank) pnt(     k)=ihor
  240 continue
      if (jrow .eq. lastrw) go to 290
      if(maxcol.eq.131) go to 260
      write(iout,250)
  250 format('1')
      write  (iout,200) (pnt(k),k=1,maxcol)
      go to 280
  260 write(iout,270) (pnt(k),k=1,maxcol)
  270 format('1',131a1)
  280 continue
  290 write  (iout,200) (pnt(k),k=1,maxcol)
      return
c next statement used if only first body corners to be plotted
c otherwise all could be plotted
c nb is total number of corners of first body of model here
  300 nb= ll(1)
      nf=1
      l=0
  310 do  320 k=nf,nb
      kk=k
      dum=xb(k)
      if (dum .lt. xmn) go to 330
      if (dum .gt. xmx) go to 330
      kx=1.5001+dlx*(dum-xmn)
      dum=yb(k)
      if (dum .lt. ymn) go to 330
      if (dum .gt. ymx) go to 330
      ky=1.5001+dly*(dum-ymn)
      l=l+1
      xa(l)=kx
  320 ya(l)=ky
      go to 350
  330 nf=kk+1
      write  (iout,340) yb(kk),xb(kk)
  340 format (5x,'body point x=',f10.3,' y=',f10.3,' is outside',
     1 ' plot boundary.')
      if (kk .lt. nb) go to 310
  350 nb=l
  360 cm=ci-dc
      do 370 i=1,nt
c changes values inputted as 'a' (restored later).
  370 a(i)=cd*(a(i)-cm)
      jr=1
c loop of rows from top to bottom
      do 580 jrow=1,lastrw
      row=1.0+uy*(jrow-1)
c major grid index (i) increases once each fiinc rows
      i=row
      ful=row-i
      ind=0
      kt=i-n
      do 380 l = 1,maxcol
  380 pnt(l) = iblank
      coleft=colefm
c loop of grid intervals from left to right
      do 460 j=1,nx
      coleft=coleft+fjinc
      if (jrow .eq. lastrw) go to 390
      kt=kt+n
      kb=kt+n
      dum = a(kt)
      zl = dum + ful*(a(kt+1) -dum)
      dum = a(kb)
      zr = dum + ful*(a(kb+1) -dum)
      go to 400
  390 ind=ind+n
      zl=a(ind)
      kb=ind+n
      zr=a(kb)
  400 den = zr-zl
      if (abs(den) .gt. 0.000001) go to 420
      izc=zl
      fl=izc
      if (fl .ne. zl) go to 460
      left=coleft+0.5
      jrt=coleft+fjincp
c loop of contours in this grid interval
      do 410 l=left,jrt
  410 pnt(l)=sym(izc)
      go to 460
  420 if (zl .gt. zr) go to 430
      fmin=zl
      fmax=zr
      go to 440
  430 fmin=zr
      fmax=zl
  440 lmin=fmin+0.9999
      lmax=fmax
      if (lmax .eq. 0) go to 460
      if (lmax .lt. lmin) go to 460
      ratio=fjinc/den
      do 450 izc=lmin,lmax
      c=coleft+ratio*(izc-zl)
  450 pnt(c)=sym(izc)
  460 continue
      if (nb .eq. 0) go to 510
      row=jrow
      nf=1
  470 do 480 k=nf,nb
      kk=k
      if (ya(k) .eq. row) go to 490
  480 continue
      go to 510
  490 nb=nb-1
      kx=xa(kk)+0.5
      pnt(kx)=jex
      if (kk .gt. nb) go to 510
      nf=kk
      do 500 k=nf,nb
      kp=k+1
      xa(k)=xa(kp)
  500 ya(k)=ya(kp)
      go to 470
  510 itest=0
      if (jrow .eq. lastrw) go to 540
      if (jrow .eq.      1) go to 540
      if (jrow .eq. iy(jr)) go to 530
      if (pnt(maxcol) .eq. iblank) pnt(maxcol)=ivert
      if (pnt(     1) .eq. iblank) pnt(     1)=ivert
  520 write  (iout,200) (pnt(k),k=1,maxcol)
      go to 580
  530 itest=1
      jr=1+jr
  540 do 550 k=1,m
      kx=jx(k)
      if (pnt(kx) .eq. iblank) pnt(kx)=jplus
  550 continue
      if (itest .eq. 1) go to 520
      do 560 k=1,maxcol
      if (pnt(     k) .eq. iblank) pnt(     k)=ihor
  560 continue
      if (jrow .eq. lastrw) go to 590
      if(maxcol.eq.131) go to 570
      write(iout,250)
      write  (iout,200) (pnt(k),k=1,maxcol)
      go to 580
  570 write(iout,270) (pnt(k),k=1,maxcol)
  580 continue
  590 write  (iout,200) (pnt(k),k=1,maxcol)
      write  (iout,600)
  600 format(//,            ' symbol',8x,
     1 'value (milligals).   y increases',
     2' to right and x increases downward')
      zc = ci-dc
      do 610 i=1,ncont
      zc=zc+dc
  610 write  (iout,620) sym(i),zc
  620 format(' ',3x,a1,6x,f14.4)
      write  (iout,630)
  630 format(4x,'+',6x,'fieldpoint', 14x,'*',6x,'corner of body')
      do 640 i=1,nt
  640 a(i)=cm+dc*a(i)
      return
  650 write (iprint,660) m,n
  660 format('0','grid of',i4,' by',i4,' (x,y) is too large (41) or ',
     1 'too small for printer contour.')
      return
      end
c***************
      subroutine ptsm(npts,*)
c
c     input data subroutine for user formatted or gridded data
c     r.godson - 3/81
c
      character*4 unix,uniz
      character*8 name,date1
      character*40 idplot
      character*50 ifile,ifile2,cfile
      character*64 id,id1
      character*50 cafile,rfile,pfile
      character*80 ifmt
      common/mplot/ymin,xmin,ymax,xmax
      common/fpts/xf(1000),yf(1000),zf(1000)
      common/st/cafile,rfile,pfile,ifile,ifile2,name,ifmt,idplot,
     1 unix,uniz
      common/gravinp/iplotr,ibody,lsqs,
     1 datum,xscale,dc,height,
     2 iobs,icalc,ires
      common/contg/nrow,ncol,dy,dx,yo,xo,xma,yma
      common/field/r(1000)
      common /trans/ inpt,iout,jin,iprint
      dimension z(1001),z2(1001)
      data in/10/,in2/11/,nrcmax/1000/
      write(iout,10)
   10 format(//,14x,'observed values',/,
     1 7x,'x',10x,'y',10x,'z',10x,'g',/)
      if(name.eq.'gridded') go to 50
c
c     user formatted data
c
      open(in,file=ifile,status='old')
      i=1
      nz=1
   20 read(in,ifmt,end=40) yf(i),xf(i),r(i),zf(i)
      write(iout,30) yf(i),xf(i),zf(i),r(i)
   30 format(1x,4f11.4)
      if(xf(i).lt.xmin) xmin=xf(i)
      if(xf(i).gt.xmax) xmax=xf(i)
      if(yf(i).lt.ymin) ymin=yf(i)
      if(yf(i).gt.ymax) ymax=yf(i)
      i=i+1
      go to 20
   40 k=i-1
      go to 230
c
c     gridded data
c
   50 open(in,file=ifile,status='old',form='unformatted')
      read(in,end=190) id,ncol,nrow,nz,xo,dx,yo,dy
      if((ncol*nrow).gt.nrcmax) go to 110
      if(dx.eq.0..or.dy.eq.0.) go to 130
      if(nz.ne.1) go to 170
      if(ifile2.eq.' ') go to 60
      open(in2,file=ifile2,status='old',form='unformatted')
      read(in2,end=190) id1,ncol1,nrow1,nz1,xo1,dx1,yo1,dy1
      if(ncol.ne.ncol1.or.nrow.ne.nrow1) go to 90
      if(dx.ne.dx1.or.dy.ne.dy1.or.xo.ne.xo1.or.yo.ne.yo1) go to 90
      if(nz.ne.nz1) go to 90
   60 mcol=ncol+1
      xo1=xo-(2*dx)
      yo1=yo-dy
      k=0
      do 80 i=1,nrow
      call rowin(z,mcol,in)
      if(ifile2.ne.' ') call rowin(z2,mcol,in2)
      do 70 j=2,mcol
      k=k+1
      r(k)=z(j)
      if(ifile2.ne.' ') height=z2(j)
      zf(k)=height
      yf(k)=xo1+(j*dx)
      xf(k)=yo1+(i*dy)
      write(iout,30) yf(k),xf(k),zf(k),r(k)
   70 continue
   80 continue
      if(xf(1).lt.xmin) xmin=xf(1)
      if(xf(k).gt.xmax) xmax=xf(k)
      if(yf(1).lt.ymin) ymin=yf(1)
      if(yf(k).gt.ymax) ymax=yf(k)
      xma=xf(k)
      yma=yf(k)
      go to 230
   90 write(iprint,100)
  100 format(' parameters on two input standard files do not match')
      go to 260
  110 write(iprint,120) nrcmax
  120 format(' number of grid points .gt. allowed maximum of ',i4)
      go to 260
  130 write(iprint,140)
  140 format(' present implementation does not allow unequal',
     1 ' grid intervals')
      go to 260
  150 write(iprint,160) nrcmax
  160 format(' the number of columns * number of rows requested is',
     1 ' greater than the maximum allowed of ',i5)
      go to 260
  170 write(iprint,180)
  180 format(' only single precision values allowed')
      go to 260
  190 write(iprint,200)
  200 format(' end of file while reading input data')
      go to 260
  210 write(iprint,220) k,nrcmax
  220 format(' number of formatted data values',i5,
     1 ' is greater than the allowed number of ',i5)
      go to 260
  230 npts=k
      if(npts.lt.1) go to 240
      ierr=0
      go to 270
  240 write(iprint,250)
  250 format(' number of field points less than 1')
  260 close(in)
      if(ifile2.ne.' ') close(in2)
      return 1
  270 close(in)
      if(ifile2.ne.' ') close(in2)
      return
      end
c***************
      subroutine rowin(z,mcol,in)
      dimension z(mcol)
      read(in) z
      return
      end
c***************
      subroutine grav3dplot(npts,*)
c
c     plotting routine for body corners & fieldpoints
c     r.godson - 4/81
c
      character*4 unix,uniz
      character*8 name
      character*40 idplot
      character*50 ifile,ifile2,cfile
      character*50 cafile,rfile,pfile
      character*80 ifmt
      integer sym(50),iddplot(10)
      equivalence(idplot,iddplot(1))
      common/mplot/xmin,ymin,xmax,ymax
      common/fpts/xf(1000),yf(1000),zf(1000)
      common/st/cafile,rfile,pfile,ifile,ifile2,name,ifmt,idplot,
     1 unix,uniz
      common/gravinp/iplotr,ibody,lsqs,
     1 datum,xscale,dc,height,
     2 iobs,icalc,ires
      common /bodk/ mm,nlim,jbody,short,nend
      common /side/xb(900),yb(900), ll(50)
      common /trans/ inpt,iout,jin,iprint
      common/contg/nrow,ncol,dy,dx,yo,xo,yma,xma
      dimension xd(2),yd(2),xs(4),ys(4),jdim(1),
     1 ifmt1(2),nscale(5),xxb(900),yyb(900)
      data jdim(1)/0/,nscale/1,0,2,0,2/,ifmt1/'(f10','.1) '/,
     1 nshl/6/,nsvl/10/,nvl/12/,
     2 nx/2/,ny/2/,vexag/1./,
     3 sym/'1','2','3','4','5','6','7','8','9','a','b','c','d','e',
     4 'f','g','h','i','j','k','l','m','n','o','p','q','r','s',
     5 't','u','v','w','x','y','z',15*'*'/
c
c
c         denver plotting system
c
   10 if(xscale.eq.0.) go to 170
      if(iplotr.eq.1.or.iplotr.eq.4) go to 20
      nxl=(xmax-xmin)/xscale*2.+.5
      if(nxl.lt.2) nxl=2
      nyl=nxl
      go to 30
   20 nxl=24
      nyl=17
   30 call scale3(xmin,xmax,nxl,xminp,xmaxp,xdel)
      call scale3(ymin,ymax,nyl,yminp,ymaxp,ydel)
      xd(1)=xminp
      xd(2)=xmaxp
      yd(1)=yminp
      yd(2)=ymaxp
      xs(1)=(xmaxp-xminp)/xscale
      ys(1)=(ymaxp-yminp)/xscale
      if(ys(1).gt.18.) ys(1)=18.
      go to 60
   40 nyl=(ymax-ymin)/xscale*vexag*4.+.5
      if(nyl.lt.2) nyl=2
   50 call scale3(ymin,ymax,nyl,yminp,ymaxp,ydel)
      yd(1)=ymaxp
      yd(2)=yminp
      xs(1)=(xmaxp-xminp)/xscale
      ys(1)=(ymaxp-yminp)/xscale*vexag
   60 call pltset(iplotr,xs(4),ys(4),jdim)
      yyss=ys(4)
      xs(2)=0.
      ys(2)=0.
      xs(3)=2.
      ys(3)=2.
      if((xs(1)+xs(3)+.2).gt.xs(4)) go to 70
      if((ys(1)+ys(3)+.2).gt.ys(4)) go to 70
      go to 100
   70 xs(4)=amin1(xs(4),13.)
   80 ys(4)=amin1(ys(4),10.)
   90 xs(3)=1.0
      ys(3)=1.0
      xs(1)=xs(4)-xs(3)-.2
      ys(1)=ys(4)-ys(3)-.2
      go to 110
  100 xs(4)=xs(1)+xs(3)+.2
      ys(4)=ys(1)+ys(3)+.2
  110 call scale(xd,yd,xs,ys,4,icode)
      if(icode.lt.0) go to 150
      call neatl
      call xaxis(xd,yd,xs,xdel,2,.08,'(f10.2)',10)
      call yaxis(yd,xd,ys,ydel,2,.08,'(f10.2)',10)
      if(iplotr.ne.1.and.iplotr.ne.4)
     1 call vchar(2.,.1,iddplot,40,3,.15,0.,0.,0.)
  120 ie=0
c
c     plot body corners
c
      do 140 i=1,mm
      is=ie+1
      ie=ie+ll(i)
      call vchar(yb(is),xb(is),sym(i),1,0,.08,0.,0.,0.)
      m=0
      do 130 k=is,ie
      m=m+1
      xxb(m)=xb(k)
      yyb(m)=yb(k)
  130 continue
      xxb(m+1)=xb(is)
      yyb(m+1)=yb(is)
      call line(yyb,xxb,m+1,0,0)
  140 continue
c
c     plot fieldpoints
c
      do 145 i=1,npts
      call vchar(yf(i),xf(i),'+',1,0,.08,0.,0.,0.)
  145 continue
      call endpt(jdim)
      return
  150 write(iprint,160)
  160 format(' unable to scale plotter')
      go to 190
  170 write(iprint,180)
  180 format(' xscale is zero')
  190 return 1
      end
c***************
      subroutine stdout(isw,z)
c
c     subroutine to create standard file
c     r.godson - 4/81
c
      character*32 id1(2),id2(2)
      character*50 file1,file2,file3
      dimension z(1)
      common/st/file1,file2,file3,ifile,ifile2,name,ifmt,idplot,
     1 unix,uniz
      common/gravinp/iplotr,ibody,lsqs,
     1 datum,xscale,dc,height,
     2 iobs,icalc,ires
      common/contg/nrow,ncol,dy,dx,xmin,ymin,xmax,ymax
      data iout/11/,nz/1/,dum/0./,
     1 id1/'gravpoly calculated values from ',
     2 'model                           '/,
     3 id2/'gravpoly residual values(observe',
     4 'd-calculated                    '/
      if(isw.eq.1)
     & open(iout,file=file1,status='new',form='unformatted')
      if(isw.eq.2)
     & open(iout,file=file2,status='new',form='unformatted')
      if(isw.eq.1) write(iout) id1,ncol,nrow,nz,ymin,dx,xmin,dy
      if(isw.eq.2) write(iout) id2,ncol,nrow,nz,ymin,dx,xmin,dy
      is=1
      ie=ncol
      do 10 i=1,nrow
      write(iout) dum,(z(j),j=is,ie)
      is=ie+1
      ie=ie+ncol
   10 continue
      close(iout)
      return
      end
      subroutine scale3(xmin,xmax,n,xminp,xmaxp,dist)
c--see comm. acm, vol.16, no.10, oct 1973, pp.639-640.
      dimension vint(5)
      data vint(1),vint(2),vint(3),vint(4),vint(5)/1.,2.,5.,10.,20./
      if(xmin.lt.xmax.and.n.gt.1) go to 10
      write(6,99999)
99999 format(34h improper input supplied to scale3)
      return
   10 del=.00002
      fn=n
      a=(xmax-xmin)/fn
      al=alog10(a)
      nal=al
      if(a.lt.1.) nal=nal-1
      b=a/10.**nal
      do 20 i=1,3
      if(b.lt.(vint(i)+del)) go to 30
   20 continue
      i=4
   30 dist=vint(i)*10.**nal
      fm1=xmin/dist
      m1=fm1
      if(fm1.lt.0.) m1=m1-1
      if(abs(float(m1)+1.-fm1).lt.del) m1=m1+1
      xminp=dist*float(m1)
      fm2=xmax/dist
      m2=fm2+1.
      if(fm2.lt.(-1.)) m2=m2-1
      if(abs(fm2+1.-float(m2)).lt.del) m2=m2-1
      xmaxp=dist*float(m2)
      np=m2-m1
      if(np.le.n) go to 40
      i=i+1
      go to 30
c
c         next 3 statements comented out by r.godson,usgs,denver,co.
c
c   40 nx=(n-np)/2
c      xminp=xminp-float(nx)*dist
c      xmaxp=xminp+float(n)*dist
40      if(xminp.gt.xmin) xminp=xmin
      if(xmaxp.lt.xmax) xmaxp=xmax
      return
      end
