cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      program ckgrad
c     check_gradient.fortran
c     Checks an aeromag .BLP file for gradients which exceed given threshholds.
c     If a bad gradient is found, both points are dumped...

      character id1*8, id2*8
      real post1(8),post2(8)

      call getfile2 (21,' Infile ','in','unformatted','.blp')

      print '(/,1h$,a)', ' Give post option to test [1 to 6]: '
      read *, nopt
      nopt=nopt+2

      print '(/,1h$,a)', ' Give max acceptable gradient: '
      read *, gmax

      call pgradhist(21,nopt)
      rewind 21

      call getfile2 (22,' Outfile of good values','out',
     &   'unformatted','.good')
      call getfile2(24,' Outfile of bad values (ascii)','out',
     &   'formatted','.bad')


      npts=0
      ngood=0
      nbadg=0
      npts=1
  5   call getpost (21, id1, post1, *90)
      v1=post1(3)
 10   call getpost (21, id2, post2, *90)
      npts=npts+1
      v2=post2(3)
      g=abs(v2-v1)
      if(g.ge.gmax.and.id1.eq.id2) go to 20
      call putpost (22, id1, post1)
      ngood=ngood+1
      go to 30

c     Bad gradient values...

 20   write(24,102) g
 102  format(' g=  ',f12.2)
      write(24,101) id1,post1
      write(24,101) id2,post2
 101  format(a8,f10.4,f9.4,f8.2,f9.2,3f8.2,f11.3)
      nbadg=nbadg+2
      go to 5

 30   id1=id2
      do 40 i=1,8
 40   post1(i)=post2(i)
      v1=post1(3)
      go to 10

 90   close(21)
      call closeblp (22)
      close(24)

      print *,'   NPTS      =',npts
      print *,'   NGOOD     =',ngood
      print *,'   NBADG     =',nbadg

      stop ' '
      end


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine pgradhist(inunit,nopt)
c  This program plots a histogram on the terminal from a post file
c     Uses guts of 'this.fortran' by Tien Grauch.

      character id*8,idlast*8,answer*4
      character*1 iex(50)
      dimension iclass(50), post(8)
      parameter (dval='ffff7fff'x)

      amax=-dval
      amin=dval
      kmax=0
      ihistmx=0
      do 5 i=1,50
      iclass(i)=0
      iex(i)='X'
5     continue
c
c  read file, calculate mean
c
      icount=0
      sum=0.
      idlast='begin_it'
      vlast=0.
 10   call getpost (inunit, id, post, *20)
      if(id.ne.idlast) go to 15
      icount=icount+1
      aval=abs(post(nopt)-vlast)
      if(aval.gt.amax) amax=aval
      if(aval.lt.amin) amin=aval
      sum=sum+aval
 15   idlast=id
      vlast=post(nopt)
      go to 10
 20   rewind inunit
c
c  determine interval
c
      amean=sum/icount
      div=.1e0
550   del1=amax-amean
      del2=amean-amin
      del1=div*del1
      del2=div*del2
      if((amax-amin)/del1.le.50.and.del1.lt.del2) go to 555
      if((amax-amin)/del2.le.50.and.del2.lt.del1) go to 556
      div=div+.1e0
      go to 550
555   del=del1
      go to 9
556   del=del2
c
c  count number of points in each interval, calc variance and line density
c
9     k=0
      lden=0
      s2=0.
      idlast='begin_it'
      vlast=0.
 22   call getpost (inunit, id, post, *32)
      if(id.ne.idlast) go to 31
      aval=abs(post(nopt)-vlast)
      line=k
      top=amin-(del*.5)
      k=0
      s2=(aval-amean)**2.+s2
25    top=top+del
      k=k+1
      if(aval.ge.top) go to 25
      iclass(k)=iclass(k)+1
      if(k.gt.kmax) kmax=k
      if(k.eq.line.or.i.eq.1) go to 30
      line=k
      lden=lden+1
30    continue
 31   idlast=id
      vlast=post(nopt)
      go to 22
 32   rewind inunit
      s2=s2/(icount-1)
      s=sqrt(s2)
      do 35 i=1,kmax
      if(iclass(i).gt.ihistmx) ihistmx=iclass(i)
35    continue
      if(ihistmx.le.50) go to 50
      fac=50./ihistmx
      do 40 i=1,kmax
      iclass(i)=iclass(i)*fac
40    continue
c
c  plot classes, print parameters
c
50    print 802,amin,amax,amean,s,icount
802   format(/,'min=    ',f14.7,10x,'max=',f14.7,/,'mean=   ',f14.7,
     1   10x,'std dev=',f14.7,/i12,' valid points,',3x,f6.2)
      print 803,del
803   format(//,' midpoint ',1x,'(interval=',f14.7,')',1x,'HISTOGRAM',/)
      pt=amin-del
      do 60 i=1,kmax
      pt=pt+del
      if(iclass(i).eq.0) go to 59
      print 804,pt,(iex(j),j=1,iclass(i))
804   format(1x,g10.4,1x,'|',50(a1))
      go to 60
59    print 804,pt
60    continue
      go to 300
c
c  ERROR message
c
 300  return
      end


