C________________________________________________________________
C
C     PROGRAM   C O N T O U R
C________________________________________________________________
C
c
c  general contouring program
c
c  originally developed and coded by..
c    gerald ian evenden
c    u. s. geological survey
c    denver, colorado  80225
c
c  modified for the honeywell/multics computer
c   by r.h. godson - april,1977
c  station posting, hi-low symbols, lat-lon ticks, active
c  defaults
c   by mike webring, USGS
c  modified for the DEC/VAX by
c   Cindy Cooper, EDS and Ray Watts, USGS
c  converted to pc's with Microsort Fortran v4.01
c   by r.h. godson june,1988
c
c
c  grids of up to about 4500 columns can be contoured with nwork=16000.
c  in practice, 30 to 40 rows per tier is prefered so that 300
c  to 400 columns is a desirable limit.  the formula for rows
c  per tier (rpt) is ......
c     rpt=4*(nwork-ncval-ncol)/(5*ncol+4)
c  if larger grids are contoured, recompile with nwork and
c  dimension of work increased and appropriate [huge] inserts.
c
      common /titls/ title1,title2,title3,fmtx,fmty
      common /setxy/ xx(2),yy(2),xp1(4),yp1(4),iplotr,sizel,
     & ncharx,nchary,sizex,sizey,adelx,adely,pllx,plly,
     & lintx,linty,xscale,yscale,xxscal,yyscal,mscale,delx,dely
      common/chksiz/conlim
      common /concom/ ncol,nrow,bmin,bmax,
     & grad,gflg,ijs,ije,ijsi,ijei,prime,ij4,cont,
     & fltmax,lmult(0:3),idashs,linet,sigma,nsig
      common /llp/ latm(3),latx(3),longm(3),longx(3),cm(3),
     &             baslat(3),
     & iproj,xxx(2),yyy(2),sizep,unit,ip,neat,tint,itpost,ibound
      COMMON /LXCB/ LXFILE,LXFMT,LXPROJ,LXUNIT,LXTYPE
      common /vect/ ispost,lowhi,nid,ncharv,szpost,vmin,vmax,
     & lifmtv(14),lfmtv(4),ich(20),lchid(20),DGRAD,sizehi,szlab
      common /labcom/ lchars(6),lfmtc(4),nchar,size,ifill(3),
     1 delb
      common /contrc/ cmin,cmax,dcval,ncval,nsec,gradi,
     1                acdel(200),acgrad(200),jcdash(200),
     2                ncval2,acsize(200),acmin(200),acmax(200)
      common /contur/ acval(200)
      COMMON /HACOM/ HACHLN,HACHSP,HACHGP,HACHMX,HACHLM,HACHVB
      common/captur/icapt
c
      dimension work(16000),idim(1),cr(2),iwork(16000)
      character pgm*8
      character*56 title1,title2,title3,LXFILE
      character*16 fmtc,fmtx,fmty,LXFMT
      CHARACTER*16 FMTC2
      integer asciino(6)
      real latm,latx,longm,longx
      logical nomore,prime
      equivalence (lfmtc,fmtc),(work(1),iwork(1))
      data nwork/16000/,idim(1)/0/
      data itty,iprint,icmd,igrid,ista/5,6,9,10,11/
c
c
c  get control paramters
      call name(*350)
c
c  convert map scale to data units/inch
      if(mscale.gt.0) then
        if(unit.gt.2.5 .or. unit.lt.-.5)
     1   stop ' invalid ''UNIT'' parm'
        unitc=1.0
        if(unit.gt.0.5) unitc=39.370079
        if(unit.gt.1.5) unitc=39370.079
        xscale=float(mscale)/unitc
        yscale=xscale
      endif
c
c  given limits instead of a grid - post stations
      if(abs(xxx(1))+abs(xxx(2)).eq.0. .and.
     1 abs(yyy(1))+abs(yyy(2)).eq.0.) go to 31
        xx(1)=xxx(1)
        xx(2)=xxx(2)
        yy(1)=yyy(1)
        yy(2)=yyy(2)
      call setnic(ier)
      call scale(xxx,yyy,xp1,yp1,3,ier)
      if(ispost.ne.0) call vector(xxx,yyy,szlab)
      call endpt(idim)
      close(ista)
      stop
c
c  default contour interval or labels
   31 if (ncval.eq.0 .and. dcval.eq.0.0) go to 35
      if (dcval.gt.0. .and. ncval.gt.0) ncval=0
      if(dcval.lt.0. .or. nchar.lt.0 .or. fmtc(1:6).eq.'      ')
     1   then
        cr(1)=cmin
        cr(2)=cmax
        if(ncval.gt.0) then
          cr(1)=acval(1)
          cr(2)=acval(ncval)
        else
          read(igrid) title1,ip1,ip2,nc,nr,nz,xo,dx,yo,dy
          na=nc*nz
          call gmax(igrid,fltmax,na,work,cr(1),cr(2))
        endif
        if(dcval.lt.0.) dcval=0.
        if(cr(1).eq.cr(2)) dcval=1.
        call setax(cr,dcval,20,NCHAR2,FMTC2)
      endif
C
C ADDITION TO PROGRAM MADE 17FEB87 TO ALLOW USER SELECTION OF
C CONTOUR LABEL FORMAT WHEN ACVALS ARE BEING USED
C
      IF(NCHAR.LT.0 .OR. FMTC(1:6).EQ.'      ') THEN
        NCHAR=NCHAR2
        FMTC=FMTC2
      END IF
c
   35 if(ncval.gt.0) then
        do 40 i=1,ncval
   40   work(i)=acval(i)
      endif
      nwkres=nwork
      if (nsec.lt.0) nsec=0
c      if (gradi.lt.0.) gradi=0.
      if (nchar.lt.0) nchar=0
      if (size.lt.0.) size=0.
      if (nsig.ne.0) nsig=4
      sigma=.001*sigma
c
c  contour values...
   50 if(dcval.gt.0.0 .or. ncval.gt.0 .or. ispost.ne.0) go to 52
      write(iprint,51)
   51 format(' %neither contours or station posting specified')
      stop
   52 if (ncval.gt.0) go to 80
c
c  incremental contours mode
      if (dcval.ge.0.0) go to 70
      write(iprint,60)
   60 format(' %dcval less than zero')
      stop
   70 ixad=1
      go to 120
c
c  specified contours mode.
   80 if (ncval.eq.1) go to 110
c
c  check ascendency.
      do 100 i=2,ncval
      if (work(i).gt.work(i-1)) go to 100
      IF(acgrad(1).NE.0) THEN
        IF(acgrad(I).NE.acgrad(I-1)) GOTO 100
      END IF
      write(iprint,90)
90    format(' %non-ascending specified contours')
      stop
  100 continue
  110 ixad=ncval+1
c
c  open grid file for preliminary check.
  120 nwkres=nwkres-ncval
      call openck(igrid,xo,yo,delx,dely,
     1 work(ixad),nwkres,iquad)
      if (ncol.eq.0) go to 380
      xxx(1)=xx(1)
      xxx(2)=xx(2)
      yyy(1)=yy(1)
      yyy(2)=yy(2)
c
c  slice up core
      if(iquad.eq.3) go to 150
      nrowt=4*(nwkres-ncol)/(5*ncol+4)
      if(nrowt.ge.2) go to 140
c
      write(iprint,130)
  130 format(' %insufficient memory')
      go to 340
c
  140 idad=ixad+ncol
      iyad=nwork-nrowt+1
      ifad=idad+nrowt*ncol
      go to 160
c
  150 nrowt=4*nwkres/(13*ncol)
      if(nrowt.lt.2) go to 120
      k=nrowt*ncol
      idad=ixad+k
      iyad=nwork-k+1
      ifad=idad+k
c
c  ok so far, scale and annotate
  160 call setnic(i)
      if(i.ne.0) go to 340
      if(iquad.eq.3) go to 200
      k=ixad+ncol-1
      if(delx.ne.0) go to 180
      do 170 i=ixad,k
  170 work(i)=work(i)*xxscal
      go to 200
  180 xo=xo*xxscal
      delx=delx*xxscal
      do 190 i=ixad,k
      work(i)=xo
  190 xo=xo+delx
c
  200 npass=(nrow+nrowt-3)/(nrowt-1)
      jres=1+nrow-nrowt-(npass-2)*(nrowt-1)
c
c   branch around contour trace
c
      IF(HACHLM.LT.0.) HACHLM=HACHSP*7.
      CALL hacher(npass,NROWT,YO*YYSCAL,DELY*YYSCAL,
     1 hachln,hachsp,HACHGP,HACHMX,HACHLM,HACHVB,CONLIM,delb)
      if(dcval.eq.0. .and. ncval.eq.0) go to 205
      call conttr(work(ixad),work(iyad),work(idad),
     1 iwork(ifad),work,nrowt,ncol,xxscal,yyscal,gflg,
     1 yo*yyscal,dely*yyscal,iquad,npass,jres,igrid,
     1 ixad,iyad)
      CALL gather
c
c  rescale in grid data units
c
  205 call scale(xxx,yyy,xp1,yp1,3,ier)
      if(ispost.eq.0) go to 210
c
c  post stations
      call vector(xxx,yyy,szlab)
      close(ista)
210   if(lowhi.eq.0) go to 211
c
c  plot high and low symbols
      if(dcval.eq.0. .and. ncval.eq.0) go to 211
      IF(LOWHI.GE.0) THEN
        NOHI=0
      ELSE
        NOHI=1
        LOWHI=-1*LOWHI
      END IF
      nc2=ncol+2*lowhi
      iw=2*lowhi+1
      if(nc2*(iw+4)+iw .gt. nwork) go to 211
      rewind igrid
      call hilow(work,work(nc2+1),work(2*nc2+1),work(3*nc2+1),
     & work(4*nc2+1),work(nc2*(iw+4)+1),nc2,iw,sizehi,DGRAD,NOHI)
211   continue
c
c  close plot
      call endpt(idim)
      if(icapt.ne.0)
     & print *,'files contour.cor and contour.val created'
  340 close(igrid)
      go to 390
c
c  command file end trap
  350 write(iprint,360)
  360 format(' %odd eof on command segment')
  380 continue
  390 stop
      end
C
C________________________________________________________________
C
C     SUBROUTINE  N A M E
C________________________________________________________________
C
      subroutine name(*)
c
c     namelist input and common block initialization
c
      common /titls/ title1,title2,title3,fmtx,fmty
      common /setxy/ xx(2),yy(2),xp1(4),yp1(4),iplotr,sizel,
     1 ncharx,nchary,sizex,sizey,adelx,adely,pllx,plly,
     & lintx,linty,xscale,yscale,xxscal,yyscal,mscale,delx,dely
      common/chksiz/conlim
      common /concom/ ncol,nrow,bmin,bmax,
     1 grad,gflg,ijs,ije,ijsi,ijei,prime,ij4,cont,
     1 fltmax,lmult(0:3),idashs,linet,sigma,nsig
      common /llp/ latm(3),latx(3),longm(3),longx(3),cm(3),
     1             baslat(3),
     1 iproj,xxx(2),yyy(2),sizep,unit,ip,neat,tint,itpost,ibound
      COMMON /LXCB/ LXFILE,LXFMT,LXPROJ,LXUNIT,LXTYPE
      common/txcb/txfile
      common /vect/ ispost,lowhi,nid,ncharv,szpost,vmin,vmax,
     & lifmtv(14),lfmtv(4),ich(20),lchid(20),DGRAD,sizehi,szlab
      common /labcom/ lchars(6),fmtc,nchar,size,idum(3),delb
      common /contrc/ cmin,cmax,dcval,ncval,nsec,gradi,
     1                acdel(200),acgrad(200),jcdash(200),
     2                ncval2,acsize(200),acmin(200),acmax(200)
      common /contur/ acval(200)
      COMMON /HACOM/ HACHLN,HACHSP,HACHGP,HACHMX,HACHLM,HACHVB
      common /pltcom/ npens
      common/files/ifile,ifile2,acfile,mxhach
      common/captur/icapt
c
      character*56 title1,title2,title3,cfile,ifile,ifile2,
     1             iblank,ifmtv
      character*16 fmtc,fmtx,fmty,jblank,fmtv
      CHARACTER*56 LXFILE,ACFILE,TXFILE
      CHARACTER*16 LXFMT
      character*4 chid(20)
      double precision p1,p2
      real latm,latx,longm,longx
      logical prime,ONGRAD,ONDASH
      REAL*4 ACFARR(7,200),JCFARR(7,200)
      INTEGER*4 LNKACF(210),IKEY(2)
      character*20 fields(40)
      EQUIVALENCE (ACFARR,JCFARR)
      equivalence (lchid,chid),(lifmtv,ifmtv),(lfmtv,fmtv)
c
      namelist /parms/ cmin,cmax,nsec,dcval,xscale,yscale,mscale,
     1 gradi,iplotr,nchar,size,idashs,ncval,acval,phi1,phi2,
     1 sizel,ncharx,nchary,sizex,sizey,adelx,adely,
     1 pllx,plly,lintx,linty,sigma,nsig,latm,latx,longm,longx,
     1 cm,baslat,iproj,sizep,unit,angle,neat,tint,itpost,ibound,
     1 title2,title3,fmtc,fmtx,fmty,ispost,vmax,vmin,fmtv,ncharv,
     1 ifmtv,
     1 ich,szpost,lowhi,chid,nid,ifile,ifile2,xxx,yyy,conlim,
     1 acdel,acgrad,jcdash,acfile,dgrad,acsize,acmin,acmax,
     1 hachsp,hachln,hachgp,mxhach,hachlm,hachvb,
     1 lxfile,lxfmt,lxproj,lxunit,lxtype,delb,sizehi,szlab,icapt,
     1 txfile
c
      data itty,iprint,icmd,igrid,ista/5,6,9,10,11/
      data iblank/' '/,jblank/' '/
      data dval/1.e37/,ddval/1.7e38/
c
      lmult(0)=256*256*256
      lmult(1)=256*256
      lmult(2)=256
      lmult(3)=1
      ibound=999
      conlim=0.
      lowhi=0
      sizehi=.08
      DGRAD=0.
      ispost=0
      xxx(1)=0.
      xxx(2)=0.
      yyy(1)=0.
      yyy(2)=0.
      do 9 i=1,20
      ich(i)=4
    9 chid(i)=' '
      nid=0
      szlab=.08
      szpost=.1
      vmin=0.
      vmax=1.
      ncharv=0
      fmtv='(f7.2)'
      ifmtv=' '
      cmin=0.
      cmax=0.
      dcval=-1.
      nchar=-1
      ncval=0
      nsec=5
      sizel=0.
      gradi=30.
      acdel(1)=0.
      acgrad(1)=0.
      gflg=1.0e37
      fltmax=1.0e37
      iplotr=1
      idashs=0
      JCDASH(1)=999
      acsize(1)=-1.
      acmin(1)=ddval
      acmax(1)=-ddval
      ACFILE=IBLANK
      linet=0
      ncharx=0
      nchary=0
      lintx=5
      linty=5
      size=.1
      sizex=.1
      sizey=.1
      adelx=0.
      adely=0.
      pllx=0.
      plly=0.
      xscale=0.
      yscale=0.
      mscale=0
      xp1(2)=0.
      yp1(2)=0.
      sigma=7.3
      nsig=0
      delb=7.0
      sizep=.1
      phi1=33.
      phi2=45.
      iproj=999
      unit=2
      neat=0
      tint=0.
      itpost=2
      cm(1)=999.
      cm(2)=0.
      cm(3)=0.
      baslat(1)=999.
      baslat(2)=0.
      baslat(3)=0.
      do 10 i=1,3
      latm(i)=0.
      latx(i)=0.
      longm(i)=0.
   10 longx(i)=0.
      title2=iblank
      title3=iblank
      fmtc=jblank
      fmtx=jblank
      fmty=jblank
      npens=8
      ifile=iblank
      ifile2=iblank
      HACHSP=.15
      HACHLN=.05
      HACHGP=0.
      MXHACH=0
      HACHLM=-1.
      HACHVB=0.
      TXFILE=IBLANK
      LXFILE=IBLANK
      LXFMT=jblank
      LXPROJ=999
      LXUNIT=2
      LXTYPE=0
      ICAPT=0
      write(iprint,20)
   20 format(' enter command filename :'$)
      read(itty,30) cfile
   30 format(a56)
      if(cfile.eq.iblank) go to 40
      open(unit=icmd,file=cfile,form='formatted',
     1 status='old',readonly)
      read(icmd,parms,end=350)
      close (icmd)
      HACHMX=FLOAT(MXHACH)
C
C IF ACFILE IS SPECIFIED THEN THIS READS IT FREE FORMAT
C    FIELD 1 - ACVAL
C    FIELD 2 - THE CONTOUR INTERVAL APPLYING TO THE ACVAL
C              (THE MAXIMUM NUMBER OF CONTOUR LINES PER INCH
C               IS CALCULATED BASED ON THIS CONTOUR INTERVAL)
C    FIELD 3 - THE MAXIMUM GRADIENT FOR THE ACVAL IN UNITS OF
C              CONTOUR LINES PER INCH (CONTOUR INTERVAL FOR
C              CALCULATING THIS IS THE INTERVAL IN FIELD 2)
C    FIELD 4 - THE TYPE OF LINE TO BE DRAWN FOR THIS ACVAL
C    FIELD 5 - THE SIZE OF THE LABELS
C    FIELD 6 - THE MINIMUM CONTOUR LEVEL WHEN ACDEL IS NEGATIVE.
C    FIELD 7 - THE MAXIMUM CONOTUR LEVEL WHEN ACDEL IS NEGATIVE.
C
      if(acfile.eq.iblank) goto 35
      open(unit=icmd,file=acfile,status='old',form='formatted',
     & readonly)
      open(24,status='scratch',carriagecontrol='list')
      ncval=0
   31 ncval=ncval+1
   36 call freerd(icmd,nfield,fields,0,*32,*32)
      if(nfield.lt.1) goto 36
      do 37 i=1,nfield
        k=ichar(fields(i)(1:1))
        if(k.lt.43.or.k.gt.57.or.k.eq.47) goto 38
   37 continue
   38 nfield=i-1
      if(nfield.lt.1) goto 36
      if(nfield.lt.7) then
        do 39 i=nfield+1,7
          fields(i)=iblank
   39   continue
      endif
      goto (71,72,73,74,75,76,77),nfield
   77 read(24,*) acval(ncval),acdel(ncval),acgrad(ncval),
     & jcdash(ncval),acsize(ncval),acmin(ncval),acmax(ncval)
      go to 711
   76 read(24,*) acval(ncval),acdel(ncval),acgrad(ncval),
     & jcdash(ncval),acsize(ncval),acmin(ncval)
      go to 711
   75 read(24,*) acval(ncval),acdel(ncval),acgrad(ncval),
     & jcdash(ncval),acsize(ncval)
      go to 711
   74 read(24,*) acval(ncval),acdel(ncval),acgrad(ncval),
     & jcdash(ncval)
      go to 711
   73 read(24,*) acval(ncval),acdel(ncval),acgrad(ncval)
      go to 711
   72 read(24,*) acval(ncval),acdel(ncval)
      go to 711
   71 read(24,*) acval(ncval)
  711 if(ncval.eq.1) then
        goto (51,52,53,54,55,56,57),nfield+1
   51   goto 58
   52   acdel(ncval)=1.e+7
   53   acgrad(ncval)=abs(gradi)
   54   jcdash(ncval)=0.
   55   acsize(ncval)=size
   56   acmin(ncval)=0.
   57   acmax(ncval)=0.
   58   goto 31
      endif
      goto (61,62,63,64,65,66,67),nfield+1
   61 goto 68
   62 acdel(ncval)=1.e+7
   63 acgrad(ncval)=abs(gradi)
   64 jcdash(ncval)=0.
   65 acsize(ncval)=size
   66 acmin(ncval)=0.
   67 acmax(ncval)=0.
   68 goto 31
C
   32 NCVAL=NCVAL-1
      CLOSE(UNIT=ICMD)
      close(24)
C
C SORT THE ACVAL, ACDEL, ACGRAD, JCDASH ,ACSIZE, ACMIN,
C AND ACMAX ARRAYS
C
   35 if(ncval.gt.0) then
        do 41 j=1,ncval
          if(acdel(j).lt.0) acval(j)=acdel(j)
   41   continue
        if(acdel(1).eq.0.) then
          do 42 j=1,ncval
            acdel(j)=1.e+7
   42   continue
        end if
        if(acgrad(1).eq.0.) then
          do 43 j=1,ncval
            acgrad(j)=abs(gradi)
   43   continue
        end if
        do 44 j=1,ncval
          acgrad(j)=acdel(j)*abs(acgrad(j))
   44   continue
        if(jcdash(1).eq.999) then
          do 45 j=1,ncval
            jcdash(j)=iabs(idashs)
   45   continue
        end if
        if(acsize(1).lt.0.) then
          do 46 j=1,ncval
            acsize(j)=size
   46   continue
        end if
        if(acmin(1).gt.dval) then
          do 47 j=1,ncval
            acmin(j)=0.
   47   continue
        end if
        if(acmax(1).lt.-dval) then
          do 48 j=1,ncval
            acmax(j)=0.
   48   continue
        end if
        nkey=2
        ikey(1)=3
        ikey(2)=1
        do 49 j=1,ncval
          acfarr(1,j)=acval(j)
          acfarr(2,j)=acdel(j)
          acfarr(3,j)=acgrad(j)
          jcfarr(4,j)=iabs(jcdash(j))
          acfarr(5,j)=acsize(j)
          acfarr(6,j)=acmin(j)
          acfarr(7,j)=acmax(j)
   49   continue
        call sortil(acfarr,7,200,ncval,ikey,nkey,lnkacf,210,
     1   ier2)
        ll=lnkacf(ncval+1)
        do 50 j=1,ncval
          acval(j)=acfarr(1,ll)
          acdel(j)=acfarr(2,ll)
          acgrad(j)=acfarr(3,ll)
          jcdash(j)=jcfarr(4,ll)
          acsize(j)=acfarr(5,ll)
          acmin(j)=acfarr(6,ll)
          acmax(j)=acfarr(7,ll)
          ll=lnkacf(ll)
   50   continue
        do 81 j=1,ncval
          if(acdel(j).ge.0) goto 33
          acfarr(1,j)=acval(j)
          acfarr(2,j)=acdel(j)
          acfarr(3,j)=acgrad(j)
          acfarr(4,j)=jcdash(j)
          acfarr(5,j)=acsize(j)
          acfarr(6,j)=acmin(j)
          acfarr(7,j)=acmax(j)
   81   continue
   33   ncval2=j-1
        if(ncval2.le.0) goto 34
        nkey=1
        ikey(1)=2
        call sortil(acfarr,7,200,ncval2,ikey,nkey,lnkacf,210,
     1   ier2)
        ll=lnkacf(ncval2+1)
        do 82 j=1,ncval2
          acval(j)=acfarr(1,ll)
          acdel(j)=abs(acfarr(2,ll))
          acgrad(j)=abs(acfarr(3,ll))
          jcdash(j)=jcfarr(4,ll)
          acsize(j)=acfarr(5,ll)
          acmin(j)=acfarr(6,ll)
          acmax(j)=acfarr(7,ll)
          ll=lnkacf(ll)
   82   continue
   34   continue
      end if
C
   40 ip=iplotr
      p1=phi1*1.745329252d-2
      p2=phi2*1.745329252d-2
      if(iproj.eq.4) call setlam(p1,p2)
      nogrid=0
      if(abs(xxx(1))+abs(xxx(2)).ne.0. .and.
     1 abs(yyy(1))+abs(yyy(2)).ne.0.) nogrid=1
c
      if(nogrid.eq.0 .and. ifile.eq.iblank) then
        print 60
   60   format(' enter grid filename :'$)
        read(itty,69) ifile
   69   format(a56)
      endif
      if(nogrid.eq.0) open(unit=igrid,file=ifile,
     1                status='old',form='unformatted',readonly)
c
      if(ispost.eq.0) return
      if(ifile2.eq.iblank) then
        print 70
   70   format(' enter station filename :'$)
        read(itty,69) ifile2
      endif
      if(ifmtv.eq.iblank) then
        print 80
   80   format(' enter format, car ret if binary :'$)
        read(itty,69) ifmtv
      endif
      if(ifmtv.eq.iblank) then
        open(unit=ista,file=ifile2,form='unformatted',
     1  status='old',readonly)
      else
        open(unit=ista,file=ifile2,form='formatted',
     1  status='old',readonly)
      endif
      return
  350 close(icmd)
      return 1
      end
C
C________________________________________________________________
C
C     SUBROUTINE  O P E N C K
C________________________________________________________________
C
      subroutine openck(igrid,xo,yo,delx,dely,
     & xdata,nwork,iquad)
c
c  initialize grid input file.
c
      common /titls/ title1,title2,title3,fmtx,fmty
      common /setxy/ xx(2),yy(2),xp1(4),yp1(4),iplotr,sizel,
     & ncharx,nchary,sizex,sizey,adelx,adely,pllx,plly,
     & lintx,linty,xscale,yscale,xxscal,yyscal,mscale,delxx,delyy
      common /concom/ ncol,nrow,bmin,bmax,
     & grad,gflg,ijs,ije,ijsi,ijei,prime,ij4,cont,
     & fltmax,lmult(0:3),idashs,linet,sigma,nsig
      character*56 title1,title2,title3
      character*16 fmtx,fmty
      dimension xdata(1),ipgm(2)
      data iprint/6/
c
      read(igrid,end=90) title1,ipgm,ncol,nrow,iquad,xo,delx,yo,
     1                   dely
      delxx=delx
      delyy=dely
      if (ncol.lt.3.or.nrow.lt.3) go to 110
      if(iquad.eq.3.and.delx.eq.0..and.dely.eq.0.) go to 80
      if (ncol.gt.nwork) go to 150
      if (iquad.ne.1) go to 130
      if (delx.ne.0) go to 30
      read(igrid,end=90) (xdata(i),i=1,ncol)
      xx(1)=xdata(1)
      xx(2)=xdata(ncol)
      go to 40
   30 xx(1)=xo
      xx(2)=xo+(ncol-1)*delx
   40 if(dely.ne.0) go to 50
      call yread(igrid,yy,nrow)
      if(nrow.lt.3) go to 110
      go to 60
   50 yy(1)=yo
      yy(2)=yo+(nrow-1)*dely
   60 if(delx.ne.0..and.dely.ne.0.) return
   70 rewind igrid
      read(igrid)
      if(delx.eq.0.) read(igrid)
      return
   80 i=ncol*3
      if(i.gt.nwork) go to 150
      read(igrid)
      call xyread(igrid,xx,yy,xdata,i)
      if(nrow.lt.3) go to 110
      go to 70
   90 write(iprint,100)
  100 format(' %end of file while processing header of input',
     1       ' file')
      go to 170
  110 write(iprint,120)
  120 format(' %no. rows or columns less than 3')
      go to 170
  130 write(iprint,140)
  140 format(' %nz on header of standard file is greater than 1')
      go to 170
  150 write(iprint,160)
  160 format(' %core exceeded for x values')
c
  170 close (igrid)
      ncol=0
      return
      end
C
C________________________________________________________________
C
C     SUBROUTINE  Y R E A D
C________________________________________________________________
C
      subroutine yread(igrid,yr,nrow)
c
c     scans specified row grid
c
      dimension yr(2)
      nrow=0
      read(igrid,end=20) yr(1)
   10 nrow=nrow+1
      read(igrid,end=20) a
      yr(2)=a
      go to 10
   20 return
      end
C
C________________________________________________________________
C
C     SUBROUTINE  X Y R E A D
C________________________________________________________________
C
      subroutine xyread(igrid,xr,yr,work,ncol3)
c
c     scans quadrilateral grid for x-y range
c
      dimension xr(2),yr(2),work(ncol3)
      common /concom/ ncol,nrow,bmin,bmax,
     & grad,gflg,ijs,ije,ijsi,ijei,prime,ij4,cont,
     & fltmax,lmult(0:3),idashs,linet,sigma,nsig
c
c     initialize
c
      nrow=0
      read(igrid,end=70) dummy,work
      xmin=fltmax
      xmax=-fltmax
      ymin=fltmax
      ymax=-fltmax
c
c scan loop
c
   10 nrow=nrow+1
      if(work(i+2).gt.gflg) go to 55
      do 50 i=1,ncol3,3
      if(work(i).le.xmax) go to 20
      xmax=work(i)
      go to 30
   20 if(work(i).ge.xmin) go to 30
      xmin=work(i)
   30 if(work(i+1).ge.ymin) go to 40
      ymin=work(i+1)
      go to 50
   40 if(work(i+1).le.ymax) go to 50
      ymax=work(i+1)
   50 continue
   55 continue
c
      read(igrid,end=60) dummy,work
      go to 10
c
   60 xr(1)=xmin
      xr(2)=xmax
      yr(1)=ymin
      yr(2)=ymax
c
   70 return
      end
C
C________________________________________________________________
C
C     SUBROUTINE  C O N T T R
C________________________________________________________________
C
      subroutine conttr(x,y,z,f,c,nrow,ncol,xxscal,yyscal,
     & gflg,yo,dely,iquad,npass,jres,igrid,ixad,iyad)
c
c     basic input and tier control
c
      dimension x(1),y(1),z(1),c(1)
      integer f(1)
c
c     setup mode control
c
      if(iquad.eq.3) go to 10
      call coorda(ixad,iyad,ncol,iquad)
      itype=-1
      if(dely.eq.0) itype=0
      go to 20
   10 call coorda(ixad,iyad,ncol,iquad)
      itype=1
c
c     remaining initialization
c
   20 klrow=(nrow-1)*ncol
      last=0
      je=nrow
c
c     tier loop
c
      do 190 ipass=1,npass
      if(ipass.eq.npass) je=jres
      if(ipass.eq.1) go to 70
c
c move down last row
c
      js=2
      jj=ncol
      do 30 i=1,ncol
   30 z(i)=z(klrow+i)
      if(itype) 40,40,50
   40 y(1)=y(nrow)
      go to 80
   50 do 60 i=1,ncol
      x(i)=x(klrow+i)
   60 y(i)=y(klrow+i)
      go to 80
c
c     first row
c
   70 js=1
      jj=0
c
c     get data
c
   80 do 140 j=js,je
      if(itype) 90,100,110
   90 read(igrid,end=130) dum,(z(jj+i),i=1,ncol)
      y(j)=yo
      yo=yo+dely
      go to 140
  100 read(igrid,end=130) y(j),(z(jj+i),i=1,ncol)
      y(j)=y(j)*yyscal
      go to 140
  110 read(igrid,end=130) dum,(x(jj+i),y(jj+i),z(jj+i),i=1,ncol)
      do 120 i=1,ncol
      kk=jj+i
      if(z(kk).gt.gflg) go to 120
      x(kk)=x(kk)*xxscal
      y(kk)=y(kk)*yyscal
  120 continue
      go to 140
  130 je=j-1
      if(je.lt.2) return
      last=1
      go to 150
  140 jj=jj+ncol
c
c     call contr
c
  150 call contr(z,f,c,c,je)
      CALL grdegg
  180 if(last.ne.0) return
  190 continue
      return
      end
C
C________________________________________________________________
C
C     SUBROUTINE  C O N T R
C________________________________________________________________
C
      subroutine contr(grid,flags,work,acval,nrowf)
c
c  basic contouring control subroutine.
c
      common /contrc/ cmin,cmax,dcval,ncval,nsec,gradi,
     1                acdel(200),acgrad(200),JCDASH(200),
     2                ncval2,acsize(200),acmin(200),acmax(200)
      common /concom/ ncol,nrow,bmin,bmax,
     & grad,gflg,ijs,ije,ijsi,ijei,prime,ij4,cont,
     & fltmax,lmult(0:3),idashs,linet,sigma,nsig
      common /setxy/ xx(2),yy(2),xp1(4),yp1(4),iplotr,sizel,
     & ncharx,nchary,sizex,sizey,adelx,adely,pllx,plly,
     & lintx,linty,xscale,yscale,xxscal,yyscal,mscale,delx,dely
      common /pltcom/ npens
      common/labcom/ dum1(11),size,dum2(4)
      dimension grid(0:*),flags(0:*),work(1),acval(1)
      integer flags
      logical prime
c
c  set gradient.
      nrow=nrowf
c
C
C IF ACVALS AND ACGRAD ARE BEING USED DO SETUP ONLY WHEN
C ACGRAD CHANGES
C
      IF(acgrad(1).NE.0.AND.NCVAL.NE.0) THEN
        PRIME=.TRUE.
        GRADI=-1
        GRAD0=acgrad(1)
        GRAD=GRAD0*GRAD0
        CALL SETUP(GRID,FLAGS,WORK)
        IF(BMIN.GE.BMAX) GOTO 140
        do 1 i=1,ncval2
          if(acgrad(i).ne.grad0) then
            grad0=acgrad(i)
            grad=grad0*grad0
            call setup(grid,flags,work)
          end if
          if(jcdash(1).ne.999) linet=iabs(jcdash(i))
          size=acsize(i)
          cmin=acmin(i)
          cmax=acmax(i)
          dcval=abs(acdel(i))
          if(cmin.ne.0.or.cmax.ne.0) then
            temin=amax1(bmin,cmin)/dcval
            icont=int(temin)
            if(aint(temin).ne.temin.and.temin.gt.0) icont=icont+1
c           icont=amax1(bmin,cmin)/dcval
            amx=amin1(bmax,cmax)
          else
            temin=bmin/dcval
            icont=int(temin)
            if(aint(temin).ne.temin.and.temin.gt.0) icont=icont+1
c           icont=bmin/dcval
            amx=bmax
          end if
          cont=icont*dcval
    5 if(cont.gt.amx) go to 1
            do 2 j=1,i-1
              if(acmin(j).eq.0..and.acmax(j).eq.0.) then
                if(errbar(cont,acdel(j)).eq.0.) go to 201
              else if(cont.ge.acmin(j).and.cont.le.acmax(j)) then
                if(errbar(cont,acdel(j)).eq.0.) go to 201
              endif
c             temod=abs(amod(cont,acdel(j)))
c             if(temod.lt.1.e-6) goto 201
c             if(acdel(j)-temod.lt.1.e-6) goto 201
    2       continue
            do 3 j=ncval2+1,ncval
              if(acval(j).eq.cont) goto 201
    3       continue
            call setlab
            call scan(grid,flags,work)
  201       icont=icont+1
            cont=icont*dcval
            go to 5
    1 continue
        do 6 i=ncval2+1,NCVAL
          CONT=ACVAL(I)
          IF(CONT.GT.BMIN.AND.CONT.LT.BMAX) THEN
            IF(acgrad(I).NE.GRAD0) THEN
              GRAD0=acgrad(I)
              GRAD=GRAD0*GRAD0
              CALL SETUP(GRID,FLAGS,WORK)
            END IF
            IF(JCDASH(1).NE.999) LINET=IABS(JCDASH(I))
            size=acsize(i)
            CALL SETLAB
            CALL SCAN(GRID,FLAGS,WORK)
          END IF
    6 continue
        GOTO 140
      END IF
C
C IF ACGRAD IS NOT BEING USED THEN DO SETUP ONLY ONCE
C
      if (nsec.le.0.or.ncval.gt.0) then
      grad=abs(gradi)**2
      else
      grad=(abs(gradi)*dcval)**2
      endif
c
c  set flags, etc..
      call setup(grid,flags,work)
10    if (bmin.ge.bmax) go to 140
      if (ncval.eq.0) go to 50
c
c  find lower limit.
      do 20 i=1,ncval
      if (acval(i).le.bmin) go to 20
      ii=i
      go to 30
   20 continue
c
c  contouring loop
c
   30 prime=.true.
      do 40 i=ii,ncval
      cont=acval(i)
      if (cont.ge.bmax) go to 140
      IF(JCDASH(1).NE.999) LINET=IABS(JCDASH(I))
      call setlab
   40 call scan(grid,flags,work)
      go to 140
c
c  execution for delta contour levels.
   50 if (cmin.eq.0..and.cmax.eq.0.) go to 60
      icont=amax1(bmin,cmin)/dcval
      amx=amin1(bmax,cmax)
      go to 70
   60 icont=bmin/dcval
      amx=bmax
c
c  contouring loop.
   70 cont=icont*dcval
      if (cont.ge.amx) go to 140
      prime=nsec.gt.0.and.mod(icont,nsec).eq.0
      if (prime) go to 100
      if (idashs) 80,135,90
c  decode primary contour line thickness
   80 linet=iabs(mod(idashs,8))
      go to 135
   90 linet=0
      go to 135
  100 if (idashs) 110,130,120
  110 linet=iabs(idashs/8)*8
      go to 130
  120 linet=idashs
  130 call setlab
C
  135 call scan(grid,flags,work)
      icont=icont+1
      go to 70
c
c  done with block
  140 return
      end
C________________________________________________________________
C
C     FUNCTION  E R R B A R
C________________________________________________________________
C
C FUNCTION ERROR BAR FINDS THE DISTANCE ALONG AN INTERVAL OF
C LENGTH B THAT A DEPARTS FROM THE NEAREST MULTIPLE OF B.
C
C   A      - REAL*4.  TEST NUMBER
C   B      - REAL*4.  LENGTH OF INTERVAL.
C
C            EXAMPLES:  IF A= 21 AND B= 20 THEN ERRBAR= .05
C                       IF A=101 AND B= 20 THEN ERRBAR= .05
C                       IF A= 49 AND B= 10 THEN ERRBAR=-.1
C
C FUNCTION ERRBAR WRITTEN BY ROB BRACKEN, USGS, 2MAR88.
C
C
      function errbar(a,b)
C
      real*8 aob
C
      aob=dble(a)/dble(b)
      errbar=aob-dnint(aob)
C
      return
      end
C________________________________________________________________
C
C     SUBROUTINE  S E T U P
C________________________________________________________________
C
      subroutine setup(grid,flags,work)
      dimension grid(0:*),flags(0:*),work(1)
      integer flags
      common /concom/ ncol,nrow,bmin,bmax,
     & grad,gflg,ijs,ije,ijsi,ijei,prime,ij4,cont,
     & fltmax,lmult(0:3),idashs,linet,sigma,nsig
      logical prime
c initialization of all parameters (arithmetic and logical)
c  unique to row block being contoured
c
c system of flags
c     bit         definition (for bit on)
c     0       edge-side 4 possible cut
c     1       edge-side 3 possible cut
c     2       edge-side 2 possible cut
c     3       edge-side 1 possible cut
c     4       edge 1 cut not made and not checked
c     5       interior scan (edge 1)
c     6       gradient (drop secondary contours)
c     7       block good (contourable)
c
      integer fg
      logical ccc,collrc,rowlg,bit,kk,collg
        DATA IDVAL/Z7FFFFFFF/
c
c start of operations
c
      nrow1=nrow-1
      ncol1=ncol-1
      ij=0
      i1j=1
      ij1=ncol
      i1j1=ij1+1
      ijn1=-ncol
      ijs=(ncol*nrow+3)/4-1
      do 10 i=0,ijs
   10 flags(i)=0
      ijs=idval
      ije=0
c
c preset bmin,bmax
c
      bmin=fltmax
      bmax=-bmin
c
c start of setup scanning
c
      do 130 j=0,nrow1
      rowlg=.false.
      collrc=.false.
      if (grad.eq.0.or.j.eq.nrow1) go to 20
      call coord(work,0,j,xll,yll)
      call coord(work,0,j+1,xul,yul)
   20 continue
      do 120 i=0,ncol1
      if (j.eq.0) go to 30
      collg=bit(flags,ijn1,1)
      go to 40
   30 collg=.false.
   40 if (i.eq.ncol1) go to 70
      ccc=collg
      if (j.eq.nrow1) go to 70
c
c determine if mesh block flagged
c
      if (gflg.ne.0.and.
     & (grid(ij).gt.gflg.or.grid(i1j).gt.gflg.or.
     &  grid(ij1).gt.gflg.or.grid(i1j1).gt.gflg)) go to 70
c
c mesh block contourable
c
      fg=1
      ijs=min0(ijs,ij)
      ije=max0(ije,ij)
c
c check and set left edge (2)
c
      if (rowlg) go to 50
      if (grid(ij1).gt.grid(ij)) fg=fg+32
      rowlg=.true.
c
c check and set lower edge (1)
c
   50 l=0
      if (grid(ij).gt.grid(i1j)) l=4
      if (.not.collg) l=l*4
      fg=fg+l
c
c check and set gradient
c
      if (grad.eq.0.) go to 60
      call coord(work,i+1,j,xlr,ylr)
      call coord(work,i+1,j+1,xur,yur)
      if ((grid(ij)-grid(i1j))**2.gt.
     &      ((xll-xlr)**2+(yll-ylr)**2)*grad
     & .or.(grid(ij)-grid(ij1))**2.gt.
     &      ((xll-xul)**2+(yll-yul)**2)*grad) go to 55
      if((grid(ij1)-grid(i1j1))**2.gt.
     &      ((xul-xur)**2+(yul-yur)**2)*grad
     & .or.(grid(ij1)-grid(i1j1))**2.gt.
     &      ((xur-xlr)**2+(yur-ylr)**2)*grad) go to 55
      if((grid(ij)-grid(i1j1))**2.lt.
     &      ((xll-xur)**2+(yll-yur)**2)*grad
     & .and.(grid(i1j)-grid(ij1))**2.lt.
     &      ((xul-xlr)**2+(yul-ylr)**2)*grad) go to 57
   55 fg=fg+2
   57 xll=xlr
      yll=ylr
      xul=xur
      yul=yur
c
c determine bmin,bmax
c
   60 bmin=amin1(bmin,grid(ij))
      bmax=amax1(bmax,grid(ij))
      call set(flags,ij,fg)
      go to 110
c
c mesh block non-contourable
c
c check and set side 3 and 4 flags
c
   70 kk=.false.
      if (.not.rowlg) go to 80
      if (grid(ij).gt.grid(ij1)) call set(flags,ij-1,128)
      kk=.true.
   80 if (.not.collg) go to 90
      if (grid(ij).lt.grid(i1j)) call set(flags,ijn1,64)
      kk=.true.
   90 if (.not.(collrc.or.kk)) go to 100
      bmin=amin1(bmin,grid(ij))
      bmax=amax1(bmax,grid(ij))
  100 rowlg=.false.
      fg=0
c
c end of mesh
c
  110 ij=i1j
      i1j=i1j+1
      ij1=i1j1
      i1j1=i1j1+1
      collrc=ccc
      ijn1=ijn1+1
  120 continue
c
  130 continue
c
      ijs=ijs/4
      ije=ije/4
      ijsi=(ijs+ncol)/4
      ijei=ije
      return
      end
C
C________________________________________________________________
C
C     SUBROUTINE  S C A N
C________________________________________________________________
C
      subroutine scan(grid,flags,work)
c
c  scans grid for undrafted contour level.
c
      dimension grid(0:*),flags(0:*),work(1)
      integer flags
      common /concom/ ncol,nrow,bmin,bmax,
     & grad,gflg,ijs,ije,ijsi,ijei,prime,ij4,cont,
     & fltmax,lmult(0:3),idashs,linet,sigma,nsig
      LOGICAL PRIME,EDGE
C
C       CHANGED DATA STATEMENTS TO BE COMPATIBLE WITH THE
C    3   2 BIT VAX.  C. COOPER, OCTOBER 7, 1981.
C       THESE STATEMENTS ARE FOR THE 36 BIT HONEYWELL/MULTICS
C     data nask1/o4004004004/,nask2/o360360360360/,nask3/o360/
C    1  ,NASK4/O20/
C     data nask5/o010010010010/,nask6/o010/,nask7/o4/,
C    & nask8/o200/,nask9/o100/,nask10/o40/,nask11/o004004004004/
      DATA MASK1/Z04040404/,MASK2/ZF0F0F0F0/,MASK3/ZF0/,
     1     MASK4/Z10/
      DATA MASK5/Z08080808/,MASK6/Z08/,MASK7/Z4/,
     & MASK8/Z80/,MASK9/Z40/,MASK10/Z20/,MASK11/Z04040404/
      data izero/0/
c
c  set interior flags.
      if (ijsi.lt.0) go to 20
      do 10 ij=ijsi,ijei
   10 flags(ij)=ior(flags(ij),ishft(iand(flags(ij),mask1),1))
c
c  setup for edge scan
   20 if (ijs.lt.0) go to 180
      assign 40 to iswa
      assign 160 to iswb
      edge=.true.
      ija=ijs
      ijb=ije
      ijsnew=-1
      mask=mask2
      maskb=mask3
      maskd=mask4
      maskf=1
   30 ij4b=ija*4+3
c
c  basic word scan
      do 170 ij=ija,ijb
      mflag=flags(ij)
      if (iand(mflag,mask).eq.izero) go to iswb,(160,150)
      if (ijsnew.lt.0) ijsnew=ij
      ijenew=ij
      ij4=ij4b
      ij4n=ij4+ncol
c
c  sub word scan
      do 140 k=1,4
      if (iand(mflag,maskb).eq.izero) go to 130
      go to iswa,(40,110)
c
c  right edge
   40 if (iand(mflag,mask8).eq.izero) go to 60
      if (cont.le.grid(ij4+1)) go to 50
      CALL CRESET(flags,ij4,mask8)
      go to 80
   50 if (cont.le.grid(ij4n+1)) go to 60
      call trace(grid,flags,work,4,maskf)
      go to 80
c
c  top edge
   60 if (iand(mflag,mask9).eq.izero) go to 80
      if (cont.le.grid(ij4n+1)) go to 70
      CALL CRESET(flags,ij4,mask9)
      go to 100
   70 if (cont.le.grid(ij4n)) go to 80
      call trace(grid,flags,work,3,maskf)
      go to 100
c
c  left edge
   80 if (iand(mflag,mask10).eq.izero) go to 100
      if (cont.le.grid(ij4n)) go to 90
      CALL CRESET(flags,ij4,mask10)
      go to 130
   90 if (cont.le.grid(ij4)) go to 100
      call trace(grid,flags,work,2,maskf)
      go to 130
c
c  bottom edge and interior scan
  100 if (iand(mflag,mask4).eq.izero) go to 130
  110 if (cont.le.grid(ij4)) go to 120
      CALL CRESET(flags,ij4,maskd)
      go to 130
  120 if (cont.gt.grid(ij4+1))
     & call trace(grid,flags,work,1,maskf)
c
C 130 mflag=mflag/512
130   mflag=ishft(mflag,-8)
      ij4=ij4-1
      ij4n=ij4n-1
  140 continue
      go to 160
c
c  interior range set
  150 if (iand(mflag,mask11).eq.izero) go to 160
      if (ijsnew.lt.0) ijsnew=ij
      ijenew=ij
  160 ij4b=ij4b+4
  170 continue
c
c  first time?
      if (.not.edge) go to 190
c
c  update edge range
      ijs=ijsnew
      ije=ijenew
  180 if (ijsi.lt.0) go to 200
c
c  setup for interior scan
      edge=.false.
      assign 110 to iswa
      assign 150 to iswb
      ijsnew=-1
      ija=ijsi
      ijb=ijei
      mask=mask5
      maskb=mask6
      maskd=mask7
      maskf=maskb
      go to 30
c
c  update interior boundary indicies
  190 ijsi=ijsnew
      ijei=ijenew
c
c  end of scan
  200 return
      end
C
C________________________________________________________________
C
C     SUBROUTINE  T R A C E
C________________________________________________________________
C
      subroutine trace(grid,flags,work,iside,mask)
c
c  follows contour through grid until
c  edge or closure found.
c
      dimension grid(0:*),flags(0:*),work(1)
      dimension istart(100),iend(100),ic(100)
      integer flags,ITURN(4,4)
      common/chksiz/conlim
      common /contrc/ cmin,cmax,dcval,ncval,nsec,gradi,
     1                ACDEL(200),ACGRAD(200),JCDASH(200),
     2                ncval2,acsize(200),acmin(200),acmax(200)
      common /concom/ ncol,nrow,bmin,bmax,
     & grad,gflg,ijs,ije,ijsi,ijei,prime,ij4,cont,
     & fltmax,lmult(0:3),idashs,linet,sigma,nsig
c
      common/labcom/ dum1(11),size,dum2(4)
      logical prime,bit,post,ksw,break,PRIME2
c
c trace and plot contour through grid
c
c
c grid indexing
c                  side 3
c          i01 +           + i11
c
c      side 2                 side 4
c
c          i00 +           + i10
c                  side 1
c
c in-- entrance side
c high-equal point(inn) always on left when looking along
c     contour line
c iol-- point opposite entrance side on left
c ior-- point opposite entrance side on right
c
      dimension x(101),y(101)
      data mask6/o10/
      DATA ITURN /-2,1,0,-1,-1,-2,1,0,0,-1,2,1,1,0,-1,2/
c
c set up tracing start
c
      kk=1
      ksw=.false.
      break=.false.
      istart(1)=0
      NTURN=0
      post=prime
      i=mod(ij4,ncol)
      j=ij4/ncol
      npts=1
      ic(1)=0
      i00=ij4
      i10=i00+1
      i01=i00+ncol
      i11=i01+1
      go to (10,20,30,40),iside
   10 CALL CRESET(flags,i00,mask6)
      fract=(cont-grid(i00))/(grid(i10)-grid(i00))
      call coord(work,i,j,xa,ya)
      call coord(work,i+1,j,xb,yb)
      iol=i01
      ior=i11
      in=1
      go to 51
   20 fract=(cont-grid(i00))/(grid(i01)-grid(i00))
      call coord(work,i,j,xa,ya)
      call coord(work,i,j+1,xb,yb)
      iol=i11
      ior=i10
      in=2
      go to 51
   30 fract=(cont-grid(i01))/(grid(i11)-grid(i01))
      call coord(work,i,j+1,xa,ya)
      call coord(work,i+1,j+1,xb,yb)
      iol=i10
      ior=i00
      in=3
      go to 51
   40 fract=(cont-grid(i10))/(grid(i11)-grid(i10))
      call coord(work,i+1,j,xa,ya)
      call coord(work,i+1,j+1,xb,yb)
      iol=i00
      ior=i01
      in=4
c
c start trace loop
c
   51 xbeg=xa+(xb-xa)*fract
      ybeg=ya+(yb-ya)*fract
      inbeg=in
C
C INITIALIZE VARIABLES TO MEASURE LENGTH OF TRACE
C
      TLEN=0.
      X0=XBEG
      Y0=YBEG
C
   50 X1=xa+(xb-xa)*fract
      Y1=ya+(yb-ya)*fract
      X(NPTS)=X1
      Y(NPTS)=Y1
C
C CALCULATE TRACE LENGTH
C
      DX=X1-X0
      DY=Y1-Y0
      DS=SQRT(DX*DX+DY*DY)
      X0=X1
      Y0=Y1
      TLEN=TLEN+DS
c
c     if gradi is negative bypass check for primaries
c
      if(gradi.ge.0.) then
        if (.not.prime.and.bit(flags,i00,2)) go to 80
      else
        if(bit(flags,i00,2)) go to 80
      endif
c
c     get starting point for line segment kk
c
      if(.not.ksw) then
        istart(kk)=npts
        ksw=.true.
      endif
      go to 85
c
c     get ending point for line segment kk
c
   80 if(ksw) then
        iend(kk)=npts
        kk=kk+1
        ic(kk)=0
        istart(kk)=0
        ksw=.false.
      endif
      break=.true.
c
c     accumulate points whether lines are broken or not
c
   85 npts=npts+1
      if (npts.le.100) go to 90
      call conplt(x,y,npts,ic,post,1,ksw,
     & break,istart,iend,kk)
      if(ksw) ic(1)=2
c      if(ksw.and.(istart(kk).eq.100)) ic(1)=2
   87 kk=1
      npts=1
      ksw=.false.
      break=.false.
      istart(1)=0
c
c determine exit side
c
   90 k=in+2
      if (grid(ior).lt.cont) k=k-1
      if (grid(iol).lt.cont) k=k-2
      if (k-in) 110,100,120
c
c saddle decision (dayhoff)
c
  100 if ((grid(i00)+grid(i10)+grid(i01)+grid(i11))*0.25.lt.cont)
     & go to 120
      k=in+2
      go to 120
  110 k=in
c
c     compute side branch
c
  120 go to (140,150,160,130,140,150),k
c
c exit bottom -- side 1
c
  130 fract=(cont-grid(i00))/(grid(i10)-grid(i00))
      call coord(work,i,j,xa,ya)
      call coord(work,i+1,j,xb,yb)
      NTURN=NTURN+ITURN(IN,1)
      if (j.eq.0) THEN
        IOUT=1
        go to 170
      END IF
      i01=i00
      i00=i00-ncol
      if (.not.bit(flags,i00,1)) THEN
        IOUT=1
        go to 170
      END IF
      in=3
      i11=i10
      i10=i10-ncol
      iol=i10
      ior=i00
      j=j-1
      go to 50
c
c exit left -- side 2
c
  140 fract=(cont-grid(i00))/(grid(i01)-grid(i00))
      call coord(work,i,j,xa,ya)
      call coord(work,i,j+1,xb,yb)
      NTURN=NTURN+ITURN(IN,2)
      if (i.eq.0) THEN
        IOUT=2
        go to 170
      END IF
      i10=i00
      i00=i00-1
      if (.not.bit(flags,i00,1)) THEN
        IOUT=2
        go to 170
      END IF
      in=4
      i11=i01
      i01=i01-1
      iol=i00
      ior=i01
      i=i-1
      go to 50
c
c exit top -- side 3
c
  150 fract=(cont-grid(i01))/(grid(i11)-grid(i01))
      call coord(work,i,j+1,xa,ya)
      call coord(work,i+1,j+1,xb,yb)
      NTURN=NTURN+ITURN(IN,3)
      if (.not.bit(flags,i01,mask)) THEN
        IOUT=3
        go to 170
      END IF
      CALL CRESET(flags,i01,mask6)
      in=1
      i00=i01
      i10=i11
      i01=i01+ncol
      i11=i11+ncol
      iol=i01
      ior=i11
      j=j+1
      go to 50
c
c exit right -- side 4
c
  160 fract=(cont-grid(i10))/(grid(i11)-grid(i10))
      call coord(work,i+1,j,xa,ya)
      call coord(work,i+1,j+1,xb,yb)
      NTURN=NTURN+ITURN(IN,4)
      if (.not.bit(flags,i10,1)) THEN
        IOUT=4
        go to 170
      END IF
      in=2
      i00=i10
      i01=i11
      i10=i10+1
      i11=i11+1
      iol=i11
      ior=i10
      i=i+1
      go to 50
c
c end of trace loop
c
  170 x(npts)=xa+(xb-xa)*fract
      y(npts)=ya+(yb-ya)*fract
      TLEN=TLEN+SQRT((X(NPTS)-X0)*(X(NPTS)-X0)+
     1     (Y(NPTS)-Y0)*(Y(NPTS)-Y0))
      if (npts.le.1.and.ic(1).eq.0) go to 190
      call conplt(x,y,npts,ic,post,3,ksw,
     & break,istart,iend,kk)
  190 XEND=X(NPTS)
      YEND=Y(NPTS)
      IF(GRADI.GE.0.) THEN
        PRIME2=PRIME
      ELSE
        PRIME2=.TRUE.
      END IF
      CALL LAYEGG(NTURN,XBEG,XEND,YBEG,YEND,TLEN,CONT,linet,
     1 PRIME2,size)
      RETURN
C  190 return
c
c end of tracing
c
      end
C
C________________________________________________________________
C
C     FUNCTION  B I T
C________________________________________________________________
C
      LOGICAL FUNCTION BIT(LF,I,MASK)
C     The byte is ANDed with MASK.  If any bits of the result
C     are set, the result is .TRUE., otherwise the result is
C     .FALSE.
      DIMENSION LF(0:*)
      J=I/4
      INDEX=IAND(I,3)
      K=ISHFT(MASK,8*(3-INDEX))
      BIT=IAND(LF(J),K).NE.0
      END
C
C________________________________________________________________
C
C     FUNCTION  I T H C H A R
C________________________________________________________________
C
      FUNCTION ITHCHAR(STRING,I)
      CHARACTER*(*) STRING
      ITHCHAR=ICHAR(STRING(I:I))
      END
C
C________________________________________________________________
C
C     SUBROUTINE  S E T
C________________________________________________________________
C
      SUBROUTINE SET(LF,I,MASK)
C     Or's MASK with the Ith byte stored in LF, where I is in
C     the MULTICS HONEYWELL order:
C   MULTICS: (3)(2)(1)(0)(7)(6)(5)(4)(11)(10)( 9) . . .
C       VAX: (0)(1)(2)(3)(4)(5)(6)(7) (8)(9)(10) . . .
      DIMENSION LF(0:*)
      J=I/4
      INDEX=IAND(I,3)
      K=ISHFT(MASK,8*(3-INDEX))
      LF(J)=IOR(LF(J),K)
      END
C
C________________________________________________________________
C
C     SUBROUTINE  C R E S E T
C________________________________________________________________
C
      SUBROUTINE CRESET(LF,I,MASK)
C     Subroutine to reset logical bits -- provides VAX calls
C     compatible with Perkin-Elmer calls.
C     Does appropriate subscript manipulation for
C     character-string
C     ordering:
C       P-E: (3)(2)(1)(0)(7)(6)(5)(4)(11)(10) . . .
C       VAX: (0)(1)(2)(3)(4)(5)(6)(7) (8)(9)(10) . . .
C
      DIMENSION LF(0:*)
      J=I/4
      INDEX=IAND(I,3)
      K=ISHFT(MASK,8*(3-INDEX))
      LF(J)=IAND(LF(J),NOT(K))
      END
C
C________________________________________________________________
C
C     SUBROUTINE  C O O R D A
C________________________________________________________________
C
      subroutine coorda(ixad,iyad,ncol,iquad)
      dimension x(1)
      k=ixad
      l=iyad
      ncoll=ncol
      isw=iquad
      return
C
C________________________________________________________________
C
C     ENTRY  C O O R D
C________________________________________________________________
C
      entry coord(x,i,j,xv,yv)
      go to (10,10,20),isw
   10 xv=x(k+i)
      yv=x(l+j)
      return
   20 ll=j*ncoll+i
      xv=x(k+ll)
      yv=x(l+ll)
      return
      end
C
C________________________________________________________________
C
C     SUBROUTINE  C O N P L T
C________________________________________________________________
C
      subroutine conplt(x,y,npts,ic,post,isw,ksw,
     & break,istart,iend,kk)
C
      common/concom/ncol,nrow,bmin,bmax,grad,gflg,ijs,ije,
     & ijsi,ijei,prime,ij4,cont,fltmax,lmult(0:3),idashs,linet,
     & sigma,nsig
      COMMON /eggchu/ GRADEA(4),NOHEN
      dimension x(101),y(101),xx(1001),yy(1001)
      dimension istart(1),iend(1),ic(1)
      logical post,prime,ksw,break,NOHEN
c
      icc=ic(1)
      if(npts.le.1) go to 90
      if(isw.eq.1) npts=100
      if(nsig.eq.0.and..not.break) go to 110
      if(.not.break) then
c
c       spline but no breaks in segment
c
        call bsplin(x,y,npts,xx,yy,nnt,step,sigma)
        go to 56
      else
        if(ksw) iend(kk)=npts
        if(.not.ksw.and.istart(kk).eq.0) kk=kk-1
        if(nsig.ne.0) then
c
c         spline and breaks in segment
c
          call bsplin(x,y,npts,xx,yy,nnt,step,sigma)
          call feed(xx,yy,nnt,iccc,-999,100+kk)
          ninc=nint(1./step)
          if(kk.eq.0) go to 50
          if(ic(1).ne.2) go to 20
          if(istart(1).ne.1) then
            ic(1)=0
          else
            ic(1)=1
          endif
   20     do 30 i=1,kk
          is=(istart(i)-1)*ninc+1
          ie=(iend(i)-1)*ninc+1
          nnnt=ie-is+1
          icc=ic(i)
C          call line(xx(is),yy(is),nnnt,icc,linet)
          call feed(xx(is),yy(is),nnnt,icc,LINET,isw)
   30     continue
        else
c
c         no spline but breaks in segment
c
          call feed(x,y,npts,iccc,-999,100+kk)
          if(kk.eq.0) go to 50
          if(ic(1).ne.2) go to 35
          if(istart(1).ne.1) then
            ic(1)=0
          else
            ic(1)=1
          endif
   35     do 40 i=1,kk
          is=istart(i)
          ie=iend(i)
          nnnt=ie-is+1
          icc=ic(i)
C          call line(x(is),y(is),nnnt,icc,linet)
                      call feed(x(is),y(is),nnnt,icc,LINET,isw)
   40     continue
        endif
      endif
   50 ic(1)=0
      return
c
c     after splining and no breaks
c
   56 go to (57,80,95),isw
   57 if (post) go to 60
C      call line(xx,yy,nnt,icc,linet)
      call FEED(xx,yy,nnt,icc,LINET,ISW)
      post=prime
      go to 70
   60 IF(NOHEN) THEN
        call label(xx,yy,nnt,icc,post,ISW)
      ELSE
        call feed(xx,yy,nnt,icc,linet,ISW)
      END IF
   70 npts=1
      ic(1)=1
      return
C   80 call line(xx,yy,nnt,icc,linet)
   80 call FEED(xx,yy,nnt,icc,LINET,ISW)
      ic(1)=0
      npts=1
      return
   90 xx(1)=x(1)
      yy(1)=y(1)
      nnt=npts
   95 if(post) go to 100
C      call line(xx,yy,nnt,icc,linet)
      call FEED(xx,yy,nnt,icc,LINET,ISW)
      return
  100 IF(NOHEN) THEN
       call label(xx,yy,nnt,icc,post,ISW)
      ELSE
       call feed(xx,yy,nnt,icc,linet,ISW)
      END IF
      return
c
c     no splining and no breaks
c
  110 go to(120,150,160),isw
  120 if(post) go to 130
C      call line(x,y,npts,icc,linet)
      call FEED(x,y,npts,icc,LINET,ISW)
      post=prime
      go to 140
  130 IF(NOHEN) THEN
       call label(x,y,npts,icc,post,ISW)
      ELSE
       call feed(x,y,npts,icc,linet,ISW)
      END IF
  140 npts=1
      ic(1)=1
      return
C  150 call line(x,y,npts,icc,linet)
  150 call FEED(x,y,npts,icc,LINET,ISW)
      npts=1
      ic(1)=0
      return
  160 if(post) go to 170
C      call line(x,y,npts,icc,linet)
      call FEED(x,y,npts,icc,LINET,ISW)
      return
  170 IF(NOHEN) THEN
       call label(x,y,npts,icc,post,ISW)
      ELSE
       call feed(x,y,npts,icc,linet,ISW)
      END IF
      return
      end
C
C________________________________________________________________
C
C     SUBROUTINE  L A B E L
C________________________________________________________________
C
      subroutine label(x,y,npts,icc,post,ISW)
c
c  label scans contour line array looking for
c  a straight segment.
c  if found,  the contour is labelled.
c
      common /concom/ ncol,nrow,bmin,bmax,
     & grad,gflg,ijs,ije,ijsi,ijei,prime,ij4,cont,
     & fltmax,lmult(0:3),idashs,linet,sigma,nsig
      common /setxy/ xx(2),yy(2),xp1(4),yp1(4),iplotr,sizel,
     & ncharx,nchary,sizex,sizey,adelx,adely,pllx,plly,
     & lintx,linty,xscale,yscale,xxscal,yyscal,mscale,delx,dely
      common/labcom/ lchars(6),fmtc,nchar,size,wdist,wdist2,ccor,
     1 delb
      common/pltcon/npens
c
      dimension x(1),y(1),xxa(1),yya(1)
      character fmtc*16,chars*24
      logical nolab,post,prime
      equivalence (f,sum),(isa,ya),(lchars,chars)
c
c setup and scan
c
      nolab=.not.(nchar.gt.0.and.size.gt.0.)
      if (nolab) go to 50
      is=2
      isa=3
      sum=0.0
      in1=2
      ie=npts-1
      if (ie.lt.3) go to 50
      xb=x(is)
      yb=y(is)
      do 40 i=isa,ie
      sum=sum+sqrt((x(i)-x(in1))**2+(y(i)-y(in1))**2)
   10 dist=(x(i)-xb)**2 + (y(i)-yb)**2
      if (dist.lt.wdist2) go to 30
      dist=sqrt(dist)
      if ((sum/dist).gt.1.02) go to 20
      ie=i
      go to 60
   20 is=is+1
      sum=sum-sqrt((x(is)-xb)**2+(y(is)-yb)**2)
      xb=x(is)
      yb=y(is)
      if (is.lt.i) go to 10
   30 in1=i
   40 continue
c
c  can't fine spot, continue line without labelling.
C   50 call line(x,y,npts,icc,linet)
   50 call FEED(x,y,npts,icc,LINET,ISW)
      go to 70
c
c  plottable location.
c
C   60 call line(x,y,is,icc,linet)
   60 call FEED(x,y,is,icc,LINET,ISW+10)
      call FEED(x(is+1),y(is+1),ie-is,1,-999,ISW+40)
      xa=x(ie)-x(in1)
      ya=y(ie)-y(in1)
      f=1.-(dist-wdist)/sqrt(xa*xa+ya*ya)
      xa=f*xa + x(in1)
      ya=f*ya + y(in1)
      phi=atan2(ya-yb,xa-xb)
      if (abs(phi).gt.1.5707963) phi=phi-sign(3.1415927,phi)
C
      IF (IPLOTR .EQ. 5) THEN
               ipen=(linet-mod(linet,100))/100
               if(ipen.lt.1) ipen=1
               if(ipen.gt.npens) ipen=npens
               call newpen(ipen)
             endif
               call VCHAR(0.5*(xa+xb),0.5*(ya+yb),lchars,nchar,
     1                     2,size,phi,ccor,0.)
      xxa(1)=xa
      yya(1)=ya
C      call line(xxa(1),yya(1),1,0,linet)
      call FEED(xxa(1),yya(1),1,0,LINET,ISW+30)
C      call line(x(ie),y(ie),npts-ie+1,1,linet)
      call FEED(x(ie),y(ie),npts-ie+1,1,LINET,ISW+20)
      post=.false.
c
   70 return
C
C________________________________________________________________
C
C     ENTRY  S E T L A B
C________________________________________________________________
C
c
c  entry to establish labeling character string.
c  must be called before label.
c
      entry setlab
      if (nolab) go to 100
C
C ADDITION MADE 20FEB87 TO ALLOW VARIABLE CONTOUR LINE LABEL
C FORMATS
C
      CALL FMTMOD(CONT,NCHAR,FMTC)
C
      write(chars,fmtc) cont
      wdist=(nchar+1)*size-.4*SIZE
      wdist2=wdist*wdist
      ccor=-.5*wdist+size
  100 return
      end
C
C________________________________________________________________
C
C       SUBROUTINE  F M T M O D
C________________________________________________________________
C
C SUBROUTINE FORMAT MODIFY SETS UP THE NUMBER OF CHARACTERS
C (NCHAR) AND THE MINIMUM SPACE FORMAT (FMT) FOR THE VALUE PASSED
C (CONT).  THE FIRST TIME FMTMOD IS CALLED IT UTILIZES THE
C INFORMATION IN NCHAR AND FMT TO DETERMINE THE ALLOWABLE NUMBER
C OF DECIMAL PLACES TO THE RIGHT OF THE DECIMAL POINT AND THE
C NUMBER OF TO CUT FROM THE RIGHT.  IN SUBSEQUENT CALLS NCHAR
C AND FMT ARE DETERMINED BASED ON THE CONSTANTS PICKED BY THE
C FIRST CALL.  THEREFORE IT IS ADVISABLE THAT THIS SUBROUTINE
C BE USED FOR ONLY ONE STREAM OF INPUT VALUES.
C
C SUBROUTINE FMTMOD WRITTEN BY ROB BRACKEN, USGS, 19FEB87
C
C
      subroutine fmtmod(cont,nchar,fmt)
      save
C
C VARIABLE DECLARATION
C
      character*(*) fmt
      character*16 fmt2
      real*8 cont2,tendec,fcont2
      data nchar2 /-999/
C
C DETERMINE IF LENDEC AND LENCUT HAVE BEEN FOUND
C
      if(nchar2.ne.-999) goto 30
C
C CONVERT THE FORMAT LENGTH SPECIFIER TO AN INTEGER
C
      fmt2=fmt
      if(fmt2(2:2).ne.'f'.and.fmt2(2:2).ne.'F') return
      do 5 i=3,16
        if(fmt2(i:i).eq.'.') goto 10
    5 continue
      return
   10 if(i.eq.3) return
      read(fmt2(3:i-1),1000) lenfmt
 1000 format(i2)
C
C CONVERT THE FORMAT DECIMAL SPECIFIER TO AN INTEGER
C
      do 15 j=i+1,16
        if(fmt2(j:j).eq.')'.or.fmt2(j:j).eq.' ') goto 20
   15 continue
      return
   20 if(j.eq.i+1) return
      read(fmt2(i+1:j-1),1000) lendec
C
C SET NCHAR2 TO INDICATE THAT LENDEC AND LENCUT HAVE BEEN FOUND
C
      nchar2=nchar
      lencut=lenfmt-nchar2
C
C ROUND CONT TO THE NUMBER OF DECIMAL PLACES STATED IN THE FORMAT
C
   30 cont2=dble(cont)
      tendec=10.d0**lendec
      fcont2=dnint(cont2*tendec)/tendec
C
C DETERMINE THE NUMBER OF DIGITS TO THE LEFT OF THE DECIMAL
C
      if(dabs(fcont2).ge.1.d0) then
        nleft=1+idnint(dlog10(dint(dabs(fcont2))))
      else
        nleft=1
      end if
      if(fcont2.lt.0.d0) nleft=nleft+1
C
C SET UP THE NEW NCHAR FOR THE PRESENT CONT
C
      lenfmt=nleft+1+lendec
      nchar=lenfmt-lencut
      if(dabs(fcont2).lt.1.d0.and.nchar.lt.1) nchar=1
C
C SET UP THE NEW FMT FOR THE PRESENT CONT
C
      llf=1
      lld=1
      if(lenfmt.ge.10) llf=2
      if(lendec.ge.10) lld=2
      if(llf.eq.1.and.lld.eq.1)write(fmt,801) lenfmt,lendec
  801 format('(f',i1,'.',i1,')')
      if(llf.eq.1.and.lld.eq.2)write(fmt,802) lenfmt,lendec
  802 format('(f',i1,'.',i2,')')
      if(llf.eq.2.and.lld.eq.1)write(fmt,803) lenfmt,lendec
  803 format('(f',i2,'.',i1,')')
      if(llf.eq.2.and.lld.eq.2)write(fmt,804) lenfmt,lendec
  804 format('(f',i2,'.',i2,')')
      return
      end
C
C
C
C________________________________________________________________
C
C     SUBROUTINE  S E T A X
C________________________________________________________________
C
      subroutine setax(x,dx,maxint,nch,fmt)
c  adjust interval and labeling format
c  input x-min max range, optional dx-spacing and
c  maxint-intervals
c  returns dx, nch-number of significant figures, fmt-labeling
c  format
      dimension x(2)
      character fmt*(*)
      ixpn(r)=int(alog10(abs(r))+100.)-100
      fmt='(1pe13.6)'
      nch=13
      if(dx.ne.0.) go to 5
      if(maxint.le.0) maxint=20
      t=(x(2)-x(1))/float(maxint)
      if(t.lt.1.e-20) return
      p10=sign(1.0,t)*10.**ixpn(t)
      t1=t/p10
      if(t1.le.1.0) dx=p10
      if(t1.gt.1.0) dx=2.*p10
      if(t1.gt.2.0) dx=5.*p10
      if(t1.gt.5.0) dx=10.*p10
    5 idecm=0
      n10=ixpn(dx)
      if(n10.lt.0) idecm=iabs(n10)
      n10=ixpn( amax1(abs(x(1)),abs(x(2))) )
      iw=4+idecm
      if(n10.ge.0) iw=3+n10+idecm
      if(iw.gt.9) go to 11
      write(fmt,10) iw,idecm
   10 format('(f',i1,'.',i1,')' )
      nch=iw
      if(idecm.eq.0) nch=nch-1
   11 return
      end
C
C________________________________________________________________
C
C     SUBROUTINE  G M A X
C________________________________________________________________
C
      subroutine gmax(igrid,fltmax,na,z,zmin,zmax)
      dimension ihdr(16),z(na)
      zmin=fltmax
      zmax=-fltmax
      rewind(igrid)
      read(igrid) ihdr,nc,nr,nz,xo,dx,yo,dy
      if(nz.gt.1) go to 30
      if(dx.eq.0.) read(igrd)
      do 20 j=1,nr
      read(igrid,end=30) y,z
      do 10 i=1,nc
      if(z(i).gt.fltmax) go to 10
      if(z(i).gt.zmax) zmax=z(i)
      if(z(i).lt.zmin) zmin=z(i)
   10 continue
   20 continue
   30 rewind(igrid)
      return
      end
C
C________________________________________________________________
C
C     SUBROUTINE  S E T N I C
C________________________________________________________________
C
      subroutine setnic(ier)
c
c  general setup of contour niceties.
c
      common /titls/ title1,title2,title3,fmtx,fmty
      common /setxy/ xx(2),yy(2),xp1(4),yp1(4),iplotr,sizel,
     & ncharx,nchary,sizex,sizey,adelx,adely,pllx,plly,
     & lintx,linty,xscale,yscale,xxscal,yyscal,mscale,delx,dely
      common /llp/ latm(3),latx(3),longm(3),longx(3),cm(3),
     1             baslat(3),
     & iproj,xxx(2),yyy(2),sizep,unit,ip,neat,tint,itpost,ibound
      COMMON /LXCB/ LXFILE,LXFMT,LXPROJ,LXUNIT,LXTYPE
      common/txcb/txfile
      common/captur/icapt
c
      dimension idim(1),it1(14),it2(14),it3(14),ifmtx(4),ifmty(4)
      character*56 title1,title2,title3,blankt,LXFILE,txfile
      character*16 fmtx,fmty,blankf,LXFMT
      real latm,latx,longm,longx
      equivalence (it1,title1),(it2,title2),(it3,title3)
      equivalence (ifmtx,fmtx),(ifmty,fmty)
      data iprint/6/,idim(1)/0/,blankf/' '/,blankt/' '/
c
      tspace=0.
      if(title1.ne.blankt) tspace=tspace+1.
      if(title2.ne.blankt) tspace=tspace+1.
      if(title3.ne.blankt) tspace=tspace+1.
      if(adelx.eq.0.0 .and. ncharx.eq.0) go to 1
      if(fmtx.ne.blankf .and. ncharx.gt.0) go to 1
      call setax(xxx,adelx,20,ncharx,fmtx)
    1 if(adely.eq.0.0 .and. nchary.eq.0) go to 2
      if(fmty.ne.blankf .and. nchary.gt.0) go to 2
      call setax(yyy,adely,20,nchary,fmty)
    2 if (sizex.lt.0.) sizex=.08
      if (sizey.lt.0.) sizey=.08
      if (sizel.lt.0.) sizel=.08
      if (sizep.lt.0.) sizep=.08
      if (ncharx.lt.0) ncharx=0
      if (nchary.lt.0) nchary=0
      if (lintx.lt.1) lintx=5
      if (linty.lt.1) linty=5
      sizelb=1.5*sizel
      if(pllx.le.0. .and. (iproj.ne.0 .or. iproj.ne.999))
     1  pllx=12.*sizep
      if(plly.le.0. .and. (iproj.ne.0 .or. iproj.ne.999))
     1 plly=5.*sizep+sizelb*(tspace+2.)
      if(pllx.eq.0. .and. plly.eq.0.) sizep=0.
c
c  margin requirement setup.
c
   20 if (pllx.le.0.) go to 30
      xp1(3)=pllx
      go to 40
   30 xp1(3)=(ncharx+1)*sizex
   40 if (plly.le.0.) go to 50
      yp1(3)=plly
      go to 60
   50 yp1(3)=(nchary+1)*sizey+(tspace+1.)*sizelb
c
   60 dx=xx(2)-xx(1)
      dy=yy(2)-yy(1)
      call pltset(iplotr,xp1(4),yp1(4),idim)
c     if(iplotr.eq.5) write(iprint,65) xp1(4),yp1(4)
c  65 format(/,' plotter size(inches): x=',f7.2,'  y=',f7.2)
c
c  check scaling
c
      if (xscale.le.0.) go to 70
      if (yscale.le.0.) yscale=xscale
      go to 80
   70 if (yscale.le.0.) go to 90
      xscale=yscale
   80 xxscal=sign(1./xscale,dx)
      yyscal=sign(1./yscale,dy)
c
c  fixed scaling.
c
      xp1(1)=abs(dx*xxscal)
      yp1(1)=abs(dy*yyscal)
      xp1(4)=xp1(1)+xp1(3)+sizex+13.*sizep
      yp1(4)=yp1(1)+yp1(3)+sizey+3.*sizep
      go to 120
c
c  relative scaling, eg. xxscal=yyscal=0.
c
   90 xp1(4)=amin1(xp1(4),10.)
      yp1(4)=amin1(yp1(4),8.)
      xp1(1)=xp1(4)-xp1(3)-sizex-6.*sizep
      yp1(1)=yp1(4)-yp1(3)-sizey-3.*sizep
      if (xp1(1).gt.0..and.yp1(1).gt.0.) go to 110
      write(iprint,100)
  100 format(' %margin requires all plot area')
      ier=2
      go to 140
  110 xxscal=xp1(1)/dx
      yyscal=yp1(1)/dy
      xy=amin1(abs(xxscal),abs(yyscal))
      xxscal=sign(xy,xxscal)
      yyscal=sign(xxscal,yyscal)
      xp1(1)=abs(dx*xxscal)
      yp1(1)=abs(dy*yyscal)
c
c  initial labelling scale call
c
  120 call scale(xx,yy,xp1,yp1,4,ier)
      if (ier.ne.0) go to 140
c
c     don't plot if contour capturing is requested
c
      if(icapt.eq.0) then
c     if(iplotr.ne.1 .and. iplotr.ne.4) write(iprint,125) xp1(4),
c    1 yp1(4)
  125 format(/,' plot size (inches): x=',f7.2,'  y=',f7.2)
c
c  plot titles
c
      if (sizel.le.0.) go to 130
      xcent=0.5*xp1(1)+xp1(3)
      yt=sizelb
      if(title3.eq.blankt) go to 127
      n=leftj(title3)
      xt=abs(xcent-float(n/2)*.75*sizel)
      call vchar(xt,yt,it3,56,3,.75*sizel,0.,0.,0.)
      yt=sizelb+sizelb
127   if(title2.eq.blankt) go to 128
      n=leftj(title2)
      xt=abs(xcent-float(n/2)*.75*sizel)
      call vchar(xt,yt,it2,56,3,.75*sizel,0.,0.,0.)
      yt=yt+sizelb
128   if(title1.eq.blankt) go to 130
      n=leftj(title1)
      xt=abs(xcent-float(n/2)*sizel)
      call vchar(xt,yt,it1,56,3,sizel,0.,0.,0.)
c
c  plot axis
c
  130 if(adelx.eq.0.) go to 131
      call xaxis(xx,yy,xp1,adelx,lintx,sizex,ifmtx,ncharx)
  131 if(adely.eq.0.) go to 132
      call yaxis(yy,xx,yp1,adely,linty,sizey,ifmty,nchary)
  132 if(neat.eq.0) call neatl
c
c  plot lat-long
      if(iproj.gt.0 .and. iproj.lt.999) call llpost
c
c  subroutine state requires the world data bank 2
  135 if(ibound .ne. 999) call state
      IF(LXFILE.NE.BLANKT)
     1 CALL LXPLOT(LXFILE,LXFMT,LXPROJ,LXUNIT,LXTYPE)
      if(txfile.ne.blankt) call txplot
      else
      xxscal=1.
      yyscal=1.
      endif
c
c  rescale plotter for grid.
c
      xx(1)=xx(1)*xxscal
      xx(2)=xx(2)*xxscal
      yy(1)=yy(1)*yyscal
      yy(2)=yy(2)*yyscal
      call scale(xx,yy,xp1,yp1,3,ier)
  140 return
      end
C
C
C________________________________________________________________
C
C     SUBROUTINE  H I L O W
C________________________________________________________________
C
        subroutine hilow(jx,zmax,jm,zmin,w,jref,nc2,iw,sizel,
     1                   DGRAD,NOHI)
c
c  routine to plot h or l symbols at local maxima/minima on
c  contours.
c  'local' is defined by a search radius in grid units,
c  parameter 'iw'
c  is the window size ... 2*radius+1.
c  coded by Mike Webring 1/80.
c
        common/labcom/lchars(6),fmtc,nchar,dum(5)
        real w(nc2,iw),jx(nc2),jm(nc2),zmax(nc2),zmin(nc2),
     1            jref(iw)
        character id*56,p*8,fmtc*16,chars*24
        equivalence (lchars,chars)
c  dv is the maximum floating point number on the VAX
        data low/76/,ihigh/72/,dv/1.e38/,fmax/1.e37/
        read(10) id,p,nc,nr,nz,xo,dx,yo,dy
        if(nc.lt.iw .or. nz.gt.1 .or. dx.eq.0. .or.
     &  dy.eq.0.) return
c
        iht=0
        ilt=0
        ihw=iw/2
        ihw1=ihw+1
C
C RE-EVALUATE DGRAD SO THAT THE VALUE PASSED TO THIS SUBROUTINE
C IS THE DIFFERENCE IN Z BETWEEN THE CENTER OF THE WINDOW AND
C THE EDGE OF THE WINDOW.
C
      DGRAD=2.0*DGRAD/(FLOAT(IHW)*(DX+DY)/2.0)**2
C
        jwt=0
        midl=ihw1
        jwl=iw+1
        lmtx=nc2-ihw+1
        do 4 j=1,iw
        do 1 i=1,nc2
1       w(i,j)=dv
4       jref(j)=j
        ir=0
        do 2 j=ihw1,iw
        call rowio(nc,w(ihw1,j),-1,10,10,ie)
2       ir=ir+1
        do 3 i=1,nc2
        zmax(i)=-1.e20
        zmin(i)=1.e20
        jx(i)=0
3       jm(i)=0
        iptr=1
        inew=1
        istop=0
C        IY=0
        y=yo
c
100     do 10 i=ihw1,nc2-ihw
        if(jx(i).gt.jwt) go to 12
        zmax(i)=-1.e20
        do 11 j=1,iw
        w2=w(i,j)
        if(w2.lt.zmax(i)) go to 11
        if(w2.gt.fmax) go to 11
        zmax(i)=w2
        jx(i)=jref(j)
11      continue
        go to 10
12      w2=w(i,inew)
        if(w2.lt.zmax(i)) go to 10
        if(w2.gt.fmax) go to 10
        zmax(i)=w2
        jx(i)=jref(inew)
10      continue
c
        do 15 i=ihw1,nc2-ihw
        if(jm(i).gt.jwt) go to 17
        zmin(i)=1.e20
        do 16 j=1,iw
        w2=w(i,j)
        if(w2.gt.zmin(i)) go to 16
        zmin(i)=w2
        jm(i)=jref(j)
16      continue
17      w2=w(i,inew)
        if(w2.gt.zmin(i)) go to 15
        zmin(i)=w2
        jm(i)=jref(inew)
15      continue
c
        m=ihw1
101     iwl=m+ihw
        iwt=m-ihw
        if(jx(m).ne.midl) go to 18
        do 19 i=iwt,iwl
        if(zmax(i).gt.zmax(m)) go to 22
19      continue
        x=xo+float(m-ihw1)*dx
          CALL LHDGRD(W,NC2,IW,M,IHW1,DX,DY,DGRADN,DGRADX,
     &    dirlh,iptr)
        IF(DGRAD.GT.0.) THEN
          IF(ABS(DGRADX).LT.DGRAD.OR.DGRADX.GE.FMAX) GOTO 32
        END IF
        wq=-dv
        do 31 jq=1,iw
        if(w(m,jq).gt.wq.and.w(m,jq).lt.fmax) wq=w(m,jq)
   31   continue
        if(nohi.eq.0) then
        call vchar(x,y,ihigh,1,1,sizel,0.,0.,0.)
        else if(wq.lt.fmax) then
        call fmtmod(wq,nchar,fmtc)
        write(chars,fmtc) wq
        if(nchar.gt.0) call vchar(x,y,lchars,nchar,2,sizel,
     &  dirlh,-float(nchar/2)*sizel,0.)
        endif
32      m=m+ihw1
        go to 20
18      if(jm(m).ne.midl) go to 22
        do 21 i=iwt,iwl
        if(zmin(i).lt.zmin(m)) go to 22
21      continue
        x=xo+float(m-ihw1)*dx
          CALL LHDGRD(W,NC2,IW,M,IHW1,DX,DY,DGRADN,DGRADX,
     &    dirlh,iptr)
        IF(DGRAD.GT.0.) THEN
          IF(ABS(DGRADN).LT.DGRAD.OR.DGRADN.GE.FMAX) GOTO 34
        END IF
        wq=dv
        do 33 jq=1,iw
        if(w(m,jq).lt.wq.and.w(m,jq).lt.fmax) wq=w(m,jq)
   33   continue
        if(nohi.eq.0) then
        call vchar(x,y,low,1,1,sizel,0.,0.,0.)
        else if(wq.lt.fmax) then
        call fmtmod(wq,nchar,fmtc)
        write(chars,fmtc) wq
        if(nchar.gt.0) call vchar(x,y,lchars,nchar,2,sizel,
     &  dirlh,-float(nchar/2)*sizel,0.)
        endif
34      m=m+ihw1
        go to 20
c
22      m=m+1
20      if(m.lt.lmtx) go to 101
c
        if(ir.eq.nr) go to 98
        call rowio(nc,w(ihw1,iptr),-1,10,10,ie)
        if(ie.ne.0) go to 99
        ir=ir+1
        go to 96
98      if(istop.eq.ihw) go to 99
        do 97 i=1,nc2
97      w(i,iptr)=dv
        istop=istop+1
c
96      inew=iptr
        jref(iptr)=jwl
        iptr=iptr+1
        if(iptr.gt.iw) iptr=1
        jwt=jwt+1
        midl=midl+1
        jwl=jwl+1
C        IY=IY+1
C        Y=DY*IY+Y0
        y=y+dy
        go to 100
99      return
        end
C
C________________________________________________________________
C
C     SUBROUTINE  R O W I O
C________________________________________________________________
C
        subroutine rowio(n,z,iop,idev,jdev,iend)
        dimension z(n)
        iend=0
        if(iop)1,2,1
1       read(idev,end=10) y,z
        if(iop)9,9,2
2       write(jdev) y,z
9       return
10      iend=1
        return
        end
C
C________________________________________________________________
C
C     SUBROUTINE  V E C T O R
C________________________________________________________________
C
        subroutine vector(xx,yy,sizel)
c
c       plots random data values and positions
c       in either vector or scalar form
c
        common /vect/ ispost,lowhi,nid,ncharv,szpost,vmin,vmax,
     1    lifmtv(14),lfmtv(4),ich(20),lchid(20),DGRAD,vdum1(2)
        dimension xx(2),yy(2),bz(6),x(200),y(200),vi(200),
     1            vd(200),vm(200)
        character*4 chid(20)
        character*56 ifmtv,blank
        character ivl*3,sta*24,fmtv*16,bid*8
        logical free
        integer arrow,ista(6)
        equivalence(ivl,jvl),(sta,ista(1))
        equivalence (lifmtv,ifmtv),(lfmtv,fmtv),(lchid,chid)
        data arrow/o061/,con/.017453292/,pi/3.14159265/,a/.9423/,
     1    blank/' '/,labl/8/
        free=.false.
        if(ifmtv(1:1).eq.'*') free=.true.
c
        if(nid.gt.19) nid=19
        if(ncharv.gt.24) ncharv=24
        jch=ich(1)
        if(ispost.gt.1 .or. ispost.lt.0) go to 100
        n=1
1       if(ifmtv.ne.blank)
     1    read(11,ifmtv,end=3)x(n),y(n),vm(n),vi(n),vd(n)
        if(ifmtv.eq.blank)
     1    read(11,end=3) x(n),y(n),vm(n),vi(n),vd(n)
        n=n+1
        go to 1
3       n=n-1
        dmax=1.e-10
        do 4 i=1,n
        if(vm(i).gt.dmax) dmax=vm(i)
4       continue
        sca=(vmax-vmin)/alog(dmax)
        pima=pi-a
        pia=pi+a
        pima2=2.*pi-a
        do 10 i=1,n
        incl=int(vi(i))
        v=alog(vm(i))
        if(v.lt.0.) v=0.
        vlen=sca*v+vmin
        th=-vd(i)*con
        if((th.gt.a .and. th.lt.pima)  .OR.
     1    (th.gt.pia .and. th.lt.pima2)) THEN
         XL = SIZEL
         YL = 0.0
        ELSE IF((TH.le.a)  .OR.
     1    (th.ge.pi .and. th.le.PIA)) THEN
         XL = 0.0
         YL = -SIZEL
         ELSE
         XL = 0.0
         YL = SIZEL
        ENDIF
        WRITE (IVL,FMTV) INCL
        CALL VCHAR(x(i),y(i),3,1,1,.05,0.,0.,0.)
        CALL VCHAR(x(i),y(i),arrow,1,1,vlen,th,0.,0.)
        CALL VCHAR(x(i),y(i),jvl,3,2,sizel,0.,xl,yl)
10      continue
        go to 99
c
100     m1=1
        m2=2
        if(xx(1).lt.xx(2)) go to 140
        m1=2
        m2=1
140     m3=1
        m4=2
        if(yy(1).lt.yy(2)) go to 141
        m3=2
        m4=1
141     yoff=-sizel*.5
        xoff=2.*sizel
c
c     put in by r.godson to plot different intervals
c     of number of input points
c
      ic=0
      if(ispost.gt.-31.and.ispost.lt.3) then
      icnt=1
      else if(ispost.gt.2) then
      icnt=ispost/2
      else
      icnt=iabs(ispost)/31
      ispost=ispost-(-31*icnt)
      endif
        iz=mod(iabs(ispost),10)
        idbr=iabs(ispost)/10 - 1
         ibr=-1
         if(ifmtv.eq.blank) ibr=0
         if(ispost.lt.0) ibr=1
        if(ibr) 101,102,103
101     if(free) then
        read(11,*,end=99) sx,sy,sz
        else
        read(11,ifmtv,end=99) sx,sy,sz
        endif
        go to 104
102     read(11,end=99) sx,sy,sz
        go to 104
103     read(11,end=99) bid,sx,sy,bz
        sz=bz(iz)
104     if(sx.lt.xx(m1) .or. sx.gt.xx(m2)) go to 122
        if(sy.lt.yy(m3) .or. sy.gt.yy(m4)) go to 122
        if(nid.ne.0) then
         call match(nid,chid,bid,isym)
         jch=ich(isym)
        endif
      if(mod(ic,icnt).eq.0) then
      call vchar(sx,sy,jch,1,1,szpost,0.,0.,0.)
      endif
      ic=ic+1
        if(idbr.ne.0 .and. ncharv.gt.0) then
         write(sta,fmtv)sz
         n=leftj(sta)
         call vchar(sx,sy,ista,n,2,sizel,0.,xoff,yoff)
        endif
        if(idbr.ge.0) then
      if(bid.ne.'       ') then
         sta=bid
         n=leftj(sta)
         call vchar(sx,sy,ista,n,2,sizel,.785,xoff,0.)
      endif
        endif
122     if(ibr) 101,102,103
99      return
        end
C
C________________________________________________________________
C
C     FUNCTION  L E F T J
C________________________________________________________________
C
        function leftj(a)
c  left justifies a string and returns the position
c  of the last nonblank character
        character a*(*)
        n=len(a)
        if(a(1:1).ne.' ') go to 15
        do 1 m=2,n
1       if(a(m:m).ne.' ') go to 5
        leftj=0
        return
5       i2=1
        do 10 i=m,n
        a(i2:i2)=a(i:i)
        a(i:i)=' '
10      i2=i2+1
        n=n-m+1
15      do 20 leftj=n,1,-1
20      if(a(leftj:leftj).ne.' ') go to 25
25      return
        end
C
C________________________________________________________________
C
C     SUBROUTINE  M A T C H
C________________________________________________________________
C
        subroutine match(n,chk,test,isym)
c       compares two character strings and returns
c       a symbol index number
        character*8 test
        character*4 chk(20)
        do 10 isym = 1,n
        length = index(chk(isym)//' ', ' ')-1
        if (index(test,chk(isym)(1:length)) .gt. 0) return
10      continue
        isym=n+1
        return
        end
C
C________________________________________________________________
C
C     SUBROUTINE  L L P O S T
C________________________________________________________________
C
        subroutine llpost
        common /llp/ latm(3),latx(3),longm(3),longx(3),cm(3),
     1               baslat(3),
     1    iproj,xxx(2),yyy(2),sizep,unit,iplotr,neat,tint,itpost,
     1    ib
        dimension scaf(3),range(2),xx(2),yy(2)
        real latm,latx,longm,longx
        character fmt*16
        logical nos,nom
        data d2r/1.7453292e-2/, conm/1.666667e-2/,
     1       cons/2.777778e-4/,
     1    scaf/39.370079,1.,.001/, icross/6/,
     1    nmax/10/
        dms2d(a,b,c)=a+sign(b,a)*conm+sign(c,a)*cons
c
        if(iproj.lt.1 .or.iproj.gt.10) return
        sca=scaf(int(unit)+1)
        do 1 i=1,2
        xx(i)=xxx(i)/(1000.*sca)
1       yy(i)=yyy(i)/(1000.*sca)
        hfx=.5*(xx(1)+xx(2))
        hfy=.5*(yy(1)+yy(2))
        if(iproj.gt.4) call setalb(iproj)
        bld=dms2d(baslat(1),baslat(2),baslat(3))
        cmd=dms2d(cm(1),cm(2),cm(3))
        if(abs(bld).gt.90. .or. abs(cmd).gt.360.) return
        call prjctl(bld,cmd,xb,yb,cmd,sca,iproj)
        ydm=dms2d(latm(1),latm(2),latm(3))
        ydx=dms2d(latx(1),latx(2),latx(3))
        xdx=dms2d(longm(1),longm(2),longm(3))
        xdm=dms2d(longx(1),longx(2),longx(3))
c  adjust cem for conic projection distance to equator
        cem=4.0e7
        if(iproj.eq.4 .and. abs(bld).lt.15.) cem=4.21e7
        if(iproj.gt.4 .and. abs(bld).lt.15.) cem=3.84e7
        ce=cem*sca
        dt=(yy(2)-yy(1))*360./(ce*5.)
c  min-max latitude of area
        if(ydm.ge.ydx) go to 9
        if(ydm.ne.0.0 .and. ydx.ne.0.0) go to 10
9       ydm=bld+(yy(1)*360.)/ce-dt
        ydx=bld+(yy(2)*360.)/ce+dt
        if(ydm.lt.-90.0) ydm=-90.0
        if(ydx.gt.90.0)  ydx=90.0
        latx(1)=ydx
        latm(1)=ydm
c  min-max longitude of area
10      if(xdm.ne.0.0 .and. xdx.ne.0.0) go to 20
        cosp=cos(d2r*amax1(abs(ydx),abs(ydm)))
        if(cosp.lt..17364) cosp=.17364
        xdm=cmd+(xx(1)*360.)/(cosp*ce)-dt
        xdx=cmd+(xx(2)*360.)/(cosp*ce)+dt
        longm(1)=xdx
        longx(1)=xdm
c  default tick interval for less than nmax ticks per side
c  result is multiple of 1, 2 or 5 deg, min, or, sec
20      if(tint.gt.0.0) go to 30
        range(1)=0.
        range(2)=amax1((xdx-xdm),(ydx-ydm))
        tint=0.
        dr=range(2)*60./float(nmax)
        if(dr.ge.60.) then
         call setax(range,tint,nmax,ndum,fmt)
         tint=tint*60.
        else if(dr.ge.1. .and. dr.lt.60.) then
         range(2)=range(2)*60.
         call setax(range,tint,nmax,ndum,fmt)
        else
         range(2)=range(2)*3600.
         call setax(range,tint,nmax,ndum,fmt)
         tint=tint/60.
        endif
c  final initialization
30      if(itpost.le.0) itpost=2
        dt=(aint(tint*60.+.0001))/3600.
        dt2=dt*float(itpost)
        dt3=dt2*60.0
        nos=.false.
        if(dt3-aint(dt3).eq.0.0) nos=.true.
        nom=.false.
        if(amod(dt3,60.0).eq.0.0) nom=.true.
        if(yy(2)-yy(1).lt.20.)  ydm=aint(60.*ydm)/60.
        if(yy(2)-yy(1).ge.20.)  ydm=aint(ydm+90.)-90.
        if(yy(2)-yy(1).gt.500.) ydm=5.*aint((ydm+90.)/5.) - 90.
        if(xx(2)-xx(1).lt.20.)  xdm=aint(60.*xdm)/60.
        if(xx(2)-xx(1).ge.20.)  xdm=aint(xdm+360.)-360.
c     utm has a limit of 3 degrees
        if(xx(2)-xx(1).gt.500. .and. iproj.ne.2)
     1    xdm=5.*aint((xdm+360.)/5.) - 360.
c  plot longitude labels
        if(sizep.le.0.0) return
        xd=xdm
100     if(xd.gt.xdx) go to 190
        call dms(xd,id,im,is)
        id=id
        yd=ydm
105     call prjctl(yd,xd,x,y,cmd,sca,iproj)
        y=y-yb
        if(x.ge.xx(1).and.x.le.xx(2) .and.
     1    y.ge.yy(1).and.y.lt.hfy) go to 109
        yd=yd+dt
        if(yd-ydx) 105,105,110
109     call latlab(-1.,0,sizep,x,yy(1),id,im,is,nos,nom)
110     if(iplotr.eq.1 .or. iplotr.eq.4) go to 120
        yd=ydx
115     call prjctl(yd,xd,x,y,cmd,sca,iproj)
        y=y-yb
        if(x.ge.xx(1).and.x.le.xx(2) .and.
     1    y.gt.hfy.and.y.le.yy(2)) go to 119
        yd=yd-dt
        if(yd-ydm) 120,115,115
119     call latlab(1.,0,sizep,x,yy(2),id,im,is,nos,nom)
120     xd=xd+dt2
        go to 100
c  plot latitude labels
190     yd=ydm
200     if(yd.gt.ydx) go to 300
        call dms(yd,id,im,is)
        xd=xdm
205     call prjctl(yd,xd,x,y,cmd,sca,iproj)
        y=y-yb
        if(y.ge.yy(1).and.y.le.yy(2) .and.
     1    x.ge.xx(1).and.x.lt.hfx) go to 209
        xd=xd+dt
        if(xd-xdx) 205,205,210
209     call latlab(-1.,1,sizep,xx(1),y,id,im,is,nos,nom)
210     if(iplotr.eq.1 .or. iplotr.eq.4) go to 220
        xd=xdx
215     call prjctl(yd,xd,x,y,cmd,sca,iproj)
        y=y-yb
        if(y.ge.yy(1).and.y.le.yy(2) .and.
     1    x.gt.hfx.and.x.le.xx(2)) go to 219
        xd=xd-dt
        if(xd-xdm) 220,215,215
219     call latlab(1.,1,sizep,xx(2),y,id,im,is,nos,nom)
220     yd=yd+dt2
        go to 200
c  plot interior lat-lon ticks
300     yd=ydm
        do 360 j=1,int((ydx-yd)/dt)+1
        xd=xdm
        do 350 i=1,int((xdx-xd)/dt)+1
        call prjctl(yd,xd,x,y,cmd,sca,iproj)
        y=y-yb
        if(x.lt.xx(1) .or. x.gt.xx(2)) go to 350
        if(y.lt.yy(1) .or. y.gt.yy(2)) go to 350
        if(sizep.lt..00025) then
          call vchar(x,y,icross,1,2,2000.0*sizep,0.,0.,0.)
        else
          call vchar(x,y,icross,1,2,2.0*sizep,0.,0.,0.)
        end if
350     xd=xd+dt
360     yd=yd+dt
        return
        end
C
C________________________________________________________________
C
C     SUBROUTINE  D M S
C________________________________________________________________
C
        subroutine dms(d,id,im,is)
        is=int(abs(d)*3600.+.5)
        id=is/3600
        im=(is-id*3600)/60
        is=is-(id*3600+im*60)
        id=isign(id,int(d))
        return
        end
C
C________________________________________________________________
C
C     SUBROUTINE  L A T L A B
C________________________________________________________________
C
        subroutine latlab(side,lat,sz,x,y,jd,jm,js,nosec,nomin)
        dimension labint(3)
        character label*12,jd2*1,jm2*1,js2*1
        equivalence (labint,label)
        logical nosec,nomin
        jd2=char(24)
        jm2=char(39)
        js2=char(34)
        write(label,50) iabs(jd),jd2,jm,jm2,js,js2
50      format(i4,a1,2(i2,a1))
        if(jm.ne.0 .or. js.ne.0) nomin=.false.
        if(js.ne.0) nosec=.false.
        nch=11
        if(nosec) nch=8
        if(nomin) nch=5
        xl=nch*sz
        yof=0.
        if(lat.eq.1) then
        if(side.lt.0.) xof=-(2.*sz+xl)
        if(side.gt.0.) xof=2.*sz
        else
        xof=-xl/2.
        yof=2.*sz*side
        endif
        call vchar(x,y,labint,nch,2,sz,0.,xof,yof)
        return
        end
C
C________________________________________________________________
C
C     SUBROUTINE  S T A T E
C________________________________________________________________
C
        subroutine state
c
c  plot world data bank 2 boundaries on contour map
        common/llp/latm(3),latx(3),longm(3),longx(3),cm(3),
     1             baslat(3),
     1    iproj,xxx(2),yyy(2),sizep,unit,ip,neat,tint,itpost,
     1    ibound
        dimension xlat(500),xlon(500),xx(500),yy(500)
        integer rank
        real latm,latx,longm,longx,llat,llong
        LOGICAL BAD
        data in/14/,in1/15/
c
c  not implemented on pc yet
c
        dmstod(a,b,c)=a+sign(b,a)*.01666667+sign(c,a)*.00027778
        pbs=dmstod(baslat(1),baslat(2),baslat(3))
        pcm=dmstod(cm(1),cm(2),cm(3))
        xlatm=dmstod(latm(1),latm(2),latm(3))
        xlatx=dmstod(latx(1),latx(2),latx(3))+.0001
        xlongm=dmstod(longm(1),longm(2),longm(3))
        xlongx=dmstod(longx(1),longx(2),longx(3))
        if(abs(xlatx).le.abs(xlatm).or.abs(xlongx).le.
     1     abs(xlongm))
     1    return
        open(in,file='data$disk:[wdb2]wdb2.tab',status='old',
     & form='unformatted')
        open(in1,file='data$disk:[wdb2]wdb2.dat',status='old',
     & recl=4000,form='unformatted',access='direct')
        if(iproj.eq.999) go to 60
        sfac=39.370079
        if(unit.eq.1.) sfac=1.
        if(unit.eq.2.) sfac=.001
        if(iproj.gt.4) call setalb(iproj)
c
c       call with baslat & cm  to determine y(pbs) at baslat
        xxxx=pbs
        call prjctl(xxxx,pcm,yy,pbs,pcm,sfac,iproj)
c
c       plot boundaries on projected map
10      read(in,end=110) lineid,rank,np,lbeg,llat,llong,ulat,
     1                   ulong
        if(llat.gt.xlatx) go to 110
        if(ulat.lt.xlatm) go to 10
        if(llong.gt.xlongm) go to 10
        if(ulong.lt.xlongx) go to 10
        nrec=np*.002+1
        if(mod(np,500).eq.0) nrec=nrec-1
        irec=lbeg-1
        icon=0
        do 30 i=1,nrec
        l=i*500
        if(l.gt.np) go to 40
        irec=irec+1
        read(in1,rec=irec) (xlat(j),xlon(j),j=1,500)
        do 20 k=1,500
        call prjctl(xlat(k),xlon(k),xx(k),yyyy,pcm,sfac,iproj)
        yy(k)=yyyy-pbs
20      continue
C
C CHECK ARRAYS AND CALL LINE
C
        ICON2=ICON
        BAD=.TRUE.
        DO 25 IEND=1,500
          IF(XX(IEND).GT.1.E20.AND.YY(IEND).GT.1.E20) THEN
            IF(.NOT.BAD) THEN
              CALL LINE(XX(IBEG),YY(IBEG),IEND-IBEG,ICON2,IBOUND)
              ICON2=0
              BAD=.TRUE.
            END IF
          ELSE
            IF(BAD) THEN
              IBEG=IEND
              BAD=.FALSE.
            END IF
          END IF
   25 CONTINUE
        IF(.NOT.BAD) THEN
          CALL LINE(XX(IBEG),YY(IBEG),IEND-IBEG,ICON2,IBOUND)
          ICON2=0
          BAD=.TRUE.
        END IF
C
C END OF ARRAY CHECK
C
c        call line(xx,yy,500,icon,ibound)
30      continue
        go to 10
40      nr=np-(l-500)
        irec=irec+1
        read(in1,rec=irec) (xlat(i),xlon(i),i=1,nr)
        do 50 k=1,nr
        call prjctl(xlat(k),xlon(k),xx(k),yyyy,pcm,sfac,iproj)
        yy(k)=yyyy-pbs
50      continue
C
C CHECK ARRAYS AND CALL LINE
C
        ICON2=ICON
        BAD=.TRUE.
        DO 55 IEND=1,NR
          IF(XX(IEND).GT.1.E20.AND.YY(IEND).GT.1.E20) THEN
            IF(.NOT.BAD) THEN
              CALL LINE(XX(IBEG),YY(IBEG),IEND-IBEG,ICON2,IBOUND)
              ICON2=0
              BAD=.TRUE.
            END IF
          ELSE
            IF(BAD) THEN
              IBEG=IEND
              BAD=.FALSE.
            END IF
          END IF
   55 CONTINUE
        IF(.NOT.BAD) THEN
          CALL LINE(XX(IBEG),YY(IBEG),IEND-IBEG,ICON2,IBOUND)
          ICON2=0
          BAD=.TRUE.
        END IF
C
C END OF ARRAY CHECK
C
c        call line(xx,yy,nr,icon,ibound)
        go to 10
c
c  plot boundaries on unprojected map where the coordinates
c  are in lat/lon seconds
60      read(in,end=110) lineid,rank,np,lbeg,llat,llong,ulat,
     1                   ulong
        if(llat.gt.xlatx) go to 110
        if(ulat.lt.xlatm) go to 60
        if(llong.gt.xlongm) go to 60
        if(ulong.lt.xlongx) go to 60
        nrec=np*.002+1
        if(mod(np,500).eq.0) nrec=nrec-1
        irec=lbeg-1
        icon=0
        do 80 i=1,nrec
        l=i*500
        if(l.gt.np) go to 90
        irec=irec+1
        read(in1,rec=irec) (xlat(j),xlon(j),j=1,500)
        do 70 k=1,500
        xx(k)=sign(xlon(k),xxx(2))*3600.
        yy(k)=xlat(k)*3600.
70      continue
        call line(xx,yy,500,icon,ibound)
80      continue
        go to 60
90      nr=np-(l-500)
        irec=irec+1
        read(in1,rec=irec) (xlat(i),xlon(i),i=1,nr)
        do 100 k=1,nr
        xx(k)=sign(xlon(k),xxx(2))*3600.
        yy(k)=xlat(k)*3600.
100     continue
        call line(xx,yy,nr,icon,ibound)
        go to 60
110     close(in)
        close(in1)
        return
        end
C
C________________________________________________________________
C
C     SUBROUTINE  P R J C T L
C________________________________________________________________
C
        subroutine prjctl(ylat,xlon,x,y,cm,sfac,iprojt)
c  call projection routines
        double precision yl,xl,x1,y1,degr
        data degr/.0174532925199433d0/
        yl=dble(ylat)*degr
        xl=dble(xlon-cm)*degr
        go to (1,2,3,4,5,5,5,8,9),iprojt
1       call poly(yl,xl,x1,y1)
        go to 20
2       call utmfwd(yl,xl,x1,y1)
        go to 20
3       call merctr(yl,xl,x1,y1)
        go to 20
4       call lamber(yl,xl,x1,y1)
        go to 20
5       call albers(yl,xl,x1,y1)
        go to 20
8       call polars(yl,xl,x1,y1)
        go to 20
9       call transm(yl,xl,x1,y1)
20      x=sngl(x1)*sfac
        y=sngl(y1)*sfac
        return
        end
C
C________________________________________________________________
C
C     SUBROUTINE  P O L Y
C________________________________________________________________
C
      subroutine poly(phi,dlamb,x,y)
      double precision phi,dlamb,xc,x,y,a,b,t,q,phi2,c1,c2
      a(xc)=
     1   6.378206402718907d 06 +xc*(
     1  -3.167517353503576d 06 +xc*(
     1   2.478805037574243d 05 +xc*(
     1  -3.530710396439220d 03 +xc*(
     1  -6.565371848240127d 02 +xc*(
     1   6.822539551727124d 01 +xc*(
     1  -2.888860980506611d 00 ))))))
      b(xc)=
     1   3.189103200618349d 06 +xc*(
     1  -2.115275857345996d 06 +xc*(
     1   4.144758431728325d 05 +xc*(
     1  -3.625295427368928d 04 +xc*(
     1   1.322429746943889d 03 +xc*(
     1   4.427183005616853d 01 +xc*(
     1  -8.630738701658902d 00 +xc*(
     1   4.279183401413811d-01 )))))))
      q(xc)=
     1   6.335034386662446d 06 +xc*(
     1   2.144094496614083d 04 +xc*(
     1  -4.182226973512467d 03 +xc*(
     1   3.609995316780635d 02 +xc*(
     1  -1.346978283534684d 01 ))))
      t(xc)=
     1   9.999999957157490d-01+xc*(
     1  -1.666665796975878d-01+xc*(
     1   8.333050613721043d-03+xc*(
     1  -1.980904608528695d-04+xc*
     1   2.605165638554101d-06 )))
      phi2=phi**2
      c1=dlamb*phi
      c2=(c1*t(phi2))**2
      x=dlamb*a(phi2)*t(c2)
      y=dlamb*c1   *b(phi2)*t(.25d0*c2)**2 + phi*q(phi2)
      return
      end
C
C________________________________________________________________
C
C     SUBROUTINE  U T M F W D
C________________________________________________________________
C
        subroutine utmfwd(phi,dlam,x,y)
c  developed by g.i. evenden, usgs
        double precision phi,dlam,x,y,dl2,p
        p=phi*phi
        dl2=dlam*dlam
        if (p .le.1.94965360d0.and.dl2.le.3.7319881d-3)
     1       go to 10
        x=1.d30
        y=1.d30
        return
10      y=phi*(
     1        6332500.47d0+p*(21431.67d0+p*(-4179.269d0+p*(
     1        359.981d0-p*13.267d0)))
     1    -dl2*(-3187827d0+p*(2114440d0+p*(-414363.5d0+p*(
     1        36344.6d0-p*1420.3d0)))
     1     -dl2*(1334935d0+p*(-2356027d0+p*(1371758d0-p*
     1        267852d0)))))
        x=dlam*(6375655.2d0+p*(-3166253.6d0+p*(247800.26d0+p*(
     1        -3569.65d0+p*(-617.35d0+p*50.89d0))))
     1     -dl2*(-1069479d0+p*(2661562d0+p*(-1785956d0+p*(
     1       485045d0-p*52022d0)))))
        return
        end
C
C________________________________________________________________
C
C     SUBROUTINE  M E R C T R
C________________________________________________________________
C
        subroutine merctr(lat,long,x,y)
        double precision lat,long,x,y,a,halfpi,b2da2,z,phi
        data a/6378206.d0/,halfpi/1.57079632679489d0/,
     1    b2da2/9.932315290818186d-1/
        x=a*long
c       compute z/2
        z=0.5d0*(halfpi-datan(b2da2*dsin(lat)/dcos(lat)))
        y=a*dlog(dcos(z)/dsin(z))
        return
        end
C
C________________________________________________________________
C
C     SUBROUTINE  L A M B E R
C________________________________________________________________
C
      subroutine lamber(ylat,xlon,x,y)
      implicit double precision(a-h,o-z)
      save fn,fk
c
c   Lambert Conformal Conic forward projection program using
c    Clark 1866 ellipsoidal earth.  (See Map Projections Used by
c    the U. S. Geological Survey, GS Bulletin 1532, pp. 107-108.)
c
c      Input:  ylat - Latitude in radians.
c              xlon - Longitude in radians, east of
c                     central meridian.
c      Output: x    - Distance in meters east of central meridan.
c              y    - Distance in meters (negative) south of
c                     90 degrees lat.
c
c    Note that if setlam entry is not called prior to calling
c     subroutine lamber, the constants fn & fk are set
c     to calculate
c     x & y for standard parallels of 33. & 45. degrees.
c
      data a/6378206.4d0/,e2/.006768657997291099d0/
      data pi4/.785398163397448310d0/,e/.82271854223003258d-1/
      data b2da2/.993231342002708901d0/
      data fn/.63049989185603457d0/,fk/.124526547337527528d8/
      z=pi4-.5d0*datan(b2da2*(dtan(ylat)))
      r=fk*dtan(z)**fn
      theta=fn*xlon
      x=r*dsin(theta)
      y=-r*dcos(theta)
      return
C
C________________________________________________________________
C
C     ENTRY  S E T L A M
C________________________________________________________________
C
c
      entry setlam(ylat1,ylat2)
c
c   This entry sets up the Lambert Conformal Conic constants for
c     standard parallels ylat1 & ylat2, entered in radians, using
c     the
c     Clark 1866 ellipsoidal earth parameters of a = 6378206.4
c     meters
c     & b = 6356583.8 meters.
c     Note that e**2 = (a*a - b*b) / (a*a).
c
        if(ylat1.ne.ylat2 .and. ylat1*ylat2.gt.0.d0) go to 2
        print  1,ylat1,ylat2
1       format(2f10.3,' incorrect standard parallels, 33 & 45',
     1                ' will be used')
        ylat1=.575958656d0
        ylat2=.785398167d0
2     cos1=dcos(ylat1)
      cos2=dcos(ylat2)
      sin1=dsin(ylat1)
      sin2=dsin(ylat2)
      esin1=e*sin1
      esin2=e*sin2
      fm1=cos1/dsqrt(1.d0-e2*sin1*sin1)
      fm2=cos2/dsqrt(1.d0-e2*sin2*sin2)
      t1=dtan(pi4-.5d0*datan(b2da2*(sin1/cos1)))
      t2=dtan(pi4-.5d0*datan(b2da2*(sin2/cos2)))
      fn=(dlog(fm1)-dlog(fm2))/(dlog(t1)-dlog(t2))
      fk=a*fm1/(fn*t1**fn)
      return
      end
C
C________________________________________________________________
C
C     SUBROUTINE  A L B E R S
C________________________________________________________________
C
        subroutine albers(ylat,xlon,x,y)
        double precision ylat,xlon,x,y,n,rho1sq,sinbt1,twoc2n,
     1    nus,nals,nhaw,rho295,rho55,rho8,tcnus,tcnals,tcnhaw,
     1    a1,b,c1,d,e1,f1,g,h,theta,rho,sinbet,sinphi,s2
        data a1/9.954804334645587d-1/,b/4.492024607745888d-3/,
     1    c1/2.736435989866449d-5/,d/1.763992166249299d-7/,
     1    e1/1.160814577272288d-9/,f1/7.714265487727804d-12/,
     1    g/5.154557173568170d-14/,h/3.455700205911349d-16/,
     1    nus/6.02903493787094d-1/,nals/8.627447947235633d-1/,
     1    nhaw/2.241096394314637d-1/,rho295/8.49196923967458d13/,
     1    rho55/1.806308673895081d13/,rho8/7.943986660586285d14/,
     1    tcnus/1.346470921892769d14/,
     1    tcnals/9.409410848453636d13/,
     1    tcnhaw/3.622298555079059d14/,
     1    sbt295/4.907351753179611d-1/,
     1    sbt55/8.1792905450587868d-1/,sbt8/1.385562096187223d-1/
        sinphi=dsin(ylat)
        s2=sinphi*sinphi
        sinbet=sinphi*(a1+s2*(b+s2*(c1+s2*(d+s2*
     1    (e1+s2*(f1+s2*(g+s2*h)))))))
        rho=dsqrt(rho1sq+twoc2n*(sinbt1-sinbet))
        theta=n*xlon
        x=rho*dsin(theta)
        y=-rho*dcos(theta)
        return
C
C________________________________________________________________
C
C     ENTRY  S E T A L B
C________________________________________________________________
C
c
c set up constants
        entry setalb(iproj)
        if(iproj-6)500,510,520
500     n=nus
        rho1sq=rho295
        sinbt1=sbt295
        twoc2n=tcnus
        return
510     n=nals
        rho1sq=rho55
        sinbt1=sbt55
        twoc2n=tcnals
        return
520     n=nhaw
        rho1sq=rho8
        sinbt1=sbt8
        twoc2n=tcnhaw
        return
        end
C
C________________________________________________________________
C
C     SUBROUTINE  P O L A R S
C________________________________________________________________
C
        subroutine polars(ylat,xlon,x,y)
c   polar stereographic projection
c  partially checked by mike webring
c  there is about 1% error with polarr calculated this way,
c  but the form should be (1+e)/(1-e) (?) which makes bigger
c  errors.
c  basic routine is due to kay edwards, flagstaff
        implicit double precision (a-h,o-z)
        data e/8.1820567882165d-2/,r/6378160d0/,
     1       rad45/.785398163397448d0/,
     1    ee/4.09102839410826d-2/,polarr/12713644.51d0/
        dlat=dabs(ylat)
c       polarr=(2.d0*r/dsqrt(1.d0-e*e)) * ((1.d0-e)/(1.d0+e))**ee
        sinc=e*dsin(dlat)
        sine=(1.d0+sinc)/(1.d0-sinc)
        dlat2=dlat*.5d0
        tane2=rad45+dlat2
        tane1=dcos(tane2)/dsin(tane2)
        tanz=tane1*(sine**ee)
        p=tanz*polarr
        y=-(p*dcos(xlon))
        x=p*dsin(xlon)
        if(ylat.lt.0.d0) y=-y
c       scale=p*dsqrt(1.d0-e*e*dsin(dlat)**2)/dcos(dlat)/r
        return
        end
C
C________________________________________________________________
C
C     SUBROUTINE  T R A N S M
C________________________________________________________________
C
      subroutine transm(ylat,xlon,x,y)
c
c   Transverse Mercator forward projection program using
c   spherical
c     earth of radius 6371204. meters.  This is the radius of a
c     spherical earth of equivalent surface area to the Clark
c     1866
c     ellipsoid.  Note that the constant rsf is the product of
c     this
c     radius and a scale factor of 0.926.  The scale factor is
c     present
c     to balance the scale errors over North America.
c
c     input:  ylat - Latitude in radians.
c             xlon - Longitude in radians, east of central
c                    meridian.
c     output: x    - Distance in meters east of central meridian.
c             y    - Distance in meters north of equator.
c
      double precision ylat,xlon,x,y,rsf,b
      data rsf/5899734.904d0/
      b=dcos(ylat)*dsin(xlon)
      x=0.5d0*rsf*dlog((1.d0+b)/(1.d0-b))
      y=rsf*datan(dtan(ylat)/dcos(xlon))
      return
      end
C
C________________________________________________________________
C
C   SUBROUTINE  L H D G R D
C________________________________________________________________
C
C SUBROUTINE LOWHI DGRADIENT WHEN CALLED BY CONTOUR RETURNS THE
C MINIMUM AND MAXIMUM CURVATURE (DELTA GRADIENT) FOUND IN THE
C WINDOW DETERMINED BY SUBROUTINE HILOW.  THE PROCEDURE IS TO
C FIT A LEAST SQUARES PARABOLA TO EACH OF 4 SLICES TAKEN THROUGH
C THE CENTER OF THE WINDOW AND THEN FIND THE MINIMUM AND MAXIMUM
C OF TWICE THE SECOND ORDER COEFFICIENT.
C
C SUBROUTINE LHDGRD WRITTEN BY ROB BRACKEN, USGS, 6MAR87
C
C
      subroutine lhdgrd(w,nc2,iw,ic,jc,dx,dy,dgradn,dgradx,
     & dirlh,iptr)
C
C VARIABLE DECLARATION
C
      real*4 w(nc2,iw),dgrad(4),dgdir(4)
      real*8 x(1000),y(1000)
      real*8 a,b,c
      data ddval/1.e38/,dval/1.e+37/
      data dgdir/0.,-1.570796,.7853982,-.7853982/
C
C SET UP HALF WINDOW WIDTHS
C
      ihw=iw/2
      ihw1=ihw+1
C
C SET UP LEFT, BOTTOM, AND TOP COORDINATES
C
      il=ic-ihw1
      jb=jc-ihw1
      jt=jc+ihw1
C
C FIND CURVATURE OF E-W SLICE
C
       k=iptr+ihw
       if(k.gt.iw) k=k-iw
       do 10 i=1,iw
        x(i)=dble(dx*i)
        y(i)=dble(w(il+i,k))
   10 continue 
      call lsqpbl(x,y,1,iw,a,b,c,ei)
      dgrad(1)=2.0*a
      if(ei.ne.0) dgrad(1)=ddval
C
C FIND CURVATURE OF S-N SLICE
C
       do 20 j=1,iw
        x(j)=dble(dy*j)
        k=iptr-1+j
        if(k.gt.iw) k=k-iw
        y(j)=dble(w(ic,k))
   20 continue
      call lsqpbl(x,y,1,iw,a,b,c,ei)
      dgrad(2)=2.0*a
      if(ei.ne.0) dgrad(2)=ddval
C
C FIND CURVATURE OF SW-NE SLICE
C
      diag=sqrt(dx*dx+dy*dy)
       do 30 ij=1,iw
        x(ij)=dble(diag*ij)
        k=iptr-1+ij
        if(k.gt.iw) k=k-iw
        y(ij)=dble(w(il+ij,k))
   30 continue
      call lsqpbl(x,y,1,iw,a,b,c,ei)
      dgrad(3)=2.0*a
      if(ei.ne.0) dgrad(3)=ddval
C
C FIND CURVATURE OF NW-SE SLICE
C
       do 40 ji=1,iw
        k=iptr-ji
        if(k.lt.1) k=k+iw
        y(ji)=dble(w(il+ji,k))
   40 continue
      call lsqpbl(x,y,1,iw,a,b,c,ei)
      dgrad(4)=2.0*a
      if(ei.ne.0) dgrad(4)=ddval
C
C FIND MINIMUM AND MAXIMUM CURVATURE
C
      dgradn=ddval
      dgradx=-1*ddval
      imx=1
      imn=1
       do 50 i=1,4
         if(dgrad(i).lt.dval) then
          if(dgrad(i).gt.dgradx) then
            dgradx=dgrad(i)
            imx=i
          endif
          if(dgrad(i).lt.dgradn) then
            dgradn=dgrad(i)
            imn=i
          endif
         end if
   50 continue
      if(dgradx.lt.-1*dval) dgradx=ddval
      if(dgradx.lt.0.) dirlh=dgdir(imx)
      if(dgradn.gt.0.) dirlh=dgdir(imn)
      return
      end
C
C________________________________________________________________
C
C   SUBROUTINE  L S Q P B L
C________________________________________________________________
C
C LEAST SQUARE PARABOLA  --  FINDS THE PARABOLA WHICH
C IS THE BEST FIT TO THE LOCUS OF POINTS PASSED TO
C THE SUBROUTINE.
C
C FOLLOWING IS A LIST OF THE PASSED VARIABLES:
C
C    X     - DOUBLE PRECISION ARRAY OF INDEPENTANT VARIABLES
C    Y     - DOUBLE PRECISION ARRAY OF DEPENDANT VARIABLES
C    IB    - INTEGER BEGINNING POSITION IN ARRAYS X AND Y FOR FIT
C    IE    - INTEGER ENDING POSITION IN ARRAYS X AND Y FOR FIT
C    A,B,C - DOUBLE PRECISION COEFFICIENTS FOR THE BEST FIT
c            PARABOLA ACCORDING TO THE EQUATION  y = Axx + Bx + C
C    EI    - REAL ERROR INDICATOR
C                0.0 - SUCCESSFUL CALCULATION
C                1.0 - DIVISION BY ZERO ERROR
C
C SUBROUTINE LSQPBL WRITTEN BY  ROB BRACKEN, USGS, 2MAY86
C
      subroutine lsqpbl( x,y, ib,ie,   a,b,c, ei )
C
C VARIABLE DECLARATION
C
      double precision x(1),y(1)
      double precision a,b,c
      double precision x1,x2,x3,x4,yx1,yx2,y1
      double precision dd,d10,d20,d11,d21,d12,d22,xs
      data dval/1.e+37/
C
C VARIABLE INITIALIZATION
C
      ei=1.0
      x1=0.d0
      x2=0.d0
      x3=0.d0
      x4=0.d0
      yx1=0.d0
      yx2=0.d0
      y1=0.d0
C
C FIND SUMS
C
      ndval=0
      do 10 i=ib,ie
        if(x(i).lt.dval.and.y(i).lt.dval) then
          x1=x1+x(i)
          xs=x(i)*x(i)
          x2=x2+xs
          x3=x3+xs*x(i)
          x4=x4+xs*xs
          yx1=yx1+y(i)*x(i)
          yx2=yx2+y(i)*xs
          y1=y1+y(i)
        else
          ndval=ndval+1
        end if
   10 continue
      n=ie-ib+1-ndval
C
C CHECK FOR DIVISION BY ZERO
C
      if(dabs(x2).lt.1.d-30) return
      if(dabs(x3).lt.1.d-30) return
      if(dabs(x4).lt.1.d-30) return
      if(n.lt.3) return
C
C FIND ELEMENTS OF 2 X 2 DETERMINANT
C
      d10=yx2/x4-yx1/x3
      d20=yx1/x3-y1/x2
      d11=x3/x4-x2/x3
      d21=x2/x3-x1/x2
      d12=x2/x4-x1/x3
      d22=x1/x3-dble(float(n))/x2
      dd=d11*d22-d12*d21
C
C FIND COEFFICIENTS
C
      if(dabs(dd).lt.1.d-30) return
      c=(d11*d20-d10*d21)/dd
      b=(d10*d22-d12*d20)/dd
      a=(y1-b*x1-c*n)/x2
C
C CALCULATION COMPLETED
C
      ei=0.0
      return
      end
C
C_______________________________________________________________
C
C     SUBROUTINE  B S P L I N E
C_______________________________________________________________
C
      subroutine bsplin(x,y,n,xx,yy,nn,step,sigmap)
      save
c
c     b-spline subroutine
c     r.godson,usgs,denver,co.
c
      dimension x(1),y(1),xx(1),yy(1),c1(10),c2(10),c3(10),c4(10)
      logical close
      data sa/.1666667/,sb/.6666667/,isw/0/
      if(isw.eq.1) go to 10
      call setbsp(sigmap,step)
      k=0
      s1=1.-step
      do 5 t=0.,s1,step
      k=k+1
      t1=t*.5
      t2=t*t
      t2a=t2*.5
      t3=t2*t
      t3a=t3*.5
      c4(k)=sa*t3
      c1(k)=-c4(k)+t2a-t1+sa
      c2(k)=t3a-t2+sb
      c3(k)=-t3a+t2a+t1+sa
    5 continue
      isw=1
   10 if(n.lt.3) then
      do 20 i=1,n
      xx(i)=x(i)
      yy(i)=y(i)
   20 continue
      nn=n
      return
      endif
      if(x(1).eq.x(n).and.y(1).eq.y(n)) then
        close=.true.
        x1=x(n-1)
        y1=y(n-1)
        x(n+1)=x(2)
        y(n+1)=y(2)
      else
        close=.false.
        x11=x(2)-x(1)
        x1=x(1)-x11
        y11=y(2)-y(1)
        y1=y(1)-y11
        xnn=x(n)-x(n-1)
        x(n+1)=x(n)+xnn
        ynn=y(n)-y(n-1)
        y(n+1)=y(n)+ynn
      end if
      nn=1
      xx1=x(1)
      xx2=x(2)
      xx3=x(3)
      yy1=y(1)
      yy2=y(2)
      yy3=y(3)
      do 25 j=1,k
      xx(nn)=c1(j)*x1+c2(j)*xx1+c3(j)*xx2+c4(j)*xx3
      yy(nn)=c1(j)*y1+c2(j)*yy1+c3(j)*yy2+c4(j)*yy3
      nn=nn+1
   25 continue
      do 30 i=2,n-1
      i1=i-1
      i2=i+1
      i3=i+2
      xxi1=x(i1)
      xxi=x(i)
      xxi2=x(i2)
      xxi3=x(i3)
      yyi1=y(i1)
      yyi=y(i)
      yyi2=y(i2)
      yyi3=y(i3)
      do 27 j=1,k
      xx(nn)=c1(j)*xxi1+c2(j)*xxi+c3(j)*xxi2+c4(j)*xxi3
      yy(nn)=c1(j)*yyi1+c2(j)*yyi+c3(j)*yyi2+c4(j)*yyi3
      nn=nn+1
   27 continue
   30 continue
      if(close) then
        xx(nn)=xx(1)
        yy(nn)=yy(1)
      else
        xx(nn)=x(n)
        yy(nn)=y(n)
      end if
      return
      end
C
C________________________________________________________________
C
C     SUBROUTINE  S E T B S P
C________________________________________________________________
C
C SUBROUTINE SET B-SPLINE RETURNS THE STEP SIZE FOR THE B-SPLINE
C WHEN GIVEN THE GRID CELL SIZE AND SCALE.
C
C PASSED VARIABLES:
C
C   DELX   - REAL*4.  X SIZE OF GRID CELL IN DATA UNITS.
C   DELY   - REAL*4.  Y SIZE
C   XXSCAL - REAL*4.  X DIRECTION MAP_INCHES/DATA_UNITS.
C   YYSCAL - REAL*4.  Y DIRECTION
C   SIGMAB - REAL*4.  MAXIMUM ALLOWABLE AVERAGE DISTANCE BETWEEN
C            SPLINED POLYGON CURVE AND PERFECT CURVE. THE MINIMUM
C            GRID CELL AREA (IN MAP INCHES) THAT WILL BE SPLINED
C            IS:  8 * [ PI*SIGMAB/( PI-2 ) ]**2
C            (RECOMMEND SIGMAB = .0073 INCHES FOR VERSATEC PLOTS)
C   STEP   - REAL*4.  NORMALIZED STEP DISTANCE FOR INPUT TO
C            B-SPLINE SUBROUTINE.
C
C SUBROUTINE SET B-SPLINE WRITTEN BY ROB BRACKEN, USGS, 6APR87
C
C
      subroutine setbsp(sigmab,step)
C
      parameter(pi=3.141592654,pio2=pi/2.)
      common/setxy/dum(26),xxscal,yyscal,mscale,delx,dely
C
C --- DISTANCE FROM GRID CELL CORNER TO CENTER IN MAP INCHES ---
      r=sqrt(delx*delx*xxscal*xxscal+dely*dely*yyscal*yyscal)/2.
C
      do 10 n=1,9
C ---   DIFFERENCE IN AREA BETWEEN CIRCLE AND POLYGON ---
        area=pi*r*r*(1.-(sin(pio2/n)*n)/pio2)
C ---   DISTANCE AROUND CIRCLE
        s=2.*pi*r
C ---   AVERAGE DISTANCE BETWEEN CIRCLE AND POLYGON BOUNDARY ---
        aos=area/s
C ---   IF DISTANCE IS WITHIN TOLERANCE THEN FINISHED ---
        if(aos.le.sigmab) goto 101
   10 continue
C
  101 step=1./n
      return
      end

C
C   SUBROUTINE  H A C H E R 
C________________________________________________________________
C
C SUBROUTINE HACHER IS DESIGNED TO PUT HACHERS ON LOW CLOSURES
C WHEN CALLED BY PROGRAM CONTOUR.  THIS SUBROUTINE WILL BRIDGE
C TIER BOUNDARIES.  AN INITIAL CALL TO THE SUBROUTINE ITSELF
C MUST BE MADE BEFORE ANY CONTOURING BEGINS IN ORDER TO
C INITIALIZE VARIABLES.  THEN A CALL TO SUBROUTINE FEED MUST
C BE MADE EACH TIME A CONTOUR LINE SEGMENT IS DRAWN.  A CALL
C TO ENTRY LAYEGG MUST BE MADE AT THE END OF EACH CONTOUR TRACE.
C ENTRY GRADEGG MUST BE CALLED AFTER EACH TIER IS COMPLETED AND
C ENTRY GATHEREGGS MUST BE CALLED AT THE END OF THE CONTOURING.
C FOLLOWING IS A LIST OF THE PASSED VARIABLES:
C
C   NPASS  - INTEGER*4.  THE NUMBER OF TIERS TO BE CONTOURED.
C   NROWT  - INTEGER*4.  THE NUMBER OF ROWS IN EACH TIER.
C   TY0    - REAL*4.  THE Y POSITION IN MAP INCHES OF THE FIRST
C            ROW IN THE GRID.
C   TDELY  - REAL*4.  THE DISTANCE BETWEEN ROWS IN MAP INCHES.
C   HLEN   - REAL*4.  THE LENGTH IN INCHES OF THE HACHER TICKS.
C   HSPACE - REAL*4.  THE DISTANCE IN INCHES BETWEEN THE HACHER
C            TICKS.  HACHERS WILL NOT BE MADE IF HSPACE = 0.
C   HGAP   - REAL*4.  THE RATIO (DIRECT DISTANCE BETWEEN CONTOUR
C            END POINTS) / (THE TOTAL LENGTH OF THE CONTOUR).
C            BY APROPRIATELY SPECIFYING THIS VARIABLE LOW
C            CLOSURES WHICH INTERSECT MAP EDGES AND DVALED AREAS
C            WILL BE HACHERED.  SUGGESTED VALUE IS .1
C   HMAX   - REAL*4.  THE MAXIMUM NUMBER OF HACHURED CONTOUR
C            LINES THAT MAY BE STACKED AROUND ANY GIVEN LOW.
C            THIS NUMBER WILL BE CONVERTED TO AN INTEGER.
C   HLIM   - REAL*4.  THE MINIMUM CIRCUMFERENCE OF A CONTOUR
C            LINE THAT WILL BE CONSIDERED PART OF THE STACK
C            AND THEREFORE SUBJECT TO THE HMAX LIMIT.
C   HVB    - REAL*4  HIGHS WHICH ARE SHORTER THAN HVB WILL BE
C            IGNORED IF THEY ARE INSIDE A LOW CLOSURE.
C   CLIM   - REAL*4.  CONTOUR LIMIT.  THE SHORTEST LENGTH (IN
C            MAP INCHES) CONTOUR LINE WHICH WILL BE PLOTTED.
C   DELB   - REAL*4.  THE DESIRED DISTANCE IN MAP INCHES BETWEEN
C            CONTOUR LINE LABELS.
C
C SUBROUTINE HACHERY WRITTEN BY ROB BRACKEN, USGS, 17MAR87
C
C
      subroutine hacher(npass,nrowt,ty0,tdely,hlen,hspace,hgap,
     1 hmax,hlim,hvb,clim,delb)
      save
C
C VARIABLE DECLARATION
C
      integer*4 lenxy,lental,lenclo,nparm
      parameter(lenxy=1001,lental=32768,lenptr=lental+40)
      parameter(lenclo=16384,nparm=5)
      parameter(tol=.000001)
      real*4 tal(2,lental),tal2(2,lental),xx(lenxy),yy(lenxy)
      real*4 xa(lenclo),ya(lenclo),dsa(lenclo)
      integer*4 ital(2,lental),lpoint(lenptr)
      integer*2 ivis(lenclo),istack(lental)
      integer*4 jzero(13),ikey(10),iparm(nparm)
      integer*4 dsk1,dsk2,dsk3,dsk4,dsk5,south,north
      parameter(dsk1=14,dsk2=15,dsk3=16,dsk4=17,dsk5=18)
      equivalence (tal(1,1),ital(1,1))
      logical*4 nohach,skip,noclim,nodelb,nohen
      common /eggchu/ jsrec,nohach,noclim,nodelb,nohen
      common/captur/icapt
       integer function inside
      data jzero /0,0,0,0,0,0,0,0,0,0,0,0,0/
c
c     open file for capturing contours if requested
c
      if(icapt.ne.0) then
      open(22,file='contour.cor',status='new',
     & form='formatted',carriagecontrol='list')
      open(23,file='contour.val',status='new',
     & form='formatted',carriagecontrol='list')
      endif
C
C DETERMINE IF HACHERS ARE GOING TO BE MADE
C
  100 nohach=.false.
      if(hlen.lt.1.e-30) nohach=.true.
      if(hspace.lt.1.e-30) nohach=.true.
      if(nint(hmax).eq.0) nohach=.true.
C
C DETERMINE IF THE CONTOUR LINE LENGTH IS TO HAVE A MINIMUM
C
      noclim=.false.
      if(clim.lt.1.e-30) noclim=.true.
C
C DETERMINE IF THE DISTANCE BETWEEN LABELS HAS BEEN SPECIFIED
C
      nodelb=.false.
      if(delb.lt.1.e-30) nodelb=.true.
C
C DETERMINE IF HACHERY IS TO BE USED AT ALL
C
      nohen=.false.
      if(nohach.and.noclim.and.nodelb.and.(icapt.eq.0)) nohen=.true.
      if(nohen) goto 199
C
C OPEN SCRATCH FILES
C
C --- BARN1 HOLDS TRACE END POINTS AND TRACE SEGMENT POINTERS ---
      open(unit=dsk1,form='unformatted',
     1 status='scratch',recl=6,
     2 access='direct')
C --- BARN2 HOLDS CONTOUR LINE POINTERS ---
      open(unit=dsk2,form='unformatted',
     1 status='scratch',recl=5,
     2 access='direct')
C --- PATH HOLDS TRACE LINKING POINTERS ---
      open(unit=dsk3,form='unformatted',
     1 status='scratch',recl=13,
     2 access='direct')
C --- THISTLES HOLDS NON-LOW CLOSURE SAMPLE POINTS ---
      open(unit=dsk5,form='unformatted',
     1 status='scratch',recl=2,
     2 access='direct')
C --- MEGARRAY HOLDS CONTOUR TRACE SEGMENTS ---
      call megaop(dsk4)
C
C INITIALIZE VARIABLES
C
C --- INITIALIZE HACHER DIMENSIONS ---
      glen=hlen
      gspace=hspace
C --- INITIALIZE CLOSURE RATIO ---
      gratio=hgap
C --- INITIALIZE MAX HACHURE IN A STACK ---
      mxhach=nint(hmax)
      if(mxhach.gt.999.or.mxhach.lt.0) mxhach=999
C --- INITIALIZE STACK QUALIFICATION MINIMUM CONTOUR LENGTH ---
      glim=hlim
C --- INITIALIZE MAXIMUM ENCLOSED HIGH LIMIT
      hachvb=hvb
C --- INITIALIZE MINIMUM CONTOUR LINE LENGTH ---
      conlim=clim
      if(glim.lt.conlim) glim=conlim
C --- INITIALIZE SPACE BETWEEN LABELS ---
      bspace=delb
      if(nodelb.or.delb.lt.1.e-30) bspace=7.0
C --- INITIALIZE FILE POINTERS ---
      jsrec=1
      nsrec=1
      ndrecs=0
      ndrecn=0
      ndrec=0
C --- INITIALIZE TIER AND STORAGE POINTERS ---
      south=dsk1
      north=dsk5
      itier=1
      ntier=npass
      nrowt1=nrowt-1
      ty1=ty0
      ty4=ty0
      dely=tdely
      do 10 i=1,nrowt1
        ty4=ty4+dely
   10 continue
C
C RETURN TO CALLING ROUTINE
C
  199 return
C
C________________________________________________________________
C
C  ENTRY  L A Y E G G
C________________________________________________________________
C
C ENTRY LAYEGG DETERMINES IF A COMPLETE TRACE MEETS THE INITIAL
C CONDITIONS FOR A LOW CLOSURE.  IF IT DOES NOT THE TRACE IS
C DISCARDED.  IF IT IS NOT A CLOSURE BUT IT ENTERS AND EXITS THE
C TIER AT THE SOUTH OR NORTH SIDE IT IS STORED FOR LATER
C EVALUATION.  IF IT IS A LOW CLOSURE IT IS HACHERED AND
C DISCARDED.
C
C  NTURN  - INTEGER*4.  THE SUM OF THE DIRECTIONS TAKEN BY THE
C           TRACE.  NEG=PREDOMINANT LEFT TURN.  ZERO=PREDOMINANT
C           STRAIGHT (NO TURN).  POS=PREDOMINANT RIGHT TURN.  A
C           CLOSURE WILL NECESSARILY BE NEG OR POS FOUR.  SINCE
C           THE CONTOUR IS DRAWN IN SUCH A WAY THAT THE SLOPE
C           ALWAYS DECREASES TO THE RIGHT A LOW CLOSURE WILL BE
C           SIGNIFIED BY NTURN=+4.
C  XB,XE  - REAL*4.  BEGINNING AND ENDING X-POSITIONS OF TRACE.
C  YB,YE  - REAL*4.                       Y-POSITIONS
C  TLEN   - REAL*4.  TOTAL LENGTH OF CONTOUR TRACE.
C  CONT   - REAL*4.  VALUE OF THE TRACE'S CONTOUR LEVEL.
C
      entry layegg(nturn,xb,xe,yb,ye,tlen,cont,linetp,ipost,size)
  300 continue
C
C DETERMINE IF HACHERS ARE TO BE MADE
C
      if(nohen) goto 399
C
C CHECK FOR COMPLETE CLOSURE OF THE TRACE WITHIN A SINGLE TIER.
C
      if(xe.eq.xb.and.ye.eq.yb) then
C ---   COMPLETE CLOSURES WILL BE PRELINKED ---
        lnkon=1
      else
C ---   NON-CLOSURES WILL BE LINKED AFTER MAP IS COMPLETED ---
        lnkon=-1
      end if
C
C STORE TRACE FOR LATER EVALUATION
C
      ndrec=ndrec+2
      ndrec1=ndrec-1
      ndrecb=ndrec1
      ndrece=ndrec
      if(lnkon.eq.1) then
C ---   STORE CLOSURES PRE-LINKED ---
        write(dsk3,rec=ndrecb) lnkon,ndrece,ndrece,
     1   nturn,nsrec,jsrec,tlen,cont,xb,yb,linetp,ipost,size
        write(dsk3,rec=ndrece) lnkon,ndrecb,ndrecb,
     1   nturn,nsrec,jsrec,tlen,cont,xe,ye,linetp,ipost,size
      else
C ---   STORE NON-CLOSURES UNLINKED ---
        write(dsk3,rec=ndrecb) lnkon,lnkon,ndrece,
     1   nturn,nsrec,jsrec,tlen,cont,xb,yb,linetp,ipost,size
        write(dsk3,rec=ndrece) lnkon,lnkon,ndrecb,
     1   nturn,nsrec,jsrec,tlen,cont,xe,ye,linetp,ipost,size
      end if
C
C DIFFERENTIATE BETWEEN NORTH AND SOUTH ENTRY AND EXIT POINTS
C
      if(ndrecs.ge.lental.or.ndrecn.ge.lental) then
      write(*,*) 'tier boundary array size(lental value) exceeded'
      stop
      endif
      if(abs(yb-ty1).le.tol) then
C ---   TRACE BEGINNING AT SOUTH TIER BOUNDARY ---
        ndrecs=ndrecs+1
        tal(1,ndrecs)=xb
        ital(2,ndrecs)=ndrecb
      else if(abs(yb-ty4).le.tol) then
C ---   TRACE BEGINNING AT NORTH TIER BOUNDARY ---
        ndrecn=ndrecn+1
        write(north,rec=ndrecn) xb,ndrecb
      end if
      if(abs(ye-ty1).le.tol) then
C ---   TRACE ENDING AT SOUTH TIER BOUNDARY ---
        ndrecs=ndrecs+1
        tal(1,ndrecs)=xe
        ital(2,ndrecs)=ndrece
      else if(abs(ye-ty4).le.tol) then
C ---   TRACE ENDING AT NORTH TIER BOUNDARY ---
        ndrecn=ndrecn+1
        write(north,rec=ndrecn) xe,ndrece
      end if
C
C ADVANCE POINTER
C
  301 nsrec=jsrec
C
C RETURN TO CALLING ROUTINE
C
  399 return
C
C________________________________________________________________
C
C     ENTRY  G R A D E G G
C________________________________________________________________
C
C ENTRY GRADEGG LINKS ALL TRACE END POINTS AT THE SOUTH SIDE OF
C THE TIER WITH THEIR CONTINUATIONS AT THE NORTH SIDE OF THE 
C PREVIOUS TIER.  IT IS ASSUMED THAT ALL Y VALUES AT THE TIER
C BOUNDARY ARE EQUAL.  THEREFORE ONLY THE X VALUES NEED TO BE
C MATCHED IN ORDER TO FIND THE CONTINUATION.
C
C
      entry grdegg
  400 continue
C
C DETERMINE IF HACHERS ARE TO BE MADE
C
      if(nohen) goto 499
C
C IF NOT ENOUGH POINTS AT SOUTH BOUNDARY OF TIER TO LINK THEN
C PROCEDE TO NEXT TIER.
C
      if(ndrecs.le.1) goto 401
C
C SORT TRACE END POINTS AT SOUTH BOUNDARY OF TIER.
C
      nkey=1
      ikey(1)=1
      call sortil(tal,2,lental,ndrecs,ikey,nkey,lpoint,lenptr,
     1 ier)
C
C LINK ALL END POINTS AT SOUTH BOUNDARY WITH MATCHING END POINTS
C AT NORTH BOUNDARY OF PREVIOUS TIER.
C
      ll=lpoint(ndrecs+1)
      x1=tal(1,ll)
      ix1=ital(2,ll)
      do 11 i=2,ndrecs
        ll=lpoint(ll)
        x2=tal(1,ll)
        ix2=ital(2,ll)
        if(x2.eq.x1) then
          read(dsk3,rec=ix1) lnkon1,lnk1,il1,
     1     nturn1,nsrec1,jsrec1,tlen1,cont1,x1,y1,linet1,ipost1,
     2     size1
          read(dsk3,rec=ix2) lnkon2,lnk2,il2,
     1     nturn2,nsrec2,jsrec2,tlen2,cont2,x2,y2,linet2,ipost2,
     2     size2
          if(lnkon1.eq.-1.and.lnkon2.eq.-1) then
            lnkon1=1
            lnkon2=1
            write(dsk3,rec=ix1) lnkon1,ix2,il1,
     1       nturn1,nsrec1,jsrec1,tlen1,cont1,x1,y1,linet1,
     2       ipost1,size1
            write(dsk3,rec=ix2) lnkon2,ix1,il2,
     1       nturn2,nsrec2,jsrec2,tlen2,cont2,x2,y2,linet2,
     2       ipost2,size2
          end if
        end if
        x1=x2
        ix1=ix2
   11 continue
C
C INCREMENT TIER NUMBER AND SWITCH TRACE END POINT STORAGE FILES.
C
  401 if(itier.lt.ntier) then
        itier=itier+1
        ty1=ty4
        do 20 i=1,nrowt1
          ty4=ty4+dely
   20 continue
        do 30 i=1,ndrecn
          read(north,rec=i) tal(1,i),ital(2,i)
   30 continue
        ndrecs=ndrecn
        ndrecn=0
      end if
C
C RETURN TO CALLING ROUTINE
C
  499 return
C
C________________________________________________________________
C
C     ENTRY  G A T H E R E G G S
C________________________________________________________________
C
C ENTRY GATHEREGGS DETERMINES WHERE THE LOW CLOSURES ARE
C AFTER THE ENTIRE PLOT IS COMPLETE AND THEN RECORDS THEIR
C LOCATION ON DSK1 AND DSK2.
C
      entry gather
  500 continue
C
C CHECK IF HACHERS ARE TO BE MADE OR MINIMUM LENGTH TO BE CHECKED
C
      if(nohen) goto 699
C
C FOLLOW EACH OPEN LINKED LIST AND CHECK IF IT QUALIFIES AS A LOW
C CLOSURE BASED ON HACH GAP AND THE DIRECTION OF TURN.
C THEN FOLLOW ALL CLOSURES AND CHECK IF THEY TURN CLOCKWISE.
C SAVE QUALIFYING LOWS IN FILES WHICH REFERENCE THEM TO THE 
C MEGARRAY SEGMENT STORAGE FILE.
C
C --- INITIALIZE FILE POINTERS ---
      ist=0
      ist2=0
      ist3=0
      level=1
C
C CHECK FOR OPEN TRACES AND OPEN TRACE CHAINS
C
      do 31 i=1,ndrec1,2
C ---   READ IN BEGINNING OF A TRACE ---
        read(dsk3,rec=i) lnkon1,lnk1,il1,
     1   nturn1,nsrec1,jsrec1,tlen1,cont1,x1,y1,linet1,ipost1,
     2   size1
C ---   SKIP DELETED (0) OR LINKED (1) TRACES ---
        if(lnkon1.ne.-1) goto 513
        read(dsk3,rec=il1) lnkon2,lnk2,il2,
     1   nturn2,nsrec2,jsrec2,tlen2,cont2,x2,y2,linet2,ipost2,
     2   size2
        if(lnkon2.eq.1) goto 515
        if(lnkon2.eq.0) goto 513
C ---   DELETE BOTH ENDS OF TRACE ---
        write(dsk3,rec=i) jzero
        write(dsk3,rec=il1) jzero
C ---   CHECK GAP FOR TRACES WHICH ARE UNLINKED AT BOTH ENDS ---
        gap=sqrt((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1))
C ---   STORE POINTERS FOR CONTOUR LINE ---
        ist=ist+1
        write(dsk1,rec=ist) nsrec1,jsrec1,cont1,linet1,ipost1,
     1   size1
        if(nturn1.gt.0.and.gap.le.gratio*tlen1) then
C ---     STORE LOW CLOSURE ---
          ist2=ist2+1
          write(dsk2,rec=ist2) cont1,tlen1,ist,ist,level
        else if(tlen1.gt.conlim.and.tlen1.gt.hachvb) then
C ---     STORE SAMPLE POINT FOR NON-LOW CLOSURE ---
          ist3=ist3+1
          write(dsk5,rec=ist3) x1,y1
        end if
        goto 513
C ---   FOLLOW CHAIN OF TRACES UNTIL UNLINKED END ---
  515   jst=0
        nturnt=0
        tlent=0.
        x0=x1
        y0=y1
        j1=i
  512   jst=jst+1
C ---   KEEP RECORD OF EACH LINKED TRACE IN CHAIN ---
        write(dsk1,rec=ist+jst) nsrec1,jsrec1,cont1,linet1,
     1   ipost1,size1
        jrev=il1-j1
        nturnt=nturnt+nturn1*jrev
        tlent=tlent+tlen1
        j2=il1
C ---   READ IN END OF TRACE ---
        read(dsk3,rec=j2) lnkon2,lnk2,il2,
     1   nturn2,nsrec2,jsrec2,tlen2,cont2,x2,y2,linet2,ipost2,
     2   size2
C ---   DELETE BOTH ENDS OF TRACE ---
        write(dsk3,rec=j1) jzero
        write(dsk3,rec=j2) jzero
C ---   IF UNLINKED END FIND GAP AND STOP FOLLOWING CHAIN ---
        if(lnkon2.ne.1) then
          gap=sqrt((x2-x0)*(x2-x0)+(y2-y0)*(y2-y0))
          goto 514
        end if
C ---   IF LINKED BACK ON ITSELF (SHOULD NEVER HAPPEN) STOP ---
        if(lnk2.eq.i) goto 514
        j1=lnk2
C ---   READ IN BEGINNING OF NEXT TRACE ---
        read(dsk3,rec=j1) lnkon1,lnk1,il1,
     1   nturn1,nsrec1,jsrec1,tlen1,cont1,x1,y1,linet1,ipost1,
     2   size1
C ---   IF UNLINKED BEGINNING FIND GAP AND STOP FOLLOWING ---
        if(lnkon1.ne.1) then
          gap=sqrt((x1-x0)*(x1-x0)+(y1-y0)*(y1-y0))
          goto 514
        end if
        goto 512
  514   if(nturnt.gt.0.and.gap.le.gratio*tlent) then
C ---     STORE POINTERS FOR LOW CLOSURE CHAIN ---
          ist2=ist2+1
          write(dsk2,rec=ist2) cont1,tlent,ist+1,ist+jst,level
        else if(tlent.gt.conlim.and.tlent.gt.hachvb) then
C ---     STORE SAMPLE POINT FOR NON-LOW CLOSURE CHAIN ---
          ist3=ist3+1
          write(dsk5,rec=ist3) x0,y0
        end if
C ---   STORE CONTOUR CHAIN ---
        ist=ist+jst
  513   continue
   31 continue
C
C CHECK FOR CLOSED TRACES AND CLOSED TRACE CHAINS
C
  501 do 32 i=1,ndrec1,2
C ---   READ IN BEGINNING OF TRACE ---
        read(dsk3,rec=i) lnkon1,lnk1,il1,
     1   nturn1,nsrec1,jsrec1,tlen1,cont1,x1,y1,linet1,ipost1,
     2   size1
C ---   BREAK INTO LINKED SECTION ---
        if(lnkon1.eq.1) then
          jst=0
          nturnt=0
          tlent=0.
          x0=x1
          y0=y1
          j1=i
  502     jst=jst+1
C ---     KEEP RECORD OF EACH LINKED TRACE ---
          write(dsk1,rec=ist+jst) nsrec1,jsrec1,cont1,linet1,
     1     ipost1,size1
          jrev=il1-j1
          nturnt=nturnt+nturn1*jrev
          tlent=tlent+tlen1
          j2=il1
C ---     READ IN END OF TRACE ---
          read(dsk3,rec=j2) lnkon2,lnk2,il2,
     1     nturn2,nsrec2,jsrec2,tlen2,cont2,x2,y2,linet2,ipost2,
     2     size2
C ---     DELETE TRACE ---
          write(dsk3,rec=j1) jzero
          write(dsk3,rec=j2) jzero
C ---     IF UNLINKED END STOP FOLLOWING CHAIN ---
          if(lnkon2.ne.1) goto 503
C ---     CHAIN CLOSES ON ITSELF ---
          if(lnk2.eq.i) goto 504
          j1=lnk2
C ---     READ BEGINNING OF NEXT TRACE ---
          read(dsk3,rec=j1) lnkon1,lnk1,il1,
     1     nturn1,nsrec1,jsrec1,tlen1,cont1,x1,y1,linet1,ipost1,
     2     size1
C ---     IF BEGINNING IS UNLINKED STOP FOLLOWING CHAIN ---
          if(lnkon1.ne.1) goto 503
          goto 502
  504     if(ist2.ge.lental.or.ist3.ge.lental) then
          write(*,*) 'closure array size(lenclo value) exceeded'
          stop
          endif
          if(nturnt.gt.0) then
C ---       STORE POINTERS FOR LOW CLOSURES ---
            ist2=ist2+1
            write(dsk2,rec=ist2) cont1,tlent,ist+1,ist+jst,level
          else if(tlent.gt.conlim.and.tlent.gt.hachvb) then
C ---       STORE SAMPLE POINT FOR NON-LOW CLOSURES ---
            ist3=ist3+1
C           if(gratio.ge.1.e-30) write(dsk5,rec=ist3) x0,y0
            write(dsk5,rec=ist3) x0,y0
          end if
C ---     STORE CONTOUR CHAIN ---
          ist=ist+jst
        end if
  503   continue
   32 continue
      close(unit=dsk3)
C
C________________________________________________________________
C
C     ENTRY  E G G Y O L K
C________________________________________________________________
C
C ENTRY EGGYOLK SORTS EACH QUALIFYING LOW CLOSURE BY TOTAL LENGTH
C (SECONDARY SORT) AND CONTOUR LEVEL (PRIMARY SORT) AND THEN
C STARTING AT THE LOWEST CONTOUR LEVEL AND SHORTEST LENGTH
C CONSTRUCTS A HEIRARCHY OF CONTOUR LEVELS.  THE LEVEL OF EACH
C CONTOUR CLOSURE IS WRITTEN BACK INTO THE FILE WHICH KEEPS TALLY
C OF THEM.
C
C
      entry eggylk
  700 continue
      if(nohach) go to 600
C
C READ IN NON-LOW CLOSURE LIST AND SORT ON X AND Y
C
C      if(gratio.lt.1.e-30) goto 701
      do 33 i=1,ist3
        read(dsk5,rec=i) tal(1,i),tal(2,i)
   33 continue
      nkey=2
      ikey(1)=1
      ikey(2)=2
      call sortil(tal,2,lental,ist3,ikey,nkey,lpoint,lenptr,
     1 ier)
      ll=lpoint(ist3+1)
      do 34 i=1,ist3
        tal2(1,i)=tal(1,ll)
        tal2(2,i)=tal(2,ll)
        ll=lpoint(ll)
   34 continue
  701 continue
C
C READ IN LOW CLOSURE LIST AND SORT ON CONTOUR VALUE AND LENGTH
C
      do 35 i=1,ist2
        read(dsk2,rec=i) tal(1,i),tal(2,i),idum3,idum4,idum5
   35 continue
      if(mxhach.lt.999) then
        nkey=2
        ikey(1)=1
        ikey(2)=2
        call sortil(tal,2,lental,ist2,ikey,nkey,lpoint,lenptr,
     1   ier)
      else
        lpoint(ist2+1)=1
        do 36 i=1,ist2
          lpoint(i)=i+1
   36   continue
      end if
C
C LOAD ALL SEGMENTS OF EACH CLOSURE INTO AN ARRAY
C
C --- INITIALIZE NUMBER OF INDEPENDANT CLOSURE STACKS ---
      nstack=0
C --- FIND POINTER OF THE LOWEST AND SHORTEST CLOSURE ---
      ll=lpoint(ist2+1)
C --- LOOP THROUGH CHECKING ONE COMPLETE CLOSURE AT A TIME ---
      do 105 jll=1,ist2
C ---   READ IN POINTERS LOCATIONS FOR THE NEXT LOW CLOSURE ---
        read(dsk2,rec=ll) conval,conlen,ibeg,iend
C ---   INITIALIZE OFFSET POINTER IN ARRAYS FOR HOLDING THE LOW
C       CLOSURE POINTS ---
        joff=0
C ---   LOOP THROUGH LOW CLOSURE POINTERS ---
        do 60 i=ibeg,iend
          read(dsk1,rec=i) nsrec,jsrec
C ---     INITIALIZE MEGARRAY POINTER ---
          iptr=nsrec
          skip=.false.
   45     if(iptr.ge.jsrec) go to 60
            call megard(iptr,nparm,iparm)
            if(skip) then
C ---         SKIP SEGMENT BECAUSE IT'S ALREADY BEEN LOADED ---
              iskip=iskip+1
              if(iskip.gt.nskip) skip=.false.
            else
C ---         LOAD SEGMENT INTO ARRAY ---
              iptr=iptr+nparm
              npts=iparm(2)
              call rmegar(iptr,npts,xx)
              call rmegar(iptr+npts,npts,yy)
              do 50 j=1,npts
                xa(joff+j)=xx(j)
                ya(joff+j)=yy(j)
   50         continue
C ---         INCREMENT OFFSET POINTER ---
              joff=joff+npts
C ---         CHECK IF SEGMENT CONTAINS SOME OTHER SEGMENTS ---
              isegtp=iparm(4)
              if(isegtp.gt.100) then
                skip=.true.
                iskip=1
                nskip=isegtp-100
              end if
            end if
C ---       POSITION MEGARRAY POINTER TO BEG OF NEXT SEGMENT ---
            iptr=iparm(1)
         go to 45
   60   continue
C
C CHECK FOR GAPS AT CORNERS AND MAKE THEM SQUARE
C
        if(xa(joff)-xa(1)) 711,715,712
  711   if(ya(joff)-ya(1)) 714,715,713
  712   if(ya(joff)-ya(1)) 713,715,714
C ---   ADD POINT TO MAKE SQUARE GAPS AT SW AND NE CORNERS ---
  713   joff=joff+1
        xa(joff)=xa(1)
        ya(joff)=ya(joff-1)
        goto 715
C ---   ADD POINT TO MAKE SQUARE GAPS AT NW AND SE CORNERS ---
  714   joff=joff+1
        xa(joff)=xa(joff-1)
        ya(joff)=ya(1)
  715   continue
C
C FIND MIN AND MAX X AND Y IN CURRENT LOW CLOSURE
C
        xamin=xa(1)
        xamax=xamin
        yamin=ya(1)
        yamax=yamin
        do 70 i=2,joff
          if(xa(i).lt.xamin) then
            xamin=xa(i)
          else if(xa(i).gt.xamax) then
            xamax=xa(i)
          end if
          if(ya(i).lt.yamin) then
            yamin=ya(i)
          else if(ya(i).gt.yamax) then
            yamax=ya(i)
          end if
   70 continue
c
C FIND IF A NON-LOW CLOSURE IS CONTAINED IN THE LOW CLOSURE
C
C        if(gratio.lt.1.e-30) goto 721
        call binsrc(tal2,ist3,1,xamin,xamax,minx,maxx)
        do 80 i=minx+1,maxx-1
          if(tal2(2,i).ge.yamin.and.tal2(2,i).le.yamax) then
      if(inside(xa,ya,joff,tal2(1,i),tal2(2,i)).ne.0) then
              level=1000
              goto 731
            end if
          end if
   80   continue
  721     continue
C
C FIND LEVEL IN STACK OF PRESENT LOW CLOSURE
C
      if(mxhach.ge.999) goto 732
C ---   INITIALIZE STACK POINTER ---
        jstack=1
C ---   INITIALIZE STACK POSITION HOLDING POINTER ---
        kstack=0
   85   if(jstack.gt.nstack) go to 95
          if(tal(1,jstack).lt.xamin) goto 741
          if(tal(1,jstack).gt.xamax) goto 741
          if(tal(2,jstack).lt.yamin) goto 741
          if(tal(2,jstack).gt.yamax) goto 741
      if(inside(xa,ya,joff,tal(1,jstack),tal(2,jstack)).ne.0) then
C ---       PRESENT STACK IS CONTAINED IN PRESENT LOW CLOSURE ---
            if(kstack.eq.0) then
C ---         SET STACK POSITION HOLDING POINTER ---
              kstack=jstack
            else
C ---         MERGE STACKS BY SETTING MAXIMUM STACK LEVEL IN
C             FIRST STACK POSITION ---
              if(istack(jstack).gt.istack(kstack))
     1         istack(kstack)=istack(jstack)
C ---         ELIMINATE SECOND STACK AFTER MERGE ---
              nstack=nstack-1
              do 90 j=jstack,nstack
                j1=j+1
                istack(j)=istack(j1)
                tal(1,j)=tal(1,j1)
                tal(2,j)=tal(2,j1)
   90         continue
              jstack=jstack-1
            end if
          end if
C ---     INCREMENT STACK POINTER ---
  741     jstack=jstack+1
        go to 85
   95   continue
        if(kstack.eq.0) then
C ---     BEGIN A NEW CLOSURE STACK ---
          nstack=nstack+1
          kstack=nstack
          istack(kstack)=1
          tal(1,kstack)=xa(2)
          tal(2,kstack)=ya(2)
        else
C ---     ADD NEW LEVEL TO EXISTING CLOSURE STACK ---
          istack(kstack)=istack(kstack)+1
        end if
C ---   IF CONTOUR DOES NOT QUALIFY THEN DO NOT COUNT IT ---
        if(conlen.lt.glim) istack(kstack)=istack(kstack)-1
C ---   WRITE OUT CLOSURE LEVEL AND POINTER LOCATIONS ---
        level=istack(kstack)
  731   write(dsk2,rec=ll) conval,conlen,ibeg,iend,level
C ---   FIND POINTER OF NEXT LOWEST AND SHORTEST CLOSURE ---
  732   ll=lpoint(ll)
  105 continue
C
C________________________________________________________________
C
C     ENTRY  H C O N P L
C________________________________________________________________
C
C ENTRY HCONPL CALLS AND CONTROLS BCONPL, THE SUBROUTINE
C WHICH DRAWS CONTOUR LINES, LABELS, AND HACHER TICKS.
C
      entry hconpl
  600 close(unit=dsk5)
C
C DETERMINE IF HACHERS ARE TO BE MADE
C
      if(nohach) goto 601
C
C FROM THE FILE WHICH CONTAINS ONE ENTIRE CLOSURE PER RECORD
C READ THE BEGINNING AND ENDING POINTERS FOR THE FILE WHICH
C CONTAINS ONE TRACE PER RECORD
C
      do 38 k=1,ist2
        read(dsk2,rec=k) dum1,dum2,ibeg,iend,level
C ---   DETERMINE IF THE LEVEL IS WITHIN ACCEPTABLE LIMITS ---
        if(level.le.mxhach) then
C
C FROM THE FILE WHICH CONTAINS ONE TRACE PER RECORD READ THE
C BEGINNING AND ENDING POINTERS FOR THE ARRAY WHICH CONTAINS THE
C TRACE SEGMENTS
C
          do 37 j=ibeg,iend
            read(dsk1,rec=j) nsrec,jsrec,contlb,linet1,ipost1,
     1       size1
            write(dsk1,rec=j) -1*nsrec,jsrec,contlb,linet1,
     1       ipost1,size1
   37     continue
        end if
   38 continue
  601 close(unit=dsk2)
      call bconpl(dsk1,ist,nparm,iparm,xa,ya,conlim,
     1 bspace,glen,gspace)
C
C RETURN TO CALLING ROUTINE
C
      close(unit=dsk1)
      call megacl(dsk4)
  699 return
      end
C
C________________________________________________________________
C
C     SUBROUTINE  H A C H
C________________________________________________________________
C
C SUBROUTINE HACH DRAWS HACHER MARKS ON LINES WHEN CALLED BY A
C PROGRAM USING THE RON WAHL PLOT SYSTEM.
C FOLLOWING IS A DESCRIPTION OF THE PASSED VARIABLES.
C
C   X,Y    - REAL*4. ARRAYS CONTAINING X AND Y LOCATIONS FOR THE
C            POINTS IN A SEGMENT OF THE CONTOUR TO BE HACHURED.
C            THE LOW SIDE IS ASSUMED TO BE ON THE RIGHT (HACHURE
C            TICS WILL BE PLACED ON THE RIGHT SIDE OF THE LINE).
C            IF THE SEGMENT IS SUPPOSED TO BE CLOSED THE FIRST
C            POINT MUST BE THE SAME AS THE LAST.
C   NPTS   - INTEGER*4.  THE NUMBER OF POINTS IN THE SEGMENT.
C   SDIST  - REAL*4.  THE CURRENT LENGTH OF THE CONTOUR.
C            (I.E. PREVIOUS SEGMENTS MAY HAVE ALREADY BEEN DRAWN)
C   HDIST  - REAL*4.  THE CURRENT LENGTH ALONG THE CONTOUR FROM
C            THE BEGINNING TO THE FIRST HACHURE TIC ON THIS
C            SEGMENT.  HDIST MUST BE GREATER THAN OR EQUAL TO
C            SDIST.
C   HLEN   - REAL*4.  LENGTH (IN MAP INCHES) OF THE HACHERS TICS.
C   HSPACE - REAL*4.  DISTANCE (IN MAP INCHES) BETWEEN HACHER
C            TICS.
C   LINETP - INTEGER*4.  A NUMBER DESIGNATING THE LINE TYPE OF
C            THE HACHURE TICS.
C
C SUBROUTINE HACH WRITTEN BY ROB BRACKEN, USGS, 24MAR87
C
C
      subroutine hach(x,y,npts,sdist,hdist,hlen,hspace,linetp)
      save
C
C VARIABLE DECLARATION
C
      real*4 x(1),y(1)
      real*4 xh(2),yh(2)
C
C CHECK, ADJUST, AND INITIALIZE VARIABLES
C
C --- CHECK HACHURE TIC SPACING ---
      if(hspace.lt.1.e-30) goto 199
C --- ADVANCE HACHURE TIC DISTANCE TO WITHIN ONE TIC SPACING
C     BEYOND CURRENT DISTANCE ---
  105 if(sdist.gt.hdist) then
        hdist=hdist+hspace
        goto 105
      end if
C --- INITIALIZE INDEX OF CURRENT POINT ALONG SEGMENT ---
      j=1
C
C FOLLOW SEGMENT TO ONE POINT BEYOND NEXT HACHER TIC
C
  106 if(sdist.gt.hdist) go to 107
        j=j+1
C ---   EXIT IF NO MORE POINTS IN SEGMENT ---
  104   if(j.gt.npts) goto 199
C ---   FIND DISTANCE BETWEEN CURRENT AND PREVIOUS POINT ---
        dx=x(j-1)-x(j)
        dy=y(j-1)-y(j)
        ds=sqrt(dx*dx+dy*dy)
        if(ds.lt.1.e-30) then
C ---     ELIMINATE DUPLICATE POINT ---
          npts=npts-1
          do 10 i=j,npts
            x(i)=x(i+1)
            y(i)=y(i+1)
   10     continue
          goto 104
        end if
C ---   INCREMENT CURRENT CONTOUR DISTANCE ---
        sdist=sdist+ds
      go to 106
  107 continue
C
C PUT ONE HACHURE TIC ON SEGMENT
C
C --- FIND POSITION ON CONTOUR LINE ---
      t=(sdist-hdist)/ds
      xh(1)=dx*t+x(j)
      yh(1)=dy*t+y(j)
C --- FIND DIRECTION OF PERPENDICULAR TO CONTOUR ---
      cosi=dx/ds
      sine=dy/ds
      cosip=-1*sine
      sinep=cosi
C --- FIND POSITION HLEN AWAY FROM CONTOUR.  ON RIGHT SIDE
C     LOOKING ALONG CONTOUR LINE (OR ON LEFT LOOKING BACK) ---
      xh(2)=cosip*hlen+xh(1)
      yh(2)=sinep*hlen+yh(1)
C
C................................................................
C
C     CALL TO PLOT SYSTEM -- LINE PLOTTING ROUTINE
C
      if(linetp.gt.99) then
      lintp=mod(linetp,100)
      else
      lintp=linetp
      endif
      call line(xh,yh,2,0,lintp)
C
C ...............................................................
C
C --- INCREMENT HACHURE TIC DISTANCE TO NEXT TIC POSITION ---
      hdist=hdist+hspace
      goto 106
C
C RETURN TO CALLING ROUTINE
C
  199 return
      end
C
C________________________________________________________________
C
C   SUBROUTINE  F E E D
C________________________________________________________________
C
C SUBROUTINE FEED STORES CONTOUR LINE SEGMENTS IN A SEQUENTIAL
C FILE UNTIL THEY ARE DISCARDED OR USED FOR HACHER POSTITIONS.
C
C   X      - REAL*4 ARRAY.  ARRAY OF CONTOUR LINE SEGMENT
C                           X POSITIONS.
C   Y      - REAL*4 ARRAY.  Y POSITIONS.
C   NPTS   - INTEGER*4.  NUMBER OF POINTS IN SEGMENT.
C   IC     - INTEGER*4.  0=BEGIN NEW SEGMENT.  1=CONTINUE FROM
C            PREVIOUS SEGMENT.
C   LINETP - INTEGER*4.  TYPE OF LINE:  PLOT SYSTEM DEPENDANT
C            -999 - SEGMENT IS NOT TO BE PLOTTED
C   ISEGTP - INTEGER*4.  TYPE OF SEGMENT:  1=MID LINE,
C            2=BEFORE GRADIENT FLAG,  3=END OF TRACE,
C            11-13 = BEFORE A LABEL,  21-23 = AFTER A LABEL.
C            31-33 = IMMEDIATELY AFTER A LABEL.
C            41-43 = POINTS REMOVED FOR THE LABEL.
C            100+KK = SEGMENT INCLUDES KK FOLLOWING SEGMENTS
C
C
      subroutine feed(x,y,npts,ic,linetp,isegtp)
      save
C
C VARIABLE DECLARATION
C
      integer*4 dsk4
      parameter(dsk4=17,nparm=5)
      real*4 x(1),y(1)
      integer*4 iparm(nparm)
      common /eggchu/ jemeg,nohach,noclim,nodelb,nohen
      common /setxy/ xx(2),yy(2),xp1(4),yp1(4),iplotr,sizel,
     & ncharx,nchary,sizex,sizey,adelx,adely,pllx,plly,
     & lintx,linty,xscale,yscale,xxscal,yyscal,mscale,delx,dely
      common/pltcom/npens
      logical*4 nohach,noclim,nodelb,nohen
C
C DETERMINE IF HACHERS ARE TO BE MADE OR MINIMUM CONTOUR LENGTH
C HAS BEEN SPECIFIED
C
      if(nohen) then
C
C................................................................
C
C       CALL TO PLOT SYSTEM -- LINE PLOTTING ROUTINE
C
        if(iplotr.eq.5) then
        ipen=(linetp-mod(linetp,100))/100
        if(ipen.lt.1) ipen=1
        if(ipen.gt.npens) ipen=npens
        call newpen(ipen)
        endif
      if(linetp.gt.-999) then
      if(linetp.gt.99) then
      lintp=mod(linetp,100)
      else
      lintp=linetp
      endif
      call line(x,y,npts,ic,lintp)
      endif
C
C................................................................
C
        goto 299
      end if
C
C WRITE TO FILE AND INCREMENT COUNTER
C
      j=jemeg
      jemeg=jemeg+nparm+npts+npts
      iparm(1)=jemeg
      iparm(2)=npts
      iparm(3)=ic
      iparm(4)=isegtp
      iparm(5)=linetp
      call megawr(j,nparm,iparm)
      j=j+nparm
      call rmegaw(j,npts,x)
      j=j+npts
      call rmegaw(j,npts,y)
  299 return
      end
C
C________________________________________________________________
C
C     SUBROUTINE   S O R T I L
C________________________________________________________________
C
c  Hart modification to Wooodrum sort from Creative Computing
c  1978,vol 4,no. 1,p. 96-101.
c  Translated to FORTRAN by R.R. Wahl UTR Branch
c  US Geol. Survey, Denver, CO
c
c     modified by r.godson,usgs
c     to handle multi-dimensioned input arrays
c     and return sorted data in another array
c     equivalent in size to the input array    
c
c     return array option is deleted in this version
c
C
C  DESCRIPTION OF PASSED VARIABLES:
C
C     AIN    - REAL*4.  2 DIMENSIONAL INPUT UNSORTED ARRAY.
C     IDIM   - INTEGER*4.  FIRST DIMENSION OF AIN.
C     JDIM   - INTEGER*4.  SECOND DIMENSION OF AIN.
C     NSORT  - INTEGER*4.  NUMBER OF COLUMNS TO SORT.
C     IKEY   - INTEGER*4.  1 DIMENSIONAL ARRAY CONTAINING A LIST
C              OF KEY FIELDS (ROW NUMBERS, FIRST INDEX) TO SORT
C              FROM MAJOR TO MINOR.
C     NKEY   - INTEGER*4.  THE NUMBER OF KEY FIELDS.
C     LNK    - INTEGER*4.  1 DIMENSIONAL OUTPUT LINK ARRAY.
C              AIN(ISORT,LNK(NSORT+1)) = LEAST VALUE.
C              AIN(ISORT,LNK(LNK(NSORT+1))) = SECOND LEAST VALUE.
C     LDIM   - INTEGER*4.  DIMENSION OF LINK ARRAY.
C              MINIMUM LDIM = NSORT + LN( NSORT-2 ) + 2
C     IER    - INTEGER*4.  ERROR INDICATOR.  0 = SUCCESSFUL RUN.
C              1 = LESS THAN 2 ELEMENTS TO SORT.  2 = NOT ENOUGH
C              WORK SPACE IN LINK ARRAY.
C
C
      subroutine sortil(ain,idim,jdim,
     1                  nsort,ikey,nkey,lnk,ldim,ier)
C
      real ain
      dimension ain(idim,jdim),lnk(ldim),ikey(nkey)
c
      ier=0
      if (nsort.le.1)  go to 1000
      mt=nsort+ifix(alog(float(nsort))/.69314718+.5)+2
      if (ldim.lt.mt)  go to 1010
c
c  Initialize variables
      k1=0
      i=0
      m1=0
      it2=0
      it4=0
c     Head of sequence 1
      j=nsort+1
      lnk(1)=1
      lnk(j)=1
      k2=1
c     Number of leaves
      nleav=nsort
c
c  Climb the tree
  250 continue
c     Low-order twig value
      if (nleav.lt.4)  go to 320
      ib2=nleav/2
      it4=it4+k2*(nleav-2*ib2)
      nleav=ib2
c     Total number of twigs at an altitude
      k2=k2*2
      go to 250
c
c  Initial calculations
  320 continue
c     Number of low-order twigs
      it4=k2-it4
c     High bit value of binary counter
      ib2=k2/2
c
c  Next twig
  350 continue
c     Exit -- sort complete
      if (k1.eq.k2)  go to 940
c     Twig number
      k1=k1+1
      it1=k1
c     High bit value
      ib1=ib2
c     Previous reflected twig number
      it3=it2
c
c  Add 1 to reflected binary counter and carry
  400 continue
c     Any more carries
      it1s=it1/2
      if (2*it1s.lt.it1)  go to 470
      it1=it1s
c     Number of merges
      m1=m1+1
      it2=it2-ib1
c     Next bit value
      ib1=ib1/2
c     Carry one
      go to 400
c
c  Twig calculations
  470 continue
c     Reflected twig number
      it2=it2+ib1
c     2-twigs and 3-twigs
      if (nleav.eq.2)  go to 550
c
c  3-twigs and 4-twigs
c     low-order twig (3-twig)
      if (it3.lt.it4)  go to 560
c
c  4-twig
c     Dis-engage number of merges
      m1=-m1
      go to 630
  550 continue
c     Low-order twig (2-twig)
      if (it3.lt.it4)  go to 610
c
c  3-twig
  560 continue
c     Number of merges
      m1=m1+1
c     Next leaf
      i=i+1
c     Generate a leaf
      lnk(i)=i
      lnk(j)=i
c     Generate next sequence head
      j=j+1
c
c  2-twig
  610 continue
c     Number of merges
      m1=m1+1
  630 continue
c     Next leaf
      i=i+1
c     Generate a new leaf
      l1=i
      lnk(i)=i
      lnk(j)=i
c     Head of older leaf (last line)
      l0=j
c     Head of latest leaf (next two lines)
      j=j+1
c     Next leaf
      i=i+1
c     Generate a leaf
      l2=i
      lnk(i)=i
      lnk(j)=i
c     Merge leaves
      go to 750
c
c  Merge twigs and branches
  700 continue
c     Head of latest branch or twig
      j=j-1
c     Head of older branch or twig
      l0=j-1
c     Head of sequence 1
      l1=lnk(l0)
c     Head of sequence 2
      l2=lnk(j)
  750 continue
c     Stay in sequence 1
C
      kkey=1
  763 if(ain(ikey(kkey),l1)-ain(ikey(kkey),l2)) 820,762,761
  762 kkey=kkey+1
      if(kkey.le.nkey) goto 763
      goto 820
  761 continue
C
C      if (ain(isort,l1).le.ain(isort,l2))  go to 820
c     Switch to sequence 2
      lnk(l0)=l2
  770 continue
c     Top leaf in sequence 2
      l0=l2
c     Next leaf in sequence 2
      l2=lnk(l0)
c     End of sequence 2
      if (l2.eq.l0)  go to 870
c     Stay in sequence 2
C
      kkey=1
  783 if(ain(ikey(kkey),l1)-ain(ikey(kkey),l2)) 781,782,770
  782 kkey=kkey+1
      if(kkey.le.nkey) goto 783
  781 continue
C
C      if (ain(isort,l1).gt.ain(isort,l2))  go to 770
c     Switch to sequence 1
      lnk(l0)=l1
  820 continue
c     Top leaf in sequence 1
      l0=l1
c     Next leaf in sequence 2
      l1=lnk(l0)
c     Not end of sequence 1
      if (l1.ne.l0)  go to 750
c     Switch to sequence 2
      lnk(l0)=l2
      go to 880
  870 continue
c     Switch to sequence 1
      lnk(l0)=l1
  880 continue
c     Number of merges
      m1=m1-1
      if (m1.gt.0)  go to 700
      if (m1.eq.0)  go to 350
c
c  Generate second half of 4-twig
c     Re-engage number of merges
      m1=1-m1
      go to 630
c
c  All done
c
c     sort output array
c
  940 ll=lnk(nsort+1)
c      do 960 i=1,nsort
c      do 950 j=1,jdim
c      aout(i,j)=ain(ll,j)
c  950 continue
c      ll=lnk(ll)
c  960 continue
  970 return
c     Less than two elements to sort
 1000 ier=1
      lnk(nsort+1)=nsort
      lnk(nsort)=nsort+1
      go to 970
c     Not enough work space in link array
 1010 ier=2
      go to 970
      end
C
C________________________________________________________________
C
C     SUBROUTINE  B I N S R C
C________________________________________________________________
C
C SUBROUTINE BINARY SEARCH USES A BINARY WALK TO SEARCH FOR
C MINIMUM AND MAXIMUM LIMITS IN A PRESORTED ARRAY.
C
C    ARRAY  - REAL*4.  A PRE-SORTED ARRAY CONTAINING VALUES OF
C             WHICH TO FIND THE POSITIONS.
C    NPTS   - INTEGER*4.  NUMBER OF POINTS IN ARRAY.
C    KEY    - INTEGER*4.  THE KEY FIELD TO SEARCH.
C    AMIN   - REAL*4.  THE VALUE OF THE LOWER LIMIT.
C    AMAX   - REAL*4.  THE VALUE OF THE UPPER LIMIT.
C    IMIN   - INTEGER*4.  THE POSITION IN ARRAY IMMEDIATELY
C             BEFORE AMIN.  IF IMIN IS GREATER THAN NPTS THEN ALL
C             VALUES IN ARRAY ARE LESS THAN AMIN.  IF IMIN IS
C             LESS THAN 1 THEN ALL VALUES IN ARRAY ARE GREATER
C             THAN AMIN.
C    IMAX   - INTEGER*4.  THE POSITION IN ARRAY IMMEDIATELY
C             AFTER AMAX.  IF IMAX IS GREATER THAN NPTS THEN ALL
C             VALUES IN ARRAY ARE LESS THAN AMAX.  IF IMAX IS
C             LESS THAN 1 THEN ALL VALUES IN ARRAY ARE GREATER
C             THAN AMAX.
C
C SUBROUTINE BINSRC WRITTEN BY ROB BRACKEN, USGS, 5MAY87.
C
C
      subroutine binsrc(array,npts,key,amin,amax,imin,imax)
      save
C
      real*4 array(2,*)
C
C FIND IMIN
C
C --- FIND POWER OF 2 LIMIT FOR IMIN ---
      limit=1
  104 if(limit.gt.npts) goto 101
      if(array(key,limit).ge.amin) goto 101
      limit=limit*2
      goto 104
C --- SET UP BEGINNING IMIN IN STRATIGIC LOCATION ---
  101 ndiff=limit/4
      imin=limit-ndiff
C --- SET DISTANCE TO WALK ON THE NEXT STEP ---
  102 ndiff=ndiff/2
      if(ndiff.lt.1) goto 103
C --- DETERMINE DIRECTION OF WALK AND MAKE A STEP ---
      if(imin.gt.npts) then
        imin=imin-ndiff
      else if(array(key,imin).ge.amin) then
        imin=imin-ndiff
      else
        imin=imin+ndiff
      end if
      goto 102
C --- CLEAN UP EDGE EFFECTS ---
  103 if(imin.gt.npts) then
        imin=npts
      else if(imin.lt.1) then
        imin=1
      end if
      if(array(key,imin).ge.amin) imin=imin-1
      if(imin.eq.npts) then
        imax=npts+1
        goto 199
      end if
C
C FIND IMAX
C
C --- FIND POWER OF 2 LIMIT FOR IMAX ---
      if(limit.ge.2) limit=limit/2
  114 if(limit.gt.npts) goto 111
      if(array(key,limit).gt.amax) goto 111
      limit=limit*2
      goto 114
C --- SET UP BEGINNING IMAX IN STRATIGIC LOCATION ---
  111 ndiff=limit/4
      imax=limit-ndiff
C --- SET DISTANCE TO WALK ON THE NEXT STEP ---
  112 ndiff=ndiff/2
      if(ndiff.lt.1) goto 113
C --- DETERMINE DIRECTION OF WALK AND MAKE A STEP ---
      if(imax.gt.npts) then
        imax=imax-ndiff
      else if(array(key,imax).gt.amax) then
        imax=imax-ndiff
      else
        imax=imax+ndiff
      end if
      goto 112
C --- CLEAN UP EDGE EFFECTS ---
  113 if(imax.gt.npts) then
        imax=npts
      else if(imax.lt.1) then
        imax=1
      end if
      if(array(key,imax).le.amax) imax=imax+1
      if(imax.eq.1) imin=0
C
C EXIT PROCEDURE
C
  199 return
      end
C
C________________________________________________________________
C
C     SUBROUTINE  B C O N P L 
C________________________________________________________________
C
C SUBROUTINE B CONTOUR PLOT IS DESIGNED TO FIND WHETHER OR NOT
C THE CONTOUR LINES ARE LONGER THAN THE MINIMUM CONTOUR LENGTH
C (CONLIM) AND PLOT THEM.  SHORTER CONTOUR LINES WILL NOT BE
C PLOTTED.  LABELS AND HACHURE TICS WILL BE ADDED TO THE CONTOUR
C LINES WHEN APPROPRIATE.
C
C   IUNIT  - INTEGER*4.  THE UNIT NUMBER OF THE DEVICE TO READ
C            ARRAY POINTERS FROM.
C   IST    - INTEGER*4.  THE TOTAL NUMBER OF POINTERS TO READ
C            FROM IUNIT.
C   NPARM  - INTEGER*4.  THE NUMBER OF PARAMETERS TO READ BEFORE
C            EACH LINE SEGMENT.
C   IPARM  - INTEGER*4.  THE ARRAY CONTAINING THE PARAMETERS.
C   X,Y    - REAL*4.  ARRAYS CONTAINING THE X AND Y COORDINATES
C            FOR THE POINTS IN THE SEGMENTS.
C   CONLIM - REAL*4.  THE MINIMUM ALLOWABLE LENGTH FOR A
C            CONTINUOUS CONTOUR SEGMENT.
C   BSPACE - REAL*4.  THE DESIRED DISTANCE IN MAP INCHES BETWEEN
C            CONTOUR LABELS.
C   GLEN   - REAL*4.  THE LENGTH OF HACHURE TICS.
C   GSPACE - REAL*4.  THE DISTANCE BETWEEN HACHURE TICS.  IF
C            GSPACE=0. HACHURE TICS WILL NOT BE MADE AT ALL.
C
C SUBROUTINE BCONPL WRITTEN BY ROB BRACKEN, USGS, 13MAY87
C
C
      subroutine bconpl(iunit,ist,nparm,iparm,x,y,conlim,
     1 bspace,glen,gspace)
      save
C
C VARIABLE DECLARATION
C
      common /concom/ ncol,nrow,bmin,bmax,
     & grad,gflg,ijs,ije,ijsi,ijei,prime,ij4,cont,
     & fltmax,lmult(0:3),idashs,linet,sigma,nsig
      common /labcom/ dum1(11),size,dum2(4)
      integer*4 iparm(1)
      real*4 x(1),y(1)
      parameter(ddval=1.1e+38,dval=1.0e+37,tol=1.e-3)
      logical*4 post,post2
      common/captur/icapt
C
C INITIALIZE VARIABLES
C
C --- LENGTH OF PREVIOUS SEGMENT ---
      tlen=0.
C --- BEGINNING POINT FOR CURRENT SEGMENT ---
      x0=ddval
      y0=ddval
C --- BEGINNING INDEX OF NEXT SEGMENT ---
      ib=1
C --- ENDING INDEX OF PREVIOUS SEGMENT ---
      ie=ib-1
C
C READ POINTERS FROM IUNIT
C
      do 30 i=1,ist
        read(iunit,rec=i) nsrec,jsrec,contlb,linetp,post,size2
        if(nsrec.lt.0) then
C ---     HACHURES ARE TO BE MADE ---
          nsrec=-1*nsrec
          hspac=gspace
        else
C ---     HACHURES ARE NOT TO BE MADE ---
          hspac=0.
        end if
C ---   INITIALIZE ARRAY POINTER FOR SECTION OF SEGMENTS ---
        iptr=nsrec
C
C EXAMINE CONTOUR SEGMENTS
C
    5   if(iptr.ge.jsrec) go to 30
          call megard(iptr,nparm,iparm)
C ---     SET POINTER FOR NEXT SEGMENT ---
          jptr=iparm(1)
          isegtp=iparm(4)
C ---     SKIP UNACCEPTABLE SEGMENTS ---
          if(isegtp.ge.30) goto 101
C ---     READ IN ACCEPTABLE SEGMENTS ---
          iptr2=iptr+nparm
          npts=iparm(2)
          call rmegar(iptr2,npts,x(ib))
          call rmegar(iptr2+npts,npts,y(ib))
          ic=iparm(3)
          if(ic.eq.0.and.
     1     (abs(x(ib)-x0).gt.tol.or.abs(y(ib)-y0).gt.tol)) then
c          if(ic.eq.0.and.(x(ib).ne.x0.or.y(ib).ne.y0)) then
C ---       SEGMENT DOES NOT JOIN WITH PREVIOUS SEGMENT ---
            if(tlen.gt.conlim) then
              if(icapt.ne.0) then
              write(23,1200) cont
 1200         format('contour value = ',f15.7)
              write(22,1000) cont,ie
 1000         format('contour value = ',f15.7,
     &        ' number of points = ',i10)
              write(*,1050) cont,ie
 1050         format(' writing contour value = ',f15.7,
     &        ' number of points = ',i10)
              write(22,1100) (x(k),y(k),k=1,ie)
 1100         format(8f10.3)
C ---         PLOT PREVIOUS SEGMENT ---
              else
              call dconlb(x,y,ie,post2,bspace,hspac)
              endif
            end if
C ---       RE-INITIALIZE TOTAL LENGTH ---
            tlen=0.
C ---       RE-INITIALZE BEGINNING POINT ---
            x0=x(ib)
            y0=y(ib)
C ---       SLIDE CURRENT SEGMENT TO BEGINNING OF X,Y ARRAY ---
            if(ie.gt.0) then
              do 10 j=1,npts
                x(j)=x(j+ie)
                y(j)=y(j+ie)
   10         continue
            end if
C ---       RE-INITIALIZE BEGINNING AND ENDING INDICES ---
            ib=1
            ie=ib-1
C ---       SET CONTOUR LEVEL, LINE TYPE, AND HACHURE PARMS ---
            size=size2
            call setcon(contlb,linetp,glen,hspac)
            post2=post
          end if
          if(x0.ge.dval.and.y0.ge.dval) then
C ---       RE-INITIALIZE BEGINNING POINT IF FIRST SEGMENT ---
            x0=x(1)
            y0=y(1)
          end if
C ---     FIND LENGTH OF CURRENT SEGMENT ---
          do 20 k=ib,ie+npts
            if(tlen.gt.conlim) goto 102
            dx=x(k)-x0
            dy=y(k)-y0
            ds=sqrt(dx*dx+dy*dy)
            tlen=tlen+ds
            x0=x(k)
            y0=y(k)
   20     continue
C ---     INCREMENT BEGINNING AND ENDING INDICES ---
  102     ib=ib+npts
          ie=ib-1
C ---     SET X0 AND Y0 TO END OF CURRENT SEGMENT ---
          x0=x(ie)
          y0=y(ie)
C ---     MOVE POINTER TO NEXT SEGMENT ---
  101     iptr=jptr
        go to 5
   30  continue
C --- PLOT LAST SEGMENT ---
      if(tlen.gt.conlim) then
              if(icapt.ne.0) then
              write(23,1200) cont
              write(22,1000) cont,ie
              write(*,1050) cont,ie
              write(22,1100) (x(k),y(k),k=1,ie)
              else
              call dconlb(x,y,ie,post2,bspace,hspac)
              endif
      end if
C
C RETURN TO CALLING ROUTINE
C
      return
      end
C
C________________________________________________________________
C
C     SUBROUTINE  D C O N L B
C________________________________________________________________
C
C SUBROUTINE DCONLB IS A DRIVER FOR CONLAB.  IT USES CONLAB TO
C PUT LABELS ON THE CONTOURS AT INTERVALS ACCORDING TO PARAMETER
C BSPACE.
C
C   X,Y    - REAL*4.  ARRAY CONTAINING THE X & Y LOCATIONS.
C   NPTS   - INTEGER*4.  TOTAL NUMBER OF POINTS IN X & Y.
C   POST   - LOGICAL*4.  IF POST IS TRUE CONTOURS WILL BE LABELED
C            OTHERWISE THEY WILL NOT.
C   BSPACE - REAL*4.  DESIRED DISTANCE BETWEEN CONTOUR LABELS.
C   HSPACE - REAL*4.  EXACT DISTANCE BETWEEN HACHURE TICS.
C
C *** NOTE - ENTRY SETCONLAB MUST BE CALLED BEFORE DCONLAB ***
C
C SUBROUTINE DCONLB WRITTEN BY ROB BRACKEN, USGS, 19MAY87.
C
C
      subroutine dconlb(x,y,npts,post,bspace,hspace)
      save
c
      common /labcom/ dum1(12),wdist,dum2(3)
      real*4 x(1),y(1)
      logical*4 post,post2
      data distl2 /0./
c
      ibeg=1
      icc=0
      post2=post
      distl=distl2*distl2
      sdist=0.
      hdist=hspace*.5
c
  101 call conlab(x,y,ibeg,npts,icc,post2,distl,dista,ie,
     1 sdist,hdist)
      if(post2) then
        ibeg=ie
        post2=post
        distl=bspace*bspace
        goto 101
      else if(post) then
        if(distl2.lt.bspace) then
          distl2=distl2+1.5*wdist
        else
          distl2=0.
        end if
      end if
      return
      end
C
C________________________________________________________________
C
C     SUBROUTINE  C O N L A B
C________________________________________________________________
C
C SUBROUTINE CONLAB IS A MODIFIED VERSION OF SUBROUTINE
C LABEL (IN CONTOUR).  THE MODIFICATIONS INCLUDE:  A) PLOTTING
C ONLY THE FIRST CONTOUR LINE BEFORE THE LABEL, B) CALLING A
C HACHURING ROUTINE TO PUT HACHURE TICKS ON THE PLOTTED LINE,  C)
C RETURNING THE LENGTH ALONG THE FIRST LINE FROM THE BEGINNING
C TO THE RIGHT SIDE OF THE LABEL, AND  D) ADDING THE EXTRA POINT
C TO THE ARRAY BEFORE THE AFTER LABEL LINE AND RETURNING ITS
C LOCATION.
C
C   X,Y    - REAL*4.  ARRAYS OF CONTOUR LINE X & Y LOCATIONS.
C   IBEG   - INTEGER*4.  THE POSITION (INDEX) IN X & Y OF THE
C            FIRST POINT TO BE CONSIDERED IN THE LABELING
C            PROCESS.  ALL PRECEDING POINTS WILL BE IGNORED.
C   NPTS   - INTEGER*4.  TOTAL NUMBER OF POINTS IN X & Y.
C   ICC    - INTEGER*4.  LINE CONTINUATION.  ICC=0 IS NO
C            CONTINUATION FROM LAST LINE.  ICC=1 IS CONTINUATION.
C            ALWAYS SET ICC TO 0 AND SUPPLY THE BEGINNING POINT
C            IN THE X & Y ARRAYS IF CONTINUATION IS DESIRED.
C   POST   - LOGICAL*4.  WHEN CALLING CONLAB IF POST IS TRUE
C            LABELS WILL BE PLOTTED.  IF POST IS FALSE LABELS
C            WILL NOT BE PLOTTED.  CONLAB SETS POST TO TRUE IF A
C            LABEL WAS ACTUALLY PLOTTED AND FALSE IF IT WAS NOT.
C   DISTL  - REAL*4.  DISTANCE TO FOLLOW CONTOUR LINE BEFORE
C            STARTING TO LOOK FOR A LABEL LOCATION.
C   DISTA  - REAL*4.  ACTUAL DISTANCE FROM THE BEGINNING OF THE
C            CONTOUR LINE TO THE FARTHEST RIGHT SIDE OF THE LABEL
C   IE     - INTEGER*4.  POSITION (INDEX) IN X & Y OF THE FIRST
C            POINT AFTER THE LABEL.  WARNING -- CONPLOT CHANGES
C            THE X & Y ARRAYS TO ADD AN EXTRA POINT IMMEDIATLY
C            AFTER THE LABEL.  THE NEW POINT IS IN POSITION IE.
C   SDIST  - REAL*4.  THIS PERTAINS ONLY TO THE HACHURING OPTION.
C            IT IS THE CURRENT DISTANCE FROM AN ARBITRARY
C            BEGINNING POSITION ALONG THE CONTOUR LINE.  IT WILL
C            BE ADDED TO WHEN HACHURE TICS ARE MADE.
C   HDIST  - REAL*4.  THIS PERTAINS ONLY TO THE HACHURING OPTION.
C            IT IS THE CURRENT DISTANCE (FROM THE SAME ARBITRARY
C            BEGINNING POSITION AS SDIST) TO THE NEXT HACHURE
C            TIC.  HDIST MUST BE GREATER THAN OR EQUAL TO SDIST.
C            IT WILL BE ADDED TO WHEN HACHURE TICS ARE MADE.
C
C *** NOTE -- CALL ENTRY SETLAB BEFORE CALLING CONLAB. ***
C
C USGS, 19MAY87
C
C
      subroutine conlab(x,y,ibeg,npts,icc,post,distl,dista,
     1 ie,sdist,hdist)
c
c  label scans contour line array looking for
c  a straight segment.
c  if found,  the contour is labelled.
c
      common /concom/ ncol,nrow,bmin,bmax,
     & grad,gflg,ijs,ije,ijsi,ijei,prime,ij4,cont,
     & fltmax,lmult(0:3),idashs,linet,sigma,nsig
      common /setxy/ xx(2),yy(2),xp1(4),yp1(4),iplotr,sizel,
     & ncharx,nchary,sizex,sizey,adelx,adely,pllx,plly,
     & lintx,linty,xscale,yscale,xxscal,yyscal,mscale,delx,dely
      common/labcom/ lchars(6),fmtc,nchar,size,wdist,wdist2,ccor,
     1 delb
      common/pltcom/npens
c
      dimension x(1),y(1)
      character fmtc*16,chars*24
      logical nolab,post,prime
      equivalence (f,sum),(isa,ya),(lchars,chars)
c
c setup for H-P plotters
c
      if(iplotr.eq.5) then
      ipen=(linet-mod(linet,100))/100
      if(ipen.lt.1) ipen=1
      if(ipen.gt.npens) ipen=npens
      call newpen(ipen)
      endif
c
c setup and scan
c
  100 is0=ibeg
      dista=0.
      nolab=.not.(post.and.nchar.gt.0.and.size.gt.0.)
      if (nolab) go to 50
c
c      do  5 is0=is0,npts-1
c        if(dista.ge.distl) goto 101
c        dx=x(is0+1)-x(is0)
c        dy=y(is0+1)-y(is0)
c        dista=dista+sqrt(dx*dx+dy*dy)
c    5 continue
c      goto 50
c
  101 is=is0+1
      isa=is+1
      sum=0.0
      in1=is
      ie=npts-1
      if (ie.lt.isa) go to 50
      xb=x(is)
      yb=y(is)
      do 40 i=isa,ie
      sum=sum+sqrt((x(i)-x(in1))**2+(y(i)-y(in1))**2)
   10 dist=(x(i)-xb)**2 + (y(i)-yb)**2
      if (dist.lt.wdist2) go to 30
      dist=sqrt(dist)
      if ((sum/dist).gt.1.02) go to 20
      if((xb-x(ibeg))**2+(yb-y(ibeg))**2.lt.distl) goto 20
      ie=i
      go to 60
   20 is=is+1
      sum=sum-sqrt((x(is)-xb)**2+(y(is)-yb)**2)
      xb=x(is)
      yb=y(is)
      if (is.lt.i) go to 10
   30 in1=i
   40 continue
      if(ibeg.eq.1.and.distl.gt.0) then
        distl=0.
        goto 100
      end if
c
c  can't fine spot, continue line without labelling.
   50 post=.false.
      npts2=npts-ibeg+1
C
C................................................................
C
C     CALL TO PLOT SYSTEM -- LINE PLOTTING ROUTINE
C
      ibeg2=ibeg
      ic=icc
   51 if(ibeg2+100.lt.npts) then
      if(linet.gt.99) then
      lintp=mod(linet,100)
      else
      lintp=linet
      endif
        call line(x(ibeg2),y(ibeg2),101,ic,lintp)
        ibeg2=ibeg2+100
        ic=0
        goto 51
      else
      if(linet.gt.99) then
      lintp=mod(linet,100)
      else
      lintp=linet
      endif
        call line(x(ibeg2),y(ibeg2),npts-ibeg2+1,ic,lintp)
      end if
C
C................................................................
C
      if(hspace.gt.1.e-30)
     1 call hach(x(ibeg),y(ibeg),npts2,sdist,hdist,hlen,hspace,
     2 linet)
c      do i=is0,npts-1
c        dx=x(i+1)-x(i)
c        dy=y(i+1)-y(i)
c        dista=dista+sqrt(dx*dx+dy*dy)
c      end do
      ie=npts
      go to 70
c
c  plottable location.
c
   60 post=.true.
      npts2=is-ibeg+1
C
C................................................................
C
C     CALL TO PLOT SYSTEM -- LINE PLOTTING ROUTINE
C
      ibeg2=ibeg
      ic=icc
   61 if(ibeg2+100.lt.is) then
      if(linet.gt.99) then
      lintp=mod(linet,100)
      else
      lintp=linet
      endif
        call line(x(ibeg2),y(ibeg2),101,ic,lintp)
        ibeg2=ibeg2+100
        ic=0
        goto 61
      else
      if(linet.gt.99) then
      lintp=mod(linet,100)
      else
      lintp=linet
      endif
        call line(x(ibeg2),y(ibeg2),is-ibeg2+1,ic,lintp)
      end if
C
C................................................................
C
      if(hspace.gt.1.e-30)
     1 call hach(x(ibeg),y(ibeg),npts2,sdist,hdist,hlen,
     2 hspace,linet)
      xa=x(ie)-x(in1)
      ya=y(ie)-y(in1)
      f=1.-(dist-wdist)/sqrt(xa*xa+ya*ya)
      xa=f*xa + x(in1)
      ya=f*ya + y(in1)
      phi=atan2(ya-yb,xa-xb)
      if (abs(phi).gt.1.5707963) phi=phi-sign(3.1415927,phi)
                call VCHAR(0.5*(xa+xb),0.5*(ya+yb),lchars,nchar,
     1                     2,size,phi,ccor,0.)
c
c      do i=is0,is
c        dx=x(i+1)-x(i)
c        dy=y(i+1)-y(i)
c        dista=dista+sqrt(dx*dx+dy*dy)
c      end do
c
c      dista=dista+sqrt((xa-x(is))**2+(ya-y(is))**2)
      ie=ie-1
      x(ie)=xa
      y(ie)=ya
c
   70 return
C
C________________________________________________________________
C
C     ENTRY  S E T C O N
C________________________________________________________________
C
c
c  entry to establish labeling character string.
c  must be called before CONLAB.
C
C   CONTLB - REAL*4.  VALUE OF CURRENT CONTOUR LEVEL.
C   LINETP - INTEGER*4.  NUMBER OF CURRENT LINE TYPE.
C   HLENG  - REAL*4.  LENGTH OF HACHURE TICS.
C   HSPAC  - REAL*4.  SPACING BETWEEN HACHURE TICS.  SETTING
C            HSPACE TO 0.E0 ELIMINATES HACHURE TIC PLOTTING.
C
      entry setcon(contlb,linetp,hleng,hspac)
C
      cont=contlb
      linet=linetp
      hlen=hleng
      hspace=hspac
C
C ADDITION MADE 20FEB87 TO ALLOW VARIABLE CONTOUR LINE LABEL
C FORMATS
C
      CALL FMTMOD(CONT,NCHAR,FMTC)
C
      write(chars,fmtc) cont
      wdist=(nchar+1)*size-.4*SIZE
      wdist2=wdist*wdist
      ccor=-.5*wdist+size
  199 return
      end
C****************************************************************
C
C________________________________________________________________
C
C     FUNCTION  I N S I D E
C________________________________________________________________
C
C FUNCTION INSIDE IS A LOGICAL FUNCTION WHICH IS TRUE WHEN A TEST
C POINT IS WITHIN THE BOUNDARIES OF A POLYGON AND FALSE WHEN THE
C TEST POINT IS OUTSIDE THE POLYGON. A POINT ON THE BOUNDARY IS
C CONSIDERED INSIDE.
C
C   X      - REAL*4 ARRAY.  X COORDINATES OF A POLYGON.
C   Y      - REAL*4 ARRAY.  Y COORDINATES
C   NPTS   - INTEGER*4.  NUMBER OF POINTS IN THE POLYGON.
C            (NOTE: THE FIRST AND LAST POINT OF THE POLYGON
C                   DO NOT NEED TO HAVE THE SAME COORDINATES.)
C   XTEST  - REAL*4.  X COORDINATE OF THE TEST POINT.
C   YTEST  - REAL*4.  Y COORDINATE
C
C FUNCTION INSIDE WRITTEN BY ROB BRACKEN, USGS, 31MAR87
C
C
       function inside(x,y,npts,xtest,ytest)
C
C VARIABLE DECLARATION
C
      logical*4  inedge
      real*4 x(1),y(1)
C
C INITIALIZE TEST POINT OUTSIDE POLYGON
C
      inside=0
C
C INITIALIZE EDGE MARKER OFF OF POLYGON BORDER LINE
C
      inedge=.false.
C
C INITIALIZE X-AXIS CROSSING COUNTER
C
      ncross=0
C
C INITIALIZE I (CURRENT POINTER) AND J (PREVIOUS POINTER)
C
      i=1
      j=npts
C
C POLYGON ENTRY PROCEDURE
C
      if(y(j)-ytest) 101,102,103
C --- POINT J BELOW X-AXIS ---
  101 if(y(i)-ytest) 111,130,120
C --- POINT J ON X-AXIS ---
  102 j=j-1
      if(j.lt.1) goto 130
      if(y(j)-ytest) 104,102,105
C --- X-AXIS APPROACHED FROM BELOW ---
  104 i=0
      if(x(npts)-xtest) 131,132,133
C --- X-AXIS APPROACHED FROM ABOVE ---
  105 i=0
      if(x(npts)-xtest) 141,142,143
C --- POINT J ABOVE X-AXIS ---
  103 if(y(i)-ytest) 110,140,121
C
C I BELOW X-AXIS. J ON OR ABOVE X-AXIS.
C
  110 if(x(i).gt.xtest) then
        if(x(j).ge.xtest) then
C ---     SEGMENT CROSSES POSITIVE X-AXIS ---
          ncross=ncross+1
          goto 111
        end if
      else
        if(x(j).lt.xtest) then
C ---     SEGMENT CROSSES NEGATIVE X-AXIS ---
          goto 111
        end if
      end if
C --- SEGMENT CROSSES X-AXIS VERY NEAR TEST POINT ---
C --- VECTOR PRODUCT:  POINT BELOW X POINT ABOVE ---
      vprod=(x(i)-xtest)*(y(j)-ytest)-(y(i)-ytest)*(x(j)-xtest)
      if(vprod.gt.0.) then
C ---   SEGMENT CROSSES POSITIVE X-AXIS ---
        ncross=ncross+1
      else if(vprod.eq.0.) then
C ---   SEGMENT CROSSES TEST POINT ---
        inedge=.true.
      end if
C --- FOLLOW POLYGON EDGE ---
  111 do 115 i=i+1,npts
        if(y(i).ge.ytest) then
          if(y(i).eq.ytest) goto 130
C ---     POINT I IS ABOVE X-AXIS ---
          j=i-1
          goto 120
        end if
  115 continue
      goto 190
C
C I ABOVE X-AXIS. J ON OR BELOW X-AXIS.
C
  120 if(x(j).gt.xtest) then
        if(x(i).ge.xtest) then
C ---     SEGMENT CROSSES POSITIVE X-AXIS ---
          ncross=ncross+1
          goto 121
        end if
      else
        if(x(i).lt.xtest) then
C ---     SEGMENT CROSSES NEGATIVE X-AXIS ---
          goto 121
        end if
      end if
C --- SEGMENT CROSSES X-AXIS VERY NEAR TEST POINT ---
C --- VECTOR PRODUCT:  POINT BELOW X POINT ABOVE ---
      vprod=(x(j)-xtest)*(y(i)-ytest)-(y(j)-ytest)*(x(i)-xtest)
      if(vprod.gt.0.) then
C ---   SEGMENT CROSSES POSITIVE X-AXIS ---
        ncross=ncross+1
      else if(vprod.eq.0.) then
C ---   SEGMENT CROSSES TEST POINT ---
        inedge=.true.
      end if
C --- FOLLOW POLYGON EDGE ---
  121 do 125 i=i+1,npts
        if(y(i).le.ytest) then
          if(y(i).eq.ytest) goto 140
C ---     POINT I IS BELOW X-AXIS ---
          j=i-1
          goto 110
        end if
  125 continue
      goto 190
C
C I ON X-AXIS.  J BELOW X-AXIS.
C
  130 if(x(i)-xtest) 131,132,133
C --- SEGMENT CROSSES TESTPOINT ---
  132 inedge=.true.
C --- POINT I ON NEGATIVE X-AXIS ---
  131 i=i+1
      if(i.gt.npts) goto 190
      if(y(i)-ytest) 111,135,121
C --- NEW POINT I ON X-AXIS ---
  135 if(x(i)-xtest) 131,132,134
C --- SEGMENT CROSSES TEST POINT ---
  134 inedge=.true.
C --- POINT I ON POSITIVE X-AXIS ---
  133 i=i+1
      if(i.gt.npts) goto 190
      if(y(i)-ytest) 111,136,137
C --- NEW POINT I ON X-AXIS ---
  136 if(x(i)-xtest) 132,132,133
C --- NEW POINT I CROSSES POSITIVE X-AXIS ---
  137 ncross=ncross+1
      goto 121
C
C I ON X-AXIS.  J ABOVE X-AXIS.
C
  140 if(x(i)-xtest) 141,142,143
C --- SEGMENT CROSSES TESTPOINT ---
  142 inedge=.true.
C --- POINT I ON NEGATIVE X-AXIS ---
  141 i=i+1
      if(i.gt.npts) goto 190
      if(y(i)-ytest) 111,145,121
C --- NEW POINT I ON X-AXIS ---
  145 if(x(i)-xtest) 141,142,144
C --- SEGMENT CROSSES TEST POINT ---
  144 inedge=.true.
C --- POINT I ON POSITIVE X-AXIS ---
  143 i=i+1
      if(i.gt.npts) goto 190
      if(y(i)-ytest) 147,146,121
C --- NEW POINT I ON X-AXIS ---
  146 if(x(i)-xtest) 142,142,143
C --- NEW POINT I CROSSES POSITIVE X-AXIS ---
  147 ncross=ncross+1
      goto 111
C
C EVALUATE INEDGE AND NCROSS
C
  190 if(inedge) then
        inside=1
C --- INSIDE IF NCROSS IS ODD ---
      else if(iand(ncross,1).eq.1) then
        inside=1
      end if
C
C RETURN TO CALLING ROUTINE
C
      return
      end


C****************************************************************
C
C     SUBROUTINE SERIES  M E G A R R A Y
C________________________________________________________________
C
C SUBROUTINE SERIES MEGARRAY IS A BLOCK OF SUBROUTINES WHICH WORK
C TOGETHER TO MAKE A DIRECT ACCESS FILE WHICH "LOOKS" LIKE AN
C ENDLESS SINGLY DIMENSIONED ARRAY.
C
C SUBROUTINES:
C
C   MEGAOPEN  - TO BE CALLED WITH THE UNIT NUMBER BEFORE DOING
C               ANY MEGARRAY OPERATIONS.
C   MEGACLOSE - TO BE CALLED AFTER MEGARRAY OPERATIONS ARE
C               COMPLETED.
C   MEGAWRITE - CALL WHEN WRITING integers TO THE ARRAY.
C   MEGAREAD  - CALL WHEN READING integers FROM THE ARRAY.
C   rMEGAWRITE - CALL WHEN WRITING reals TO THE ARRAY.
C   rMEGAREAD  - CALL WHEN READING reals FROM THE ARRAY.
C
C PARAMETERS:
C
C   IUNIT  - INTEGER*4.  UNIT NUMBER TO BE USED FOR ARRAY STORAGE
C   NBEGIN - INTEGER*4.  BEGINNING LOCATION (IN WORDS) IN THE
C            MEGARRAY FOR THE SMALL ARRAY THAT IS BEING STORED OR
C            RETRIEVED.  THIS MAY BE ANY NUMBER WHICH WILL FIT ON
C            THE UNIT BEING ACCESSED.
C   LENGTH - INTEGER*4.  LENGTH (IN WORDS) OF THE SMALL ARRAY.
C   ARRAY  - INTEGER*4.  A SMALL ARRAY WHICH HAS A BEGINNING
C            LOCATION AT NBEGIN WITHIN THE MEGARRAY AND A SIZE OF
C            LENGTH.  THE SMALL ARRAY CAN BE ANY SIZE.
C
C SUBROUTINE SERIES MEGARRAY WRITTEN BY ROB BRACKEN, USGS, 9APR87
C
C________________________________________________________________
C
C     SUBROUTINE  M E G A O P
C________________________________________________________________
C
C
      subroutine megaop(iunit)
C
C VARIABLE DECLARATION
C
      parameter(lenbuf=450,nbuf=8)
      integer*4 junit,nummax,jboff(nbuf),jbnum(nbuf),jbmod(nbuf)
      INTEGER*4 buffer(lenbuf,nbuf)
      common /bufcom/ junit,nummax,jboff,jbnum,jbmod,buffer
C
C OPEN SCRATCH FILE
C
      open(unit=iunit,form='unformatted',
     1     status='scratch',recl=lenbuf*4,
     2     access='direct')
C
C INITIALIZE VARIABLES
C
      junit=iunit
      nummax=0
      do 20 j=1,nbuf
        jboff(j)=-1
        jbnum(j)=j
        jbmod(j)=0
        do 10 i=1,lenbuf
          buffer(i,j)=0
   10   continue
   20 continue
C
C RETURN TO CALLING PROGRAM
C
  199 return
      end
C
C
C________________________________________________________________
C
C     SUBROUTINE  M E G A C L
C________________________________________________________________
C
C
      subroutine megacl
C
C VARIABLE DECLARATION
C
      parameter(lenbuf=450,nbuf=8)
      integer*4 junit,nummax,jboff(nbuf),jbnum(nbuf),jbmod(nbuf)
      INTEGER*4 buffer(lenbuf,nbuf)
      common /bufcom/ junit,nummax,jboff,jbnum,jbmod,buffer
C
C WRITE TO DISK ALL SPECIFIED BUFFERS
C
      do 10 i=1,nbuf
        if(jbmod(j).ne.0) call bfswap(junit,jboff(i)+1,0,nummax,
     1   buffer(1,jbnum(i)),lenbuf)
   10 continue
C
C CLOSE SCRATCH UNIT AND RETURN TO CALLING ROUTINE
C
      close(unit=junit)
  299 return
      end
C
C________________________________________________________________
C
C     SUBROUTINE M E G A W R
C________________________________________________________________
C
C
      subroutine megawr(nbegin,length,array)
C
C VARIABLE DECLARATION
C
      INTEGER*4 array(1)
      parameter(lenbuf=450,nbuf=8)
      integer*4 junit,nummax,jboff(nbuf),jbnum(nbuf),jbmod(nbuf)
      INTEGER*4 buffer(lenbuf,nbuf)
      common /bufcom/ junit,nummax,jboff,jbnum,jbmod,buffer
C
C INITIALIZE OFFSET POINTERS
C
      inoff=nbegin-1
      iaoff=0
      iboff=(inoff)/lenbuf
      iwoff=inoff-iboff*lenbuf
C
C CHECK WHETHER FIRST BUFFER IS BEING REFERENCED
C
      if(iboff.eq.jboff(1)) then
        laspta=length-iaoff
        goto 301
      end if
C
C CHECK WHETHER 2ND - LAST BUFFERS ARE BEING REFERENCED
C
  303 laspta=length-iaoff
      do 10 i=2,nbuf
        if(iboff.eq.jboff(i)) goto 302
   10 continue
C
C OUTPUT LEAST ACTIVE BUFFER AND READ IN BUFFER BEING REFERENCED
C
      i=i-1
      if(jbmod(i).eq.0) then
        numout=0
      else
        numout=jboff(i)+1
        jbmod(i)=0
      end if
      if(iwoff.eq.0.and.laspta.ge.lenbuf) then
        numin=0
      else
        numin=iboff+1
      endif
      call bfswap(junit,numout,numin,nummax,buffer(1,jbnum(i)),
     1            lenbuf)
C
C ROTATE REFERENCED BUFFER TO FIRST POSITION
C
  302 ibnum=jbnum(i)
      ibmod=jbmod(i)
      do 20 j=i,2,-1
        j1=j-1
        jboff(j)=jboff(j1)
        jbnum(j)=jbnum(j1)
        jbmod(j)=jbmod(j1)
   20 continue
      jboff(1)=iboff
      jbnum(1)=ibnum
      jbmod(1)=ibmod
C
C BEGIN WRITING ARRAY INTO BUFFERS
C
  301 j=iwoff-iaoff
      jbmod(1)=-1
      if(iwoff+laspta.le.lenbuf) then
C
C REMAINDER OF ARRAY FITS ENTIRELY INTO PRESENT BUFFER
C
        do 30 i=iwoff+1,iwoff+laspta
          buffer(i,jbnum(1))=array(i-j)
   30   continue
      else
C
C REMAINDER OF ARRAY EXTENDS BEYOND PRESENT BUFFER
C
        do 40 i=iwoff+1,lenbuf
          buffer(i,jbnum(1))=array(i-j)
   40   continue
        iaoff=iaoff+lenbuf-iwoff
        iboff=iboff+1
        iwoff=0
        goto 303
      end if
C
C RETURN TO CALLING ROUTINE
C
  399 return
      end
C
C________________________________________________________________
C
C     SUBROUTINE M E G A RD
C________________________________________________________________
C
C
      subroutine megard(nbegin,length,array)
C
C VARIABLE DECLARATION
C
      INTEGER*4 array(1)
      parameter(lenbuf=450,nbuf=8)
      integer*4 junit,nummax,jboff(nbuf),jbnum(nbuf),jbmod(nbuf)
      INTEGER*4 buffer(lenbuf,nbuf)
      common /bufcom/ junit,nummax,jboff,jbnum,jbmod,buffer
C
C INITIALIZE OFFSET POINTERS
C
      inoff=nbegin-1
      iaoff=0
      iboff=(inoff)/lenbuf
      iwoff=inoff-iboff*lenbuf
C
C CHECK WHETHER FIRST BUFFER IS BEING REFERENCED
C
      if(iboff.eq.jboff(1)) then
        laspta=length-iaoff
        goto 401
      end if
C
C CHECK WHETHER 2ND - LAST BUFFERS ARE BEING REFERENCED
C
  403 laspta=length-iaoff
      do 10 i=2,nbuf
        if(iboff.eq.jboff(i)) goto 402
   10 continue
C
C OUTPUT LEAST ACTIVE BUFFER AND READ IN BUFFER BEING REFERENCED
C
      i=i-1
      if(jbmod(i).eq.0) then
        numout=0
      else
        numout=jboff(i)+1
      end if
      numin=iboff+1
      call bfswap(junit,numout,numin,nummax,buffer(1,jbnum(i)),
     1            lenbuf)
C
C ROTATE REFERENCED BUFFER TO FIRST POSITION
C
  402 ibnum=jbnum(i)
      ibmod=jbmod(i)
      do 20 j=i,2,-1
        j1=j-1
        jboff(j)=jboff(j1)
        jbnum(j)=jbnum(j1)
        jbmod(j)=jbmod(j1)
   20 continue
      jboff(1)=iboff
      jbnum(1)=ibnum
      jbmod(1)=ibmod
C
C BEGIN WRITING BUFFERS INTO ARRAYS
C
  401 j=iwoff-iaoff
      if(iwoff+laspta.le.lenbuf) then
C
C REMAINDER OF ARRAY CONTAINED ENTIRELY BY PRESENT BUFFER
C
        do 30 i=iwoff+1,iwoff+laspta
          array(i-j)=buffer(i,jbnum(1))
   30   continue
      else
C
C REMAINDER OF ARRAY EXTENDS BEYOND PRESENT BUFFER
C
        do 40 i=iwoff+1,lenbuf
          array(i-j)=buffer(i,jbnum(1))
   40   continue
        iaoff=iaoff+lenbuf-iwoff
        iboff=iboff+1
        iwoff=0
        goto 403
      end if
C
C RETURN TO CALLING ROUTINE
C
  499 return
      end
C
C________________________________________________________________
C
C     SUBROUTINE  R M E G A W
C________________________________________________________________
C
C
      subroutine rmegaw(nbegin,length,array)
C
C VARIABLE DECLARATION
C
      REAL*4 array(1)
      parameter(lenbuf=450,nbuf=8)
      integer*4 junit,nummax,jboff(nbuf),jbnum(nbuf),jbmod(nbuf)
      INTEGER*4 buffer(lenbuf,nbuf)
      common /bufcom/ junit,nummax,jboff,jbnum,jbmod,buffer
      REAL*4 RUFFER(LENBUF,NBUF)
      EQUIVALENCE (BUFFER(1,1),RUFFER(1,1))
C
C INITIALIZE OFFSET POINTERS
C
      inoff=nbegin-1
      iaoff=0
      iboff=(inoff)/lenbuf
      iwoff=inoff-iboff*lenbuf
C
C CHECK WHETHER FIRST BUFFER IS BEING REFERENCED
C
      if(iboff.eq.jboff(1)) then
        laspta=length-iaoff
        goto 301
      end if
C
C CHECK WHETHER 2ND - LAST BUFFERS ARE BEING REFERENCED
C
  303 laspta=length-iaoff
      do 10 i=2,nbuf
        if(iboff.eq.jboff(i)) goto 302
   10 continue
C
C OUTPUT LEAST ACTIVE BUFFER AND READ IN BUFFER BEING REFERENCED
C
      i=i-1
      if(jbmod(i).eq.0) then
        numout=0
      else
        numout=jboff(i)+1
        jbmod(i)=0
      end if
      if(iwoff.eq.0.and.laspta.ge.lenbuf) then
        numin=0
      else
        numin=iboff+1
      endif
      call bfswap(junit,numout,numin,nummax,buffer(1,jbnum(i)),
     1            lenbuf)
C
C ROTATE REFERENCED BUFFER TO FIRST POSITION
C
  302 ibnum=jbnum(i)
      ibmod=jbmod(i)
      do 20 j=i,2,-1
        j1=j-1
        jboff(j)=jboff(j1)
        jbnum(j)=jbnum(j1)
        jbmod(j)=jbmod(j1)
   20 continue
      jboff(1)=iboff
      jbnum(1)=ibnum
      jbmod(1)=ibmod
C
C BEGIN WRITING ARRAY INTO BUFFERS
C
  301 j=iwoff-iaoff
      jbmod(1)=-1
      if(iwoff+laspta.le.lenbuf) then
C
C REMAINDER OF ARRAY FITS ENTIRELY INTO PRESENT BUFFER
C
        do 30 i=iwoff+1,iwoff+laspta
          Ruffer(i,jbnum(1))=array(i-j)
   30   continue
      else
C
C REMAINDER OF ARRAY EXTENDS BEYOND PRESENT BUFFER
C
        do 40 i=iwoff+1,lenbuf
          Ruffer(i,jbnum(1))=array(i-j)
   40   continue
        iaoff=iaoff+lenbuf-iwoff
        iboff=iboff+1
        iwoff=0
        goto 303
      end if
C
C RETURN TO CALLING ROUTINE
C
  399 return
      end
C
C________________________________________________________________
C
C     SUBROUTINE  R M E G A R
C________________________________________________________________
C
C
      subroutine rmegar(nbegin,length,array)
C
C VARIABLE DECLARATION
C
      REAL*4 array(1)
      parameter(lenbuf=450,nbuf=8)
      integer*4 junit,nummax,jboff(nbuf),jbnum(nbuf),jbmod(nbuf)
      INTEGER*4 buffer(lenbuf,nbuf)
      common /bufcom/ junit,nummax,jboff,jbnum,jbmod,buffer
      REAL*4 RUFFER(LENBUF,NBUF)
      EQUIVALENCE (BUFFER(1,1),RUFFER(1,1))
C
C INITIALIZE OFFSET POINTERS
C
      inoff=nbegin-1
      iaoff=0
      iboff=(inoff)/lenbuf
      iwoff=inoff-iboff*lenbuf
C
C CHECK WHETHER FIRST BUFFER IS BEING REFERENCED
C
      if(iboff.eq.jboff(1)) then
        laspta=length-iaoff
        goto 401
      end if
C
C CHECK WHETHER 2ND - LAST BUFFERS ARE BEING REFERENCED
C
  403 laspta=length-iaoff
      do 10 i=2,nbuf
        if(iboff.eq.jboff(i)) goto 402
   10 continue
C
C OUTPUT LEAST ACTIVE BUFFER AND READ IN BUFFER BEING REFERENCED
C
      i=i-1
      if(jbmod(i).eq.0) then
        numout=0
      else
        numout=jboff(i)+1
      end if
      numin=iboff+1
      call bfswap(junit,numout,numin,nummax,buffer(1,jbnum(i)),
     1            lenbuf)
C
C ROTATE REFERENCED BUFFER TO FIRST POSITION
C
  402 ibnum=jbnum(i)
      ibmod=jbmod(i)
      do 20 j=i,2,-1
        j1=j-1
        jboff(j)=jboff(j1)
        jbnum(j)=jbnum(j1)
        jbmod(j)=jbmod(j1)
   20 continue
      jboff(1)=iboff
      jbnum(1)=ibnum
      jbmod(1)=ibmod
C
C BEGIN WRITING BUFFERS INTO ARRAYS
C
  401 j=iwoff-iaoff
      if(iwoff+laspta.le.lenbuf) then
C
C REMAINDER OF ARRAY CONTAINED ENTIRELY BY PRESENT BUFFER
C
        do 30 i=iwoff+1,iwoff+laspta
          array(i-j)=Ruffer(i,jbnum(1))
   30   continue
      else
C
C REMAINDER OF ARRAY EXTENDS BEYOND PRESENT BUFFER
C
        do 40 i=iwoff+1,lenbuf
          array(i-j)=Ruffer(i,jbnum(1))
   40   continue
        iaoff=iaoff+lenbuf-iwoff
        iboff=iboff+1
        iwoff=0
        goto 403
      end if
C
C RETURN TO CALLING ROUTINE
C
  499 return
      end
C
C________________________________________________________________
C
C     SUBROUTINE  B F S W A P
C________________________________________________________________
C
C
      subroutine bfswap(iunit,numout,numin,nummax,buffer,lenbuf)
C
C VARIABLE DECLARATION
C
      INTEGER*4 buffer(lenbuf)
C
C WRITE OUT BUFFER AND INCREMENT MAX NUMBER OF RECORD COUNTER
C
      if(numout.gt.0) then
        write(iunit,rec=numout) buffer
        if(numout.gt.nummax) nummax=numout
      end if
C
C READ IN NEW BUFFER IF WITHIN RANGE OF RECORDS IN FILE
C
      if(numin.eq.0) goto 599
      if(numin.le.nummax) then
        read(iunit,rec=numin) buffer
C
C FILL BUFFER WITH ZEROS
C
      else
        do 10 i=1,lenbuf
          buffer(i)=0
   10   continue
      end if
C
C RETURN TO CALLING ROUTINE
C
  599 return
      end
C
C****************************************************************

C
C________________________________________________________________
C
C     SUBROUTINE  L X P L O T
C________________________________________________________________
C
C SUBROUTINE LINE EXTERNAL PLOT WHEN CALLED BY PROGRAM CONTOUR
C WILL PLOT LINES FROM AN EXTERNAL FILE.  THE PARMS NEEDED ARE
C AS FOLLOWS:
C
C   LXFILE = CHARACTER*56.  THE NAME OF THE EXTERNAL FILE
C            CONTAINING THE ORDERED PAIRS OF THE LINE SEGMENT OR
C            SEGMENTS TO PLOT.  EACH LINE SEGMENT MUST TERMINATE
C            WITH AN END-OF-FILE OR A NUMBER GREATER THAN OR
C            EQUAL TO 1.0E+37 IN EITHER X OR Y OR BOTH FIELDS.
C            DEFAULT IS BLANKS WHICH MEANS NO EXTERNAL LINE
C            PLOTTING WILL BE DONE.
C   LXFMT  = CHARACTER*16.  THE FORMAT OF THE INPUT FILE.
C            IF LXFMT IS NON-BLANK THEN THE DATA IS READ IN
C            LIST FORMAT(I.E.,THE FORMAT IS IGNORED).
C            DEFAULT IS BLANKS WHICH MEANS BINARY XYZ FILE.
C   LXPROJ = INTEGER*4.  THE NUMBER OF THE PROJECTION OF LXFILE.
C            IF THE FILE HAS BEEN PROJECTED IT MUST HAVE THE SAME
C            PROJECTION NUMBER, CENTRAL MERIDIAN, AND BASLAT AS
C            THE GRID FILE.  DEFAULT IS 999 WHICH MEANS
C            UNPROJECTED DATA.
C   LXUNIT = INTEGER*4.  THE NUMBER REPRESENTING THE TYPE OF
C            UNITS IN THE LXFILE.  0 - INCHES (PROJECTED),
C            SECONDS (UNPROJECTED); 1 - METERS, MINUTES; AND
C            DEFAULT IS 2 - KILOMETERS, DEGREES.  NOTE:  IF
C            LXPROJ=999 THEN LXUNIT IS SECONDS, MINUTES, OR
C            DEGREES.  OTHERWISE IT IS INCHES, METERS, OR
C            KILOMETERS.  IF THE GRID IS NOT PROJECTED SETTING
C            UNIT = 0, 1, OR 2 WILL SPECIFY SECONDS, MINUTES,
C            AND DEGREES FOR THE GRID SO THAT THE GRID UNITS
C            (USE UNIT) MAY BE MATCHED TO THE LXFILE UNITS
C            (USE LXUNIT).
C   LXTYPE = INTEGER*4.  THE NUMBER OF THE DESIRED LINE TYPE
C            (SEE IDASHS IN THE CONTOUR DOCUMENTATION).  DEFAULT
C            IS 0 WHICH MEANS A SOLID UNTHICKENED LINE WILL BE
C            USED.  IF LXTYPE IS SET TO 999 THE FIRST POINT OF
C            EACH LINE SEGMENT IN LXFILE WILL BE TAKEN AS THE
C            VALUE FOR LXTYPE.  IN THIS CASE BOTH X AND Y MUST BE
C            EQUAL TO EACH OTHER AND THEY MUST BE EQUAL TO A
C            VALID LINE TYPE NUMBER.
C
C SUBROUTINE LXPLOT WRITTEN BY ROB BRACKEN, USGS, 23FEB87
C
C
      subroutine lxplot(lxfile,lxfmt,lxproj,lxunit,lxtype)
      save
C
C VARIABLE DECLARATION
C
      common/llp/latm(3),latx(3),longm(3),longx(3),cm(3),
     1           baslat(3),iproj,xxx(2),yyy(2),sizep,unit,ip,
     2           neat,tint,itpost,ibound
      integer*4 isize
      parameter(isize=50)
      dimension xlat(isize),xlon(isize),xx(isize),yy(isize)
      dimension lnum(isize)
      integer*4 idsk
      parameter(idsk=14)
      character*132 fields(10)
      character*56 lxfile,blank
      character*16 lxfmt,blank1
      parameter(dval=1.0e+37)
      logical eof
C
C FUNCTIONS
C
      integer*4 function lintyp
      real*8 min2dg,sec2dg
      parameter(min2dg=1.d0/60.d0,sec2dg=1.d0/3600.d0)
      data blank/' '/,blank1/' '/
      dms2d(a,b,c)=-(a+sign(b,a)*min2dg+sign(c,a)*sec2dg)
      dms2d1(a,b,c)=a+sign(b,a)*min2dg+sign(c,a)*sec2dg
C
C CHECK IF PLOT SHOULD BE DONE
C
      if(lxfile.eq.blank) return
C
C SET UP ASCII FILE TYPE BASED ON LXFMT
C
      eof=.false.
      if(lxfmt.eq.blank1) then
        nftype=0
        open(unit=idsk,file=lxfile,form='unformatted',status='old',
     &  readonly)
      else
        open(24,status='scratch',carriagecontrol='list')
        open(unit=idsk,file=lxfile,form='formatted',status='old',
     &  readonly)
        call freerd(idsk,nfield,fields,0,*910,*910)
        close(24)
        rewind idsk
        if(nfield.lt.2.or.nfield.gt.3) go to 910
        if(nfield.eq.2) then
        nftype=1
        else
        nftype=2
        endif
      endif
C
C BRANCH IF A PROJECTION NEED NOT BE PERFORMED ON THE INPUT DATA
C
      if(lxproj.eq.iproj) goto 240
C
C PROJECT AND PLOT UNPROJECTED INPUT DATA
C
      if(lxproj.ne.999) goto 901
C
C SET UP FACTORS FOR CONVERTING INPUT UNITS TO DEGREES
C
      dfac=1.0
      if(lxunit.eq.1) dfac=60.0
      if(lxunit.eq.0) dfac=3600.0
C
C SET UP FACTORS FOR CONVERTING OUTPUT UNITS FROM METERS
C
      sfac=.001
      if(unit.eq.1.0) sfac=1.0
      if(unit.eq.0.0) sfac=100.0/2.54
C
C SET UP PROJECTION
C
      if(iproj.gt.4) call setalb(iproj)
      pcm=dms2d(cm(1),cm(2),cm(3))
      pbs=dms2d1(baslat(1),baslat(2),baslat(3))
C
C FIND PROJECTED Y-COORDINATE OF THE BASLAT
C
      xxxx=pbs
      call prjctl(xxxx,pcm,yy(1),pbs,pcm,sfac,iproj)
C
C BEGIN A NEW LINE SEGMENT
C
   50 j=1
C
C INITIALIZE THE BRIDGING NUMBER
C
      icon=0
      icon2=0
C
C READ LXFILE AND DETERMINE THE LINE TYPE
C
      if(nftype.eq.0) then
      read(idsk,end=80) xlon(j),xlat(j)
      else if(nftype.eq.1) then
      read(idsk,*,end=80) xlon(j),xlat(j)
      else
      read(idsk,*,end=80) xlon(j),xlat(j),lnum(j)
      endif
      if(lxtype.eq.999) then
        ltype=lintyp(xlon(j),xlat(j))
        if(ltype.eq.999) ltype=0
        goto 110
      end if
      ltype=lxtype
      goto 170
C
C READ EACH SUCCESSIVE POINT IN LXFILE AND BRANCH TO PLOTTING
C IF THE END OF THE LINE SEGMENT HAS BEEN REACHED.
C
  130 j=j+1
  110 if(nftype.eq.0) then
      read(idsk,end=80) xlon(j),xlat(j)
      else if(nftype.eq.1) then
      read(idsk,*,end=80) xlon(j),xlat(j)
      else
      read(idsk,*,end=80) xlon(j),xlat(j),lnum(j)
      endif
  170 if(xlon(j).ge.dval.or.xlat(j).ge.dval) go to 180
      if(nftype.eq.2.and.j.ne.1) then
      if(lnum(j).ne.lnum(j-1)) go to 180
      endif
C
C CONVERT DATA TO DEGREES AND PROJECT
C
  175 xlon(j)=sign(xlon(j),pcm)*dfac
      xlat(j)=xlat(j)*dfac
      call prjctl(xlat(j),xlon(j),xx(j),yyyy,pcm,sfac,iproj)
      yy(j)=yyyy-pbs
C
C LOOP TO NEXT ORDERED PAIR UNLESS ARRAYS ARE FULL
C
      if(j.lt.isize) goto 130
C
C SET ICON2 TO BRIDGE BETWEEN THIS DATA SET AND THE NEXT ONE
C
      icon2=1
      goto 190
C
C CONTINUE PLOTTING AT END OF FILE ONLY IF ARRAYS ARE NOT EMPTY
C
   80 eof=.true.
   90 if(j-1.lt.2.and.icon.eq.0) goto 901
C
C CALL LINE IF THERE IS MORE THAN ONE POINT OR IF BRIDGING FROM
C THE LAST SEGMENT.  REMEMBER THE COORDS OF THE LAST POINT
C
  180 j=j-1
  190 if(icon.eq.0.and.j.ge.2.or.icon.eq.1.and.j.ge.1) then
        call line(xx,yy,j,icon,ltype)
        xlp=xx(j)
        ylp=yy(j)
      end if
      if(eof) go to 910
C
C SET ICON FOR NEXT CALL TO LINE
C
      icon=icon2
C
C BRANCH TO BEGIN NEW LINE SEGMENT UNLESS BRIDGING
C
      if(icon.eq.0.and.nftype.ne.2) goto 50
      if(icon.eq.0.and.nftype.eq.2) then
      xlon(1)=xlon(j+1)
      xlat(1)=xlat(j+1)
      lnum(1)=lnum(j+1)
      j=1
      go to 175
      endif
C
C CONTINUE WITH PRESENT SEGMENT WHEN BRIDGING
C
      j=0
      icon2=0
      goto 130
C
C PLOT INPUT DATA - NO PROJECTING REQUIRED
C
  240 continue
C
C SET UP FACTORS FOR CONVERTING INPUT UNITS TO DEGREES OR METERS.
C
      if(lxproj.eq.999) then
        dfac=1.0
        if(lxunit.eq.1) dfac=min2dg
        if(lxunit.eq.0) dfac=sec2dg
      else
        dfac=1000
        if(lxunit.eq.1) dfac=1.0
        if(lxunit.eq.0) dfac=2.54/100.0
      end if
C
C SET UP FACTORS FOR CONVERTING OUTPUT UNITS FROM DEGREES OR
C METERS TO DATA UNITS
C
      if(iproj.eq.999) then
        sfac=1.0
        if(unit.eq.1) sfac=60.0
        if(unit.eq.0) sfac=3600.0
      else
        sfac=.001
        if(unit.eq.1) sfac=1.0
        if(unit.eq.0) sfac=100.0/2.54
      end if
C
C BEGIN A NEW LINE SEGMENT
C
  250 j=1
C
C INITIALIZE THE BRIDGING NUMBER
C
      icon=0
      icon2=0
C
C READ LXFILE AND DETERMINE THE LINE TYPE
C
      if(nftype.eq.0) then
      read(idsk,end=280) xlon(j),xlat(j)
      else if(nftype.eq.1) then
      read(idsk,*,end=280) xlon(j),xlat(j)
      else
      read(idsk,*,end=280) xlon(j),xlat(j),lnum(j)
      endif
      if(lxtype.eq.999) then
        ltype=lintyp(xlon(j),xlat(j))
        if(ltype.eq.999) ltype=0
        goto 310
      end if
      ltype=lxtype
      goto 370
C
C READ EACH SUCCESSIVE POINT IN LXFILE AND BRANCH TO PLOTTING
C IF THE END OF THE LINE SEGMENT HAS BEEN REACHED.
C
  330 j=j+1
  310 if(nftype.eq.0) then
      read(idsk,end=280) xlon(j),xlat(j)
      else if(nftype.eq.1) then
      read(idsk,*,end=280) xlon(j),xlat(j)
      else
      read(idsk,*,end=280) xlon(j),xlat(j),lnum(j)
      endif
  370 if(xlon(j).ge.dval.or.xlat(j).ge.dval) go to 380
      if(nftype.eq.2.and.j.ne.1) then
      if(lnum(j).ne.lnum(j-1)) go to 380
      endif
C
C CONVERT DATA TO MAP UNITS
C
  375 xlon(j)=xlon(j)*dfac
      xlat(j)=xlat(j)*dfac
      xx(j)=xlon(j)*sfac
      yy(j)=xlat(j)*sfac
C
C LOOP TO NEXT ORDERED PAIR UNLESS ARRAYS ARE FULL
C
      if(j.lt.isize) goto 330
C
C SET ICON2 TO BRIDGE BETWEEN THIS DATA SET AND THE NEXT ONE
C
      icon2=1
      goto 390
C
C CONTINUE PLOTTING AT END OF FILE ONLY IF ARRAYS ARE NOT EMPTY
  280 eof=.true.
C
  290 if(j-1.lt.2.and.icon.eq.0) goto 901
C
C CALL LINE IF THERE IS MORE THAN ONE POINT OR IF BRIDGING FROM
C THE LAST SEGMENT.  REMEMBER COORDS OF LAST POINT.
C
  380 j=j-1
  390 if(icon.eq.0.and.j.ge.2.or.icon.eq.1.and.j.ge.1) then
        call line(xx,yy,j,icon,ltype)
        xlp=xx(j)
        ylp=yy(j)
      end if
      if(eof) go to 910
C
C SET ICON FOR NEXT CALL TO LINE
C
      icon=icon2
C
C BRANCH TO BEGIN NEW LINE SEGMENT UNLESS BRIDGING
C
      if(icon.eq.0.and.nftype.ne.2) goto 250
      if(icon.eq.0.and.nftype.eq.2) then
      xlon(1)=xlon(j+1)
      xlat(1)=xlat(j+1)
      lnum(1)=lnum(j+1)
      j=1
      go to 375
      endif
C
C CONTINUE WITH PRESENT SEGMENT WHEN BRIDGING
C
      j=0
      icon2=0
      goto 330
C
C END SEQUENCE
C
  901 xx(1)=xlp
      yy(1)=ylp
      call line(xx,yy,1,0,ltype)
  910 close(unit=idsk)
      return
      end
C
C________________________________________________________________
C
C     FUNCTION  L I N T Y P
C________________________________________________________________
C
C FUNCTION LINE TYPE RETURNS AN INTEGER EQUAL TO A AND B ONLY IF
C A=B, A IS BETWEEN 0 AND 998 INCLUSIVE, AND A IS NEARLY AN
C INTEGER.  OTHERWISE IT RETURNS 999.
C
C FUNCTION LINTYP WRITTEN BY ROB BRACKEN, USGS, 23FEB87
C
C
      function lintyp(a,b)
      lintyp=999
      if(abs(a-b).gt.1.e-5) return
      if(a.gt.998.1.or.a.lt.0.0) return
      if(abs(a-anint(a)).gt.1.e-5) return
      lintyp=nint(a)
      return
      end
      subroutine txplot
c
c     Reads an ascii file to plot text on a contour map.
c     It calls subroutine freerd to determine the number
c     of fields.The minimun number of input fields is five.
c     The order of fields is exactly the same as a call to
c     subroutine vchar with the execption that the number
c     of characters to plot is not included.
c
      character*132 fields(10),text,blank
      common/txcb/txfile
      character*56 txfile
      integer ltext(33)
      equivalence(text,ltext(1))
      data blank/' '/
      open(24,status='scratch',carriagecontrol='list')
      open(25,file=txfile,status='old',err=997,iostat=istat,
     & readonly)
   10 theta=0.
      xoff=0.
      yoff=0.
      call freerd(25,nfield,fields,0,*999,*999)
      if(nfield.lt.5.or.nfield.gt.8) go to 999
      if(nfield.lt.8) then
      do 20 i=nfield+1,8
      fields(i)=blank
   20 continue
      endif
      length=leftj(fields(3))
      go to (999,999,999,999,30,40,50,60),nfield
   30 if(length.lt.2) then
      read(24,*,err=998,iostat=istat) x,y,ltext(1),icode,size
      else
      read(24,*,err=998,iostat=istat) x,y,text,icode,size
      length=leftj(text)
      endif
      go to 70
   40 if(length.lt.2) then
      read(24,*,err=998,iostat=istat) x,y,ltext(1),icode,size,theta
      else
      read(24,*,err=998,iostat=istat) x,y,text,icode,size,theta
      length=leftj(text)
      endif
      go to 70
   50 if(length.lt.2) then
      read(24,*,err=998,iostat=istat)x,y,ltext(1),icode,size,theta,xoff
      else
      read(24,*,err=998,iostat=istat)x,y,text,icode,size,theta,xoff
      length=leftj(text)
      endif
      go to 70
   60 if(length.lt.2)then
      read(24,*,err=998,iostat=istat)x,y,ltext(1),icode,size,theta,
     & xoff,yoff
      else
      read(24,*,err=998,iostat=istat)x,y,text,icode,size,theta,
     & xoff,yoff
      length=leftj(text)
      endif
   70 call vchar(x,y,ltext,length,icode,size,theta,xoff,yoff)
      go to 10
  997 print *,'error opening text file; error no. = ',istat
      go to   999
  998 print *,'error reading text file; error no. = ',istat
  999 close(24)
      return
      end
C________________________________________________________________
C
C      SUBROUTINE FREERD
C________________________________________________________________
C SUBROUTINE FREE READ UTILIZES ASCIIP TO READ
C AN ASCII RECORD AND BREAK IT INTO FIELDS. FIELS MAY BE
C SEPARATED BY ANY COMBINATION OF BLANKS AND COMMMAS.  CARRIAGE
C RETURNS (END-OF-RECORD) MAY INDICATE FIELD DELIMITERS, EOR, OR
C EOF DEPENDING ON THE VALUE OF NREAD AND NFIELD.  DITTO MARKS
C (A SINGLE DECIMAL (.)) MAY BE USED TO ASSIGN THE VALUE FROM THE
C LAST (MOST RECENT) CALL TO FREEREAD3 IN THE CORROSPONDING FIELD
C TO THE FIELD OF THE DITTO MARK IN THE PRESENT CALL.
C
C THE MAXIMUM ACCUMULATIVE FIELD LENGTH FOR ANY ONE CALL IS
C 132 CHARACTERS.  THIS SUBROUTINE IS INTENDED FOR TERMINAL
C ENTRY OR SMALL ASCII FILES WHICH REQUIRE GREAT READING
C FLEXIBILITY.
C
C   IUNIT  - INTEGER*4.  UNIT NUMBER TO BE READ.  THIS MAY BE A
C            TERMINAL KEYBOARD OR ANY FILE (DISK, TAPE, ETC).
C   NFIELD - INTEGER*4.  TOTAL NUMBER OF FIELDS ACTUALLY READ.
C   FIELDS - CHARACTER*(*).  CHARACTER ARRAY CONTAINING THE
C            FIELDS WHICH ARE READ IN.  EACH ELEMENT OF THE ARRAY
C            CONTAINS ONE FIELD.
C   NREAD  - INTEGER*4.  DETERMINES WHETHER A CARRIAGE RETURN IS
C            A FIELD DELIMITER (TYPICALLY SPACE, COMMA),
C            AN END-OF-REC MARKER (TYPICALLY CARRIAGE RETURN),
C            OR AN END-OF-FILE MARKER (TYPICALLY CONTROL-Z,
C            E-O-F, EXIT).  THE FIELD DELIMITER INDICATES
C            BEGINNING OF A NEW FIELD AND CONTROL REMAINS IN
C            FREEREAD3.  THE END-OF-REC MARKER INDICATES THAT
C            ALL FIELDS FOR THIS RECORD HAVE BEEN ACCUMULATED AND
C            CONTROL IS TRANSFERED BACK TO THE CALLING ROUTINE.
C            THE END-OF-FILE MARKER INDICATES THAT THERE IS NO
C            DATA AVAILABLE ON THIS CALL AND CONTROL IS
C            TRANSFERED BACK TO THE CALLING ROUTINE VIA THE
C            STARRED (*) RETURN.  FOLLOWING IS A DESCRIPTION OF
C            HOW A CARRIAGE RETURN (OR END OF RECORD) BEHAVES AS
C            A FUNCTION OF THE VALUE OF NREAD AND THE NUMBER OF
C            FIELDS READ IN (NFIELD):
C
C              NREAD > 0:  0 =< NFIELD < NREAD:  FIELD DELIM.
C                          NFIELD >= NREAD:  END-OF-REC.
C              NREAD = 0:  FOR ALL NFIELD:  END-OF-REC.
C              NREAD < 0:  NFIELD = 0:  END-OF-FILE *2.
C                          0 < NFIELD < ABS(NREAD):  FIELD DELIM.
C                          NFIELD >= ABS(NREAD):  END-OF-REC.
C                          LAST FIELD WAS 'EXIT':  END-OF-FILE *1
C
C              FOR ALL NREAD AND NFIELD CONTROL-Z AND E-O-F ARE
C              END-OF-FILE *1 MARKERS.  WARNING:  CONTROL-Z DOES
C              SOME UNPREDICTABLE THINGS IN ADDITION TO WHAT IT'S
C              SUPPOSED TO DO.  IT IS RECOMMENDED THAT THE USER
C              AVOID IT ALL TOGETHER.
C
C   *1     - LINE NUMBER TO WHICH CONTROL IS RETURNED IN THE
C            CASE OF AN END-OF-FILE *1
C   *2     - LINE NUMBER TO WHICH CONTROL IS RETURNED IN THE
C            CASE OF AN END-OF-FILE *2
C
C SUBROUTINE FREEREAD3 WRITTEN BY ROB BRACKEN, USGS, 20JUL87.
C
C
      subroutine freerd(iunit,nfield,fields,nread,*,*)
      save
C
      character*(*) fields(1)
      character*132 alphnu,alphn2
      character*5 ftest
      character*1 ditto
      data alphnu /' '/
C
C REMEMBER LAST READ
C
      alphn2=alphnu
C
C READ THE FILE
C
      i=1
      nfield=0
  102 read(iunit,801,end=998) alphnu
  801 format(a132)
C
C PARSE THE LINE FROM THE FILE
C
      ditto=' '
      call asciip(132,alphnu,ditto,nfield,fields(i))
C
C DETERMINE IF THE PROPER NUMBER OF FIELDS HAVE BEEN READ
C
      i=i+nfield
      nfield=i-1
      if(nread.lt.0) then
        if(i.eq.1) goto 997
        ftest=fields(i-1)
        call upperc(ftest,5)
        if(ftest.eq.'EXIT ') goto 998
      endif
      if(nread.ne.0.and.i.le.abs(nread)) goto 102
C
C FILL IN THE DITTO MARKS
C
      ditto='.'
      call asciip(132,alphn2,ditto,nfld2,fields)
C
C SET UP ALPHNU WITH PRESENT SET OF FIELDS
C
      lent=0
      do 20 j=1,nfield
        do 10 len=1,132
          if(fields(j)(len:len).eq.' ') goto 101
   10   continue
  101   alphnu(lent+1:lent+len)=fields(j)(1:len)
        lent=lent+len
   20 continue
      if(lent.lt.132) alphnu(lent+1:132)=' '
C
C CUT OUT ANY FIELDS BEYOND THE LAST FIELD IN THIS READ
C
      if(nfield.lt.nfld2) then
        do 30 i=nfield+1,nfld2
          fields(i)=' '
   30   continue
      endif
C
C NORMAL RETURN
C
      rewind(24)
      write(24,*) (fields(i),i=1,nfield)
      rewind(24)
  999 return
C
C END OF FILE REACHED
C
  998 alphnu=' '
      return 1
  997 alphnu=' '
      return 2
      end
C________________________________________________________________
C
C     SUBROUTINE  A S C I I P
C________________________________________________________________
C
C SUBROUTINE ASCII PARSE TAKES A CHARACTER VARIABLE OF ANY LENGTH
C AND DETERMINES WHERE THE DATA FIELDS ARE.  THE FIELDS MUST BE
C SEPARATED BY A BLANK SPACE OR A COMMA (AS IN THE VMS STANDARD).
C
C   MXLEN  - INTEGER*4.  MAXIMUM ALLOWABLE LENGTH OF THE INPUT
C            CHARACTER VARIABLE.
C   ALPHNU - CHARACTER*(*).  CHARACTER (ALPHA-NUMERIC) VARIABLE
C            TO BE PARSED.
C   DITTO  - CHARACTER*1.  THE SYMBOL WHICH IS TO BE USED AS A
C            DITTO MARK.  IF DITTO IS BLANK THEN NO DITTO
C            FUNCTION WILL BE PERFORMED.  SEE "FIELDS".
C   NFIELD - INTEGER*4.  THE NUMBER OF FIELDS WHICH WERE READ IN.
C   FIELDS - CHARACTER*(*).  CHARACTER (ALPHA-NUMERIC) VARIABLE
C            ARRAY TO WHICH THE FIELDS WILL BE READ FROM ALPHNU.
C            EACH ARRAY POSITION IN "FIELDS" WILL CONTAIN A
C            SINGLE FIELD.  IF DITTO IS BLANK ALL FIELDS WILL BE
C            READ FROM ALPHNU TO "FIELDS".  IF DITTO IS NOT BLANK
C            THEN ONLY THOSE ARRAY POSITIONS IN "FIELDS" WHICH
C            CONTAIN A SINGLE DITTO CHARACTER WILL BE FILLED.
C
C SUBROUTINE ASCIIPARSE WRITTEN BY ROB BRACKEN, USGS, 20JUL87.
C
C
      subroutine asciip(mxlen,alphnu,ditto,nfield,fields)
C
      character*(*) alphnu,fields(1)
      character*1 ditto,apos
      logical*4 blank,text,iapos
      data apos/''''/
C
C INIALIZE VARIABLES
C
      blank=.true.
      iapos=.false.
      text=.false.
      nfield=0
C
C SET UP ARRAY CONTAINING FIELDS.
C
      do 10 i=1,mxlen
      if(alphnu(i:i).eq.apos) then
       if(.not.text) then
       if(.not.iapos) then
C      FIRST APOSTROPHY READ
       text=.true.
       ibeg=i
       else
C      TWO APOSTROPHYS IN A ROW SO IT IS PART OF TEXT
       text=.true.
       nfield=nfield-1
       endif
      else
C      SECOND APOSTROPHY READ-TEXT FIELD COMPLETE
       text=.false.
       nfield=nfield+1
       if(ditto.eq.' '.or.fields(nfield).eq.ditto)
     1 fields(nfield)=alphnu(ibeg:i)
       blank=.true.
       iapos=.true.
      endif
        else if(alphnu(i:i).eq.' '.or.alphnu(i:i).eq.','
     1          .and.(.not.text)) then
          iapos=.false.
          if(.not.blank) then
C ---       PREVIOUS FIELD NON-BLANK/PRESENT FIELD BLANK ---
            nfield=nfield+1
            if(ditto.eq.' '.or.fields(nfield).eq.ditto)
     1       fields(nfield)=alphnu(ibeg:i-1)
            blank=.true.
          end if
        else
          if(blank.and.(.not.text)) then
C ---       PREVIOUS FIELD BLANK/PRESENT FIELD NON-BLANK ---
            ibeg=i
            blank=.false.
          end if
        end if
   10 continue
      if(.not.blank) then
C ---   FINAL FIELD NON-BLANK ---
        nfield=nfield+1
        if(ditto.eq.' '.or.fields(nfield).eq.ditto)
     1   fields(nfield)=alphnu(ibeg:i-1)
        blank=.true.
      end if
C
C EXIT PROCEDURE
C
  199 return
      end
C________________________________________________________________
C
C     SUBROUTINE  U P P E R C
C________________________________________________________________
C
C SUBROUTINE UPPER CASE CONVERTS ALPHA-NUMERIC VARIABLES INTO
C ALL UPPER CASE LETTERS.
C
C   ALPHA  - CHARACTER*(*).  ALPHA-NUMERIC TO BE CONVERTED.
C   LENGTH - INTEGER*4.  LENGTH OF ALPHA.
C
C SUBROUTINE UPPERC WRITTEN BY ROB BRACKEN, USGS, 17JUL87.
C
C
      subroutine upperc(alpha,length)
C
      character*(*) alpha
C
      do 10 i=1,length
        k=ichar(alpha(i:i))
        if(k.ge.97.and.k.le.122) then
          alpha(i:i)=char(k-32)
        end if
   10 continue
      return
      end


